#include "src/builtins/builtins-array-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-utils-gen.h"
#include "src/builtins/builtins.h"
#include "src/codegen/code-factory.h"
#include "src/heap/factory-inl.h"
#include "src/objects/arguments.h"
#include "src/objects/bigint.h"
#include "src/objects/elements-kind.h"
#include "src/objects/free-space.h"
#include "src/objects/js-generator.h"
#include "src/objects/js-promise.h"
#include "src/objects/js-regexp-string-iterator.h"
#include "src/objects/js-weak-refs.h"
#include "src/objects/objects.h"
#include "src/objects/source-text-module.h"
#include "src/objects/stack-frame-info.h"
#include "src/objects/synthetic-module.h"
#include "src/objects/template-objects.h"
#include "src/builtins/builtins-bigint-gen.h"
#include "src/builtins/builtins-collections-gen.h"
#include "src/builtins/builtins-data-view-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-iterator-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-constructor-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/objects/js-break-iterator.h"
#include "src/objects/js-collator.h"
#include "src/objects/js-number-format.h"
#include "src/objects/js-objects.h"
#include "src/objects/js-plural-rules.h"
#include "src/objects/js-relative-time-format.h"
#include "src/objects/js-date-time-format.h"
#include "src/objects/js-list-format.h"
#include "src/objects/js-locale.h"
#include "src/objects/js-segment-iterator.h"
#include "src/objects/js-segmenter.h"
#include "torque-generated/../../deps/v8/src/builtins/arguments-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-copywithin-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-join-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-lastindexof-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-map-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-right-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reverse-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-shift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-splice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-unshift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/base-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/bigint-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/boolean-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/collections-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/data-view-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/extras-utils-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/frames-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/growable-fixed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/internal-coverage-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/math-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-fromentries-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-constructor-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-delete-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-has-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-is-extensible-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-prevent-extensions-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revocable-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revoke-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/reflect-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-exec-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-all-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-replace-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-search-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-source-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-split-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-test-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-endswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-html-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-pad-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-repeat-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-startswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-substring-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/torque-internal-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-createtypedarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduceright-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-subarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/third_party/v8/builtins/array-sort-tq-csa.h"
#include "torque-generated/../../deps/v8/test/torque/test-torque-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/intl-objects-tq-csa.h"

namespace v8 {
namespace internal {

TNode<FixedArray> GetCoverageInfo_309(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<JSFunction> p_function, compiler::CodeAssemblerLabel* label_IfNoCoverageInfo) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, SharedFunctionInfo, HeapObject> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, SharedFunctionInfo, HeapObject, DebugInfo> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, SharedFunctionInfo> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, SharedFunctionInfo, DebugInfo> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, SharedFunctionInfo, DebugInfo> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, SharedFunctionInfo, DebugInfo> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, FixedArray> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, FixedArray> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_function);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<JSFunction> tmp1;
    ca_.Bind(&block0, &tmp0, &tmp1);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 23);
    TNode<IntPtrT> tmp2 = ca_.IntPtrConstant(JSFunction::kSharedFunctionInfoOffset);
    USE(tmp2);
    TNode<SharedFunctionInfo>tmp3 = CodeStubAssembler(state_).LoadReference<SharedFunctionInfo>(CodeStubAssembler::Reference{tmp1, tmp2});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 24);
    TNode<IntPtrT> tmp4 = ca_.IntPtrConstant(SharedFunctionInfo::kScriptOrDebugInfoOffset);
    USE(tmp4);
    TNode<HeapObject>tmp5 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp3, tmp4});
    TNode<DebugInfo> tmp6;
    USE(tmp6);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp6 = Cast9DebugInfo_145(state_, TNode<Context>{tmp0}, TNode<HeapObject>{tmp5}, &label0);
    ca_.Goto(&block5, tmp0, tmp1, tmp3, tmp5, tmp6);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block6, tmp0, tmp1, tmp3, tmp5);
    }
  }

  if (block6.is_used()) {
    TNode<Context> tmp7;
    TNode<JSFunction> tmp8;
    TNode<SharedFunctionInfo> tmp9;
    TNode<HeapObject> tmp10;
    ca_.Bind(&block6, &tmp7, &tmp8, &tmp9, &tmp10);
    ca_.Goto(&block4, tmp7, tmp8, tmp9);
  }

  if (block5.is_used()) {
    TNode<Context> tmp11;
    TNode<JSFunction> tmp12;
    TNode<SharedFunctionInfo> tmp13;
    TNode<HeapObject> tmp14;
    TNode<DebugInfo> tmp15;
    ca_.Bind(&block5, &tmp11, &tmp12, &tmp13, &tmp14, &tmp15);
    ca_.Goto(&block3, tmp11, tmp12, tmp13, tmp15);
  }

  if (block4.is_used()) {
    TNode<Context> tmp16;
    TNode<JSFunction> tmp17;
    TNode<SharedFunctionInfo> tmp18;
    ca_.Bind(&block4, &tmp16, &tmp17, &tmp18);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 25);
    ca_.Goto(&block1);
  }

  if (block3.is_used()) {
    TNode<Context> tmp19;
    TNode<JSFunction> tmp20;
    TNode<SharedFunctionInfo> tmp21;
    TNode<DebugInfo> tmp22;
    ca_.Bind(&block3, &tmp19, &tmp20, &tmp21, &tmp22);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 27);
    TNode<IntPtrT> tmp23 = ca_.IntPtrConstant(DebugInfo::kFlagsOffset);
    USE(tmp23);
    TNode<Smi>tmp24 = CodeStubAssembler(state_).LoadReference<Smi>(CodeStubAssembler::Reference{tmp22, tmp23});
    TNode<Smi> tmp25;
    USE(tmp25);
    tmp25 = FromConstexpr5ATSmi17ATconstexpr_int31_155(state_, DebugInfo::kHasCoverageInfo);
    TNode<Smi> tmp26;
    USE(tmp26);
    tmp26 = CodeStubAssembler(state_).SmiAnd(TNode<Smi>{tmp24}, TNode<Smi>{tmp25});
    TNode<Smi> tmp27;
    USE(tmp27);
    tmp27 = FromConstexpr5ATSmi17ATconstexpr_int31_155(state_, 0);
    TNode<BoolT> tmp28;
    USE(tmp28);
    tmp28 = CodeStubAssembler(state_).SmiEqual(TNode<Smi>{tmp26}, TNode<Smi>{tmp27});
    ca_.Branch(tmp28, &block7, &block8, tmp19, tmp20, tmp21, tmp22);
  }

  if (block7.is_used()) {
    TNode<Context> tmp29;
    TNode<JSFunction> tmp30;
    TNode<SharedFunctionInfo> tmp31;
    TNode<DebugInfo> tmp32;
    ca_.Bind(&block7, &tmp29, &tmp30, &tmp31, &tmp32);
    ca_.Goto(&block1);
  }

  if (block8.is_used()) {
    TNode<Context> tmp33;
    TNode<JSFunction> tmp34;
    TNode<SharedFunctionInfo> tmp35;
    TNode<DebugInfo> tmp36;
    ca_.Bind(&block8, &tmp33, &tmp34, &tmp35, &tmp36);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 28);
    TNode<IntPtrT> tmp37 = ca_.IntPtrConstant(DebugInfo::kCoverageInfoOffset);
    USE(tmp37);
    TNode<HeapObject>tmp38 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp36, tmp37});
    TNode<FixedArray> tmp39;
    USE(tmp39);
    tmp39 = UnsafeCast14ATCoverageInfo_1491(state_, TNode<Context>{tmp33}, TNode<Object>{tmp38});
    ca_.Goto(&block2, tmp33, tmp34, tmp39);
  }

  if (block2.is_used()) {
    TNode<Context> tmp40;
    TNode<JSFunction> tmp41;
    TNode<FixedArray> tmp42;
    ca_.Bind(&block2, &tmp40, &tmp41, &tmp42);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 21);
    ca_.Goto(&block9, tmp40, tmp41, tmp42);
  }

  if (block1.is_used()) {
    ca_.Bind(&block1);
    ca_.Goto(label_IfNoCoverageInfo);
  }

    TNode<Context> tmp43;
    TNode<JSFunction> tmp44;
    TNode<FixedArray> tmp45;
    ca_.Bind(&block9, &tmp43, &tmp44, &tmp45);
  return TNode<FixedArray>{tmp45};
}

TNode<Smi> SlotCount_310(compiler::CodeAssemblerState* state_, TNode<FixedArray> p_coverageInfo) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<FixedArray> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedArray> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedArray> block5(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedArray> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedArray> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedArray> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedArray> block9(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedArray> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedArray> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedArray, Smi> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedArray, Smi> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_coverageInfo);

  if (block0.is_used()) {
    TNode<FixedArray> tmp0;
    ca_.Bind(&block0, &tmp0);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 32);
    ca_.Goto(&block3, tmp0);
  }

  if (block2.is_used()) {
    TNode<FixedArray> tmp1;
    ca_.Bind(&block2, &tmp1);
    TNode<BoolT> tmp2;
    USE(tmp2);
    tmp2 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, (CodeStubAssembler(state_).ConstexprInt31Equal(CoverageInfo::kFirstSlotIndex, 0)));
    ca_.Branch(tmp2, &block4, &block5, tmp1);
  }

  if (block5.is_used()) {
    TNode<FixedArray> tmp3;
    ca_.Bind(&block5, &tmp3);
    CodeStubAssembler(state_).FailAssert("Torque assert 'kFirstSlotIndex == 0' failed", "../../deps/v8/src/builtins/internal-coverage.tq", 32);
  }

  if (block4.is_used()) {
    TNode<FixedArray> tmp4;
    ca_.Bind(&block4, &tmp4);
  }

  if (block3.is_used()) {
    TNode<FixedArray> tmp5;
    ca_.Bind(&block3, &tmp5);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 33);
    ca_.Goto(&block7, tmp5);
  }

  if (block6.is_used()) {
    TNode<FixedArray> tmp6;
    ca_.Bind(&block6, &tmp6);
    TNode<IntPtrT> tmp7 = ca_.IntPtrConstant(FixedArrayBase::kLengthOffset);
    USE(tmp7);
    TNode<Smi>tmp8 = CodeStubAssembler(state_).LoadReference<Smi>(CodeStubAssembler::Reference{tmp6, tmp7});
    TNode<Smi> tmp9;
    USE(tmp9);
    tmp9 = FromConstexpr5ATSmi17ATconstexpr_int31_155(state_, CoverageInfo::kSlotIndexCountMask);
    TNode<Smi> tmp10;
    USE(tmp10);
    tmp10 = CodeStubAssembler(state_).SmiAnd(TNode<Smi>{tmp8}, TNode<Smi>{tmp9});
    TNode<Smi> tmp11;
    USE(tmp11);
    tmp11 = FromConstexpr5ATSmi17ATconstexpr_int31_155(state_, CoverageInfo::kFirstSlotIndex);
    TNode<BoolT> tmp12;
    USE(tmp12);
    tmp12 = CodeStubAssembler(state_).SmiEqual(TNode<Smi>{tmp11}, TNode<Smi>{tmp10});
    ca_.Branch(tmp12, &block8, &block9, tmp6);
  }

  if (block9.is_used()) {
    TNode<FixedArray> tmp13;
    ca_.Bind(&block9, &tmp13);
    CodeStubAssembler(state_).FailAssert("Torque assert 'kFirstSlotIndex == (coverageInfo.length & kSlotIndexCountMask)' failed", "../../deps/v8/src/builtins/internal-coverage.tq", 33);
  }

  if (block8.is_used()) {
    TNode<FixedArray> tmp14;
    ca_.Bind(&block8, &tmp14);
  }

  if (block7.is_used()) {
    TNode<FixedArray> tmp15;
    ca_.Bind(&block7, &tmp15);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 34);
    TNode<IntPtrT> tmp16 = ca_.IntPtrConstant(FixedArrayBase::kLengthOffset);
    USE(tmp16);
    TNode<Smi>tmp17 = CodeStubAssembler(state_).LoadReference<Smi>(CodeStubAssembler::Reference{tmp15, tmp16});
    TNode<Smi> tmp18;
    USE(tmp18);
    tmp18 = CodeStubAssembler(state_).SmiSar(TNode<Smi>{tmp17}, CoverageInfo::kSlotIndexCountLog2);
    ca_.Goto(&block1, tmp15, tmp18);
  }

  if (block1.is_used()) {
    TNode<FixedArray> tmp19;
    TNode<Smi> tmp20;
    ca_.Bind(&block1, &tmp19, &tmp20);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 31);
    ca_.Goto(&block10, tmp19, tmp20);
  }

    TNode<FixedArray> tmp21;
    TNode<Smi> tmp22;
    ca_.Bind(&block10, &tmp21, &tmp22);
  return TNode<Smi>{tmp22};
}

TNode<Smi> FirstIndexForSlot_311(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<Smi> p_slot) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, Smi> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Smi> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Smi> block5(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Smi> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Smi> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Smi, Smi> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Smi, Smi> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_slot);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<Smi> tmp1;
    ca_.Bind(&block0, &tmp0, &tmp1);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 38);
    ca_.Goto(&block3, tmp0, tmp1);
  }

  if (block2.is_used()) {
    TNode<Context> tmp2;
    TNode<Smi> tmp3;
    ca_.Bind(&block2, &tmp2, &tmp3);
    TNode<BoolT> tmp4;
    USE(tmp4);
    tmp4 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, (CodeStubAssembler(state_).ConstexprInt31Equal(CoverageInfo::kFirstSlotIndex, 0)));
    ca_.Branch(tmp4, &block4, &block5, tmp2, tmp3);
  }

  if (block5.is_used()) {
    TNode<Context> tmp5;
    TNode<Smi> tmp6;
    ca_.Bind(&block5, &tmp5, &tmp6);
    CodeStubAssembler(state_).FailAssert("Torque assert 'kFirstSlotIndex == 0' failed", "../../deps/v8/src/builtins/internal-coverage.tq", 38);
  }

  if (block4.is_used()) {
    TNode<Context> tmp7;
    TNode<Smi> tmp8;
    ca_.Bind(&block4, &tmp7, &tmp8);
  }

  if (block3.is_used()) {
    TNode<Context> tmp9;
    TNode<Smi> tmp10;
    ca_.Bind(&block3, &tmp9, &tmp10);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 39);
    TNode<Smi> tmp11;
    USE(tmp11);
    tmp11 = CodeStubAssembler(state_).SmiShl(TNode<Smi>{tmp10}, CoverageInfo::kSlotIndexCountLog2);
    ca_.Goto(&block1, tmp9, tmp10, tmp11);
  }

  if (block1.is_used()) {
    TNode<Context> tmp12;
    TNode<Smi> tmp13;
    TNode<Smi> tmp14;
    ca_.Bind(&block1, &tmp12, &tmp13, &tmp14);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 37);
    ca_.Goto(&block6, tmp12, tmp13, tmp14);
  }

    TNode<Context> tmp15;
    TNode<Smi> tmp16;
    TNode<Smi> tmp17;
    ca_.Bind(&block6, &tmp15, &tmp16, &tmp17);
  return TNode<Smi>{tmp17};
}

void IncrementBlockCount_312(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<FixedArray> p_coverageInfo, TNode<Smi> p_slot) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi> block5(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi, Smi, Smi, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT, HeapObject, IntPtrT, IntPtrT, IntPtrT, IntPtrT> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi, Smi, Smi, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT, HeapObject, IntPtrT, IntPtrT, IntPtrT, IntPtrT> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi, Smi, Smi, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT, HeapObject, IntPtrT, IntPtrT, IntPtrT, IntPtrT, HeapObject, IntPtrT> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi, Smi, Smi, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi, Smi, Smi, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT, HeapObject, IntPtrT> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi, Smi, Smi, FixedArray, IntPtrT, IntPtrT, Smi, Smi, HeapObject, IntPtrT> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi, Smi, Smi, FixedArray, IntPtrT, IntPtrT, Smi, Smi, HeapObject, IntPtrT, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT, HeapObject, IntPtrT, IntPtrT, IntPtrT, IntPtrT> block17(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi, Smi, Smi, FixedArray, IntPtrT, IntPtrT, Smi, Smi, HeapObject, IntPtrT, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT, HeapObject, IntPtrT, IntPtrT, IntPtrT, IntPtrT> block18(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi, Smi, Smi, FixedArray, IntPtrT, IntPtrT, Smi, Smi, HeapObject, IntPtrT, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT, HeapObject, IntPtrT, IntPtrT, IntPtrT, IntPtrT, HeapObject, IntPtrT> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi, Smi, Smi, FixedArray, IntPtrT, IntPtrT, Smi, Smi, HeapObject, IntPtrT, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT> block15(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi, Smi, Smi, FixedArray, IntPtrT, IntPtrT, Smi, Smi, HeapObject, IntPtrT, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT, HeapObject, IntPtrT> block14(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi, Smi, Smi, FixedArray, IntPtrT, IntPtrT, Smi, Smi, HeapObject, IntPtrT, FixedArray, IntPtrT, IntPtrT, Smi, Smi, HeapObject, IntPtrT> block13(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi> block20(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_coverageInfo, p_slot);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<FixedArray> tmp1;
    TNode<Smi> tmp2;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 44);
    ca_.Goto(&block3, tmp0, tmp1, tmp2);
  }

  if (block2.is_used()) {
    TNode<Context> tmp3;
    TNode<FixedArray> tmp4;
    TNode<Smi> tmp5;
    ca_.Bind(&block2, &tmp3, &tmp4, &tmp5);
    TNode<Smi> tmp6;
    USE(tmp6);
    tmp6 = SlotCount_310(state_, TNode<FixedArray>{tmp4});
    TNode<BoolT> tmp7;
    USE(tmp7);
    tmp7 = CodeStubAssembler(state_).SmiLessThan(TNode<Smi>{tmp5}, TNode<Smi>{tmp6});
    ca_.Branch(tmp7, &block4, &block5, tmp3, tmp4, tmp5);
  }

  if (block5.is_used()) {
    TNode<Context> tmp8;
    TNode<FixedArray> tmp9;
    TNode<Smi> tmp10;
    ca_.Bind(&block5, &tmp8, &tmp9, &tmp10);
    CodeStubAssembler(state_).FailAssert("Torque assert 'slot < SlotCount(coverageInfo)' failed", "../../deps/v8/src/builtins/internal-coverage.tq", 44);
  }

  if (block4.is_used()) {
    TNode<Context> tmp11;
    TNode<FixedArray> tmp12;
    TNode<Smi> tmp13;
    ca_.Bind(&block4, &tmp11, &tmp12, &tmp13);
  }

  if (block3.is_used()) {
    TNode<Context> tmp14;
    TNode<FixedArray> tmp15;
    TNode<Smi> tmp16;
    ca_.Bind(&block3, &tmp14, &tmp15, &tmp16);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 45);
    TNode<Smi> tmp17;
    USE(tmp17);
    tmp17 = FirstIndexForSlot_311(state_, TNode<Context>{tmp14}, TNode<Smi>{tmp16});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 46);
    TNode<Smi> tmp18;
    USE(tmp18);
    tmp18 = FromConstexpr5ATSmi17ATconstexpr_int31_155(state_, CoverageInfo::kSlotBlockCountIndex);
    TNode<Smi> tmp19;
    USE(tmp19);
    tmp19 = CodeStubAssembler(state_).SmiAdd(TNode<Smi>{tmp17}, TNode<Smi>{tmp18});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 47);
    TNode<IntPtrT> tmp20 = ca_.IntPtrConstant(FixedArray::kObjectsOffset);
    USE(tmp20);
    TNode<IntPtrT> tmp21 = ca_.IntPtrConstant(FixedArrayBase::kLengthOffset);
    USE(tmp21);
    TNode<Smi>tmp22 = CodeStubAssembler(state_).LoadReference<Smi>(CodeStubAssembler::Reference{tmp15, tmp21});
    TNode<IntPtrT> tmp23;
    USE(tmp23);
    tmp23 = Convert8ATintptr5ATSmi_189(state_, TNode<Smi>{tmp22});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 55);
    TNode<IntPtrT> tmp24;
    USE(tmp24);
    tmp24 = Convert8ATintptr5ATSmi_189(state_, TNode<Smi>{tmp19});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 56);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 37);
    TNode<UintPtrT> tmp25;
    USE(tmp25);
    tmp25 = Convert9ATuintptr8ATintptr_206(state_, TNode<IntPtrT>{tmp24});
    TNode<UintPtrT> tmp26;
    USE(tmp26);
    tmp26 = Convert9ATuintptr8ATintptr_206(state_, TNode<IntPtrT>{tmp23});
    TNode<BoolT> tmp27;
    USE(tmp27);
    tmp27 = CodeStubAssembler(state_).UintPtrLessThan(TNode<UintPtrT>{tmp25}, TNode<UintPtrT>{tmp26});
    ca_.Branch(tmp27, &block10, &block11, tmp14, tmp15, tmp16, tmp17, tmp19, tmp15, tmp20, tmp23, tmp19, tmp19, tmp24, tmp15, tmp20, tmp23, tmp24, tmp24);
  }

  if (block10.is_used()) {
    TNode<Context> tmp28;
    TNode<FixedArray> tmp29;
    TNode<Smi> tmp30;
    TNode<Smi> tmp31;
    TNode<Smi> tmp32;
    TNode<FixedArray> tmp33;
    TNode<IntPtrT> tmp34;
    TNode<IntPtrT> tmp35;
    TNode<Smi> tmp36;
    TNode<Smi> tmp37;
    TNode<IntPtrT> tmp38;
    TNode<HeapObject> tmp39;
    TNode<IntPtrT> tmp40;
    TNode<IntPtrT> tmp41;
    TNode<IntPtrT> tmp42;
    TNode<IntPtrT> tmp43;
    ca_.Bind(&block10, &tmp28, &tmp29, &tmp30, &tmp31, &tmp32, &tmp33, &tmp34, &tmp35, &tmp36, &tmp37, &tmp38, &tmp39, &tmp40, &tmp41, &tmp42, &tmp43);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 39);
    TNode<IntPtrT> tmp44;
    USE(tmp44);
    tmp44 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, (SizeOf20UT5ATSmi10HeapObject_354(state_)));
    TNode<IntPtrT> tmp45;
    USE(tmp45);
    tmp45 = CodeStubAssembler(state_).IntPtrMul(TNode<IntPtrT>{tmp43}, TNode<IntPtrT>{tmp44});
    TNode<IntPtrT> tmp46;
    USE(tmp46);
    tmp46 = CodeStubAssembler(state_).IntPtrAdd(TNode<IntPtrT>{tmp40}, TNode<IntPtrT>{tmp45});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 38);
    TNode<HeapObject> tmp47;
    USE(tmp47);
    TNode<IntPtrT> tmp48;
    USE(tmp48);
    std::tie(tmp47, tmp48) = UnsafeNewReference20UT5ATSmi10HeapObject_1440(state_, TNode<HeapObject>{tmp39}, TNode<IntPtrT>{tmp46}).Flatten();
    ca_.Goto(&block9, tmp28, tmp29, tmp30, tmp31, tmp32, tmp33, tmp34, tmp35, tmp36, tmp37, tmp38, tmp39, tmp40, tmp41, tmp42, tmp43, tmp47, tmp48);
  }

  if (block11.is_used()) {
    TNode<Context> tmp49;
    TNode<FixedArray> tmp50;
    TNode<Smi> tmp51;
    TNode<Smi> tmp52;
    TNode<Smi> tmp53;
    TNode<FixedArray> tmp54;
    TNode<IntPtrT> tmp55;
    TNode<IntPtrT> tmp56;
    TNode<Smi> tmp57;
    TNode<Smi> tmp58;
    TNode<IntPtrT> tmp59;
    TNode<HeapObject> tmp60;
    TNode<IntPtrT> tmp61;
    TNode<IntPtrT> tmp62;
    TNode<IntPtrT> tmp63;
    TNode<IntPtrT> tmp64;
    ca_.Bind(&block11, &tmp49, &tmp50, &tmp51, &tmp52, &tmp53, &tmp54, &tmp55, &tmp56, &tmp57, &tmp58, &tmp59, &tmp60, &tmp61, &tmp62, &tmp63, &tmp64);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 41);
    ca_.Goto(&block8, tmp49, tmp50, tmp51, tmp52, tmp53, tmp54, tmp55, tmp56, tmp57, tmp58, tmp59);
  }

  if (block9.is_used()) {
    TNode<Context> tmp65;
    TNode<FixedArray> tmp66;
    TNode<Smi> tmp67;
    TNode<Smi> tmp68;
    TNode<Smi> tmp69;
    TNode<FixedArray> tmp70;
    TNode<IntPtrT> tmp71;
    TNode<IntPtrT> tmp72;
    TNode<Smi> tmp73;
    TNode<Smi> tmp74;
    TNode<IntPtrT> tmp75;
    TNode<HeapObject> tmp76;
    TNode<IntPtrT> tmp77;
    TNode<IntPtrT> tmp78;
    TNode<IntPtrT> tmp79;
    TNode<IntPtrT> tmp80;
    TNode<HeapObject> tmp81;
    TNode<IntPtrT> tmp82;
    ca_.Bind(&block9, &tmp65, &tmp66, &tmp67, &tmp68, &tmp69, &tmp70, &tmp71, &tmp72, &tmp73, &tmp74, &tmp75, &tmp76, &tmp77, &tmp78, &tmp79, &tmp80, &tmp81, &tmp82);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 56);
    ca_.Goto(&block7, tmp65, tmp66, tmp67, tmp68, tmp69, tmp70, tmp71, tmp72, tmp73, tmp74, tmp75, tmp81, tmp82);
  }

  if (block8.is_used()) {
    TNode<Context> tmp83;
    TNode<FixedArray> tmp84;
    TNode<Smi> tmp85;
    TNode<Smi> tmp86;
    TNode<Smi> tmp87;
    TNode<FixedArray> tmp88;
    TNode<IntPtrT> tmp89;
    TNode<IntPtrT> tmp90;
    TNode<Smi> tmp91;
    TNode<Smi> tmp92;
    TNode<IntPtrT> tmp93;
    ca_.Bind(&block8, &tmp83, &tmp84, &tmp85, &tmp86, &tmp87, &tmp88, &tmp89, &tmp90, &tmp91, &tmp92, &tmp93);
    CodeStubAssembler(state_).Unreachable();
  }

  if (block7.is_used()) {
    TNode<Context> tmp94;
    TNode<FixedArray> tmp95;
    TNode<Smi> tmp96;
    TNode<Smi> tmp97;
    TNode<Smi> tmp98;
    TNode<FixedArray> tmp99;
    TNode<IntPtrT> tmp100;
    TNode<IntPtrT> tmp101;
    TNode<Smi> tmp102;
    TNode<Smi> tmp103;
    TNode<IntPtrT> tmp104;
    TNode<HeapObject> tmp105;
    TNode<IntPtrT> tmp106;
    ca_.Bind(&block7, &tmp94, &tmp95, &tmp96, &tmp97, &tmp98, &tmp99, &tmp100, &tmp101, &tmp102, &tmp103, &tmp104, &tmp105, &tmp106);
    ca_.Goto(&block6, tmp94, tmp95, tmp96, tmp97, tmp98, tmp99, tmp100, tmp101, tmp102, tmp103, tmp105, tmp106);
  }

  if (block6.is_used()) {
    TNode<Context> tmp107;
    TNode<FixedArray> tmp108;
    TNode<Smi> tmp109;
    TNode<Smi> tmp110;
    TNode<Smi> tmp111;
    TNode<FixedArray> tmp112;
    TNode<IntPtrT> tmp113;
    TNode<IntPtrT> tmp114;
    TNode<Smi> tmp115;
    TNode<Smi> tmp116;
    TNode<HeapObject> tmp117;
    TNode<IntPtrT> tmp118;
    ca_.Bind(&block6, &tmp107, &tmp108, &tmp109, &tmp110, &tmp111, &tmp112, &tmp113, &tmp114, &tmp115, &tmp116, &tmp117, &tmp118);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 48);
    TNode<IntPtrT> tmp119 = ca_.IntPtrConstant(FixedArray::kObjectsOffset);
    USE(tmp119);
    TNode<IntPtrT> tmp120 = ca_.IntPtrConstant(FixedArrayBase::kLengthOffset);
    USE(tmp120);
    TNode<Smi>tmp121 = CodeStubAssembler(state_).LoadReference<Smi>(CodeStubAssembler::Reference{tmp108, tmp120});
    TNode<IntPtrT> tmp122;
    USE(tmp122);
    tmp122 = Convert8ATintptr5ATSmi_189(state_, TNode<Smi>{tmp121});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 55);
    TNode<IntPtrT> tmp123;
    USE(tmp123);
    tmp123 = Convert8ATintptr5ATSmi_189(state_, TNode<Smi>{tmp111});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 56);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 37);
    TNode<UintPtrT> tmp124;
    USE(tmp124);
    tmp124 = Convert9ATuintptr8ATintptr_206(state_, TNode<IntPtrT>{tmp123});
    TNode<UintPtrT> tmp125;
    USE(tmp125);
    tmp125 = Convert9ATuintptr8ATintptr_206(state_, TNode<IntPtrT>{tmp122});
    TNode<BoolT> tmp126;
    USE(tmp126);
    tmp126 = CodeStubAssembler(state_).UintPtrLessThan(TNode<UintPtrT>{tmp124}, TNode<UintPtrT>{tmp125});
    ca_.Branch(tmp126, &block17, &block18, tmp107, tmp108, tmp109, tmp110, tmp111, tmp112, tmp113, tmp114, tmp115, tmp116, tmp117, tmp118, tmp108, tmp119, tmp122, tmp111, tmp111, tmp123, tmp108, tmp119, tmp122, tmp123, tmp123);
  }

  if (block17.is_used()) {
    TNode<Context> tmp127;
    TNode<FixedArray> tmp128;
    TNode<Smi> tmp129;
    TNode<Smi> tmp130;
    TNode<Smi> tmp131;
    TNode<FixedArray> tmp132;
    TNode<IntPtrT> tmp133;
    TNode<IntPtrT> tmp134;
    TNode<Smi> tmp135;
    TNode<Smi> tmp136;
    TNode<HeapObject> tmp137;
    TNode<IntPtrT> tmp138;
    TNode<FixedArray> tmp139;
    TNode<IntPtrT> tmp140;
    TNode<IntPtrT> tmp141;
    TNode<Smi> tmp142;
    TNode<Smi> tmp143;
    TNode<IntPtrT> tmp144;
    TNode<HeapObject> tmp145;
    TNode<IntPtrT> tmp146;
    TNode<IntPtrT> tmp147;
    TNode<IntPtrT> tmp148;
    TNode<IntPtrT> tmp149;
    ca_.Bind(&block17, &tmp127, &tmp128, &tmp129, &tmp130, &tmp131, &tmp132, &tmp133, &tmp134, &tmp135, &tmp136, &tmp137, &tmp138, &tmp139, &tmp140, &tmp141, &tmp142, &tmp143, &tmp144, &tmp145, &tmp146, &tmp147, &tmp148, &tmp149);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 39);
    TNode<IntPtrT> tmp150;
    USE(tmp150);
    tmp150 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, (SizeOf20UT5ATSmi10HeapObject_354(state_)));
    TNode<IntPtrT> tmp151;
    USE(tmp151);
    tmp151 = CodeStubAssembler(state_).IntPtrMul(TNode<IntPtrT>{tmp149}, TNode<IntPtrT>{tmp150});
    TNode<IntPtrT> tmp152;
    USE(tmp152);
    tmp152 = CodeStubAssembler(state_).IntPtrAdd(TNode<IntPtrT>{tmp146}, TNode<IntPtrT>{tmp151});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 38);
    TNode<HeapObject> tmp153;
    USE(tmp153);
    TNode<IntPtrT> tmp154;
    USE(tmp154);
    std::tie(tmp153, tmp154) = UnsafeNewReference20UT5ATSmi10HeapObject_1440(state_, TNode<HeapObject>{tmp145}, TNode<IntPtrT>{tmp152}).Flatten();
    ca_.Goto(&block16, tmp127, tmp128, tmp129, tmp130, tmp131, tmp132, tmp133, tmp134, tmp135, tmp136, tmp137, tmp138, tmp139, tmp140, tmp141, tmp142, tmp143, tmp144, tmp145, tmp146, tmp147, tmp148, tmp149, tmp153, tmp154);
  }

  if (block18.is_used()) {
    TNode<Context> tmp155;
    TNode<FixedArray> tmp156;
    TNode<Smi> tmp157;
    TNode<Smi> tmp158;
    TNode<Smi> tmp159;
    TNode<FixedArray> tmp160;
    TNode<IntPtrT> tmp161;
    TNode<IntPtrT> tmp162;
    TNode<Smi> tmp163;
    TNode<Smi> tmp164;
    TNode<HeapObject> tmp165;
    TNode<IntPtrT> tmp166;
    TNode<FixedArray> tmp167;
    TNode<IntPtrT> tmp168;
    TNode<IntPtrT> tmp169;
    TNode<Smi> tmp170;
    TNode<Smi> tmp171;
    TNode<IntPtrT> tmp172;
    TNode<HeapObject> tmp173;
    TNode<IntPtrT> tmp174;
    TNode<IntPtrT> tmp175;
    TNode<IntPtrT> tmp176;
    TNode<IntPtrT> tmp177;
    ca_.Bind(&block18, &tmp155, &tmp156, &tmp157, &tmp158, &tmp159, &tmp160, &tmp161, &tmp162, &tmp163, &tmp164, &tmp165, &tmp166, &tmp167, &tmp168, &tmp169, &tmp170, &tmp171, &tmp172, &tmp173, &tmp174, &tmp175, &tmp176, &tmp177);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 41);
    ca_.Goto(&block15, tmp155, tmp156, tmp157, tmp158, tmp159, tmp160, tmp161, tmp162, tmp163, tmp164, tmp165, tmp166, tmp167, tmp168, tmp169, tmp170, tmp171, tmp172);
  }

  if (block16.is_used()) {
    TNode<Context> tmp178;
    TNode<FixedArray> tmp179;
    TNode<Smi> tmp180;
    TNode<Smi> tmp181;
    TNode<Smi> tmp182;
    TNode<FixedArray> tmp183;
    TNode<IntPtrT> tmp184;
    TNode<IntPtrT> tmp185;
    TNode<Smi> tmp186;
    TNode<Smi> tmp187;
    TNode<HeapObject> tmp188;
    TNode<IntPtrT> tmp189;
    TNode<FixedArray> tmp190;
    TNode<IntPtrT> tmp191;
    TNode<IntPtrT> tmp192;
    TNode<Smi> tmp193;
    TNode<Smi> tmp194;
    TNode<IntPtrT> tmp195;
    TNode<HeapObject> tmp196;
    TNode<IntPtrT> tmp197;
    TNode<IntPtrT> tmp198;
    TNode<IntPtrT> tmp199;
    TNode<IntPtrT> tmp200;
    TNode<HeapObject> tmp201;
    TNode<IntPtrT> tmp202;
    ca_.Bind(&block16, &tmp178, &tmp179, &tmp180, &tmp181, &tmp182, &tmp183, &tmp184, &tmp185, &tmp186, &tmp187, &tmp188, &tmp189, &tmp190, &tmp191, &tmp192, &tmp193, &tmp194, &tmp195, &tmp196, &tmp197, &tmp198, &tmp199, &tmp200, &tmp201, &tmp202);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 56);
    ca_.Goto(&block14, tmp178, tmp179, tmp180, tmp181, tmp182, tmp183, tmp184, tmp185, tmp186, tmp187, tmp188, tmp189, tmp190, tmp191, tmp192, tmp193, tmp194, tmp195, tmp201, tmp202);
  }

  if (block15.is_used()) {
    TNode<Context> tmp203;
    TNode<FixedArray> tmp204;
    TNode<Smi> tmp205;
    TNode<Smi> tmp206;
    TNode<Smi> tmp207;
    TNode<FixedArray> tmp208;
    TNode<IntPtrT> tmp209;
    TNode<IntPtrT> tmp210;
    TNode<Smi> tmp211;
    TNode<Smi> tmp212;
    TNode<HeapObject> tmp213;
    TNode<IntPtrT> tmp214;
    TNode<FixedArray> tmp215;
    TNode<IntPtrT> tmp216;
    TNode<IntPtrT> tmp217;
    TNode<Smi> tmp218;
    TNode<Smi> tmp219;
    TNode<IntPtrT> tmp220;
    ca_.Bind(&block15, &tmp203, &tmp204, &tmp205, &tmp206, &tmp207, &tmp208, &tmp209, &tmp210, &tmp211, &tmp212, &tmp213, &tmp214, &tmp215, &tmp216, &tmp217, &tmp218, &tmp219, &tmp220);
    CodeStubAssembler(state_).Unreachable();
  }

  if (block14.is_used()) {
    TNode<Context> tmp221;
    TNode<FixedArray> tmp222;
    TNode<Smi> tmp223;
    TNode<Smi> tmp224;
    TNode<Smi> tmp225;
    TNode<FixedArray> tmp226;
    TNode<IntPtrT> tmp227;
    TNode<IntPtrT> tmp228;
    TNode<Smi> tmp229;
    TNode<Smi> tmp230;
    TNode<HeapObject> tmp231;
    TNode<IntPtrT> tmp232;
    TNode<FixedArray> tmp233;
    TNode<IntPtrT> tmp234;
    TNode<IntPtrT> tmp235;
    TNode<Smi> tmp236;
    TNode<Smi> tmp237;
    TNode<IntPtrT> tmp238;
    TNode<HeapObject> tmp239;
    TNode<IntPtrT> tmp240;
    ca_.Bind(&block14, &tmp221, &tmp222, &tmp223, &tmp224, &tmp225, &tmp226, &tmp227, &tmp228, &tmp229, &tmp230, &tmp231, &tmp232, &tmp233, &tmp234, &tmp235, &tmp236, &tmp237, &tmp238, &tmp239, &tmp240);
    ca_.Goto(&block13, tmp221, tmp222, tmp223, tmp224, tmp225, tmp226, tmp227, tmp228, tmp229, tmp230, tmp231, tmp232, tmp233, tmp234, tmp235, tmp236, tmp237, tmp239, tmp240);
  }

  if (block13.is_used()) {
    TNode<Context> tmp241;
    TNode<FixedArray> tmp242;
    TNode<Smi> tmp243;
    TNode<Smi> tmp244;
    TNode<Smi> tmp245;
    TNode<FixedArray> tmp246;
    TNode<IntPtrT> tmp247;
    TNode<IntPtrT> tmp248;
    TNode<Smi> tmp249;
    TNode<Smi> tmp250;
    TNode<HeapObject> tmp251;
    TNode<IntPtrT> tmp252;
    TNode<FixedArray> tmp253;
    TNode<IntPtrT> tmp254;
    TNode<IntPtrT> tmp255;
    TNode<Smi> tmp256;
    TNode<Smi> tmp257;
    TNode<HeapObject> tmp258;
    TNode<IntPtrT> tmp259;
    ca_.Bind(&block13, &tmp241, &tmp242, &tmp243, &tmp244, &tmp245, &tmp246, &tmp247, &tmp248, &tmp249, &tmp250, &tmp251, &tmp252, &tmp253, &tmp254, &tmp255, &tmp256, &tmp257, &tmp258, &tmp259);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 48);
    TNode<Object>tmp260 = CodeStubAssembler(state_).LoadReference<Object>(CodeStubAssembler::Reference{tmp258, tmp259});
    TNode<Smi> tmp261;
    USE(tmp261);
    tmp261 = UnsafeCast5ATSmi_1439(state_, TNode<Context>{tmp241}, TNode<Object>{tmp260});
    TNode<Smi> tmp262;
    USE(tmp262);
    tmp262 = FromConstexpr5ATSmi17ATconstexpr_int31_155(state_, 1);
    TNode<Smi> tmp263;
    USE(tmp263);
    tmp263 = CodeStubAssembler(state_).SmiAdd(TNode<Smi>{tmp261}, TNode<Smi>{tmp262});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 47);
    CodeStubAssembler(state_).StoreReference(CodeStubAssembler::Reference{tmp251, tmp252}, tmp263);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 43);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 42);
    ca_.Goto(&block1, tmp241, tmp242, tmp243);
  }

  if (block1.is_used()) {
    TNode<Context> tmp264;
    TNode<FixedArray> tmp265;
    TNode<Smi> tmp266;
    ca_.Bind(&block1, &tmp264, &tmp265, &tmp266);
    ca_.Goto(&block20, tmp264, tmp265, tmp266);
  }

    TNode<Context> tmp267;
    TNode<FixedArray> tmp268;
    TNode<Smi> tmp269;
    ca_.Bind(&block20, &tmp267, &tmp268, &tmp269);
}

TF_BUILTIN(IncBlockCounter, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  TNode<Context> parameter0 = UncheckedCast<Context>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<JSFunction> parameter1 = UncheckedCast<JSFunction>(Parameter(Descriptor::ParameterIndex<0>()));
  USE(parameter1);
  TNode<Smi> parameter2 = UncheckedCast<Smi>(Parameter(Descriptor::ParameterIndex<1>()));
  USE(parameter2);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, Smi> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, Smi, JSFunction> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, Smi, JSFunction, FixedArray> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, Smi> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, Smi, FixedArray> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, parameter0, parameter1, parameter2);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<JSFunction> tmp1;
    TNode<Smi> tmp2;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 59);
    TNode<FixedArray> tmp3;
    USE(tmp3);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp3 = GetCoverageInfo_309(state_, TNode<Context>{tmp0}, TNode<JSFunction>{tmp1}, &label0);
    ca_.Goto(&block3, tmp0, tmp1, tmp2, tmp1, tmp3);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block4, tmp0, tmp1, tmp2, tmp1);
    }
  }

  if (block4.is_used()) {
    TNode<Context> tmp4;
    TNode<JSFunction> tmp5;
    TNode<Smi> tmp6;
    TNode<JSFunction> tmp7;
    ca_.Bind(&block4, &tmp4, &tmp5, &tmp6, &tmp7);
    ca_.Goto(&block2, tmp4, tmp5, tmp6);
  }

  if (block3.is_used()) {
    TNode<Context> tmp8;
    TNode<JSFunction> tmp9;
    TNode<Smi> tmp10;
    TNode<JSFunction> tmp11;
    TNode<FixedArray> tmp12;
    ca_.Bind(&block3, &tmp8, &tmp9, &tmp10, &tmp11, &tmp12);
    ca_.Goto(&block1, tmp8, tmp9, tmp10, tmp12);
  }

  if (block2.is_used()) {
    TNode<Context> tmp13;
    TNode<JSFunction> tmp14;
    TNode<Smi> tmp15;
    ca_.Bind(&block2, &tmp13, &tmp14, &tmp15);
    TNode<Oddball> tmp16;
    USE(tmp16);
    tmp16 = Undefined_64(state_);
    CodeStubAssembler(state_).Return(tmp16);
  }

  if (block1.is_used()) {
    TNode<Context> tmp17;
    TNode<JSFunction> tmp18;
    TNode<Smi> tmp19;
    TNode<FixedArray> tmp20;
    ca_.Bind(&block1, &tmp17, &tmp18, &tmp19, &tmp20);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 58);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 60);
    IncrementBlockCount_312(state_, TNode<Context>{tmp17}, TNode<FixedArray>{tmp20}, TNode<Smi>{tmp19});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 61);
    TNode<Oddball> tmp21;
    USE(tmp21);
    tmp21 = Undefined_64(state_);
    CodeStubAssembler(state_).Return(tmp21);
  }
}

TNode<FixedArray> UnsafeCast14ATCoverageInfo_1491(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<Object> p_o) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block5(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, FixedArray> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, FixedArray> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_o);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<Object> tmp1;
    ca_.Bind(&block0, &tmp0, &tmp1);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/base.tq", 3001);
    ca_.Goto(&block3, tmp0, tmp1);
  }

  if (block2.is_used()) {
    TNode<Context> tmp2;
    TNode<Object> tmp3;
    ca_.Bind(&block2, &tmp2, &tmp3);
    TNode<BoolT> tmp4;
    USE(tmp4);
    tmp4 = Is14ATCoverageInfo20UT5ATSmi10HeapObject_1554(state_, TNode<Context>{tmp2}, TNode<Object>{tmp3});
    ca_.Branch(tmp4, &block4, &block5, tmp2, tmp3);
  }

  if (block5.is_used()) {
    TNode<Context> tmp5;
    TNode<Object> tmp6;
    ca_.Bind(&block5, &tmp5, &tmp6);
    CodeStubAssembler(state_).FailAssert("Torque assert 'Is<A>(o)' failed", "../../deps/v8/src/builtins/base.tq", 3001);
  }

  if (block4.is_used()) {
    TNode<Context> tmp7;
    TNode<Object> tmp8;
    ca_.Bind(&block4, &tmp7, &tmp8);
  }

  if (block3.is_used()) {
    TNode<Context> tmp9;
    TNode<Object> tmp10;
    ca_.Bind(&block3, &tmp9, &tmp10);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/base.tq", 3002);
    TNode<FixedArray> tmp11;
    USE(tmp11);
    tmp11 = TORQUE_CAST(TNode<Object>{tmp10});
    ca_.Goto(&block1, tmp9, tmp10, tmp11);
  }

  if (block1.is_used()) {
    TNode<Context> tmp12;
    TNode<Object> tmp13;
    TNode<FixedArray> tmp14;
    ca_.Bind(&block1, &tmp12, &tmp13, &tmp14);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/internal-coverage.tq", 28);
    ca_.Goto(&block6, tmp12, tmp13, tmp14);
  }

    TNode<Context> tmp15;
    TNode<Object> tmp16;
    TNode<FixedArray> tmp17;
    ca_.Bind(&block6, &tmp15, &tmp16, &tmp17);
  return TNode<FixedArray>{tmp17};
}

}  // namespace internal
}  // namespace v8

