#include "src/builtins/builtins-array-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-utils-gen.h"
#include "src/builtins/builtins.h"
#include "src/codegen/code-factory.h"
#include "src/heap/factory-inl.h"
#include "src/objects/arguments.h"
#include "src/objects/bigint.h"
#include "src/objects/elements-kind.h"
#include "src/objects/free-space.h"
#include "src/objects/js-generator.h"
#include "src/objects/js-promise.h"
#include "src/objects/js-regexp-string-iterator.h"
#include "src/objects/js-weak-refs.h"
#include "src/objects/objects.h"
#include "src/objects/source-text-module.h"
#include "src/objects/stack-frame-info.h"
#include "src/objects/synthetic-module.h"
#include "src/objects/template-objects.h"
#include "src/builtins/builtins-bigint-gen.h"
#include "src/builtins/builtins-collections-gen.h"
#include "src/builtins/builtins-data-view-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-iterator-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-constructor-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/objects/js-break-iterator.h"
#include "src/objects/js-collator.h"
#include "src/objects/js-number-format.h"
#include "src/objects/js-objects.h"
#include "src/objects/js-plural-rules.h"
#include "src/objects/js-relative-time-format.h"
#include "src/objects/js-date-time-format.h"
#include "src/objects/js-list-format.h"
#include "src/objects/js-locale.h"
#include "src/objects/js-segment-iterator.h"
#include "src/objects/js-segmenter.h"
#include "torque-generated/../../deps/v8/src/builtins/arguments-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-copywithin-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-join-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-lastindexof-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-map-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-right-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reverse-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-shift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-splice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-unshift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/base-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/bigint-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/boolean-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/collections-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/data-view-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/extras-utils-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/frames-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/growable-fixed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/internal-coverage-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/math-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-fromentries-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-constructor-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-delete-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-has-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-is-extensible-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-prevent-extensions-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revocable-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revoke-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/reflect-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-exec-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-all-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-replace-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-search-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-source-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-split-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-test-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-endswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-html-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-pad-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-repeat-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-startswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-substring-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/torque-internal-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-createtypedarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduceright-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-subarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/third_party/v8/builtins/array-sort-tq-csa.h"
#include "torque-generated/../../deps/v8/test/torque/test-torque-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/intl-objects-tq-csa.h"

namespace v8 {
namespace internal {

TF_BUILTIN(ProxyDeleteProperty, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  TNode<Context> parameter0 = UncheckedCast<Context>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<JSProxy> parameter1 = UncheckedCast<JSProxy>(Parameter(Descriptor::ParameterIndex<0>()));
  USE(parameter1);
  TNode<Name> parameter2 = UncheckedCast<Name>(Parameter(Descriptor::ParameterIndex<1>()));
  USE(parameter2);
  TNode<Smi> parameter3 = UncheckedCast<Smi>(Parameter(Descriptor::ParameterIndex<2>()));
  USE(parameter3);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi> block4(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi> block8(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi> block12(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi> block17(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi, BoolT> block21(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi, BoolT> block22(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi, BoolT, BoolT> block23(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi> block20(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi> block19(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi> block18(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi, HeapObject> block25(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi, HeapObject, JSReceiver> block24(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi, JSReceiver, JSReceiver, JSReceiver> block29(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi, JSReceiver, JSReceiver, JSReceiver, JSReceiver> block28(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi, JSReceiver, JSReceiver> block27(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi, JSReceiver, JSReceiver, JSReceiver> block26(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi, JSReceiver, JSReceiver, JSReceiver, Object> block30(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi, JSReceiver, JSReceiver, JSReceiver, Object> block32(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi, JSReceiver, JSReceiver, JSReceiver, Object> block33(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi, JSReceiver, JSReceiver, JSReceiver, Object> block31(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi, Object> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Smi> block14(&ca_, compiler::CodeAssemblerLabel::kDeferred);
    ca_.Goto(&block0, parameter0, parameter1, parameter2, parameter3);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<JSProxy> tmp1;
    TNode<Name> tmp2;
    TNode<Smi> tmp3;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 16);
    CodeStubAssembler(state_).PerformStackCheck(TNode<Context>{tmp0});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 18);
    ca_.Goto(&block2, tmp0, tmp1, tmp2, tmp3);
  }

  if (block1.is_used()) {
    TNode<Context> tmp4;
    TNode<JSProxy> tmp5;
    TNode<Name> tmp6;
    TNode<Smi> tmp7;
    ca_.Bind(&block1, &tmp4, &tmp5, &tmp6, &tmp7);
    TNode<BoolT> tmp8;
    USE(tmp8);
    tmp8 = CodeStubAssembler(state_).TaggedIsNotSmi(TNode<Object>{tmp6});
    ca_.Branch(tmp8, &block3, &block4, tmp4, tmp5, tmp6, tmp7);
  }

  if (block4.is_used()) {
    TNode<Context> tmp9;
    TNode<JSProxy> tmp10;
    TNode<Name> tmp11;
    TNode<Smi> tmp12;
    ca_.Bind(&block4, &tmp9, &tmp10, &tmp11, &tmp12);
    CodeStubAssembler(state_).FailAssert("Torque assert 'TaggedIsNotSmi(name)' failed", "../../deps/v8/src/builtins/proxy-delete-property.tq", 18);
  }

  if (block3.is_used()) {
    TNode<Context> tmp13;
    TNode<JSProxy> tmp14;
    TNode<Name> tmp15;
    TNode<Smi> tmp16;
    ca_.Bind(&block3, &tmp13, &tmp14, &tmp15, &tmp16);
  }

  if (block2.is_used()) {
    TNode<Context> tmp17;
    TNode<JSProxy> tmp18;
    TNode<Name> tmp19;
    TNode<Smi> tmp20;
    ca_.Bind(&block2, &tmp17, &tmp18, &tmp19, &tmp20);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 19);
    ca_.Goto(&block6, tmp17, tmp18, tmp19, tmp20);
  }

  if (block5.is_used()) {
    TNode<Context> tmp21;
    TNode<JSProxy> tmp22;
    TNode<Name> tmp23;
    TNode<Smi> tmp24;
    ca_.Bind(&block5, &tmp21, &tmp22, &tmp23, &tmp24);
    TNode<BoolT> tmp25;
    USE(tmp25);
    tmp25 = CodeStubAssembler(state_).IsName(TNode<HeapObject>{tmp23});
    ca_.Branch(tmp25, &block7, &block8, tmp21, tmp22, tmp23, tmp24);
  }

  if (block8.is_used()) {
    TNode<Context> tmp26;
    TNode<JSProxy> tmp27;
    TNode<Name> tmp28;
    TNode<Smi> tmp29;
    ca_.Bind(&block8, &tmp26, &tmp27, &tmp28, &tmp29);
    CodeStubAssembler(state_).FailAssert("Torque assert 'IsName(name)' failed", "../../deps/v8/src/builtins/proxy-delete-property.tq", 19);
  }

  if (block7.is_used()) {
    TNode<Context> tmp30;
    TNode<JSProxy> tmp31;
    TNode<Name> tmp32;
    TNode<Smi> tmp33;
    ca_.Bind(&block7, &tmp30, &tmp31, &tmp32, &tmp33);
  }

  if (block6.is_used()) {
    TNode<Context> tmp34;
    TNode<JSProxy> tmp35;
    TNode<Name> tmp36;
    TNode<Smi> tmp37;
    ca_.Bind(&block6, &tmp34, &tmp35, &tmp36, &tmp37);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 20);
    ca_.Goto(&block10, tmp34, tmp35, tmp36, tmp37);
  }

  if (block9.is_used()) {
    TNode<Context> tmp38;
    TNode<JSProxy> tmp39;
    TNode<Name> tmp40;
    TNode<Smi> tmp41;
    ca_.Bind(&block9, &tmp38, &tmp39, &tmp40, &tmp41);
    TNode<BoolT> tmp42;
    USE(tmp42);
    tmp42 = CodeStubAssembler(state_).IsPrivateSymbol(TNode<HeapObject>{tmp40});
    TNode<BoolT> tmp43;
    USE(tmp43);
    tmp43 = CodeStubAssembler(state_).Word32BinaryNot(TNode<BoolT>{tmp42});
    ca_.Branch(tmp43, &block11, &block12, tmp38, tmp39, tmp40, tmp41);
  }

  if (block12.is_used()) {
    TNode<Context> tmp44;
    TNode<JSProxy> tmp45;
    TNode<Name> tmp46;
    TNode<Smi> tmp47;
    ca_.Bind(&block12, &tmp44, &tmp45, &tmp46, &tmp47);
    CodeStubAssembler(state_).FailAssert("Torque assert '!IsPrivateSymbol(name)' failed", "../../deps/v8/src/builtins/proxy-delete-property.tq", 20);
  }

  if (block11.is_used()) {
    TNode<Context> tmp48;
    TNode<JSProxy> tmp49;
    TNode<Name> tmp50;
    TNode<Smi> tmp51;
    ca_.Bind(&block11, &tmp48, &tmp49, &tmp50, &tmp51);
  }

  if (block10.is_used()) {
    TNode<Context> tmp52;
    TNode<JSProxy> tmp53;
    TNode<Name> tmp54;
    TNode<Smi> tmp55;
    ca_.Bind(&block10, &tmp52, &tmp53, &tmp54, &tmp55);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 26);
    ca_.Goto(&block18, tmp52, tmp53, tmp54, tmp55);
  }

  if (block17.is_used()) {
    TNode<Context> tmp56;
    TNode<JSProxy> tmp57;
    TNode<Name> tmp58;
    TNode<Smi> tmp59;
    ca_.Bind(&block17, &tmp56, &tmp57, &tmp58, &tmp59);
    TNode<IntPtrT> tmp60 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp60);
    TNode<HeapObject>tmp61 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp57, tmp60});
    TNode<Oddball> tmp62;
    USE(tmp62);
    tmp62 = Null_63(state_);
    TNode<BoolT> tmp63;
    USE(tmp63);
    tmp63 = CodeStubAssembler(state_).TaggedEqual(TNode<HeapObject>{tmp61}, TNode<HeapObject>{tmp62});
    ca_.Branch(tmp63, &block21, &block22, tmp56, tmp57, tmp58, tmp59, tmp63);
  }

  if (block21.is_used()) {
    TNode<Context> tmp64;
    TNode<JSProxy> tmp65;
    TNode<Name> tmp66;
    TNode<Smi> tmp67;
    TNode<BoolT> tmp68;
    ca_.Bind(&block21, &tmp64, &tmp65, &tmp66, &tmp67, &tmp68);
    TNode<BoolT> tmp69;
    USE(tmp69);
    tmp69 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, true);
    ca_.Goto(&block23, tmp64, tmp65, tmp66, tmp67, tmp68, tmp69);
  }

  if (block22.is_used()) {
    TNode<Context> tmp70;
    TNode<JSProxy> tmp71;
    TNode<Name> tmp72;
    TNode<Smi> tmp73;
    TNode<BoolT> tmp74;
    ca_.Bind(&block22, &tmp70, &tmp71, &tmp72, &tmp73, &tmp74);
    TNode<IntPtrT> tmp75 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp75);
    TNode<HeapObject>tmp76 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp71, tmp75});
    TNode<BoolT> tmp77;
    USE(tmp77);
    tmp77 = Is10JSReceiver21UT6ATNull10JSReceiver_1495(state_, TNode<Context>{tmp70}, TNode<HeapObject>{tmp76});
    ca_.Goto(&block23, tmp70, tmp71, tmp72, tmp73, tmp74, tmp77);
  }

  if (block23.is_used()) {
    TNode<Context> tmp78;
    TNode<JSProxy> tmp79;
    TNode<Name> tmp80;
    TNode<Smi> tmp81;
    TNode<BoolT> tmp82;
    TNode<BoolT> tmp83;
    ca_.Bind(&block23, &tmp78, &tmp79, &tmp80, &tmp81, &tmp82, &tmp83);
    ca_.Branch(tmp83, &block19, &block20, tmp78, tmp79, tmp80, tmp81);
  }

  if (block20.is_used()) {
    TNode<Context> tmp84;
    TNode<JSProxy> tmp85;
    TNode<Name> tmp86;
    TNode<Smi> tmp87;
    ca_.Bind(&block20, &tmp84, &tmp85, &tmp86, &tmp87);
    CodeStubAssembler(state_).FailAssert("Torque assert 'proxy.handler == Null || Is<JSReceiver>(proxy.handler)' failed", "../../deps/v8/src/builtins/proxy-delete-property.tq", 26);
  }

  if (block19.is_used()) {
    TNode<Context> tmp88;
    TNode<JSProxy> tmp89;
    TNode<Name> tmp90;
    TNode<Smi> tmp91;
    ca_.Bind(&block19, &tmp88, &tmp89, &tmp90, &tmp91);
  }

  if (block18.is_used()) {
    TNode<Context> tmp92;
    TNode<JSProxy> tmp93;
    TNode<Name> tmp94;
    TNode<Smi> tmp95;
    ca_.Bind(&block18, &tmp92, &tmp93, &tmp94, &tmp95);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 28);
    TNode<IntPtrT> tmp96 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp96);
    TNode<HeapObject>tmp97 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp93, tmp96});
    TNode<JSReceiver> tmp98;
    USE(tmp98);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp98 = Cast10JSReceiver_143(state_, TNode<HeapObject>{tmp97}, &label0);
    ca_.Goto(&block24, tmp92, tmp93, tmp94, tmp95, tmp97, tmp98);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block25, tmp92, tmp93, tmp94, tmp95, tmp97);
    }
  }

  if (block25.is_used()) {
    TNode<Context> tmp99;
    TNode<JSProxy> tmp100;
    TNode<Name> tmp101;
    TNode<Smi> tmp102;
    TNode<HeapObject> tmp103;
    ca_.Bind(&block25, &tmp99, &tmp100, &tmp101, &tmp102, &tmp103);
    ca_.Goto(&block14, tmp99, tmp100, tmp101, tmp102);
  }

  if (block24.is_used()) {
    TNode<Context> tmp104;
    TNode<JSProxy> tmp105;
    TNode<Name> tmp106;
    TNode<Smi> tmp107;
    TNode<HeapObject> tmp108;
    TNode<JSReceiver> tmp109;
    ca_.Bind(&block24, &tmp104, &tmp105, &tmp106, &tmp107, &tmp108, &tmp109);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 31);
    TNode<IntPtrT> tmp110 = ca_.IntPtrConstant(JSProxy::kTargetOffset);
    USE(tmp110);
    TNode<HeapObject>tmp111 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp105, tmp110});
    TNode<JSReceiver> tmp112;
    USE(tmp112);
    tmp112 = UnsafeCast10JSReceiver_1486(state_, TNode<Context>{tmp104}, TNode<Object>{tmp111});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 35);
    TNode<JSReceiver> tmp113;
    USE(tmp113);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp113 = GetMethod_248(state_, TNode<Context>{tmp104}, TNode<Object>{tmp109}, "deleteProperty", &label0);
    ca_.Goto(&block28, tmp104, tmp105, tmp106, tmp107, tmp109, tmp112, tmp109, tmp113);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block29, tmp104, tmp105, tmp106, tmp107, tmp109, tmp112, tmp109);
    }
  }

  if (block29.is_used()) {
    TNode<Context> tmp114;
    TNode<JSProxy> tmp115;
    TNode<Name> tmp116;
    TNode<Smi> tmp117;
    TNode<JSReceiver> tmp118;
    TNode<JSReceiver> tmp119;
    TNode<JSReceiver> tmp120;
    ca_.Bind(&block29, &tmp114, &tmp115, &tmp116, &tmp117, &tmp118, &tmp119, &tmp120);
    ca_.Goto(&block27, tmp114, tmp115, tmp116, tmp117, tmp118, tmp119);
  }

  if (block28.is_used()) {
    TNode<Context> tmp121;
    TNode<JSProxy> tmp122;
    TNode<Name> tmp123;
    TNode<Smi> tmp124;
    TNode<JSReceiver> tmp125;
    TNode<JSReceiver> tmp126;
    TNode<JSReceiver> tmp127;
    TNode<JSReceiver> tmp128;
    ca_.Bind(&block28, &tmp121, &tmp122, &tmp123, &tmp124, &tmp125, &tmp126, &tmp127, &tmp128);
    ca_.Goto(&block26, tmp121, tmp122, tmp123, tmp124, tmp125, tmp126, tmp128);
  }

  if (block27.is_used()) {
    TNode<Context> tmp129;
    TNode<JSProxy> tmp130;
    TNode<Name> tmp131;
    TNode<Smi> tmp132;
    TNode<JSReceiver> tmp133;
    TNode<JSReceiver> tmp134;
    ca_.Bind(&block27, &tmp129, &tmp130, &tmp131, &tmp132, &tmp133, &tmp134);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 36);
    ca_.Goto(&block16, tmp129, tmp130, tmp131, tmp132, tmp134);
  }

  if (block26.is_used()) {
    TNode<Context> tmp135;
    TNode<JSProxy> tmp136;
    TNode<Name> tmp137;
    TNode<Smi> tmp138;
    TNode<JSReceiver> tmp139;
    TNode<JSReceiver> tmp140;
    TNode<JSReceiver> tmp141;
    ca_.Bind(&block26, &tmp135, &tmp136, &tmp137, &tmp138, &tmp139, &tmp140, &tmp141);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 35);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 40);
    TNode<Object> tmp142;
    USE(tmp142);
    tmp142 = CodeStubAssembler(state_).Call(TNode<Context>{tmp135}, TNode<JSReceiver>{tmp141}, TNode<Object>{tmp139}, TNode<Object>{tmp140}, TNode<Object>{tmp137});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 43);
    TNode<BoolT> tmp143;
    USE(tmp143);
    tmp143 = ToBoolean_243(state_, TNode<Object>{tmp142});
    TNode<BoolT> tmp144;
    USE(tmp144);
    tmp144 = CodeStubAssembler(state_).Word32BinaryNot(TNode<BoolT>{tmp143});
    ca_.Branch(tmp144, &block30, &block31, tmp135, tmp136, tmp137, tmp138, tmp139, tmp140, tmp141, tmp142);
  }

  if (block30.is_used()) {
    TNode<Context> tmp145;
    TNode<JSProxy> tmp146;
    TNode<Name> tmp147;
    TNode<Smi> tmp148;
    TNode<JSReceiver> tmp149;
    TNode<JSReceiver> tmp150;
    TNode<JSReceiver> tmp151;
    TNode<Object> tmp152;
    ca_.Bind(&block30, &tmp145, &tmp146, &tmp147, &tmp148, &tmp149, &tmp150, &tmp151, &tmp152);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 44);
    TNode<Smi> tmp153;
    USE(tmp153);
    tmp153 = CodeStubAssembler(state_).SmiConstant(LanguageMode::kStrict);
    TNode<BoolT> tmp154;
    USE(tmp154);
    tmp154 = CodeStubAssembler(state_).SmiEqual(TNode<Smi>{tmp148}, TNode<Smi>{tmp153});
    ca_.Branch(tmp154, &block32, &block33, tmp145, tmp146, tmp147, tmp148, tmp149, tmp150, tmp151, tmp152);
  }

  if (block32.is_used()) {
    TNode<Context> tmp155;
    TNode<JSProxy> tmp156;
    TNode<Name> tmp157;
    TNode<Smi> tmp158;
    TNode<JSReceiver> tmp159;
    TNode<JSReceiver> tmp160;
    TNode<JSReceiver> tmp161;
    TNode<Object> tmp162;
    ca_.Bind(&block32, &tmp155, &tmp156, &tmp157, &tmp158, &tmp159, &tmp160, &tmp161, &tmp162);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 45);
    TNode<Object> tmp163;
    USE(tmp163);
    tmp163 = FromConstexpr20UT5ATSmi10HeapObject18ATconstexpr_string_171(state_, "deleteProperty");
    CodeStubAssembler(state_).ThrowTypeError(TNode<Context>{tmp155}, MessageTemplate::kProxyTrapReturnedFalsishFor, TNode<Object>{tmp163}, TNode<Object>{tmp157});
  }

  if (block33.is_used()) {
    TNode<Context> tmp164;
    TNode<JSProxy> tmp165;
    TNode<Name> tmp166;
    TNode<Smi> tmp167;
    TNode<JSReceiver> tmp168;
    TNode<JSReceiver> tmp169;
    TNode<JSReceiver> tmp170;
    TNode<Object> tmp171;
    ca_.Bind(&block33, &tmp164, &tmp165, &tmp166, &tmp167, &tmp168, &tmp169, &tmp170, &tmp171);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 47);
    TNode<Oddball> tmp172;
    USE(tmp172);
    tmp172 = False_66(state_);
    CodeStubAssembler(state_).Return(tmp172);
  }

  if (block31.is_used()) {
    TNode<Context> tmp173;
    TNode<JSProxy> tmp174;
    TNode<Name> tmp175;
    TNode<Smi> tmp176;
    TNode<JSReceiver> tmp177;
    TNode<JSReceiver> tmp178;
    TNode<JSReceiver> tmp179;
    TNode<Object> tmp180;
    ca_.Bind(&block31, &tmp173, &tmp174, &tmp175, &tmp176, &tmp177, &tmp178, &tmp179, &tmp180);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 56);
    ProxiesCodeStubAssembler(state_).CheckDeleteTrapResult(TNode<Context>{tmp173}, TNode<JSReceiver>{tmp178}, TNode<JSProxy>{tmp174}, TNode<Name>{tmp175});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 59);
    TNode<Oddball> tmp181;
    USE(tmp181);
    tmp181 = True_65(state_);
    CodeStubAssembler(state_).Return(tmp181);
  }

  if (block16.is_used()) {
    TNode<Context> tmp182;
    TNode<JSProxy> tmp183;
    TNode<Name> tmp184;
    TNode<Smi> tmp185;
    TNode<Object> tmp186;
    ca_.Bind(&block16, &tmp182, &tmp183, &tmp184, &tmp185, &tmp186);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 63);
    TNode<Oddball> tmp187;
    tmp187 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kDeleteProperty, tmp182, tmp186, tmp184, tmp185));
    USE(tmp187);
    CodeStubAssembler(state_).Return(tmp187);
  }

  if (block14.is_used()) {
    TNode<Context> tmp188;
    TNode<JSProxy> tmp189;
    TNode<Name> tmp190;
    TNode<Smi> tmp191;
    ca_.Bind(&block14, &tmp188, &tmp189, &tmp190, &tmp191);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 66);
    CodeStubAssembler(state_).ThrowTypeError(TNode<Context>{tmp188}, MessageTemplate::kProxyRevoked, "deleteProperty");
  }
}

TNode<BoolT> Is10JSReceiver21UT6ATNull10JSReceiver_1495(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<HeapObject> p_o) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, HeapObject> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, HeapObject, HeapObject> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, HeapObject, HeapObject, JSReceiver> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, HeapObject> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, HeapObject, JSReceiver> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, HeapObject, BoolT> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, HeapObject, BoolT> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_o);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<HeapObject> tmp1;
    ca_.Bind(&block0, &tmp0, &tmp1);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/base.tq", 2996);
    TNode<JSReceiver> tmp2;
    USE(tmp2);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp2 = Cast10JSReceiver_143(state_, TNode<HeapObject>{tmp1}, &label0);
    ca_.Goto(&block4, tmp0, tmp1, tmp1, tmp2);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block5, tmp0, tmp1, tmp1);
    }
  }

  if (block5.is_used()) {
    TNode<Context> tmp3;
    TNode<HeapObject> tmp4;
    TNode<HeapObject> tmp5;
    ca_.Bind(&block5, &tmp3, &tmp4, &tmp5);
    ca_.Goto(&block3, tmp3, tmp4);
  }

  if (block4.is_used()) {
    TNode<Context> tmp6;
    TNode<HeapObject> tmp7;
    TNode<HeapObject> tmp8;
    TNode<JSReceiver> tmp9;
    ca_.Bind(&block4, &tmp6, &tmp7, &tmp8, &tmp9);
    ca_.Goto(&block2, tmp6, tmp7, tmp9);
  }

  if (block3.is_used()) {
    TNode<Context> tmp10;
    TNode<HeapObject> tmp11;
    ca_.Bind(&block3, &tmp10, &tmp11);
    TNode<BoolT> tmp12;
    USE(tmp12);
    tmp12 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, false);
    ca_.Goto(&block1, tmp10, tmp11, tmp12);
  }

  if (block2.is_used()) {
    TNode<Context> tmp13;
    TNode<HeapObject> tmp14;
    TNode<JSReceiver> tmp15;
    ca_.Bind(&block2, &tmp13, &tmp14, &tmp15);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/base.tq", 2997);
    TNode<BoolT> tmp16;
    USE(tmp16);
    tmp16 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, true);
    ca_.Goto(&block1, tmp13, tmp14, tmp16);
  }

  if (block1.is_used()) {
    TNode<Context> tmp17;
    TNode<HeapObject> tmp18;
    TNode<BoolT> tmp19;
    ca_.Bind(&block1, &tmp17, &tmp18, &tmp19);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-delete-property.tq", 26);
    ca_.Goto(&block6, tmp17, tmp18, tmp19);
  }

    TNode<Context> tmp20;
    TNode<HeapObject> tmp21;
    TNode<BoolT> tmp22;
    ca_.Bind(&block6, &tmp20, &tmp21, &tmp22);
  return TNode<BoolT>{tmp22};
}

}  // namespace internal
}  // namespace v8

