#include "src/builtins/builtins-array-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-utils-gen.h"
#include "src/builtins/builtins.h"
#include "src/codegen/code-factory.h"
#include "src/heap/factory-inl.h"
#include "src/objects/arguments.h"
#include "src/objects/bigint.h"
#include "src/objects/elements-kind.h"
#include "src/objects/free-space.h"
#include "src/objects/js-generator.h"
#include "src/objects/js-promise.h"
#include "src/objects/js-regexp-string-iterator.h"
#include "src/objects/js-weak-refs.h"
#include "src/objects/objects.h"
#include "src/objects/source-text-module.h"
#include "src/objects/stack-frame-info.h"
#include "src/objects/synthetic-module.h"
#include "src/objects/template-objects.h"
#include "src/builtins/builtins-bigint-gen.h"
#include "src/builtins/builtins-collections-gen.h"
#include "src/builtins/builtins-data-view-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-iterator-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-constructor-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/objects/js-break-iterator.h"
#include "src/objects/js-collator.h"
#include "src/objects/js-number-format.h"
#include "src/objects/js-objects.h"
#include "src/objects/js-plural-rules.h"
#include "src/objects/js-relative-time-format.h"
#include "src/objects/js-date-time-format.h"
#include "src/objects/js-list-format.h"
#include "src/objects/js-locale.h"
#include "src/objects/js-segment-iterator.h"
#include "src/objects/js-segmenter.h"
#include "torque-generated/../../deps/v8/src/builtins/arguments-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-copywithin-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-join-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-lastindexof-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-map-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-right-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reverse-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-shift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-splice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-unshift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/base-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/bigint-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/boolean-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/collections-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/data-view-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/extras-utils-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/frames-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/growable-fixed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/internal-coverage-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/math-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-fromentries-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-constructor-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-delete-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-has-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-is-extensible-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-prevent-extensions-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revocable-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revoke-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/reflect-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-exec-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-all-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-replace-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-search-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-source-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-split-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-test-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-endswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-html-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-pad-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-repeat-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-startswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-substring-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/torque-internal-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-createtypedarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduceright-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-subarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/third_party/v8/builtins/array-sort-tq-csa.h"
#include "torque-generated/../../deps/v8/test/torque/test-torque-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/intl-objects-tq-csa.h"

namespace v8 {
namespace internal {

TF_BUILTIN(ProxyGetPrototypeOf, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  TNode<Context> parameter0 = UncheckedCast<Context>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<JSProxy> parameter1 = UncheckedCast<JSProxy>(Parameter(Descriptor::ParameterIndex<0>()));
  USE(parameter1);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, BoolT> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, BoolT> block12(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, BoolT, BoolT> block13(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy> block10(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject> block15(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, JSReceiver> block14(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver> block19(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, JSReceiver> block18(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject> block17(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, Object, BoolT> block22(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, Object, BoolT> block23(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, Object, BoolT, BoolT> block24(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, Object> block20(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, Object> block21(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, Object, Object> block25(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, Object, Object, BoolT> block29(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, Object, Object, BoolT> block30(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, Object, Object, BoolT, BoolT> block31(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, Object, Object> block28(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, Object, Object> block27(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, Object, Object> block26(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, Object, Object> block32(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, Object, Object> block33(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, Object, Object, Object> block34(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, Object, Object, Object> block35(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Object> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy> block4(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy> block2(&ca_, compiler::CodeAssemblerLabel::kDeferred);
    ca_.Goto(&block0, parameter0, parameter1);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<JSProxy> tmp1;
    ca_.Bind(&block0, &tmp0, &tmp1);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 13);
    CodeStubAssembler(state_).PerformStackCheck(TNode<Context>{tmp0});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 19);
    ca_.Goto(&block8, tmp0, tmp1);
  }

  if (block7.is_used()) {
    TNode<Context> tmp2;
    TNode<JSProxy> tmp3;
    ca_.Bind(&block7, &tmp2, &tmp3);
    TNode<IntPtrT> tmp4 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp4);
    TNode<HeapObject>tmp5 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp3, tmp4});
    TNode<Oddball> tmp6;
    USE(tmp6);
    tmp6 = Null_63(state_);
    TNode<BoolT> tmp7;
    USE(tmp7);
    tmp7 = CodeStubAssembler(state_).TaggedEqual(TNode<HeapObject>{tmp5}, TNode<HeapObject>{tmp6});
    ca_.Branch(tmp7, &block11, &block12, tmp2, tmp3, tmp7);
  }

  if (block11.is_used()) {
    TNode<Context> tmp8;
    TNode<JSProxy> tmp9;
    TNode<BoolT> tmp10;
    ca_.Bind(&block11, &tmp8, &tmp9, &tmp10);
    TNode<BoolT> tmp11;
    USE(tmp11);
    tmp11 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, true);
    ca_.Goto(&block13, tmp8, tmp9, tmp10, tmp11);
  }

  if (block12.is_used()) {
    TNode<Context> tmp12;
    TNode<JSProxy> tmp13;
    TNode<BoolT> tmp14;
    ca_.Bind(&block12, &tmp12, &tmp13, &tmp14);
    TNode<IntPtrT> tmp15 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp15);
    TNode<HeapObject>tmp16 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp13, tmp15});
    TNode<BoolT> tmp17;
    USE(tmp17);
    tmp17 = Is10JSReceiver21UT6ATNull10JSReceiver_1495(state_, TNode<Context>{tmp12}, TNode<HeapObject>{tmp16});
    ca_.Goto(&block13, tmp12, tmp13, tmp14, tmp17);
  }

  if (block13.is_used()) {
    TNode<Context> tmp18;
    TNode<JSProxy> tmp19;
    TNode<BoolT> tmp20;
    TNode<BoolT> tmp21;
    ca_.Bind(&block13, &tmp18, &tmp19, &tmp20, &tmp21);
    ca_.Branch(tmp21, &block9, &block10, tmp18, tmp19);
  }

  if (block10.is_used()) {
    TNode<Context> tmp22;
    TNode<JSProxy> tmp23;
    ca_.Bind(&block10, &tmp22, &tmp23);
    CodeStubAssembler(state_).FailAssert("Torque assert 'proxy.handler == Null || Is<JSReceiver>(proxy.handler)' failed", "../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 19);
  }

  if (block9.is_used()) {
    TNode<Context> tmp24;
    TNode<JSProxy> tmp25;
    ca_.Bind(&block9, &tmp24, &tmp25);
  }

  if (block8.is_used()) {
    TNode<Context> tmp26;
    TNode<JSProxy> tmp27;
    ca_.Bind(&block8, &tmp26, &tmp27);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 21);
    TNode<IntPtrT> tmp28 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp28);
    TNode<HeapObject>tmp29 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp27, tmp28});
    TNode<JSReceiver> tmp30;
    USE(tmp30);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp30 = Cast10JSReceiver_143(state_, TNode<HeapObject>{tmp29}, &label0);
    ca_.Goto(&block14, tmp26, tmp27, tmp29, tmp30);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block15, tmp26, tmp27, tmp29);
    }
  }

  if (block15.is_used()) {
    TNode<Context> tmp31;
    TNode<JSProxy> tmp32;
    TNode<HeapObject> tmp33;
    ca_.Bind(&block15, &tmp31, &tmp32, &tmp33);
    ca_.Goto(&block4, tmp31, tmp32);
  }

  if (block14.is_used()) {
    TNode<Context> tmp34;
    TNode<JSProxy> tmp35;
    TNode<HeapObject> tmp36;
    TNode<JSReceiver> tmp37;
    ca_.Bind(&block14, &tmp34, &tmp35, &tmp36, &tmp37);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 24);
    TNode<IntPtrT> tmp38 = ca_.IntPtrConstant(JSProxy::kTargetOffset);
    USE(tmp38);
    TNode<HeapObject>tmp39 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp35, tmp38});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 28);
    TNode<JSReceiver> tmp40;
    USE(tmp40);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp40 = GetMethod_248(state_, TNode<Context>{tmp34}, TNode<Object>{tmp37}, "getPrototypeOf", &label0);
    ca_.Goto(&block18, tmp34, tmp35, tmp37, tmp39, tmp37, tmp40);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block19, tmp34, tmp35, tmp37, tmp39, tmp37);
    }
  }

  if (block19.is_used()) {
    TNode<Context> tmp41;
    TNode<JSProxy> tmp42;
    TNode<JSReceiver> tmp43;
    TNode<HeapObject> tmp44;
    TNode<JSReceiver> tmp45;
    ca_.Bind(&block19, &tmp41, &tmp42, &tmp43, &tmp44, &tmp45);
    ca_.Goto(&block17, tmp41, tmp42, tmp43, tmp44);
  }

  if (block18.is_used()) {
    TNode<Context> tmp46;
    TNode<JSProxy> tmp47;
    TNode<JSReceiver> tmp48;
    TNode<HeapObject> tmp49;
    TNode<JSReceiver> tmp50;
    TNode<JSReceiver> tmp51;
    ca_.Bind(&block18, &tmp46, &tmp47, &tmp48, &tmp49, &tmp50, &tmp51);
    ca_.Goto(&block16, tmp46, tmp47, tmp48, tmp49, tmp51);
  }

  if (block17.is_used()) {
    TNode<Context> tmp52;
    TNode<JSProxy> tmp53;
    TNode<JSReceiver> tmp54;
    TNode<HeapObject> tmp55;
    ca_.Bind(&block17, &tmp52, &tmp53, &tmp54, &tmp55);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 29);
    ca_.Goto(&block6, tmp52, tmp53, tmp55);
  }

  if (block16.is_used()) {
    TNode<Context> tmp56;
    TNode<JSProxy> tmp57;
    TNode<JSReceiver> tmp58;
    TNode<HeapObject> tmp59;
    TNode<JSReceiver> tmp60;
    ca_.Bind(&block16, &tmp56, &tmp57, &tmp58, &tmp59, &tmp60);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 28);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 32);
    TNode<Object> tmp61;
    USE(tmp61);
    tmp61 = CodeStubAssembler(state_).Call(TNode<Context>{tmp56}, TNode<JSReceiver>{tmp60}, TNode<Object>{tmp58}, TNode<Object>{tmp59});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 36);
    TNode<BoolT> tmp62;
    USE(tmp62);
    tmp62 = Is10JSReceiver90UT8ATBigInt7ATFalse6ATNull5ATSmi6ATTrue11ATUndefined10HeapNumber10JSReceiver6String6Symbol_1493(state_, TNode<Context>{tmp56}, TNode<Object>{tmp61});
    TNode<BoolT> tmp63;
    USE(tmp63);
    tmp63 = CodeStubAssembler(state_).Word32BinaryNot(TNode<BoolT>{tmp62});
    ca_.Branch(tmp63, &block22, &block23, tmp56, tmp57, tmp58, tmp59, tmp60, tmp61, tmp63);
  }

  if (block22.is_used()) {
    TNode<Context> tmp64;
    TNode<JSProxy> tmp65;
    TNode<JSReceiver> tmp66;
    TNode<HeapObject> tmp67;
    TNode<JSReceiver> tmp68;
    TNode<Object> tmp69;
    TNode<BoolT> tmp70;
    ca_.Bind(&block22, &tmp64, &tmp65, &tmp66, &tmp67, &tmp68, &tmp69, &tmp70);
    TNode<Oddball> tmp71;
    USE(tmp71);
    tmp71 = Null_63(state_);
    TNode<BoolT> tmp72;
    USE(tmp72);
    tmp72 = CodeStubAssembler(state_).TaggedNotEqual(TNode<Object>{tmp69}, TNode<HeapObject>{tmp71});
    ca_.Goto(&block24, tmp64, tmp65, tmp66, tmp67, tmp68, tmp69, tmp70, tmp72);
  }

  if (block23.is_used()) {
    TNode<Context> tmp73;
    TNode<JSProxy> tmp74;
    TNode<JSReceiver> tmp75;
    TNode<HeapObject> tmp76;
    TNode<JSReceiver> tmp77;
    TNode<Object> tmp78;
    TNode<BoolT> tmp79;
    ca_.Bind(&block23, &tmp73, &tmp74, &tmp75, &tmp76, &tmp77, &tmp78, &tmp79);
    TNode<BoolT> tmp80;
    USE(tmp80);
    tmp80 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, false);
    ca_.Goto(&block24, tmp73, tmp74, tmp75, tmp76, tmp77, tmp78, tmp79, tmp80);
  }

  if (block24.is_used()) {
    TNode<Context> tmp81;
    TNode<JSProxy> tmp82;
    TNode<JSReceiver> tmp83;
    TNode<HeapObject> tmp84;
    TNode<JSReceiver> tmp85;
    TNode<Object> tmp86;
    TNode<BoolT> tmp87;
    TNode<BoolT> tmp88;
    ca_.Bind(&block24, &tmp81, &tmp82, &tmp83, &tmp84, &tmp85, &tmp86, &tmp87, &tmp88);
    ca_.Branch(tmp88, &block20, &block21, tmp81, tmp82, tmp83, tmp84, tmp85, tmp86);
  }

  if (block20.is_used()) {
    TNode<Context> tmp89;
    TNode<JSProxy> tmp90;
    TNode<JSReceiver> tmp91;
    TNode<HeapObject> tmp92;
    TNode<JSReceiver> tmp93;
    TNode<Object> tmp94;
    ca_.Bind(&block20, &tmp89, &tmp90, &tmp91, &tmp92, &tmp93, &tmp94);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 37);
    ca_.Goto(&block2, tmp89, tmp90);
  }

  if (block21.is_used()) {
    TNode<Context> tmp95;
    TNode<JSProxy> tmp96;
    TNode<JSReceiver> tmp97;
    TNode<HeapObject> tmp98;
    TNode<JSReceiver> tmp99;
    TNode<Object> tmp100;
    ca_.Bind(&block21, &tmp95, &tmp96, &tmp97, &tmp98, &tmp99, &tmp100);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 42);
    TNode<Object> tmp101;
    USE(tmp101);
    tmp101 = ObjectIsExtensible_314(state_, TNode<Context>{tmp95}, TNode<Object>{tmp98});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 43);
    ca_.Goto(&block26, tmp95, tmp96, tmp97, tmp98, tmp99, tmp100, tmp101);
  }

  if (block25.is_used()) {
    TNode<Context> tmp102;
    TNode<JSProxy> tmp103;
    TNode<JSReceiver> tmp104;
    TNode<HeapObject> tmp105;
    TNode<JSReceiver> tmp106;
    TNode<Object> tmp107;
    TNode<Object> tmp108;
    ca_.Bind(&block25, &tmp102, &tmp103, &tmp104, &tmp105, &tmp106, &tmp107, &tmp108);
    TNode<Oddball> tmp109;
    USE(tmp109);
    tmp109 = True_65(state_);
    TNode<BoolT> tmp110;
    USE(tmp110);
    tmp110 = CodeStubAssembler(state_).TaggedEqual(TNode<Object>{tmp108}, TNode<HeapObject>{tmp109});
    ca_.Branch(tmp110, &block29, &block30, tmp102, tmp103, tmp104, tmp105, tmp106, tmp107, tmp108, tmp110);
  }

  if (block29.is_used()) {
    TNode<Context> tmp111;
    TNode<JSProxy> tmp112;
    TNode<JSReceiver> tmp113;
    TNode<HeapObject> tmp114;
    TNode<JSReceiver> tmp115;
    TNode<Object> tmp116;
    TNode<Object> tmp117;
    TNode<BoolT> tmp118;
    ca_.Bind(&block29, &tmp111, &tmp112, &tmp113, &tmp114, &tmp115, &tmp116, &tmp117, &tmp118);
    TNode<BoolT> tmp119;
    USE(tmp119);
    tmp119 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, true);
    ca_.Goto(&block31, tmp111, tmp112, tmp113, tmp114, tmp115, tmp116, tmp117, tmp118, tmp119);
  }

  if (block30.is_used()) {
    TNode<Context> tmp120;
    TNode<JSProxy> tmp121;
    TNode<JSReceiver> tmp122;
    TNode<HeapObject> tmp123;
    TNode<JSReceiver> tmp124;
    TNode<Object> tmp125;
    TNode<Object> tmp126;
    TNode<BoolT> tmp127;
    ca_.Bind(&block30, &tmp120, &tmp121, &tmp122, &tmp123, &tmp124, &tmp125, &tmp126, &tmp127);
    TNode<Oddball> tmp128;
    USE(tmp128);
    tmp128 = False_66(state_);
    TNode<BoolT> tmp129;
    USE(tmp129);
    tmp129 = CodeStubAssembler(state_).TaggedEqual(TNode<Object>{tmp126}, TNode<HeapObject>{tmp128});
    ca_.Goto(&block31, tmp120, tmp121, tmp122, tmp123, tmp124, tmp125, tmp126, tmp127, tmp129);
  }

  if (block31.is_used()) {
    TNode<Context> tmp130;
    TNode<JSProxy> tmp131;
    TNode<JSReceiver> tmp132;
    TNode<HeapObject> tmp133;
    TNode<JSReceiver> tmp134;
    TNode<Object> tmp135;
    TNode<Object> tmp136;
    TNode<BoolT> tmp137;
    TNode<BoolT> tmp138;
    ca_.Bind(&block31, &tmp130, &tmp131, &tmp132, &tmp133, &tmp134, &tmp135, &tmp136, &tmp137, &tmp138);
    ca_.Branch(tmp138, &block27, &block28, tmp130, tmp131, tmp132, tmp133, tmp134, tmp135, tmp136);
  }

  if (block28.is_used()) {
    TNode<Context> tmp139;
    TNode<JSProxy> tmp140;
    TNode<JSReceiver> tmp141;
    TNode<HeapObject> tmp142;
    TNode<JSReceiver> tmp143;
    TNode<Object> tmp144;
    TNode<Object> tmp145;
    ca_.Bind(&block28, &tmp139, &tmp140, &tmp141, &tmp142, &tmp143, &tmp144, &tmp145);
    CodeStubAssembler(state_).FailAssert("Torque assert 'extensibleTarget == True || extensibleTarget == False' failed", "../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 43);
  }

  if (block27.is_used()) {
    TNode<Context> tmp146;
    TNode<JSProxy> tmp147;
    TNode<JSReceiver> tmp148;
    TNode<HeapObject> tmp149;
    TNode<JSReceiver> tmp150;
    TNode<Object> tmp151;
    TNode<Object> tmp152;
    ca_.Bind(&block27, &tmp146, &tmp147, &tmp148, &tmp149, &tmp150, &tmp151, &tmp152);
  }

  if (block26.is_used()) {
    TNode<Context> tmp153;
    TNode<JSProxy> tmp154;
    TNode<JSReceiver> tmp155;
    TNode<HeapObject> tmp156;
    TNode<JSReceiver> tmp157;
    TNode<Object> tmp158;
    TNode<Object> tmp159;
    ca_.Bind(&block26, &tmp153, &tmp154, &tmp155, &tmp156, &tmp157, &tmp158, &tmp159);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 44);
    TNode<Oddball> tmp160;
    USE(tmp160);
    tmp160 = True_65(state_);
    TNode<BoolT> tmp161;
    USE(tmp161);
    tmp161 = CodeStubAssembler(state_).TaggedEqual(TNode<Object>{tmp159}, TNode<HeapObject>{tmp160});
    ca_.Branch(tmp161, &block32, &block33, tmp153, tmp154, tmp155, tmp156, tmp157, tmp158, tmp159);
  }

  if (block32.is_used()) {
    TNode<Context> tmp162;
    TNode<JSProxy> tmp163;
    TNode<JSReceiver> tmp164;
    TNode<HeapObject> tmp165;
    TNode<JSReceiver> tmp166;
    TNode<Object> tmp167;
    TNode<Object> tmp168;
    ca_.Bind(&block32, &tmp162, &tmp163, &tmp164, &tmp165, &tmp166, &tmp167, &tmp168);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 45);
    CodeStubAssembler(state_).Return(tmp167);
  }

  if (block33.is_used()) {
    TNode<Context> tmp169;
    TNode<JSProxy> tmp170;
    TNode<JSReceiver> tmp171;
    TNode<HeapObject> tmp172;
    TNode<JSReceiver> tmp173;
    TNode<Object> tmp174;
    TNode<Object> tmp175;
    ca_.Bind(&block33, &tmp169, &tmp170, &tmp171, &tmp172, &tmp173, &tmp174, &tmp175);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 49);
    TNode<Object> tmp176;
    USE(tmp176);
    tmp176 = ObjectGetPrototypeOf_317(state_, TNode<Context>{tmp169}, TNode<Object>{tmp172});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 54);
    TNode<BoolT> tmp177;
    USE(tmp177);
    tmp177 = SameValue_245(state_, TNode<Object>{tmp176}, TNode<Object>{tmp174});
    ca_.Branch(tmp177, &block34, &block35, tmp169, tmp170, tmp171, tmp172, tmp173, tmp174, tmp175, tmp176);
  }

  if (block34.is_used()) {
    TNode<Context> tmp178;
    TNode<JSProxy> tmp179;
    TNode<JSReceiver> tmp180;
    TNode<HeapObject> tmp181;
    TNode<JSReceiver> tmp182;
    TNode<Object> tmp183;
    TNode<Object> tmp184;
    TNode<Object> tmp185;
    ca_.Bind(&block34, &tmp178, &tmp179, &tmp180, &tmp181, &tmp182, &tmp183, &tmp184, &tmp185);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 55);
    CodeStubAssembler(state_).Return(tmp183);
  }

  if (block35.is_used()) {
    TNode<Context> tmp186;
    TNode<JSProxy> tmp187;
    TNode<JSReceiver> tmp188;
    TNode<HeapObject> tmp189;
    TNode<JSReceiver> tmp190;
    TNode<Object> tmp191;
    TNode<Object> tmp192;
    TNode<Object> tmp193;
    ca_.Bind(&block35, &tmp186, &tmp187, &tmp188, &tmp189, &tmp190, &tmp191, &tmp192, &tmp193);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 57);
    CodeStubAssembler(state_).ThrowTypeError(TNode<Context>{tmp186}, MessageTemplate::kProxyGetPrototypeOfNonExtensible);
  }

  if (block6.is_used()) {
    TNode<Context> tmp194;
    TNode<JSProxy> tmp195;
    TNode<Object> tmp196;
    ca_.Bind(&block6, &tmp194, &tmp195, &tmp196);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 61);
    TNode<Object> tmp197;
    USE(tmp197);
    tmp197 = ObjectGetPrototypeOf_317(state_, TNode<Context>{tmp194}, TNode<Object>{tmp196});
    CodeStubAssembler(state_).Return(tmp197);
  }

  if (block4.is_used()) {
    TNode<Context> tmp198;
    TNode<JSProxy> tmp199;
    ca_.Bind(&block4, &tmp198, &tmp199);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 64);
    CodeStubAssembler(state_).ThrowTypeError(TNode<Context>{tmp198}, MessageTemplate::kProxyRevoked, "getPrototypeOf");
  }

  if (block2.is_used()) {
    TNode<Context> tmp200;
    TNode<JSProxy> tmp201;
    ca_.Bind(&block2, &tmp200, &tmp201);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-prototype-of.tq", 67);
    CodeStubAssembler(state_).ThrowTypeError(TNode<Context>{tmp200}, MessageTemplate::kProxyGetPrototypeOfInvalid);
  }
}

}  // namespace internal
}  // namespace v8

