#include "src/builtins/builtins-array-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-utils-gen.h"
#include "src/builtins/builtins.h"
#include "src/codegen/code-factory.h"
#include "src/heap/factory-inl.h"
#include "src/objects/arguments.h"
#include "src/objects/bigint.h"
#include "src/objects/elements-kind.h"
#include "src/objects/free-space.h"
#include "src/objects/js-generator.h"
#include "src/objects/js-promise.h"
#include "src/objects/js-regexp-string-iterator.h"
#include "src/objects/js-weak-refs.h"
#include "src/objects/objects.h"
#include "src/objects/source-text-module.h"
#include "src/objects/stack-frame-info.h"
#include "src/objects/synthetic-module.h"
#include "src/objects/template-objects.h"
#include "src/builtins/builtins-bigint-gen.h"
#include "src/builtins/builtins-collections-gen.h"
#include "src/builtins/builtins-data-view-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-iterator-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-constructor-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/objects/js-break-iterator.h"
#include "src/objects/js-collator.h"
#include "src/objects/js-number-format.h"
#include "src/objects/js-objects.h"
#include "src/objects/js-plural-rules.h"
#include "src/objects/js-relative-time-format.h"
#include "src/objects/js-date-time-format.h"
#include "src/objects/js-list-format.h"
#include "src/objects/js-locale.h"
#include "src/objects/js-segment-iterator.h"
#include "src/objects/js-segmenter.h"
#include "torque-generated/../../deps/v8/src/builtins/arguments-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-copywithin-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-join-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-lastindexof-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-map-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-right-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reverse-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-shift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-splice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-unshift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/base-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/bigint-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/boolean-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/collections-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/data-view-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/extras-utils-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/frames-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/growable-fixed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/internal-coverage-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/math-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-fromentries-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-constructor-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-delete-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-has-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-is-extensible-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-prevent-extensions-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revocable-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revoke-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/reflect-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-exec-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-all-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-replace-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-search-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-source-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-split-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-test-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-endswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-html-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-pad-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-repeat-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-startswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-substring-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/torque-internal-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-createtypedarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduceright-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-subarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/third_party/v8/builtins/array-sort-tq-csa.h"
#include "torque-generated/../../deps/v8/test/torque/test-torque-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/intl-objects-tq-csa.h"

namespace v8 {
namespace internal {

TF_BUILTIN(ProxyHasProperty, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  TNode<Context> parameter0 = UncheckedCast<Context>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<JSProxy> parameter1 = UncheckedCast<JSProxy>(Parameter(Descriptor::ParameterIndex<0>()));
  USE(parameter1);
  TNode<Name> parameter2 = UncheckedCast<Name>(Parameter(Descriptor::ParameterIndex<1>()));
  USE(parameter2);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name> block4(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name> block8(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name> block12(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name> block17(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, BoolT> block21(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, BoolT> block22(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, BoolT, BoolT> block23(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name> block20(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name> block19(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name> block18(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, HeapObject> block25(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, HeapObject, JSReceiver> block24(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, JSReceiver, HeapObject> block29(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, JSReceiver, HeapObject, JSReceiver> block28(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, JSReceiver> block27(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, JSReceiver, JSReceiver> block26(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, JSReceiver, JSReceiver, JSReceiver> block33(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, JSReceiver, JSReceiver, JSReceiver, JSReceiver> block32(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, JSReceiver, JSReceiver> block31(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, JSReceiver, JSReceiver, JSReceiver> block30(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, JSReceiver, JSReceiver, JSReceiver, Object> block34(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, JSReceiver, JSReceiver, JSReceiver, Object> block35(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name> block14(&ca_, compiler::CodeAssemblerLabel::kDeferred);
    ca_.Goto(&block0, parameter0, parameter1, parameter2);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<JSProxy> tmp1;
    TNode<Name> tmp2;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-has-property.tq", 13);
    ca_.Goto(&block2, tmp0, tmp1, tmp2);
  }

  if (block1.is_used()) {
    TNode<Context> tmp3;
    TNode<JSProxy> tmp4;
    TNode<Name> tmp5;
    ca_.Bind(&block1, &tmp3, &tmp4, &tmp5);
    TNode<BoolT> tmp6;
    USE(tmp6);
    tmp6 = CodeStubAssembler(state_).IsJSProxy(TNode<HeapObject>{tmp4});
    ca_.Branch(tmp6, &block3, &block4, tmp3, tmp4, tmp5);
  }

  if (block4.is_used()) {
    TNode<Context> tmp7;
    TNode<JSProxy> tmp8;
    TNode<Name> tmp9;
    ca_.Bind(&block4, &tmp7, &tmp8, &tmp9);
    CodeStubAssembler(state_).FailAssert("Torque assert 'IsJSProxy(proxy)' failed", "../../deps/v8/src/builtins/proxy-has-property.tq", 13);
  }

  if (block3.is_used()) {
    TNode<Context> tmp10;
    TNode<JSProxy> tmp11;
    TNode<Name> tmp12;
    ca_.Bind(&block3, &tmp10, &tmp11, &tmp12);
  }

  if (block2.is_used()) {
    TNode<Context> tmp13;
    TNode<JSProxy> tmp14;
    TNode<Name> tmp15;
    ca_.Bind(&block2, &tmp13, &tmp14, &tmp15);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-has-property.tq", 15);
    CodeStubAssembler(state_).PerformStackCheck(TNode<Context>{tmp13});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-has-property.tq", 18);
    ca_.Goto(&block6, tmp13, tmp14, tmp15);
  }

  if (block5.is_used()) {
    TNode<Context> tmp16;
    TNode<JSProxy> tmp17;
    TNode<Name> tmp18;
    ca_.Bind(&block5, &tmp16, &tmp17, &tmp18);
    TNode<BoolT> tmp19;
    USE(tmp19);
    tmp19 = CodeStubAssembler(state_).IsName(TNode<HeapObject>{tmp18});
    ca_.Branch(tmp19, &block7, &block8, tmp16, tmp17, tmp18);
  }

  if (block8.is_used()) {
    TNode<Context> tmp20;
    TNode<JSProxy> tmp21;
    TNode<Name> tmp22;
    ca_.Bind(&block8, &tmp20, &tmp21, &tmp22);
    CodeStubAssembler(state_).FailAssert("Torque assert 'IsName(name)' failed", "../../deps/v8/src/builtins/proxy-has-property.tq", 18);
  }

  if (block7.is_used()) {
    TNode<Context> tmp23;
    TNode<JSProxy> tmp24;
    TNode<Name> tmp25;
    ca_.Bind(&block7, &tmp23, &tmp24, &tmp25);
  }

  if (block6.is_used()) {
    TNode<Context> tmp26;
    TNode<JSProxy> tmp27;
    TNode<Name> tmp28;
    ca_.Bind(&block6, &tmp26, &tmp27, &tmp28);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-has-property.tq", 19);
    ca_.Goto(&block10, tmp26, tmp27, tmp28);
  }

  if (block9.is_used()) {
    TNode<Context> tmp29;
    TNode<JSProxy> tmp30;
    TNode<Name> tmp31;
    ca_.Bind(&block9, &tmp29, &tmp30, &tmp31);
    TNode<BoolT> tmp32;
    USE(tmp32);
    tmp32 = CodeStubAssembler(state_).IsPrivateSymbol(TNode<HeapObject>{tmp31});
    TNode<BoolT> tmp33;
    USE(tmp33);
    tmp33 = CodeStubAssembler(state_).Word32BinaryNot(TNode<BoolT>{tmp32});
    ca_.Branch(tmp33, &block11, &block12, tmp29, tmp30, tmp31);
  }

  if (block12.is_used()) {
    TNode<Context> tmp34;
    TNode<JSProxy> tmp35;
    TNode<Name> tmp36;
    ca_.Bind(&block12, &tmp34, &tmp35, &tmp36);
    CodeStubAssembler(state_).FailAssert("Torque assert '!IsPrivateSymbol(name)' failed", "../../deps/v8/src/builtins/proxy-has-property.tq", 19);
  }

  if (block11.is_used()) {
    TNode<Context> tmp37;
    TNode<JSProxy> tmp38;
    TNode<Name> tmp39;
    ca_.Bind(&block11, &tmp37, &tmp38, &tmp39);
  }

  if (block10.is_used()) {
    TNode<Context> tmp40;
    TNode<JSProxy> tmp41;
    TNode<Name> tmp42;
    ca_.Bind(&block10, &tmp40, &tmp41, &tmp42);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-has-property.tq", 25);
    ca_.Goto(&block18, tmp40, tmp41, tmp42);
  }

  if (block17.is_used()) {
    TNode<Context> tmp43;
    TNode<JSProxy> tmp44;
    TNode<Name> tmp45;
    ca_.Bind(&block17, &tmp43, &tmp44, &tmp45);
    TNode<IntPtrT> tmp46 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp46);
    TNode<HeapObject>tmp47 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp44, tmp46});
    TNode<Oddball> tmp48;
    USE(tmp48);
    tmp48 = Null_63(state_);
    TNode<BoolT> tmp49;
    USE(tmp49);
    tmp49 = CodeStubAssembler(state_).TaggedEqual(TNode<HeapObject>{tmp47}, TNode<HeapObject>{tmp48});
    ca_.Branch(tmp49, &block21, &block22, tmp43, tmp44, tmp45, tmp49);
  }

  if (block21.is_used()) {
    TNode<Context> tmp50;
    TNode<JSProxy> tmp51;
    TNode<Name> tmp52;
    TNode<BoolT> tmp53;
    ca_.Bind(&block21, &tmp50, &tmp51, &tmp52, &tmp53);
    TNode<BoolT> tmp54;
    USE(tmp54);
    tmp54 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, true);
    ca_.Goto(&block23, tmp50, tmp51, tmp52, tmp53, tmp54);
  }

  if (block22.is_used()) {
    TNode<Context> tmp55;
    TNode<JSProxy> tmp56;
    TNode<Name> tmp57;
    TNode<BoolT> tmp58;
    ca_.Bind(&block22, &tmp55, &tmp56, &tmp57, &tmp58);
    TNode<IntPtrT> tmp59 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp59);
    TNode<HeapObject>tmp60 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp56, tmp59});
    TNode<BoolT> tmp61;
    USE(tmp61);
    tmp61 = Is10JSReceiver21UT6ATNull10JSReceiver_1495(state_, TNode<Context>{tmp55}, TNode<HeapObject>{tmp60});
    ca_.Goto(&block23, tmp55, tmp56, tmp57, tmp58, tmp61);
  }

  if (block23.is_used()) {
    TNode<Context> tmp62;
    TNode<JSProxy> tmp63;
    TNode<Name> tmp64;
    TNode<BoolT> tmp65;
    TNode<BoolT> tmp66;
    ca_.Bind(&block23, &tmp62, &tmp63, &tmp64, &tmp65, &tmp66);
    ca_.Branch(tmp66, &block19, &block20, tmp62, tmp63, tmp64);
  }

  if (block20.is_used()) {
    TNode<Context> tmp67;
    TNode<JSProxy> tmp68;
    TNode<Name> tmp69;
    ca_.Bind(&block20, &tmp67, &tmp68, &tmp69);
    CodeStubAssembler(state_).FailAssert("Torque assert 'proxy.handler == Null || Is<JSReceiver>(proxy.handler)' failed", "../../deps/v8/src/builtins/proxy-has-property.tq", 25);
  }

  if (block19.is_used()) {
    TNode<Context> tmp70;
    TNode<JSProxy> tmp71;
    TNode<Name> tmp72;
    ca_.Bind(&block19, &tmp70, &tmp71, &tmp72);
  }

  if (block18.is_used()) {
    TNode<Context> tmp73;
    TNode<JSProxy> tmp74;
    TNode<Name> tmp75;
    ca_.Bind(&block18, &tmp73, &tmp74, &tmp75);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-has-property.tq", 27);
    TNode<IntPtrT> tmp76 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp76);
    TNode<HeapObject>tmp77 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp74, tmp76});
    TNode<JSReceiver> tmp78;
    USE(tmp78);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp78 = Cast10JSReceiver_143(state_, TNode<HeapObject>{tmp77}, &label0);
    ca_.Goto(&block24, tmp73, tmp74, tmp75, tmp77, tmp78);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block25, tmp73, tmp74, tmp75, tmp77);
    }
  }

  if (block25.is_used()) {
    TNode<Context> tmp79;
    TNode<JSProxy> tmp80;
    TNode<Name> tmp81;
    TNode<HeapObject> tmp82;
    ca_.Bind(&block25, &tmp79, &tmp80, &tmp81, &tmp82);
    ca_.Goto(&block14, tmp79, tmp80, tmp81);
  }

  if (block24.is_used()) {
    TNode<Context> tmp83;
    TNode<JSProxy> tmp84;
    TNode<Name> tmp85;
    TNode<HeapObject> tmp86;
    TNode<JSReceiver> tmp87;
    ca_.Bind(&block24, &tmp83, &tmp84, &tmp85, &tmp86, &tmp87);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-has-property.tq", 30);
    TNode<IntPtrT> tmp88 = ca_.IntPtrConstant(JSProxy::kTargetOffset);
    USE(tmp88);
    TNode<HeapObject>tmp89 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp84, tmp88});
    TNode<JSReceiver> tmp90;
    USE(tmp90);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp90 = Cast10JSReceiver_143(state_, TNode<HeapObject>{tmp89}, &label0);
    ca_.Goto(&block28, tmp83, tmp84, tmp85, tmp87, tmp89, tmp90);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block29, tmp83, tmp84, tmp85, tmp87, tmp89);
    }
  }

  if (block29.is_used()) {
    TNode<Context> tmp91;
    TNode<JSProxy> tmp92;
    TNode<Name> tmp93;
    TNode<JSReceiver> tmp94;
    TNode<HeapObject> tmp95;
    ca_.Bind(&block29, &tmp91, &tmp92, &tmp93, &tmp94, &tmp95);
    ca_.Goto(&block27, tmp91, tmp92, tmp93, tmp94);
  }

  if (block28.is_used()) {
    TNode<Context> tmp96;
    TNode<JSProxy> tmp97;
    TNode<Name> tmp98;
    TNode<JSReceiver> tmp99;
    TNode<HeapObject> tmp100;
    TNode<JSReceiver> tmp101;
    ca_.Bind(&block28, &tmp96, &tmp97, &tmp98, &tmp99, &tmp100, &tmp101);
    ca_.Goto(&block26, tmp96, tmp97, tmp98, tmp99, tmp101);
  }

  if (block27.is_used()) {
    TNode<Context> tmp102;
    TNode<JSProxy> tmp103;
    TNode<Name> tmp104;
    TNode<JSReceiver> tmp105;
    ca_.Bind(&block27, &tmp102, &tmp103, &tmp104, &tmp105);
    CodeStubAssembler(state_).Unreachable();
  }

  if (block26.is_used()) {
    TNode<Context> tmp106;
    TNode<JSProxy> tmp107;
    TNode<Name> tmp108;
    TNode<JSReceiver> tmp109;
    TNode<JSReceiver> tmp110;
    ca_.Bind(&block26, &tmp106, &tmp107, &tmp108, &tmp109, &tmp110);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-has-property.tq", 34);
    TNode<JSReceiver> tmp111;
    USE(tmp111);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp111 = GetMethod_248(state_, TNode<Context>{tmp106}, TNode<Object>{tmp109}, "has", &label0);
    ca_.Goto(&block32, tmp106, tmp107, tmp108, tmp109, tmp110, tmp109, tmp111);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block33, tmp106, tmp107, tmp108, tmp109, tmp110, tmp109);
    }
  }

  if (block33.is_used()) {
    TNode<Context> tmp112;
    TNode<JSProxy> tmp113;
    TNode<Name> tmp114;
    TNode<JSReceiver> tmp115;
    TNode<JSReceiver> tmp116;
    TNode<JSReceiver> tmp117;
    ca_.Bind(&block33, &tmp112, &tmp113, &tmp114, &tmp115, &tmp116, &tmp117);
    ca_.Goto(&block31, tmp112, tmp113, tmp114, tmp115, tmp116);
  }

  if (block32.is_used()) {
    TNode<Context> tmp118;
    TNode<JSProxy> tmp119;
    TNode<Name> tmp120;
    TNode<JSReceiver> tmp121;
    TNode<JSReceiver> tmp122;
    TNode<JSReceiver> tmp123;
    TNode<JSReceiver> tmp124;
    ca_.Bind(&block32, &tmp118, &tmp119, &tmp120, &tmp121, &tmp122, &tmp123, &tmp124);
    ca_.Goto(&block30, tmp118, tmp119, tmp120, tmp121, tmp122, tmp124);
  }

  if (block31.is_used()) {
    TNode<Context> tmp125;
    TNode<JSProxy> tmp126;
    TNode<Name> tmp127;
    TNode<JSReceiver> tmp128;
    TNode<JSReceiver> tmp129;
    ca_.Bind(&block31, &tmp125, &tmp126, &tmp127, &tmp128, &tmp129);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-has-property.tq", 35);
    ca_.Goto(&block16, tmp125, tmp126, tmp127, tmp129);
  }

  if (block30.is_used()) {
    TNode<Context> tmp130;
    TNode<JSProxy> tmp131;
    TNode<Name> tmp132;
    TNode<JSReceiver> tmp133;
    TNode<JSReceiver> tmp134;
    TNode<JSReceiver> tmp135;
    ca_.Bind(&block30, &tmp130, &tmp131, &tmp132, &tmp133, &tmp134, &tmp135);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-has-property.tq", 34);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-has-property.tq", 42);
    TNode<Object> tmp136;
    USE(tmp136);
    tmp136 = CodeStubAssembler(state_).Call(TNode<Context>{tmp130}, TNode<JSReceiver>{tmp135}, TNode<Object>{tmp133}, TNode<Object>{tmp134}, TNode<Object>{tmp132});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-has-property.tq", 43);
    TNode<BoolT> tmp137;
    USE(tmp137);
    tmp137 = ToBoolean_243(state_, TNode<Object>{tmp136});
    ca_.Branch(tmp137, &block34, &block35, tmp130, tmp131, tmp132, tmp133, tmp134, tmp135, tmp136);
  }

  if (block34.is_used()) {
    TNode<Context> tmp138;
    TNode<JSProxy> tmp139;
    TNode<Name> tmp140;
    TNode<JSReceiver> tmp141;
    TNode<JSReceiver> tmp142;
    TNode<JSReceiver> tmp143;
    TNode<Object> tmp144;
    ca_.Bind(&block34, &tmp138, &tmp139, &tmp140, &tmp141, &tmp142, &tmp143, &tmp144);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-has-property.tq", 44);
    TNode<Oddball> tmp145;
    USE(tmp145);
    tmp145 = True_65(state_);
    CodeStubAssembler(state_).Return(tmp145);
  }

  if (block35.is_used()) {
    TNode<Context> tmp146;
    TNode<JSProxy> tmp147;
    TNode<Name> tmp148;
    TNode<JSReceiver> tmp149;
    TNode<JSReceiver> tmp150;
    TNode<JSReceiver> tmp151;
    TNode<Object> tmp152;
    ca_.Bind(&block35, &tmp146, &tmp147, &tmp148, &tmp149, &tmp150, &tmp151, &tmp152);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-has-property.tq", 46);
    ProxiesCodeStubAssembler(state_).CheckHasTrapResult(TNode<Context>{tmp146}, TNode<JSReceiver>{tmp150}, TNode<JSProxy>{tmp147}, TNode<Name>{tmp148});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-has-property.tq", 47);
    TNode<Oddball> tmp153;
    USE(tmp153);
    tmp153 = False_66(state_);
    CodeStubAssembler(state_).Return(tmp153);
  }

  if (block16.is_used()) {
    TNode<Context> tmp154;
    TNode<JSProxy> tmp155;
    TNode<Name> tmp156;
    TNode<Object> tmp157;
    ca_.Bind(&block16, &tmp154, &tmp155, &tmp156, &tmp157);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-has-property.tq", 51);
   CodeStubAssembler(state_).TailCallBuiltin(Builtins::kHasProperty, tmp154, tmp157, tmp156);
  }

  if (block14.is_used()) {
    TNode<Context> tmp158;
    TNode<JSProxy> tmp159;
    TNode<Name> tmp160;
    ca_.Bind(&block14, &tmp158, &tmp159, &tmp160);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-has-property.tq", 54);
    CodeStubAssembler(state_).ThrowTypeError(TNode<Context>{tmp158}, MessageTemplate::kProxyRevoked, "has");
  }
}

}  // namespace internal
}  // namespace v8

