#include "src/builtins/builtins-array-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-utils-gen.h"
#include "src/builtins/builtins.h"
#include "src/codegen/code-factory.h"
#include "src/heap/factory-inl.h"
#include "src/objects/arguments.h"
#include "src/objects/bigint.h"
#include "src/objects/elements-kind.h"
#include "src/objects/free-space.h"
#include "src/objects/js-generator.h"
#include "src/objects/js-promise.h"
#include "src/objects/js-regexp-string-iterator.h"
#include "src/objects/js-weak-refs.h"
#include "src/objects/objects.h"
#include "src/objects/source-text-module.h"
#include "src/objects/stack-frame-info.h"
#include "src/objects/synthetic-module.h"
#include "src/objects/template-objects.h"
#include "src/builtins/builtins-bigint-gen.h"
#include "src/builtins/builtins-collections-gen.h"
#include "src/builtins/builtins-data-view-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-iterator-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-constructor-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/objects/js-break-iterator.h"
#include "src/objects/js-collator.h"
#include "src/objects/js-number-format.h"
#include "src/objects/js-objects.h"
#include "src/objects/js-plural-rules.h"
#include "src/objects/js-relative-time-format.h"
#include "src/objects/js-date-time-format.h"
#include "src/objects/js-list-format.h"
#include "src/objects/js-locale.h"
#include "src/objects/js-segment-iterator.h"
#include "src/objects/js-segmenter.h"
#include "torque-generated/../../deps/v8/src/builtins/arguments-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-copywithin-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-join-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-lastindexof-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-map-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-right-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reverse-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-shift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-splice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-unshift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/base-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/bigint-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/boolean-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/collections-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/data-view-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/extras-utils-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/frames-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/growable-fixed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/internal-coverage-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/math-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-fromentries-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-constructor-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-delete-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-has-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-is-extensible-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-prevent-extensions-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revocable-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revoke-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/reflect-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-exec-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-all-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-replace-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-search-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-source-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-split-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-test-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-endswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-html-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-pad-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-repeat-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-startswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-substring-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/torque-internal-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-createtypedarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduceright-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-subarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/third_party/v8/builtins/array-sort-tq-csa.h"
#include "torque-generated/../../deps/v8/test/torque/test-torque-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/intl-objects-tq-csa.h"

namespace v8 {
namespace internal {

TF_BUILTIN(ProxyIsExtensible, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  TNode<Context> parameter0 = UncheckedCast<Context>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<JSProxy> parameter1 = UncheckedCast<JSProxy>(Parameter(Descriptor::ParameterIndex<0>()));
  USE(parameter1);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, BoolT> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, BoolT> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, BoolT, BoolT> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy> block8(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject> block13(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, JSReceiver> block12(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver> block17(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, JSReceiver> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject> block15(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver> block14(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, BoolT, BoolT> block18(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, JSReceiver, HeapObject, JSReceiver, BoolT, BoolT> block19(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Object> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy> block2(&ca_, compiler::CodeAssemblerLabel::kDeferred);
    ca_.Goto(&block0, parameter0, parameter1);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<JSProxy> tmp1;
    ca_.Bind(&block0, &tmp0, &tmp1);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-is-extensible.tq", 13);
    CodeStubAssembler(state_).PerformStackCheck(TNode<Context>{tmp0});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-is-extensible.tq", 19);
    ca_.Goto(&block6, tmp0, tmp1);
  }

  if (block5.is_used()) {
    TNode<Context> tmp2;
    TNode<JSProxy> tmp3;
    ca_.Bind(&block5, &tmp2, &tmp3);
    TNode<IntPtrT> tmp4 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp4);
    TNode<HeapObject>tmp5 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp3, tmp4});
    TNode<Oddball> tmp6;
    USE(tmp6);
    tmp6 = Null_63(state_);
    TNode<BoolT> tmp7;
    USE(tmp7);
    tmp7 = CodeStubAssembler(state_).TaggedEqual(TNode<HeapObject>{tmp5}, TNode<HeapObject>{tmp6});
    ca_.Branch(tmp7, &block9, &block10, tmp2, tmp3, tmp7);
  }

  if (block9.is_used()) {
    TNode<Context> tmp8;
    TNode<JSProxy> tmp9;
    TNode<BoolT> tmp10;
    ca_.Bind(&block9, &tmp8, &tmp9, &tmp10);
    TNode<BoolT> tmp11;
    USE(tmp11);
    tmp11 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, true);
    ca_.Goto(&block11, tmp8, tmp9, tmp10, tmp11);
  }

  if (block10.is_used()) {
    TNode<Context> tmp12;
    TNode<JSProxy> tmp13;
    TNode<BoolT> tmp14;
    ca_.Bind(&block10, &tmp12, &tmp13, &tmp14);
    TNode<IntPtrT> tmp15 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp15);
    TNode<HeapObject>tmp16 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp13, tmp15});
    TNode<BoolT> tmp17;
    USE(tmp17);
    tmp17 = Is10JSReceiver21UT6ATNull10JSReceiver_1495(state_, TNode<Context>{tmp12}, TNode<HeapObject>{tmp16});
    ca_.Goto(&block11, tmp12, tmp13, tmp14, tmp17);
  }

  if (block11.is_used()) {
    TNode<Context> tmp18;
    TNode<JSProxy> tmp19;
    TNode<BoolT> tmp20;
    TNode<BoolT> tmp21;
    ca_.Bind(&block11, &tmp18, &tmp19, &tmp20, &tmp21);
    ca_.Branch(tmp21, &block7, &block8, tmp18, tmp19);
  }

  if (block8.is_used()) {
    TNode<Context> tmp22;
    TNode<JSProxy> tmp23;
    ca_.Bind(&block8, &tmp22, &tmp23);
    CodeStubAssembler(state_).FailAssert("Torque assert 'proxy.handler == Null || Is<JSReceiver>(proxy.handler)' failed", "../../deps/v8/src/builtins/proxy-is-extensible.tq", 19);
  }

  if (block7.is_used()) {
    TNode<Context> tmp24;
    TNode<JSProxy> tmp25;
    ca_.Bind(&block7, &tmp24, &tmp25);
  }

  if (block6.is_used()) {
    TNode<Context> tmp26;
    TNode<JSProxy> tmp27;
    ca_.Bind(&block6, &tmp26, &tmp27);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-is-extensible.tq", 21);
    TNode<IntPtrT> tmp28 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp28);
    TNode<HeapObject>tmp29 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp27, tmp28});
    TNode<JSReceiver> tmp30;
    USE(tmp30);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp30 = Cast10JSReceiver_143(state_, TNode<HeapObject>{tmp29}, &label0);
    ca_.Goto(&block12, tmp26, tmp27, tmp29, tmp30);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block13, tmp26, tmp27, tmp29);
    }
  }

  if (block13.is_used()) {
    TNode<Context> tmp31;
    TNode<JSProxy> tmp32;
    TNode<HeapObject> tmp33;
    ca_.Bind(&block13, &tmp31, &tmp32, &tmp33);
    ca_.Goto(&block2, tmp31, tmp32);
  }

  if (block12.is_used()) {
    TNode<Context> tmp34;
    TNode<JSProxy> tmp35;
    TNode<HeapObject> tmp36;
    TNode<JSReceiver> tmp37;
    ca_.Bind(&block12, &tmp34, &tmp35, &tmp36, &tmp37);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-is-extensible.tq", 24);
    TNode<IntPtrT> tmp38 = ca_.IntPtrConstant(JSProxy::kTargetOffset);
    USE(tmp38);
    TNode<HeapObject>tmp39 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp35, tmp38});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-is-extensible.tq", 28);
    TNode<JSReceiver> tmp40;
    USE(tmp40);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp40 = GetMethod_248(state_, TNode<Context>{tmp34}, TNode<Object>{tmp37}, "isExtensible", &label0);
    ca_.Goto(&block16, tmp34, tmp35, tmp37, tmp39, tmp37, tmp40);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block17, tmp34, tmp35, tmp37, tmp39, tmp37);
    }
  }

  if (block17.is_used()) {
    TNode<Context> tmp41;
    TNode<JSProxy> tmp42;
    TNode<JSReceiver> tmp43;
    TNode<HeapObject> tmp44;
    TNode<JSReceiver> tmp45;
    ca_.Bind(&block17, &tmp41, &tmp42, &tmp43, &tmp44, &tmp45);
    ca_.Goto(&block15, tmp41, tmp42, tmp43, tmp44);
  }

  if (block16.is_used()) {
    TNode<Context> tmp46;
    TNode<JSProxy> tmp47;
    TNode<JSReceiver> tmp48;
    TNode<HeapObject> tmp49;
    TNode<JSReceiver> tmp50;
    TNode<JSReceiver> tmp51;
    ca_.Bind(&block16, &tmp46, &tmp47, &tmp48, &tmp49, &tmp50, &tmp51);
    ca_.Goto(&block14, tmp46, tmp47, tmp48, tmp49, tmp51);
  }

  if (block15.is_used()) {
    TNode<Context> tmp52;
    TNode<JSProxy> tmp53;
    TNode<JSReceiver> tmp54;
    TNode<HeapObject> tmp55;
    ca_.Bind(&block15, &tmp52, &tmp53, &tmp54, &tmp55);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-is-extensible.tq", 29);
    ca_.Goto(&block4, tmp52, tmp53, tmp55);
  }

  if (block14.is_used()) {
    TNode<Context> tmp56;
    TNode<JSProxy> tmp57;
    TNode<JSReceiver> tmp58;
    TNode<HeapObject> tmp59;
    TNode<JSReceiver> tmp60;
    ca_.Bind(&block14, &tmp56, &tmp57, &tmp58, &tmp59, &tmp60);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-is-extensible.tq", 28);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-is-extensible.tq", 33);
    TNode<Object> tmp61;
    USE(tmp61);
    tmp61 = CodeStubAssembler(state_).Call(TNode<Context>{tmp56}, TNode<JSReceiver>{tmp60}, TNode<Object>{tmp58}, TNode<Object>{tmp59});
    TNode<BoolT> tmp62;
    USE(tmp62);
    tmp62 = ToBoolean_243(state_, TNode<Object>{tmp61});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-is-extensible.tq", 36);
    TNode<Object> tmp63;
    USE(tmp63);
    tmp63 = ObjectIsExtensible_314(state_, TNode<Context>{tmp56}, TNode<Object>{tmp59});
    TNode<BoolT> tmp64;
    USE(tmp64);
    tmp64 = ToBoolean_243(state_, TNode<Object>{tmp63});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-is-extensible.tq", 40);
    TNode<BoolT> tmp65;
    USE(tmp65);
    tmp65 = CodeStubAssembler(state_).Word32NotEqual(TNode<BoolT>{tmp62}, TNode<BoolT>{tmp64});
    ca_.Branch(tmp65, &block18, &block19, tmp56, tmp57, tmp58, tmp59, tmp60, tmp62, tmp64);
  }

  if (block18.is_used()) {
    TNode<Context> tmp66;
    TNode<JSProxy> tmp67;
    TNode<JSReceiver> tmp68;
    TNode<HeapObject> tmp69;
    TNode<JSReceiver> tmp70;
    TNode<BoolT> tmp71;
    TNode<BoolT> tmp72;
    ca_.Bind(&block18, &tmp66, &tmp67, &tmp68, &tmp69, &tmp70, &tmp71, &tmp72);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-is-extensible.tq", 43);
    TNode<Oddball> tmp73;
    USE(tmp73);
    tmp73 = CodeStubAssembler(state_).SelectBooleanConstant(TNode<BoolT>{tmp72});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-is-extensible.tq", 41);
    CodeStubAssembler(state_).ThrowTypeError(TNode<Context>{tmp66}, MessageTemplate::kProxyIsExtensibleInconsistent, TNode<Object>{tmp73});
  }

  if (block19.is_used()) {
    TNode<Context> tmp74;
    TNode<JSProxy> tmp75;
    TNode<JSReceiver> tmp76;
    TNode<HeapObject> tmp77;
    TNode<JSReceiver> tmp78;
    TNode<BoolT> tmp79;
    TNode<BoolT> tmp80;
    ca_.Bind(&block19, &tmp74, &tmp75, &tmp76, &tmp77, &tmp78, &tmp79, &tmp80);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-is-extensible.tq", 46);
    TNode<Oddball> tmp81;
    USE(tmp81);
    tmp81 = CodeStubAssembler(state_).SelectBooleanConstant(TNode<BoolT>{tmp79});
    CodeStubAssembler(state_).Return(tmp81);
  }

  if (block4.is_used()) {
    TNode<Context> tmp82;
    TNode<JSProxy> tmp83;
    TNode<Object> tmp84;
    ca_.Bind(&block4, &tmp82, &tmp83, &tmp84);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-is-extensible.tq", 50);
    TNode<Object> tmp85;
    USE(tmp85);
    tmp85 = ObjectIsExtensible_314(state_, TNode<Context>{tmp82}, TNode<Object>{tmp84});
    CodeStubAssembler(state_).Return(tmp85);
  }

  if (block2.is_used()) {
    TNode<Context> tmp86;
    TNode<JSProxy> tmp87;
    ca_.Bind(&block2, &tmp86, &tmp87);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-is-extensible.tq", 53);
    CodeStubAssembler(state_).ThrowTypeError(TNode<Context>{tmp86}, MessageTemplate::kProxyRevoked, "isExtensible");
  }
}

}  // namespace internal
}  // namespace v8

