#include "src/builtins/builtins-array-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-utils-gen.h"
#include "src/builtins/builtins.h"
#include "src/codegen/code-factory.h"
#include "src/heap/factory-inl.h"
#include "src/objects/arguments.h"
#include "src/objects/bigint.h"
#include "src/objects/elements-kind.h"
#include "src/objects/free-space.h"
#include "src/objects/js-generator.h"
#include "src/objects/js-promise.h"
#include "src/objects/js-regexp-string-iterator.h"
#include "src/objects/js-weak-refs.h"
#include "src/objects/objects.h"
#include "src/objects/source-text-module.h"
#include "src/objects/stack-frame-info.h"
#include "src/objects/synthetic-module.h"
#include "src/objects/template-objects.h"
#include "src/builtins/builtins-bigint-gen.h"
#include "src/builtins/builtins-collections-gen.h"
#include "src/builtins/builtins-data-view-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-iterator-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-constructor-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/objects/js-break-iterator.h"
#include "src/objects/js-collator.h"
#include "src/objects/js-number-format.h"
#include "src/objects/js-objects.h"
#include "src/objects/js-plural-rules.h"
#include "src/objects/js-relative-time-format.h"
#include "src/objects/js-date-time-format.h"
#include "src/objects/js-list-format.h"
#include "src/objects/js-locale.h"
#include "src/objects/js-segment-iterator.h"
#include "src/objects/js-segmenter.h"
#include "torque-generated/../../deps/v8/src/builtins/arguments-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-copywithin-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-join-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-lastindexof-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-map-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-right-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reverse-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-shift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-splice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-unshift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/base-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/bigint-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/boolean-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/collections-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/data-view-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/extras-utils-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/frames-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/growable-fixed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/internal-coverage-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/math-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-fromentries-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-constructor-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-delete-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-has-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-is-extensible-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-prevent-extensions-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revocable-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revoke-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/reflect-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-exec-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-all-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-replace-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-search-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-source-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-split-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-test-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-endswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-html-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-pad-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-repeat-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-startswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-substring-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/torque-internal-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-createtypedarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduceright-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-subarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/third_party/v8/builtins/array-sort-tq-csa.h"
#include "torque-generated/../../deps/v8/test/torque/test-torque-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/intl-objects-tq-csa.h"

namespace v8 {
namespace internal {

TF_BUILTIN(ProxyPreventExtensions, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  TNode<Context> parameter0 = UncheckedCast<Context>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<JSProxy> parameter1 = UncheckedCast<JSProxy>(Parameter(Descriptor::ParameterIndex<0>()));
  USE(parameter1);
  TNode<Oddball> parameter2 = UncheckedCast<Oddball>(Parameter(Descriptor::ParameterIndex<1>()));
  USE(parameter2);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, BoolT> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, BoolT> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, BoolT, BoolT> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball> block8(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, HeapObject> block13(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, HeapObject, JSReceiver> block12(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, JSReceiver, HeapObject, JSReceiver> block17(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, JSReceiver, HeapObject, JSReceiver, JSReceiver> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, JSReceiver, HeapObject> block15(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, JSReceiver, HeapObject, JSReceiver> block14(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, JSReceiver, HeapObject, JSReceiver, Object> block18(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object> block21(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object, BoolT> block25(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object, BoolT> block26(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object, BoolT, BoolT> block27(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object> block24(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object> block23(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object> block22(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object> block28(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object> block29(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, JSReceiver, HeapObject, JSReceiver, Object> block19(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, JSReceiver, HeapObject, JSReceiver, Object> block30(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, JSReceiver, HeapObject, JSReceiver, Object> block31(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, JSReceiver, HeapObject, JSReceiver, Object> block20(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, Object> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, Object> block32(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball, Object> block33(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Oddball> block2(&ca_, compiler::CodeAssemblerLabel::kDeferred);
    ca_.Goto(&block0, parameter0, parameter1, parameter2);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<JSProxy> tmp1;
    TNode<Oddball> tmp2;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 14);
    CodeStubAssembler(state_).PerformStackCheck(TNode<Context>{tmp0});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 20);
    ca_.Goto(&block6, tmp0, tmp1, tmp2);
  }

  if (block5.is_used()) {
    TNode<Context> tmp3;
    TNode<JSProxy> tmp4;
    TNode<Oddball> tmp5;
    ca_.Bind(&block5, &tmp3, &tmp4, &tmp5);
    TNode<IntPtrT> tmp6 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp6);
    TNode<HeapObject>tmp7 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp4, tmp6});
    TNode<Oddball> tmp8;
    USE(tmp8);
    tmp8 = Null_63(state_);
    TNode<BoolT> tmp9;
    USE(tmp9);
    tmp9 = CodeStubAssembler(state_).TaggedEqual(TNode<HeapObject>{tmp7}, TNode<HeapObject>{tmp8});
    ca_.Branch(tmp9, &block9, &block10, tmp3, tmp4, tmp5, tmp9);
  }

  if (block9.is_used()) {
    TNode<Context> tmp10;
    TNode<JSProxy> tmp11;
    TNode<Oddball> tmp12;
    TNode<BoolT> tmp13;
    ca_.Bind(&block9, &tmp10, &tmp11, &tmp12, &tmp13);
    TNode<BoolT> tmp14;
    USE(tmp14);
    tmp14 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, true);
    ca_.Goto(&block11, tmp10, tmp11, tmp12, tmp13, tmp14);
  }

  if (block10.is_used()) {
    TNode<Context> tmp15;
    TNode<JSProxy> tmp16;
    TNode<Oddball> tmp17;
    TNode<BoolT> tmp18;
    ca_.Bind(&block10, &tmp15, &tmp16, &tmp17, &tmp18);
    TNode<IntPtrT> tmp19 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp19);
    TNode<HeapObject>tmp20 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp16, tmp19});
    TNode<BoolT> tmp21;
    USE(tmp21);
    tmp21 = Is10JSReceiver21UT6ATNull10JSReceiver_1495(state_, TNode<Context>{tmp15}, TNode<HeapObject>{tmp20});
    ca_.Goto(&block11, tmp15, tmp16, tmp17, tmp18, tmp21);
  }

  if (block11.is_used()) {
    TNode<Context> tmp22;
    TNode<JSProxy> tmp23;
    TNode<Oddball> tmp24;
    TNode<BoolT> tmp25;
    TNode<BoolT> tmp26;
    ca_.Bind(&block11, &tmp22, &tmp23, &tmp24, &tmp25, &tmp26);
    ca_.Branch(tmp26, &block7, &block8, tmp22, tmp23, tmp24);
  }

  if (block8.is_used()) {
    TNode<Context> tmp27;
    TNode<JSProxy> tmp28;
    TNode<Oddball> tmp29;
    ca_.Bind(&block8, &tmp27, &tmp28, &tmp29);
    CodeStubAssembler(state_).FailAssert("Torque assert 'proxy.handler == Null || Is<JSReceiver>(proxy.handler)' failed", "../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 20);
  }

  if (block7.is_used()) {
    TNode<Context> tmp30;
    TNode<JSProxy> tmp31;
    TNode<Oddball> tmp32;
    ca_.Bind(&block7, &tmp30, &tmp31, &tmp32);
  }

  if (block6.is_used()) {
    TNode<Context> tmp33;
    TNode<JSProxy> tmp34;
    TNode<Oddball> tmp35;
    ca_.Bind(&block6, &tmp33, &tmp34, &tmp35);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 22);
    TNode<IntPtrT> tmp36 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp36);
    TNode<HeapObject>tmp37 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp34, tmp36});
    TNode<JSReceiver> tmp38;
    USE(tmp38);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp38 = Cast10JSReceiver_143(state_, TNode<HeapObject>{tmp37}, &label0);
    ca_.Goto(&block12, tmp33, tmp34, tmp35, tmp37, tmp38);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block13, tmp33, tmp34, tmp35, tmp37);
    }
  }

  if (block13.is_used()) {
    TNode<Context> tmp39;
    TNode<JSProxy> tmp40;
    TNode<Oddball> tmp41;
    TNode<HeapObject> tmp42;
    ca_.Bind(&block13, &tmp39, &tmp40, &tmp41, &tmp42);
    ca_.Goto(&block2, tmp39, tmp40, tmp41);
  }

  if (block12.is_used()) {
    TNode<Context> tmp43;
    TNode<JSProxy> tmp44;
    TNode<Oddball> tmp45;
    TNode<HeapObject> tmp46;
    TNode<JSReceiver> tmp47;
    ca_.Bind(&block12, &tmp43, &tmp44, &tmp45, &tmp46, &tmp47);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 25);
    TNode<IntPtrT> tmp48 = ca_.IntPtrConstant(JSProxy::kTargetOffset);
    USE(tmp48);
    TNode<HeapObject>tmp49 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp44, tmp48});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 29);
    TNode<JSReceiver> tmp50;
    USE(tmp50);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp50 = GetMethod_248(state_, TNode<Context>{tmp43}, TNode<Object>{tmp47}, "preventExtensions", &label0);
    ca_.Goto(&block16, tmp43, tmp44, tmp45, tmp47, tmp49, tmp47, tmp50);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block17, tmp43, tmp44, tmp45, tmp47, tmp49, tmp47);
    }
  }

  if (block17.is_used()) {
    TNode<Context> tmp51;
    TNode<JSProxy> tmp52;
    TNode<Oddball> tmp53;
    TNode<JSReceiver> tmp54;
    TNode<HeapObject> tmp55;
    TNode<JSReceiver> tmp56;
    ca_.Bind(&block17, &tmp51, &tmp52, &tmp53, &tmp54, &tmp55, &tmp56);
    ca_.Goto(&block15, tmp51, tmp52, tmp53, tmp54, tmp55);
  }

  if (block16.is_used()) {
    TNode<Context> tmp57;
    TNode<JSProxy> tmp58;
    TNode<Oddball> tmp59;
    TNode<JSReceiver> tmp60;
    TNode<HeapObject> tmp61;
    TNode<JSReceiver> tmp62;
    TNode<JSReceiver> tmp63;
    ca_.Bind(&block16, &tmp57, &tmp58, &tmp59, &tmp60, &tmp61, &tmp62, &tmp63);
    ca_.Goto(&block14, tmp57, tmp58, tmp59, tmp60, tmp61, tmp63);
  }

  if (block15.is_used()) {
    TNode<Context> tmp64;
    TNode<JSProxy> tmp65;
    TNode<Oddball> tmp66;
    TNode<JSReceiver> tmp67;
    TNode<HeapObject> tmp68;
    ca_.Bind(&block15, &tmp64, &tmp65, &tmp66, &tmp67, &tmp68);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 30);
    ca_.Goto(&block4, tmp64, tmp65, tmp66, tmp68);
  }

  if (block14.is_used()) {
    TNode<Context> tmp69;
    TNode<JSProxy> tmp70;
    TNode<Oddball> tmp71;
    TNode<JSReceiver> tmp72;
    TNode<HeapObject> tmp73;
    TNode<JSReceiver> tmp74;
    ca_.Bind(&block14, &tmp69, &tmp70, &tmp71, &tmp72, &tmp73, &tmp74);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 29);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 34);
    TNode<Object> tmp75;
    USE(tmp75);
    tmp75 = CodeStubAssembler(state_).Call(TNode<Context>{tmp69}, TNode<JSReceiver>{tmp74}, TNode<Object>{tmp72}, TNode<Object>{tmp73});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 39);
    TNode<BoolT> tmp76;
    USE(tmp76);
    tmp76 = ToBoolean_243(state_, TNode<Object>{tmp75});
    ca_.Branch(tmp76, &block18, &block19, tmp69, tmp70, tmp71, tmp72, tmp73, tmp74, tmp75);
  }

  if (block18.is_used()) {
    TNode<Context> tmp77;
    TNode<JSProxy> tmp78;
    TNode<Oddball> tmp79;
    TNode<JSReceiver> tmp80;
    TNode<HeapObject> tmp81;
    TNode<JSReceiver> tmp82;
    TNode<Object> tmp83;
    ca_.Bind(&block18, &tmp77, &tmp78, &tmp79, &tmp80, &tmp81, &tmp82, &tmp83);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 40);
    TNode<Object> tmp84;
    USE(tmp84);
    tmp84 = ObjectIsExtensible_314(state_, TNode<Context>{tmp77}, TNode<Object>{tmp81});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 41);
    ca_.Goto(&block22, tmp77, tmp78, tmp79, tmp80, tmp81, tmp82, tmp83, tmp84);
  }

  if (block21.is_used()) {
    TNode<Context> tmp85;
    TNode<JSProxy> tmp86;
    TNode<Oddball> tmp87;
    TNode<JSReceiver> tmp88;
    TNode<HeapObject> tmp89;
    TNode<JSReceiver> tmp90;
    TNode<Object> tmp91;
    TNode<Object> tmp92;
    ca_.Bind(&block21, &tmp85, &tmp86, &tmp87, &tmp88, &tmp89, &tmp90, &tmp91, &tmp92);
    TNode<Oddball> tmp93;
    USE(tmp93);
    tmp93 = True_65(state_);
    TNode<BoolT> tmp94;
    USE(tmp94);
    tmp94 = CodeStubAssembler(state_).TaggedEqual(TNode<Object>{tmp92}, TNode<HeapObject>{tmp93});
    ca_.Branch(tmp94, &block25, &block26, tmp85, tmp86, tmp87, tmp88, tmp89, tmp90, tmp91, tmp92, tmp94);
  }

  if (block25.is_used()) {
    TNode<Context> tmp95;
    TNode<JSProxy> tmp96;
    TNode<Oddball> tmp97;
    TNode<JSReceiver> tmp98;
    TNode<HeapObject> tmp99;
    TNode<JSReceiver> tmp100;
    TNode<Object> tmp101;
    TNode<Object> tmp102;
    TNode<BoolT> tmp103;
    ca_.Bind(&block25, &tmp95, &tmp96, &tmp97, &tmp98, &tmp99, &tmp100, &tmp101, &tmp102, &tmp103);
    TNode<BoolT> tmp104;
    USE(tmp104);
    tmp104 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, true);
    ca_.Goto(&block27, tmp95, tmp96, tmp97, tmp98, tmp99, tmp100, tmp101, tmp102, tmp103, tmp104);
  }

  if (block26.is_used()) {
    TNode<Context> tmp105;
    TNode<JSProxy> tmp106;
    TNode<Oddball> tmp107;
    TNode<JSReceiver> tmp108;
    TNode<HeapObject> tmp109;
    TNode<JSReceiver> tmp110;
    TNode<Object> tmp111;
    TNode<Object> tmp112;
    TNode<BoolT> tmp113;
    ca_.Bind(&block26, &tmp105, &tmp106, &tmp107, &tmp108, &tmp109, &tmp110, &tmp111, &tmp112, &tmp113);
    TNode<Oddball> tmp114;
    USE(tmp114);
    tmp114 = False_66(state_);
    TNode<BoolT> tmp115;
    USE(tmp115);
    tmp115 = CodeStubAssembler(state_).TaggedEqual(TNode<Object>{tmp112}, TNode<HeapObject>{tmp114});
    ca_.Goto(&block27, tmp105, tmp106, tmp107, tmp108, tmp109, tmp110, tmp111, tmp112, tmp113, tmp115);
  }

  if (block27.is_used()) {
    TNode<Context> tmp116;
    TNode<JSProxy> tmp117;
    TNode<Oddball> tmp118;
    TNode<JSReceiver> tmp119;
    TNode<HeapObject> tmp120;
    TNode<JSReceiver> tmp121;
    TNode<Object> tmp122;
    TNode<Object> tmp123;
    TNode<BoolT> tmp124;
    TNode<BoolT> tmp125;
    ca_.Bind(&block27, &tmp116, &tmp117, &tmp118, &tmp119, &tmp120, &tmp121, &tmp122, &tmp123, &tmp124, &tmp125);
    ca_.Branch(tmp125, &block23, &block24, tmp116, tmp117, tmp118, tmp119, tmp120, tmp121, tmp122, tmp123);
  }

  if (block24.is_used()) {
    TNode<Context> tmp126;
    TNode<JSProxy> tmp127;
    TNode<Oddball> tmp128;
    TNode<JSReceiver> tmp129;
    TNode<HeapObject> tmp130;
    TNode<JSReceiver> tmp131;
    TNode<Object> tmp132;
    TNode<Object> tmp133;
    ca_.Bind(&block24, &tmp126, &tmp127, &tmp128, &tmp129, &tmp130, &tmp131, &tmp132, &tmp133);
    CodeStubAssembler(state_).FailAssert("Torque assert 'extensibleTarget == True || extensibleTarget == False' failed", "../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 41);
  }

  if (block23.is_used()) {
    TNode<Context> tmp134;
    TNode<JSProxy> tmp135;
    TNode<Oddball> tmp136;
    TNode<JSReceiver> tmp137;
    TNode<HeapObject> tmp138;
    TNode<JSReceiver> tmp139;
    TNode<Object> tmp140;
    TNode<Object> tmp141;
    ca_.Bind(&block23, &tmp134, &tmp135, &tmp136, &tmp137, &tmp138, &tmp139, &tmp140, &tmp141);
  }

  if (block22.is_used()) {
    TNode<Context> tmp142;
    TNode<JSProxy> tmp143;
    TNode<Oddball> tmp144;
    TNode<JSReceiver> tmp145;
    TNode<HeapObject> tmp146;
    TNode<JSReceiver> tmp147;
    TNode<Object> tmp148;
    TNode<Object> tmp149;
    ca_.Bind(&block22, &tmp142, &tmp143, &tmp144, &tmp145, &tmp146, &tmp147, &tmp148, &tmp149);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 42);
    TNode<Oddball> tmp150;
    USE(tmp150);
    tmp150 = True_65(state_);
    TNode<BoolT> tmp151;
    USE(tmp151);
    tmp151 = CodeStubAssembler(state_).TaggedEqual(TNode<Object>{tmp149}, TNode<HeapObject>{tmp150});
    ca_.Branch(tmp151, &block28, &block29, tmp142, tmp143, tmp144, tmp145, tmp146, tmp147, tmp148, tmp149);
  }

  if (block28.is_used()) {
    TNode<Context> tmp152;
    TNode<JSProxy> tmp153;
    TNode<Oddball> tmp154;
    TNode<JSReceiver> tmp155;
    TNode<HeapObject> tmp156;
    TNode<JSReceiver> tmp157;
    TNode<Object> tmp158;
    TNode<Object> tmp159;
    ca_.Bind(&block28, &tmp152, &tmp153, &tmp154, &tmp155, &tmp156, &tmp157, &tmp158, &tmp159);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 43);
    CodeStubAssembler(state_).ThrowTypeError(TNode<Context>{tmp152}, MessageTemplate::kProxyPreventExtensionsExtensible);
  }

  if (block29.is_used()) {
    TNode<Context> tmp160;
    TNode<JSProxy> tmp161;
    TNode<Oddball> tmp162;
    TNode<JSReceiver> tmp163;
    TNode<HeapObject> tmp164;
    TNode<JSReceiver> tmp165;
    TNode<Object> tmp166;
    TNode<Object> tmp167;
    ca_.Bind(&block29, &tmp160, &tmp161, &tmp162, &tmp163, &tmp164, &tmp165, &tmp166, &tmp167);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 39);
    ca_.Goto(&block20, tmp160, tmp161, tmp162, tmp163, tmp164, tmp165, tmp166);
  }

  if (block19.is_used()) {
    TNode<Context> tmp168;
    TNode<JSProxy> tmp169;
    TNode<Oddball> tmp170;
    TNode<JSReceiver> tmp171;
    TNode<HeapObject> tmp172;
    TNode<JSReceiver> tmp173;
    TNode<Object> tmp174;
    ca_.Bind(&block19, &tmp168, &tmp169, &tmp170, &tmp171, &tmp172, &tmp173, &tmp174);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 46);
    TNode<Oddball> tmp175;
    USE(tmp175);
    tmp175 = True_65(state_);
    TNode<BoolT> tmp176;
    USE(tmp176);
    tmp176 = CodeStubAssembler(state_).TaggedEqual(TNode<HeapObject>{tmp170}, TNode<HeapObject>{tmp175});
    ca_.Branch(tmp176, &block30, &block31, tmp168, tmp169, tmp170, tmp171, tmp172, tmp173, tmp174);
  }

  if (block30.is_used()) {
    TNode<Context> tmp177;
    TNode<JSProxy> tmp178;
    TNode<Oddball> tmp179;
    TNode<JSReceiver> tmp180;
    TNode<HeapObject> tmp181;
    TNode<JSReceiver> tmp182;
    TNode<Object> tmp183;
    ca_.Bind(&block30, &tmp177, &tmp178, &tmp179, &tmp180, &tmp181, &tmp182, &tmp183);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 47);
    CodeStubAssembler(state_).ThrowTypeError(TNode<Context>{tmp177}, MessageTemplate::kProxyTrapReturnedFalsish, "preventExtensions");
  }

  if (block31.is_used()) {
    TNode<Context> tmp184;
    TNode<JSProxy> tmp185;
    TNode<Oddball> tmp186;
    TNode<JSReceiver> tmp187;
    TNode<HeapObject> tmp188;
    TNode<JSReceiver> tmp189;
    TNode<Object> tmp190;
    ca_.Bind(&block31, &tmp184, &tmp185, &tmp186, &tmp187, &tmp188, &tmp189, &tmp190);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 49);
    TNode<Oddball> tmp191;
    USE(tmp191);
    tmp191 = False_66(state_);
    CodeStubAssembler(state_).Return(tmp191);
  }

  if (block20.is_used()) {
    TNode<Context> tmp192;
    TNode<JSProxy> tmp193;
    TNode<Oddball> tmp194;
    TNode<JSReceiver> tmp195;
    TNode<HeapObject> tmp196;
    TNode<JSReceiver> tmp197;
    TNode<Object> tmp198;
    ca_.Bind(&block20, &tmp192, &tmp193, &tmp194, &tmp195, &tmp196, &tmp197, &tmp198);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 53);
    TNode<Oddball> tmp199;
    USE(tmp199);
    tmp199 = True_65(state_);
    CodeStubAssembler(state_).Return(tmp199);
  }

  if (block4.is_used()) {
    TNode<Context> tmp200;
    TNode<JSProxy> tmp201;
    TNode<Oddball> tmp202;
    TNode<Object> tmp203;
    ca_.Bind(&block4, &tmp200, &tmp201, &tmp202, &tmp203);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 57);
    TNode<Oddball> tmp204;
    USE(tmp204);
    tmp204 = True_65(state_);
    TNode<BoolT> tmp205;
    USE(tmp205);
    tmp205 = CodeStubAssembler(state_).TaggedEqual(TNode<HeapObject>{tmp202}, TNode<HeapObject>{tmp204});
    ca_.Branch(tmp205, &block32, &block33, tmp200, tmp201, tmp202, tmp203);
  }

  if (block32.is_used()) {
    TNode<Context> tmp206;
    TNode<JSProxy> tmp207;
    TNode<Oddball> tmp208;
    TNode<Object> tmp209;
    ca_.Bind(&block32, &tmp206, &tmp207, &tmp208, &tmp209);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 58);
    TNode<Object> tmp210;
    USE(tmp210);
    tmp210 = ObjectPreventExtensionsThrow_315(state_, TNode<Context>{tmp206}, TNode<Object>{tmp209});
    CodeStubAssembler(state_).Return(tmp210);
  }

  if (block33.is_used()) {
    TNode<Context> tmp211;
    TNode<JSProxy> tmp212;
    TNode<Oddball> tmp213;
    TNode<Object> tmp214;
    ca_.Bind(&block33, &tmp211, &tmp212, &tmp213, &tmp214);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 60);
    TNode<Object> tmp215;
    USE(tmp215);
    tmp215 = ObjectPreventExtensionsDontThrow_316(state_, TNode<Context>{tmp211}, TNode<Object>{tmp214});
    CodeStubAssembler(state_).Return(tmp215);
  }

  if (block2.is_used()) {
    TNode<Context> tmp216;
    TNode<JSProxy> tmp217;
    TNode<Oddball> tmp218;
    ca_.Bind(&block2, &tmp216, &tmp217, &tmp218);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-prevent-extensions.tq", 63);
    CodeStubAssembler(state_).ThrowTypeError(TNode<Context>{tmp216}, MessageTemplate::kProxyRevoked, "preventExtensions");
  }
}

}  // namespace internal
}  // namespace v8

