#include "src/builtins/builtins-array-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-utils-gen.h"
#include "src/builtins/builtins.h"
#include "src/codegen/code-factory.h"
#include "src/heap/factory-inl.h"
#include "src/objects/arguments.h"
#include "src/objects/bigint.h"
#include "src/objects/elements-kind.h"
#include "src/objects/free-space.h"
#include "src/objects/js-generator.h"
#include "src/objects/js-promise.h"
#include "src/objects/js-regexp-string-iterator.h"
#include "src/objects/js-weak-refs.h"
#include "src/objects/objects.h"
#include "src/objects/source-text-module.h"
#include "src/objects/stack-frame-info.h"
#include "src/objects/synthetic-module.h"
#include "src/objects/template-objects.h"
#include "src/builtins/builtins-bigint-gen.h"
#include "src/builtins/builtins-collections-gen.h"
#include "src/builtins/builtins-data-view-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-iterator-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-constructor-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/objects/js-break-iterator.h"
#include "src/objects/js-collator.h"
#include "src/objects/js-number-format.h"
#include "src/objects/js-objects.h"
#include "src/objects/js-plural-rules.h"
#include "src/objects/js-relative-time-format.h"
#include "src/objects/js-date-time-format.h"
#include "src/objects/js-list-format.h"
#include "src/objects/js-locale.h"
#include "src/objects/js-segment-iterator.h"
#include "src/objects/js-segmenter.h"
#include "torque-generated/../../deps/v8/src/builtins/arguments-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-copywithin-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-join-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-lastindexof-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-map-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-right-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reverse-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-shift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-splice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-unshift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/base-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/bigint-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/boolean-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/collections-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/data-view-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/extras-utils-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/frames-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/growable-fixed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/internal-coverage-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/math-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-fromentries-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-constructor-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-delete-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-has-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-is-extensible-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-prevent-extensions-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revocable-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revoke-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/reflect-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-exec-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-all-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-replace-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-search-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-source-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-split-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-test-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-endswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-html-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-pad-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-repeat-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-startswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-substring-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/torque-internal-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-createtypedarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduceright-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-subarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/third_party/v8/builtins/array-sort-tq-csa.h"
#include "torque-generated/../../deps/v8/test/torque/test-torque-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/intl-objects-tq-csa.h"

namespace v8 {
namespace internal {

TF_BUILTIN(ProxySetPrototypeOf, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  TNode<Context> parameter0 = UncheckedCast<Context>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<JSProxy> parameter1 = UncheckedCast<JSProxy>(Parameter(Descriptor::ParameterIndex<0>()));
  USE(parameter1);
  TNode<HeapObject> parameter2 = UncheckedCast<HeapObject>(Parameter(Descriptor::ParameterIndex<1>()));
  USE(parameter2);
  TNode<Oddball> parameter3 = UncheckedCast<Oddball>(Parameter(Descriptor::ParameterIndex<2>()));
  USE(parameter3);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, BoolT> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, BoolT> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, BoolT, BoolT> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball> block8(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball> block12(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, BoolT> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, BoolT> block17(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, BoolT, BoolT> block18(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball> block15(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball> block14(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball> block13(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, HeapObject> block20(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, HeapObject, JSReceiver> block19(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject, JSReceiver> block24(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject, JSReceiver, JSReceiver> block23(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject> block22(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject, JSReceiver> block21(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject, JSReceiver, Object> block25(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject, JSReceiver, Object> block27(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject, JSReceiver, Object> block28(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject, JSReceiver, Object> block26(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object> block29(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object, BoolT> block33(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object, BoolT> block34(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object, BoolT, BoolT> block35(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object> block32(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object> block31(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object> block30(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object> block36(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object> block37(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object, Object> block38(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, JSReceiver, HeapObject, JSReceiver, Object, Object, Object> block39(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, Object, HeapObject> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, Object, HeapObject> block40(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball, Object, HeapObject> block41(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, HeapObject, Oddball> block2(&ca_, compiler::CodeAssemblerLabel::kDeferred);
    ca_.Goto(&block0, parameter0, parameter1, parameter2, parameter3);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<JSProxy> tmp1;
    TNode<HeapObject> tmp2;
    TNode<Oddball> tmp3;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 14);
    CodeStubAssembler(state_).PerformStackCheck(TNode<Context>{tmp0});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 18);
    ca_.Goto(&block6, tmp0, tmp1, tmp2, tmp3);
  }

  if (block5.is_used()) {
    TNode<Context> tmp4;
    TNode<JSProxy> tmp5;
    TNode<HeapObject> tmp6;
    TNode<Oddball> tmp7;
    ca_.Bind(&block5, &tmp4, &tmp5, &tmp6, &tmp7);
    TNode<Oddball> tmp8;
    USE(tmp8);
    tmp8 = Null_63(state_);
    TNode<BoolT> tmp9;
    USE(tmp9);
    tmp9 = CodeStubAssembler(state_).TaggedEqual(TNode<HeapObject>{tmp6}, TNode<HeapObject>{tmp8});
    ca_.Branch(tmp9, &block9, &block10, tmp4, tmp5, tmp6, tmp7, tmp9);
  }

  if (block9.is_used()) {
    TNode<Context> tmp10;
    TNode<JSProxy> tmp11;
    TNode<HeapObject> tmp12;
    TNode<Oddball> tmp13;
    TNode<BoolT> tmp14;
    ca_.Bind(&block9, &tmp10, &tmp11, &tmp12, &tmp13, &tmp14);
    TNode<BoolT> tmp15;
    USE(tmp15);
    tmp15 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, true);
    ca_.Goto(&block11, tmp10, tmp11, tmp12, tmp13, tmp14, tmp15);
  }

  if (block10.is_used()) {
    TNode<Context> tmp16;
    TNode<JSProxy> tmp17;
    TNode<HeapObject> tmp18;
    TNode<Oddball> tmp19;
    TNode<BoolT> tmp20;
    ca_.Bind(&block10, &tmp16, &tmp17, &tmp18, &tmp19, &tmp20);
    TNode<BoolT> tmp21;
    USE(tmp21);
    tmp21 = Is10JSReceiver21UT6ATNull10JSReceiver_1495(state_, TNode<Context>{tmp16}, TNode<HeapObject>{tmp18});
    ca_.Goto(&block11, tmp16, tmp17, tmp18, tmp19, tmp20, tmp21);
  }

  if (block11.is_used()) {
    TNode<Context> tmp22;
    TNode<JSProxy> tmp23;
    TNode<HeapObject> tmp24;
    TNode<Oddball> tmp25;
    TNode<BoolT> tmp26;
    TNode<BoolT> tmp27;
    ca_.Bind(&block11, &tmp22, &tmp23, &tmp24, &tmp25, &tmp26, &tmp27);
    ca_.Branch(tmp27, &block7, &block8, tmp22, tmp23, tmp24, tmp25);
  }

  if (block8.is_used()) {
    TNode<Context> tmp28;
    TNode<JSProxy> tmp29;
    TNode<HeapObject> tmp30;
    TNode<Oddball> tmp31;
    ca_.Bind(&block8, &tmp28, &tmp29, &tmp30, &tmp31);
    CodeStubAssembler(state_).FailAssert("Torque assert 'proto == Null || Is<JSReceiver>(proto)' failed", "../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 18);
  }

  if (block7.is_used()) {
    TNode<Context> tmp32;
    TNode<JSProxy> tmp33;
    TNode<HeapObject> tmp34;
    TNode<Oddball> tmp35;
    ca_.Bind(&block7, &tmp32, &tmp33, &tmp34, &tmp35);
  }

  if (block6.is_used()) {
    TNode<Context> tmp36;
    TNode<JSProxy> tmp37;
    TNode<HeapObject> tmp38;
    TNode<Oddball> tmp39;
    ca_.Bind(&block6, &tmp36, &tmp37, &tmp38, &tmp39);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 23);
    ca_.Goto(&block13, tmp36, tmp37, tmp38, tmp39);
  }

  if (block12.is_used()) {
    TNode<Context> tmp40;
    TNode<JSProxy> tmp41;
    TNode<HeapObject> tmp42;
    TNode<Oddball> tmp43;
    ca_.Bind(&block12, &tmp40, &tmp41, &tmp42, &tmp43);
    TNode<IntPtrT> tmp44 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp44);
    TNode<HeapObject>tmp45 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp41, tmp44});
    TNode<Oddball> tmp46;
    USE(tmp46);
    tmp46 = Null_63(state_);
    TNode<BoolT> tmp47;
    USE(tmp47);
    tmp47 = CodeStubAssembler(state_).TaggedEqual(TNode<HeapObject>{tmp45}, TNode<HeapObject>{tmp46});
    ca_.Branch(tmp47, &block16, &block17, tmp40, tmp41, tmp42, tmp43, tmp47);
  }

  if (block16.is_used()) {
    TNode<Context> tmp48;
    TNode<JSProxy> tmp49;
    TNode<HeapObject> tmp50;
    TNode<Oddball> tmp51;
    TNode<BoolT> tmp52;
    ca_.Bind(&block16, &tmp48, &tmp49, &tmp50, &tmp51, &tmp52);
    TNode<BoolT> tmp53;
    USE(tmp53);
    tmp53 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, true);
    ca_.Goto(&block18, tmp48, tmp49, tmp50, tmp51, tmp52, tmp53);
  }

  if (block17.is_used()) {
    TNode<Context> tmp54;
    TNode<JSProxy> tmp55;
    TNode<HeapObject> tmp56;
    TNode<Oddball> tmp57;
    TNode<BoolT> tmp58;
    ca_.Bind(&block17, &tmp54, &tmp55, &tmp56, &tmp57, &tmp58);
    TNode<IntPtrT> tmp59 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp59);
    TNode<HeapObject>tmp60 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp55, tmp59});
    TNode<BoolT> tmp61;
    USE(tmp61);
    tmp61 = Is10JSReceiver21UT6ATNull10JSReceiver_1495(state_, TNode<Context>{tmp54}, TNode<HeapObject>{tmp60});
    ca_.Goto(&block18, tmp54, tmp55, tmp56, tmp57, tmp58, tmp61);
  }

  if (block18.is_used()) {
    TNode<Context> tmp62;
    TNode<JSProxy> tmp63;
    TNode<HeapObject> tmp64;
    TNode<Oddball> tmp65;
    TNode<BoolT> tmp66;
    TNode<BoolT> tmp67;
    ca_.Bind(&block18, &tmp62, &tmp63, &tmp64, &tmp65, &tmp66, &tmp67);
    ca_.Branch(tmp67, &block14, &block15, tmp62, tmp63, tmp64, tmp65);
  }

  if (block15.is_used()) {
    TNode<Context> tmp68;
    TNode<JSProxy> tmp69;
    TNode<HeapObject> tmp70;
    TNode<Oddball> tmp71;
    ca_.Bind(&block15, &tmp68, &tmp69, &tmp70, &tmp71);
    CodeStubAssembler(state_).FailAssert("Torque assert 'proxy.handler == Null || Is<JSReceiver>(proxy.handler)' failed", "../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 23);
  }

  if (block14.is_used()) {
    TNode<Context> tmp72;
    TNode<JSProxy> tmp73;
    TNode<HeapObject> tmp74;
    TNode<Oddball> tmp75;
    ca_.Bind(&block14, &tmp72, &tmp73, &tmp74, &tmp75);
  }

  if (block13.is_used()) {
    TNode<Context> tmp76;
    TNode<JSProxy> tmp77;
    TNode<HeapObject> tmp78;
    TNode<Oddball> tmp79;
    ca_.Bind(&block13, &tmp76, &tmp77, &tmp78, &tmp79);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 25);
    TNode<IntPtrT> tmp80 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp80);
    TNode<HeapObject>tmp81 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp77, tmp80});
    TNode<JSReceiver> tmp82;
    USE(tmp82);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp82 = Cast10JSReceiver_143(state_, TNode<HeapObject>{tmp81}, &label0);
    ca_.Goto(&block19, tmp76, tmp77, tmp78, tmp79, tmp81, tmp82);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block20, tmp76, tmp77, tmp78, tmp79, tmp81);
    }
  }

  if (block20.is_used()) {
    TNode<Context> tmp83;
    TNode<JSProxy> tmp84;
    TNode<HeapObject> tmp85;
    TNode<Oddball> tmp86;
    TNode<HeapObject> tmp87;
    ca_.Bind(&block20, &tmp83, &tmp84, &tmp85, &tmp86, &tmp87);
    ca_.Goto(&block2, tmp83, tmp84, tmp85, tmp86);
  }

  if (block19.is_used()) {
    TNode<Context> tmp88;
    TNode<JSProxy> tmp89;
    TNode<HeapObject> tmp90;
    TNode<Oddball> tmp91;
    TNode<HeapObject> tmp92;
    TNode<JSReceiver> tmp93;
    ca_.Bind(&block19, &tmp88, &tmp89, &tmp90, &tmp91, &tmp92, &tmp93);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 28);
    TNode<IntPtrT> tmp94 = ca_.IntPtrConstant(JSProxy::kTargetOffset);
    USE(tmp94);
    TNode<HeapObject>tmp95 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp89, tmp94});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 32);
    TNode<JSReceiver> tmp96;
    USE(tmp96);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp96 = GetMethod_248(state_, TNode<Context>{tmp88}, TNode<Object>{tmp93}, "setPrototypeOf", &label0);
    ca_.Goto(&block23, tmp88, tmp89, tmp90, tmp91, tmp93, tmp95, tmp93, tmp96);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block24, tmp88, tmp89, tmp90, tmp91, tmp93, tmp95, tmp93);
    }
  }

  if (block24.is_used()) {
    TNode<Context> tmp97;
    TNode<JSProxy> tmp98;
    TNode<HeapObject> tmp99;
    TNode<Oddball> tmp100;
    TNode<JSReceiver> tmp101;
    TNode<HeapObject> tmp102;
    TNode<JSReceiver> tmp103;
    ca_.Bind(&block24, &tmp97, &tmp98, &tmp99, &tmp100, &tmp101, &tmp102, &tmp103);
    ca_.Goto(&block22, tmp97, tmp98, tmp99, tmp100, tmp101, tmp102);
  }

  if (block23.is_used()) {
    TNode<Context> tmp104;
    TNode<JSProxy> tmp105;
    TNode<HeapObject> tmp106;
    TNode<Oddball> tmp107;
    TNode<JSReceiver> tmp108;
    TNode<HeapObject> tmp109;
    TNode<JSReceiver> tmp110;
    TNode<JSReceiver> tmp111;
    ca_.Bind(&block23, &tmp104, &tmp105, &tmp106, &tmp107, &tmp108, &tmp109, &tmp110, &tmp111);
    ca_.Goto(&block21, tmp104, tmp105, tmp106, tmp107, tmp108, tmp109, tmp111);
  }

  if (block22.is_used()) {
    TNode<Context> tmp112;
    TNode<JSProxy> tmp113;
    TNode<HeapObject> tmp114;
    TNode<Oddball> tmp115;
    TNode<JSReceiver> tmp116;
    TNode<HeapObject> tmp117;
    ca_.Bind(&block22, &tmp112, &tmp113, &tmp114, &tmp115, &tmp116, &tmp117);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 33);
    ca_.Goto(&block4, tmp112, tmp113, tmp114, tmp115, tmp117, tmp114);
  }

  if (block21.is_used()) {
    TNode<Context> tmp118;
    TNode<JSProxy> tmp119;
    TNode<HeapObject> tmp120;
    TNode<Oddball> tmp121;
    TNode<JSReceiver> tmp122;
    TNode<HeapObject> tmp123;
    TNode<JSReceiver> tmp124;
    ca_.Bind(&block21, &tmp118, &tmp119, &tmp120, &tmp121, &tmp122, &tmp123, &tmp124);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 32);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 37);
    TNode<Object> tmp125;
    USE(tmp125);
    tmp125 = CodeStubAssembler(state_).Call(TNode<Context>{tmp118}, TNode<JSReceiver>{tmp124}, TNode<Object>{tmp122}, TNode<Object>{tmp123}, TNode<Object>{tmp120});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 40);
    TNode<BoolT> tmp126;
    USE(tmp126);
    tmp126 = ToBoolean_243(state_, TNode<Object>{tmp125});
    TNode<BoolT> tmp127;
    USE(tmp127);
    tmp127 = CodeStubAssembler(state_).Word32BinaryNot(TNode<BoolT>{tmp126});
    ca_.Branch(tmp127, &block25, &block26, tmp118, tmp119, tmp120, tmp121, tmp122, tmp123, tmp124, tmp125);
  }

  if (block25.is_used()) {
    TNode<Context> tmp128;
    TNode<JSProxy> tmp129;
    TNode<HeapObject> tmp130;
    TNode<Oddball> tmp131;
    TNode<JSReceiver> tmp132;
    TNode<HeapObject> tmp133;
    TNode<JSReceiver> tmp134;
    TNode<Object> tmp135;
    ca_.Bind(&block25, &tmp128, &tmp129, &tmp130, &tmp131, &tmp132, &tmp133, &tmp134, &tmp135);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 41);
    TNode<Oddball> tmp136;
    USE(tmp136);
    tmp136 = True_65(state_);
    TNode<BoolT> tmp137;
    USE(tmp137);
    tmp137 = CodeStubAssembler(state_).TaggedEqual(TNode<HeapObject>{tmp131}, TNode<HeapObject>{tmp136});
    ca_.Branch(tmp137, &block27, &block28, tmp128, tmp129, tmp130, tmp131, tmp132, tmp133, tmp134, tmp135);
  }

  if (block27.is_used()) {
    TNode<Context> tmp138;
    TNode<JSProxy> tmp139;
    TNode<HeapObject> tmp140;
    TNode<Oddball> tmp141;
    TNode<JSReceiver> tmp142;
    TNode<HeapObject> tmp143;
    TNode<JSReceiver> tmp144;
    TNode<Object> tmp145;
    ca_.Bind(&block27, &tmp138, &tmp139, &tmp140, &tmp141, &tmp142, &tmp143, &tmp144, &tmp145);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 42);
    CodeStubAssembler(state_).ThrowTypeError(TNode<Context>{tmp138}, MessageTemplate::kProxyTrapReturnedFalsishFor, "setPrototypeOf");
  }

  if (block28.is_used()) {
    TNode<Context> tmp146;
    TNode<JSProxy> tmp147;
    TNode<HeapObject> tmp148;
    TNode<Oddball> tmp149;
    TNode<JSReceiver> tmp150;
    TNode<HeapObject> tmp151;
    TNode<JSReceiver> tmp152;
    TNode<Object> tmp153;
    ca_.Bind(&block28, &tmp146, &tmp147, &tmp148, &tmp149, &tmp150, &tmp151, &tmp152, &tmp153);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 44);
    TNode<Oddball> tmp154;
    USE(tmp154);
    tmp154 = False_66(state_);
    CodeStubAssembler(state_).Return(tmp154);
  }

  if (block26.is_used()) {
    TNode<Context> tmp155;
    TNode<JSProxy> tmp156;
    TNode<HeapObject> tmp157;
    TNode<Oddball> tmp158;
    TNode<JSReceiver> tmp159;
    TNode<HeapObject> tmp160;
    TNode<JSReceiver> tmp161;
    TNode<Object> tmp162;
    ca_.Bind(&block26, &tmp155, &tmp156, &tmp157, &tmp158, &tmp159, &tmp160, &tmp161, &tmp162);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 49);
    TNode<Object> tmp163;
    USE(tmp163);
    tmp163 = ObjectIsExtensible_314(state_, TNode<Context>{tmp155}, TNode<Object>{tmp160});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 50);
    ca_.Goto(&block30, tmp155, tmp156, tmp157, tmp158, tmp159, tmp160, tmp161, tmp162, tmp163);
  }

  if (block29.is_used()) {
    TNode<Context> tmp164;
    TNode<JSProxy> tmp165;
    TNode<HeapObject> tmp166;
    TNode<Oddball> tmp167;
    TNode<JSReceiver> tmp168;
    TNode<HeapObject> tmp169;
    TNode<JSReceiver> tmp170;
    TNode<Object> tmp171;
    TNode<Object> tmp172;
    ca_.Bind(&block29, &tmp164, &tmp165, &tmp166, &tmp167, &tmp168, &tmp169, &tmp170, &tmp171, &tmp172);
    TNode<Oddball> tmp173;
    USE(tmp173);
    tmp173 = True_65(state_);
    TNode<BoolT> tmp174;
    USE(tmp174);
    tmp174 = CodeStubAssembler(state_).TaggedEqual(TNode<Object>{tmp172}, TNode<HeapObject>{tmp173});
    ca_.Branch(tmp174, &block33, &block34, tmp164, tmp165, tmp166, tmp167, tmp168, tmp169, tmp170, tmp171, tmp172, tmp174);
  }

  if (block33.is_used()) {
    TNode<Context> tmp175;
    TNode<JSProxy> tmp176;
    TNode<HeapObject> tmp177;
    TNode<Oddball> tmp178;
    TNode<JSReceiver> tmp179;
    TNode<HeapObject> tmp180;
    TNode<JSReceiver> tmp181;
    TNode<Object> tmp182;
    TNode<Object> tmp183;
    TNode<BoolT> tmp184;
    ca_.Bind(&block33, &tmp175, &tmp176, &tmp177, &tmp178, &tmp179, &tmp180, &tmp181, &tmp182, &tmp183, &tmp184);
    TNode<BoolT> tmp185;
    USE(tmp185);
    tmp185 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, true);
    ca_.Goto(&block35, tmp175, tmp176, tmp177, tmp178, tmp179, tmp180, tmp181, tmp182, tmp183, tmp184, tmp185);
  }

  if (block34.is_used()) {
    TNode<Context> tmp186;
    TNode<JSProxy> tmp187;
    TNode<HeapObject> tmp188;
    TNode<Oddball> tmp189;
    TNode<JSReceiver> tmp190;
    TNode<HeapObject> tmp191;
    TNode<JSReceiver> tmp192;
    TNode<Object> tmp193;
    TNode<Object> tmp194;
    TNode<BoolT> tmp195;
    ca_.Bind(&block34, &tmp186, &tmp187, &tmp188, &tmp189, &tmp190, &tmp191, &tmp192, &tmp193, &tmp194, &tmp195);
    TNode<Oddball> tmp196;
    USE(tmp196);
    tmp196 = False_66(state_);
    TNode<BoolT> tmp197;
    USE(tmp197);
    tmp197 = CodeStubAssembler(state_).TaggedEqual(TNode<Object>{tmp194}, TNode<HeapObject>{tmp196});
    ca_.Goto(&block35, tmp186, tmp187, tmp188, tmp189, tmp190, tmp191, tmp192, tmp193, tmp194, tmp195, tmp197);
  }

  if (block35.is_used()) {
    TNode<Context> tmp198;
    TNode<JSProxy> tmp199;
    TNode<HeapObject> tmp200;
    TNode<Oddball> tmp201;
    TNode<JSReceiver> tmp202;
    TNode<HeapObject> tmp203;
    TNode<JSReceiver> tmp204;
    TNode<Object> tmp205;
    TNode<Object> tmp206;
    TNode<BoolT> tmp207;
    TNode<BoolT> tmp208;
    ca_.Bind(&block35, &tmp198, &tmp199, &tmp200, &tmp201, &tmp202, &tmp203, &tmp204, &tmp205, &tmp206, &tmp207, &tmp208);
    ca_.Branch(tmp208, &block31, &block32, tmp198, tmp199, tmp200, tmp201, tmp202, tmp203, tmp204, tmp205, tmp206);
  }

  if (block32.is_used()) {
    TNode<Context> tmp209;
    TNode<JSProxy> tmp210;
    TNode<HeapObject> tmp211;
    TNode<Oddball> tmp212;
    TNode<JSReceiver> tmp213;
    TNode<HeapObject> tmp214;
    TNode<JSReceiver> tmp215;
    TNode<Object> tmp216;
    TNode<Object> tmp217;
    ca_.Bind(&block32, &tmp209, &tmp210, &tmp211, &tmp212, &tmp213, &tmp214, &tmp215, &tmp216, &tmp217);
    CodeStubAssembler(state_).FailAssert("Torque assert 'extensibleTarget == True || extensibleTarget == False' failed", "../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 50);
  }

  if (block31.is_used()) {
    TNode<Context> tmp218;
    TNode<JSProxy> tmp219;
    TNode<HeapObject> tmp220;
    TNode<Oddball> tmp221;
    TNode<JSReceiver> tmp222;
    TNode<HeapObject> tmp223;
    TNode<JSReceiver> tmp224;
    TNode<Object> tmp225;
    TNode<Object> tmp226;
    ca_.Bind(&block31, &tmp218, &tmp219, &tmp220, &tmp221, &tmp222, &tmp223, &tmp224, &tmp225, &tmp226);
  }

  if (block30.is_used()) {
    TNode<Context> tmp227;
    TNode<JSProxy> tmp228;
    TNode<HeapObject> tmp229;
    TNode<Oddball> tmp230;
    TNode<JSReceiver> tmp231;
    TNode<HeapObject> tmp232;
    TNode<JSReceiver> tmp233;
    TNode<Object> tmp234;
    TNode<Object> tmp235;
    ca_.Bind(&block30, &tmp227, &tmp228, &tmp229, &tmp230, &tmp231, &tmp232, &tmp233, &tmp234, &tmp235);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 51);
    TNode<Oddball> tmp236;
    USE(tmp236);
    tmp236 = True_65(state_);
    TNode<BoolT> tmp237;
    USE(tmp237);
    tmp237 = CodeStubAssembler(state_).TaggedEqual(TNode<Object>{tmp235}, TNode<HeapObject>{tmp236});
    ca_.Branch(tmp237, &block36, &block37, tmp227, tmp228, tmp229, tmp230, tmp231, tmp232, tmp233, tmp234, tmp235);
  }

  if (block36.is_used()) {
    TNode<Context> tmp238;
    TNode<JSProxy> tmp239;
    TNode<HeapObject> tmp240;
    TNode<Oddball> tmp241;
    TNode<JSReceiver> tmp242;
    TNode<HeapObject> tmp243;
    TNode<JSReceiver> tmp244;
    TNode<Object> tmp245;
    TNode<Object> tmp246;
    ca_.Bind(&block36, &tmp238, &tmp239, &tmp240, &tmp241, &tmp242, &tmp243, &tmp244, &tmp245, &tmp246);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 52);
    TNode<Oddball> tmp247;
    USE(tmp247);
    tmp247 = True_65(state_);
    CodeStubAssembler(state_).Return(tmp247);
  }

  if (block37.is_used()) {
    TNode<Context> tmp248;
    TNode<JSProxy> tmp249;
    TNode<HeapObject> tmp250;
    TNode<Oddball> tmp251;
    TNode<JSReceiver> tmp252;
    TNode<HeapObject> tmp253;
    TNode<JSReceiver> tmp254;
    TNode<Object> tmp255;
    TNode<Object> tmp256;
    ca_.Bind(&block37, &tmp248, &tmp249, &tmp250, &tmp251, &tmp252, &tmp253, &tmp254, &tmp255, &tmp256);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 56);
    TNode<Object> tmp257;
    USE(tmp257);
    tmp257 = ObjectGetPrototypeOf_317(state_, TNode<Context>{tmp248}, TNode<Object>{tmp253});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 61);
    TNode<BoolT> tmp258;
    USE(tmp258);
    tmp258 = SameValue_245(state_, TNode<Object>{tmp250}, TNode<Object>{tmp257});
    ca_.Branch(tmp258, &block38, &block39, tmp248, tmp249, tmp250, tmp251, tmp252, tmp253, tmp254, tmp255, tmp256, tmp257);
  }

  if (block38.is_used()) {
    TNode<Context> tmp259;
    TNode<JSProxy> tmp260;
    TNode<HeapObject> tmp261;
    TNode<Oddball> tmp262;
    TNode<JSReceiver> tmp263;
    TNode<HeapObject> tmp264;
    TNode<JSReceiver> tmp265;
    TNode<Object> tmp266;
    TNode<Object> tmp267;
    TNode<Object> tmp268;
    ca_.Bind(&block38, &tmp259, &tmp260, &tmp261, &tmp262, &tmp263, &tmp264, &tmp265, &tmp266, &tmp267, &tmp268);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 62);
    TNode<Oddball> tmp269;
    USE(tmp269);
    tmp269 = True_65(state_);
    CodeStubAssembler(state_).Return(tmp269);
  }

  if (block39.is_used()) {
    TNode<Context> tmp270;
    TNode<JSProxy> tmp271;
    TNode<HeapObject> tmp272;
    TNode<Oddball> tmp273;
    TNode<JSReceiver> tmp274;
    TNode<HeapObject> tmp275;
    TNode<JSReceiver> tmp276;
    TNode<Object> tmp277;
    TNode<Object> tmp278;
    TNode<Object> tmp279;
    ca_.Bind(&block39, &tmp270, &tmp271, &tmp272, &tmp273, &tmp274, &tmp275, &tmp276, &tmp277, &tmp278, &tmp279);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 64);
    CodeStubAssembler(state_).ThrowTypeError(TNode<Context>{tmp270}, MessageTemplate::kProxySetPrototypeOfNonExtensible);
  }

  if (block4.is_used()) {
    TNode<Context> tmp280;
    TNode<JSProxy> tmp281;
    TNode<HeapObject> tmp282;
    TNode<Oddball> tmp283;
    TNode<Object> tmp284;
    TNode<HeapObject> tmp285;
    ca_.Bind(&block4, &tmp280, &tmp281, &tmp282, &tmp283, &tmp284, &tmp285);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 68);
    TNode<Oddball> tmp286;
    USE(tmp286);
    tmp286 = True_65(state_);
    TNode<BoolT> tmp287;
    USE(tmp287);
    tmp287 = CodeStubAssembler(state_).TaggedEqual(TNode<HeapObject>{tmp283}, TNode<HeapObject>{tmp286});
    ca_.Branch(tmp287, &block40, &block41, tmp280, tmp281, tmp282, tmp283, tmp284, tmp285);
  }

  if (block40.is_used()) {
    TNode<Context> tmp288;
    TNode<JSProxy> tmp289;
    TNode<HeapObject> tmp290;
    TNode<Oddball> tmp291;
    TNode<Object> tmp292;
    TNode<HeapObject> tmp293;
    ca_.Bind(&block40, &tmp288, &tmp289, &tmp290, &tmp291, &tmp292, &tmp293);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 69);
    TNode<Object> tmp294;
    USE(tmp294);
    tmp294 = ObjectSetPrototypeOfThrow_319(state_, TNode<Context>{tmp288}, TNode<Object>{tmp292}, TNode<HeapObject>{tmp293});
    CodeStubAssembler(state_).Return(tmp294);
  }

  if (block41.is_used()) {
    TNode<Context> tmp295;
    TNode<JSProxy> tmp296;
    TNode<HeapObject> tmp297;
    TNode<Oddball> tmp298;
    TNode<Object> tmp299;
    TNode<HeapObject> tmp300;
    ca_.Bind(&block41, &tmp295, &tmp296, &tmp297, &tmp298, &tmp299, &tmp300);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 71);
    TNode<Object> tmp301;
    USE(tmp301);
    tmp301 = ObjectSetPrototypeOfDontThrow_320(state_, TNode<Context>{tmp295}, TNode<Object>{tmp299}, TNode<HeapObject>{tmp300});
    CodeStubAssembler(state_).Return(tmp301);
  }

  if (block2.is_used()) {
    TNode<Context> tmp302;
    TNode<JSProxy> tmp303;
    TNode<HeapObject> tmp304;
    TNode<Oddball> tmp305;
    ca_.Bind(&block2, &tmp302, &tmp303, &tmp304, &tmp305);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-set-prototype-of.tq", 74);
    CodeStubAssembler(state_).ThrowTypeError(TNode<Context>{tmp302}, MessageTemplate::kProxyRevoked, "setPrototypeOf");
  }
}

}  // namespace internal
}  // namespace v8

