#include "src/builtins/builtins-array-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-utils-gen.h"
#include "src/builtins/builtins.h"
#include "src/codegen/code-factory.h"
#include "src/heap/factory-inl.h"
#include "src/objects/arguments.h"
#include "src/objects/bigint.h"
#include "src/objects/elements-kind.h"
#include "src/objects/free-space.h"
#include "src/objects/js-generator.h"
#include "src/objects/js-promise.h"
#include "src/objects/js-regexp-string-iterator.h"
#include "src/objects/js-weak-refs.h"
#include "src/objects/objects.h"
#include "src/objects/source-text-module.h"
#include "src/objects/stack-frame-info.h"
#include "src/objects/synthetic-module.h"
#include "src/objects/template-objects.h"
#include "src/builtins/builtins-bigint-gen.h"
#include "src/builtins/builtins-collections-gen.h"
#include "src/builtins/builtins-data-view-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-iterator-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-constructor-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/objects/js-break-iterator.h"
#include "src/objects/js-collator.h"
#include "src/objects/js-number-format.h"
#include "src/objects/js-objects.h"
#include "src/objects/js-plural-rules.h"
#include "src/objects/js-relative-time-format.h"
#include "src/objects/js-date-time-format.h"
#include "src/objects/js-list-format.h"
#include "src/objects/js-locale.h"
#include "src/objects/js-segment-iterator.h"
#include "src/objects/js-segmenter.h"
#include "torque-generated/../../deps/v8/src/builtins/arguments-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-copywithin-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-join-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-lastindexof-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-map-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-right-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reverse-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-shift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-splice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-unshift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/base-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/bigint-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/boolean-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/collections-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/data-view-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/extras-utils-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/frames-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/growable-fixed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/internal-coverage-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/math-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-fromentries-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-constructor-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-delete-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-has-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-is-extensible-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-prevent-extensions-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revocable-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revoke-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/reflect-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-exec-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-all-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-replace-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-search-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-source-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-split-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-test-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-endswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-html-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-pad-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-repeat-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-startswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-substring-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/torque-internal-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-createtypedarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduceright-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-subarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/third_party/v8/builtins/array-sort-tq-csa.h"
#include "torque-generated/../../deps/v8/test/torque/test-torque-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/intl-objects-tq-csa.h"

namespace v8 {
namespace internal {

int31_t kStringPadStart_349(compiler::CodeAssemblerState* state_) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0);

    ca_.Bind(&block0);
return 0;
}

int31_t kStringPadEnd_350(compiler::CodeAssemblerState* state_) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0);

    ca_.Bind(&block0);
return 1;
}

TNode<String> StringPad_351(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<Object> p_receiver, TorqueStructArguments p_arguments, const char* p_methodName, int31_t p_variant) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number> block7(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, Number, Number> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, Number, Number, Smi> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, Number, Smi> block12(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, Number, Smi> block13(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, Number> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, Number> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT> block14(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Object> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Object> block18(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Object> block19(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Object> block17(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT> block15(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT> block20(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT> block23(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT> block22(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT> block21(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT> block24(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT> block25(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi> block26(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi> block27(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi> block28(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi> block31(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi> block30(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi> block29(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi, Smi, String> block32(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi, Smi, String> block33(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi, Smi, String, Int32T, Int32T, Int32T, Int32T> block35(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi, Smi, String, Int32T, Int32T, Int32T, Int32T> block36(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi, Smi, String> block34(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi, Smi, String> block37(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi, Smi, String> block40(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi, Smi, String> block39(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi, Smi, String> block38(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi, Smi, String> block41(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi, Smi, String> block42(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi, Smi, String> block43(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi, Smi, String> block46(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi, Smi, String> block45(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String, Smi, Number, String, IntPtrT, Smi, Smi, String> block44(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, RawPtrT, RawPtrT, IntPtrT, String> block47(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_receiver, p_arguments.frame, p_arguments.base, p_arguments.length);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<Object> tmp1;
    TNode<RawPtrT> tmp2;
    TNode<RawPtrT> tmp3;
    TNode<IntPtrT> tmp4;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 18);
    TNode<String> tmp5;
    USE(tmp5);
    tmp5 = FromConstexpr6String18ATconstexpr_string_157(state_, p_methodName);
    TNode<String> tmp6;
    USE(tmp6);
    tmp6 = CodeStubAssembler(state_).ToThisString(TNode<Context>{tmp0}, TNode<Object>{tmp1}, TNode<String>{tmp5});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 19);
    TNode<Smi> tmp7;
    USE(tmp7);
    tmp7 = CodeStubAssembler(state_).LoadStringLengthAsSmi(TNode<String>{tmp6});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 21);
    TNode<IntPtrT> tmp8;
    USE(tmp8);
    tmp8 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, 0);
    TNode<BoolT> tmp9;
    USE(tmp9);
    tmp9 = CodeStubAssembler(state_).WordEqual(TNode<IntPtrT>{tmp4}, TNode<IntPtrT>{tmp8});
    ca_.Branch(tmp9, &block2, &block3, tmp0, tmp1, tmp2, tmp3, tmp4, tmp6, tmp7);
  }

  if (block2.is_used()) {
    TNode<Context> tmp10;
    TNode<Object> tmp11;
    TNode<RawPtrT> tmp12;
    TNode<RawPtrT> tmp13;
    TNode<IntPtrT> tmp14;
    TNode<String> tmp15;
    TNode<Smi> tmp16;
    ca_.Bind(&block2, &tmp10, &tmp11, &tmp12, &tmp13, &tmp14, &tmp15, &tmp16);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 22);
    ca_.Goto(&block1, tmp10, tmp11, tmp12, tmp13, tmp14, tmp15);
  }

  if (block3.is_used()) {
    TNode<Context> tmp17;
    TNode<Object> tmp18;
    TNode<RawPtrT> tmp19;
    TNode<RawPtrT> tmp20;
    TNode<IntPtrT> tmp21;
    TNode<String> tmp22;
    TNode<Smi> tmp23;
    ca_.Bind(&block3, &tmp17, &tmp18, &tmp19, &tmp20, &tmp21, &tmp22, &tmp23);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 24);
    TNode<IntPtrT> tmp24;
    USE(tmp24);
    tmp24 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, 0);
    TNode<Object> tmp25;
    USE(tmp25);
    tmp25 = CodeStubAssembler(state_).GetArgumentValue(TorqueStructArguments{TNode<RawPtrT>{tmp19}, TNode<RawPtrT>{tmp20}, TNode<IntPtrT>{tmp21}}, TNode<IntPtrT>{tmp24});
    TNode<Number> tmp26;
    USE(tmp26);
    tmp26 = CodeStubAssembler(state_).ToLength_Inline(TNode<Context>{tmp17}, TNode<Object>{tmp25});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 25);
    ca_.Goto(&block5, tmp17, tmp18, tmp19, tmp20, tmp21, tmp22, tmp23, tmp26);
  }

  if (block4.is_used()) {
    TNode<Context> tmp27;
    TNode<Object> tmp28;
    TNode<RawPtrT> tmp29;
    TNode<RawPtrT> tmp30;
    TNode<IntPtrT> tmp31;
    TNode<String> tmp32;
    TNode<Smi> tmp33;
    TNode<Number> tmp34;
    ca_.Bind(&block4, &tmp27, &tmp28, &tmp29, &tmp30, &tmp31, &tmp32, &tmp33, &tmp34);
    TNode<BoolT> tmp35;
    USE(tmp35);
    tmp35 = CodeStubAssembler(state_).IsNumberNormalized(TNode<Number>{tmp34});
    ca_.Branch(tmp35, &block6, &block7, tmp27, tmp28, tmp29, tmp30, tmp31, tmp32, tmp33, tmp34);
  }

  if (block7.is_used()) {
    TNode<Context> tmp36;
    TNode<Object> tmp37;
    TNode<RawPtrT> tmp38;
    TNode<RawPtrT> tmp39;
    TNode<IntPtrT> tmp40;
    TNode<String> tmp41;
    TNode<Smi> tmp42;
    TNode<Number> tmp43;
    ca_.Bind(&block7, &tmp36, &tmp37, &tmp38, &tmp39, &tmp40, &tmp41, &tmp42, &tmp43);
    CodeStubAssembler(state_).FailAssert("Torque assert 'IsNumberNormalized(maxLength)' failed", "../../deps/v8/src/builtins/string-pad.tq", 25);
  }

  if (block6.is_used()) {
    TNode<Context> tmp44;
    TNode<Object> tmp45;
    TNode<RawPtrT> tmp46;
    TNode<RawPtrT> tmp47;
    TNode<IntPtrT> tmp48;
    TNode<String> tmp49;
    TNode<Smi> tmp50;
    TNode<Number> tmp51;
    ca_.Bind(&block6, &tmp44, &tmp45, &tmp46, &tmp47, &tmp48, &tmp49, &tmp50, &tmp51);
  }

  if (block5.is_used()) {
    TNode<Context> tmp52;
    TNode<Object> tmp53;
    TNode<RawPtrT> tmp54;
    TNode<RawPtrT> tmp55;
    TNode<IntPtrT> tmp56;
    TNode<String> tmp57;
    TNode<Smi> tmp58;
    TNode<Number> tmp59;
    ca_.Bind(&block5, &tmp52, &tmp53, &tmp54, &tmp55, &tmp56, &tmp57, &tmp58, &tmp59);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 27);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 28);
    TNode<Smi> tmp60;
    USE(tmp60);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp60 = Cast5ATSmi_83(state_, TNode<Object>{tmp59}, &label0);
    ca_.Goto(&block10, tmp52, tmp53, tmp54, tmp55, tmp56, tmp57, tmp58, tmp59, tmp59, tmp59, tmp60);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block11, tmp52, tmp53, tmp54, tmp55, tmp56, tmp57, tmp58, tmp59, tmp59, tmp59);
    }
  }

  if (block11.is_used()) {
    TNode<Context> tmp61;
    TNode<Object> tmp62;
    TNode<RawPtrT> tmp63;
    TNode<RawPtrT> tmp64;
    TNode<IntPtrT> tmp65;
    TNode<String> tmp66;
    TNode<Smi> tmp67;
    TNode<Number> tmp68;
    TNode<Number> tmp69;
    TNode<Number> tmp70;
    ca_.Bind(&block11, &tmp61, &tmp62, &tmp63, &tmp64, &tmp65, &tmp66, &tmp67, &tmp68, &tmp69, &tmp70);
    ca_.Goto(&block9, tmp61, tmp62, tmp63, tmp64, tmp65, tmp66, tmp67, tmp68, tmp69);
  }

  if (block10.is_used()) {
    TNode<Context> tmp71;
    TNode<Object> tmp72;
    TNode<RawPtrT> tmp73;
    TNode<RawPtrT> tmp74;
    TNode<IntPtrT> tmp75;
    TNode<String> tmp76;
    TNode<Smi> tmp77;
    TNode<Number> tmp78;
    TNode<Number> tmp79;
    TNode<Number> tmp80;
    TNode<Smi> tmp81;
    ca_.Bind(&block10, &tmp71, &tmp72, &tmp73, &tmp74, &tmp75, &tmp76, &tmp77, &tmp78, &tmp79, &tmp80, &tmp81);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 29);
    TNode<BoolT> tmp82;
    USE(tmp82);
    tmp82 = CodeStubAssembler(state_).SmiLessThanOrEqual(TNode<Smi>{tmp81}, TNode<Smi>{tmp77});
    ca_.Branch(tmp82, &block12, &block13, tmp71, tmp72, tmp73, tmp74, tmp75, tmp76, tmp77, tmp78, tmp79, tmp81);
  }

  if (block12.is_used()) {
    TNode<Context> tmp83;
    TNode<Object> tmp84;
    TNode<RawPtrT> tmp85;
    TNode<RawPtrT> tmp86;
    TNode<IntPtrT> tmp87;
    TNode<String> tmp88;
    TNode<Smi> tmp89;
    TNode<Number> tmp90;
    TNode<Number> tmp91;
    TNode<Smi> tmp92;
    ca_.Bind(&block12, &tmp83, &tmp84, &tmp85, &tmp86, &tmp87, &tmp88, &tmp89, &tmp90, &tmp91, &tmp92);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 30);
    ca_.Goto(&block1, tmp83, tmp84, tmp85, tmp86, tmp87, tmp88);
  }

  if (block13.is_used()) {
    TNode<Context> tmp93;
    TNode<Object> tmp94;
    TNode<RawPtrT> tmp95;
    TNode<RawPtrT> tmp96;
    TNode<IntPtrT> tmp97;
    TNode<String> tmp98;
    TNode<Smi> tmp99;
    TNode<Number> tmp100;
    TNode<Number> tmp101;
    TNode<Smi> tmp102;
    ca_.Bind(&block13, &tmp93, &tmp94, &tmp95, &tmp96, &tmp97, &tmp98, &tmp99, &tmp100, &tmp101, &tmp102);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 28);
    ca_.Goto(&block8, tmp93, tmp94, tmp95, tmp96, tmp97, tmp98, tmp99, tmp100, tmp101);
  }

  if (block9.is_used()) {
    TNode<Context> tmp103;
    TNode<Object> tmp104;
    TNode<RawPtrT> tmp105;
    TNode<RawPtrT> tmp106;
    TNode<IntPtrT> tmp107;
    TNode<String> tmp108;
    TNode<Smi> tmp109;
    TNode<Number> tmp110;
    TNode<Number> tmp111;
    ca_.Bind(&block9, &tmp103, &tmp104, &tmp105, &tmp106, &tmp107, &tmp108, &tmp109, &tmp110, &tmp111);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 33);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 28);
    ca_.Goto(&block8, tmp103, tmp104, tmp105, tmp106, tmp107, tmp108, tmp109, tmp110, tmp111);
  }

  if (block8.is_used()) {
    TNode<Context> tmp112;
    TNode<Object> tmp113;
    TNode<RawPtrT> tmp114;
    TNode<RawPtrT> tmp115;
    TNode<IntPtrT> tmp116;
    TNode<String> tmp117;
    TNode<Smi> tmp118;
    TNode<Number> tmp119;
    TNode<Number> tmp120;
    ca_.Bind(&block8, &tmp112, &tmp113, &tmp114, &tmp115, &tmp116, &tmp117, &tmp118, &tmp119, &tmp120);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 27);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 37);
    TNode<String> tmp121;
    USE(tmp121);
    tmp121 = FromConstexpr6String18ATconstexpr_string_157(state_, " ");
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 38);
    TNode<IntPtrT> tmp122;
    USE(tmp122);
    tmp122 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, 1);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 40);
    TNode<IntPtrT> tmp123;
    USE(tmp123);
    tmp123 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, 1);
    TNode<BoolT> tmp124;
    USE(tmp124);
    tmp124 = CodeStubAssembler(state_).WordNotEqual(TNode<IntPtrT>{tmp116}, TNode<IntPtrT>{tmp123});
    ca_.Branch(tmp124, &block14, &block15, tmp112, tmp113, tmp114, tmp115, tmp116, tmp117, tmp118, tmp119, tmp121, tmp122);
  }

  if (block14.is_used()) {
    TNode<Context> tmp125;
    TNode<Object> tmp126;
    TNode<RawPtrT> tmp127;
    TNode<RawPtrT> tmp128;
    TNode<IntPtrT> tmp129;
    TNode<String> tmp130;
    TNode<Smi> tmp131;
    TNode<Number> tmp132;
    TNode<String> tmp133;
    TNode<IntPtrT> tmp134;
    ca_.Bind(&block14, &tmp125, &tmp126, &tmp127, &tmp128, &tmp129, &tmp130, &tmp131, &tmp132, &tmp133, &tmp134);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 41);
    TNode<IntPtrT> tmp135;
    USE(tmp135);
    tmp135 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, 1);
    TNode<Object> tmp136;
    USE(tmp136);
    tmp136 = CodeStubAssembler(state_).GetArgumentValue(TorqueStructArguments{TNode<RawPtrT>{tmp127}, TNode<RawPtrT>{tmp128}, TNode<IntPtrT>{tmp129}}, TNode<IntPtrT>{tmp135});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 42);
    TNode<Oddball> tmp137;
    USE(tmp137);
    tmp137 = Undefined_64(state_);
    TNode<BoolT> tmp138;
    USE(tmp138);
    tmp138 = CodeStubAssembler(state_).TaggedNotEqual(TNode<Object>{tmp136}, TNode<HeapObject>{tmp137});
    ca_.Branch(tmp138, &block16, &block17, tmp125, tmp126, tmp127, tmp128, tmp129, tmp130, tmp131, tmp132, tmp133, tmp134, tmp136);
  }

  if (block16.is_used()) {
    TNode<Context> tmp139;
    TNode<Object> tmp140;
    TNode<RawPtrT> tmp141;
    TNode<RawPtrT> tmp142;
    TNode<IntPtrT> tmp143;
    TNode<String> tmp144;
    TNode<Smi> tmp145;
    TNode<Number> tmp146;
    TNode<String> tmp147;
    TNode<IntPtrT> tmp148;
    TNode<Object> tmp149;
    ca_.Bind(&block16, &tmp139, &tmp140, &tmp141, &tmp142, &tmp143, &tmp144, &tmp145, &tmp146, &tmp147, &tmp148, &tmp149);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 43);
    TNode<String> tmp150;
    USE(tmp150);
    tmp150 = CodeStubAssembler(state_).ToString_Inline(TNode<Context>{tmp139}, TNode<Object>{tmp149});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 44);
    TNode<IntPtrT> tmp151;
    USE(tmp151);
    tmp151 = CodeStubAssembler(state_).LoadStringLengthAsWord(TNode<String>{tmp150});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 45);
    TNode<IntPtrT> tmp152;
    USE(tmp152);
    tmp152 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, 0);
    TNode<BoolT> tmp153;
    USE(tmp153);
    tmp153 = CodeStubAssembler(state_).WordEqual(TNode<IntPtrT>{tmp151}, TNode<IntPtrT>{tmp152});
    ca_.Branch(tmp153, &block18, &block19, tmp139, tmp140, tmp141, tmp142, tmp143, tmp144, tmp145, tmp146, tmp150, tmp151, tmp149);
  }

  if (block18.is_used()) {
    TNode<Context> tmp154;
    TNode<Object> tmp155;
    TNode<RawPtrT> tmp156;
    TNode<RawPtrT> tmp157;
    TNode<IntPtrT> tmp158;
    TNode<String> tmp159;
    TNode<Smi> tmp160;
    TNode<Number> tmp161;
    TNode<String> tmp162;
    TNode<IntPtrT> tmp163;
    TNode<Object> tmp164;
    ca_.Bind(&block18, &tmp154, &tmp155, &tmp156, &tmp157, &tmp158, &tmp159, &tmp160, &tmp161, &tmp162, &tmp163, &tmp164);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 46);
    ca_.Goto(&block1, tmp154, tmp155, tmp156, tmp157, tmp158, tmp159);
  }

  if (block19.is_used()) {
    TNode<Context> tmp165;
    TNode<Object> tmp166;
    TNode<RawPtrT> tmp167;
    TNode<RawPtrT> tmp168;
    TNode<IntPtrT> tmp169;
    TNode<String> tmp170;
    TNode<Smi> tmp171;
    TNode<Number> tmp172;
    TNode<String> tmp173;
    TNode<IntPtrT> tmp174;
    TNode<Object> tmp175;
    ca_.Bind(&block19, &tmp165, &tmp166, &tmp167, &tmp168, &tmp169, &tmp170, &tmp171, &tmp172, &tmp173, &tmp174, &tmp175);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 42);
    ca_.Goto(&block17, tmp165, tmp166, tmp167, tmp168, tmp169, tmp170, tmp171, tmp172, tmp173, tmp174, tmp175);
  }

  if (block17.is_used()) {
    TNode<Context> tmp176;
    TNode<Object> tmp177;
    TNode<RawPtrT> tmp178;
    TNode<RawPtrT> tmp179;
    TNode<IntPtrT> tmp180;
    TNode<String> tmp181;
    TNode<Smi> tmp182;
    TNode<Number> tmp183;
    TNode<String> tmp184;
    TNode<IntPtrT> tmp185;
    TNode<Object> tmp186;
    ca_.Bind(&block17, &tmp176, &tmp177, &tmp178, &tmp179, &tmp180, &tmp181, &tmp182, &tmp183, &tmp184, &tmp185, &tmp186);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 40);
    ca_.Goto(&block15, tmp176, tmp177, tmp178, tmp179, tmp180, tmp181, tmp182, tmp183, tmp184, tmp185);
  }

  if (block15.is_used()) {
    TNode<Context> tmp187;
    TNode<Object> tmp188;
    TNode<RawPtrT> tmp189;
    TNode<RawPtrT> tmp190;
    TNode<IntPtrT> tmp191;
    TNode<String> tmp192;
    TNode<Smi> tmp193;
    TNode<Number> tmp194;
    TNode<String> tmp195;
    TNode<IntPtrT> tmp196;
    ca_.Bind(&block15, &tmp187, &tmp188, &tmp189, &tmp190, &tmp191, &tmp192, &tmp193, &tmp194, &tmp195, &tmp196);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 52);
    ca_.Goto(&block21, tmp187, tmp188, tmp189, tmp190, tmp191, tmp192, tmp193, tmp194, tmp195, tmp196);
  }

  if (block20.is_used()) {
    TNode<Context> tmp197;
    TNode<Object> tmp198;
    TNode<RawPtrT> tmp199;
    TNode<RawPtrT> tmp200;
    TNode<IntPtrT> tmp201;
    TNode<String> tmp202;
    TNode<Smi> tmp203;
    TNode<Number> tmp204;
    TNode<String> tmp205;
    TNode<IntPtrT> tmp206;
    ca_.Bind(&block20, &tmp197, &tmp198, &tmp199, &tmp200, &tmp201, &tmp202, &tmp203, &tmp204, &tmp205, &tmp206);
    TNode<IntPtrT> tmp207;
    USE(tmp207);
    tmp207 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, 0);
    TNode<BoolT> tmp208;
    USE(tmp208);
    tmp208 = CodeStubAssembler(state_).IntPtrGreaterThan(TNode<IntPtrT>{tmp206}, TNode<IntPtrT>{tmp207});
    ca_.Branch(tmp208, &block22, &block23, tmp197, tmp198, tmp199, tmp200, tmp201, tmp202, tmp203, tmp204, tmp205, tmp206);
  }

  if (block23.is_used()) {
    TNode<Context> tmp209;
    TNode<Object> tmp210;
    TNode<RawPtrT> tmp211;
    TNode<RawPtrT> tmp212;
    TNode<IntPtrT> tmp213;
    TNode<String> tmp214;
    TNode<Smi> tmp215;
    TNode<Number> tmp216;
    TNode<String> tmp217;
    TNode<IntPtrT> tmp218;
    ca_.Bind(&block23, &tmp209, &tmp210, &tmp211, &tmp212, &tmp213, &tmp214, &tmp215, &tmp216, &tmp217, &tmp218);
    CodeStubAssembler(state_).FailAssert("Torque assert 'fillLength > 0' failed", "../../deps/v8/src/builtins/string-pad.tq", 52);
  }

  if (block22.is_used()) {
    TNode<Context> tmp219;
    TNode<Object> tmp220;
    TNode<RawPtrT> tmp221;
    TNode<RawPtrT> tmp222;
    TNode<IntPtrT> tmp223;
    TNode<String> tmp224;
    TNode<Smi> tmp225;
    TNode<Number> tmp226;
    TNode<String> tmp227;
    TNode<IntPtrT> tmp228;
    ca_.Bind(&block22, &tmp219, &tmp220, &tmp221, &tmp222, &tmp223, &tmp224, &tmp225, &tmp226, &tmp227, &tmp228);
  }

  if (block21.is_used()) {
    TNode<Context> tmp229;
    TNode<Object> tmp230;
    TNode<RawPtrT> tmp231;
    TNode<RawPtrT> tmp232;
    TNode<IntPtrT> tmp233;
    TNode<String> tmp234;
    TNode<Smi> tmp235;
    TNode<Number> tmp236;
    TNode<String> tmp237;
    TNode<IntPtrT> tmp238;
    ca_.Bind(&block21, &tmp229, &tmp230, &tmp231, &tmp232, &tmp233, &tmp234, &tmp235, &tmp236, &tmp237, &tmp238);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 54);
    TNode<BoolT> tmp239;
    USE(tmp239);
    tmp239 = CodeStubAssembler(state_).TaggedIsSmi(TNode<Object>{tmp236});
    TNode<BoolT> tmp240;
    USE(tmp240);
    tmp240 = CodeStubAssembler(state_).Word32BinaryNot(TNode<BoolT>{tmp239});
    ca_.Branch(tmp240, &block24, &block25, tmp229, tmp230, tmp231, tmp232, tmp233, tmp234, tmp235, tmp236, tmp237, tmp238);
  }

  if (block24.is_used()) {
    TNode<Context> tmp241;
    TNode<Object> tmp242;
    TNode<RawPtrT> tmp243;
    TNode<RawPtrT> tmp244;
    TNode<IntPtrT> tmp245;
    TNode<String> tmp246;
    TNode<Smi> tmp247;
    TNode<Number> tmp248;
    TNode<String> tmp249;
    TNode<IntPtrT> tmp250;
    ca_.Bind(&block24, &tmp241, &tmp242, &tmp243, &tmp244, &tmp245, &tmp246, &tmp247, &tmp248, &tmp249, &tmp250);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 55);
    CodeStubAssembler(state_).CallRuntime(Runtime::kThrowInvalidStringLength, tmp241);
    CodeStubAssembler(state_).Unreachable();
  }

  if (block25.is_used()) {
    TNode<Context> tmp252;
    TNode<Object> tmp253;
    TNode<RawPtrT> tmp254;
    TNode<RawPtrT> tmp255;
    TNode<IntPtrT> tmp256;
    TNode<String> tmp257;
    TNode<Smi> tmp258;
    TNode<Number> tmp259;
    TNode<String> tmp260;
    TNode<IntPtrT> tmp261;
    ca_.Bind(&block25, &tmp252, &tmp253, &tmp254, &tmp255, &tmp256, &tmp257, &tmp258, &tmp259, &tmp260, &tmp261);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 58);
    TNode<Smi> tmp262;
    USE(tmp262);
    tmp262 = UnsafeCast5ATSmi_1439(state_, TNode<Context>{tmp252}, TNode<Object>{tmp259});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 59);
    TNode<Smi> tmp263;
    USE(tmp263);
    tmp263 = CodeStubAssembler(state_).SmiConstant(String::kMaxLength);
    TNode<BoolT> tmp264;
    USE(tmp264);
    tmp264 = CodeStubAssembler(state_).SmiGreaterThan(TNode<Smi>{tmp262}, TNode<Smi>{tmp263});
    ca_.Branch(tmp264, &block26, &block27, tmp252, tmp253, tmp254, tmp255, tmp256, tmp257, tmp258, tmp259, tmp260, tmp261, tmp262);
  }

  if (block26.is_used()) {
    TNode<Context> tmp265;
    TNode<Object> tmp266;
    TNode<RawPtrT> tmp267;
    TNode<RawPtrT> tmp268;
    TNode<IntPtrT> tmp269;
    TNode<String> tmp270;
    TNode<Smi> tmp271;
    TNode<Number> tmp272;
    TNode<String> tmp273;
    TNode<IntPtrT> tmp274;
    TNode<Smi> tmp275;
    ca_.Bind(&block26, &tmp265, &tmp266, &tmp267, &tmp268, &tmp269, &tmp270, &tmp271, &tmp272, &tmp273, &tmp274, &tmp275);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 60);
    CodeStubAssembler(state_).CallRuntime(Runtime::kThrowInvalidStringLength, tmp265);
    CodeStubAssembler(state_).Unreachable();
  }

  if (block27.is_used()) {
    TNode<Context> tmp277;
    TNode<Object> tmp278;
    TNode<RawPtrT> tmp279;
    TNode<RawPtrT> tmp280;
    TNode<IntPtrT> tmp281;
    TNode<String> tmp282;
    TNode<Smi> tmp283;
    TNode<Number> tmp284;
    TNode<String> tmp285;
    TNode<IntPtrT> tmp286;
    TNode<Smi> tmp287;
    ca_.Bind(&block27, &tmp277, &tmp278, &tmp279, &tmp280, &tmp281, &tmp282, &tmp283, &tmp284, &tmp285, &tmp286, &tmp287);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 62);
    ca_.Goto(&block29, tmp277, tmp278, tmp279, tmp280, tmp281, tmp282, tmp283, tmp284, tmp285, tmp286, tmp287);
  }

  if (block28.is_used()) {
    TNode<Context> tmp288;
    TNode<Object> tmp289;
    TNode<RawPtrT> tmp290;
    TNode<RawPtrT> tmp291;
    TNode<IntPtrT> tmp292;
    TNode<String> tmp293;
    TNode<Smi> tmp294;
    TNode<Number> tmp295;
    TNode<String> tmp296;
    TNode<IntPtrT> tmp297;
    TNode<Smi> tmp298;
    ca_.Bind(&block28, &tmp288, &tmp289, &tmp290, &tmp291, &tmp292, &tmp293, &tmp294, &tmp295, &tmp296, &tmp297, &tmp298);
    TNode<BoolT> tmp299;
    USE(tmp299);
    tmp299 = CodeStubAssembler(state_).SmiGreaterThan(TNode<Smi>{tmp298}, TNode<Smi>{tmp294});
    ca_.Branch(tmp299, &block30, &block31, tmp288, tmp289, tmp290, tmp291, tmp292, tmp293, tmp294, tmp295, tmp296, tmp297, tmp298);
  }

  if (block31.is_used()) {
    TNode<Context> tmp300;
    TNode<Object> tmp301;
    TNode<RawPtrT> tmp302;
    TNode<RawPtrT> tmp303;
    TNode<IntPtrT> tmp304;
    TNode<String> tmp305;
    TNode<Smi> tmp306;
    TNode<Number> tmp307;
    TNode<String> tmp308;
    TNode<IntPtrT> tmp309;
    TNode<Smi> tmp310;
    ca_.Bind(&block31, &tmp300, &tmp301, &tmp302, &tmp303, &tmp304, &tmp305, &tmp306, &tmp307, &tmp308, &tmp309, &tmp310);
    CodeStubAssembler(state_).FailAssert("Torque assert 'smiMaxLength > stringLength' failed", "../../deps/v8/src/builtins/string-pad.tq", 62);
  }

  if (block30.is_used()) {
    TNode<Context> tmp311;
    TNode<Object> tmp312;
    TNode<RawPtrT> tmp313;
    TNode<RawPtrT> tmp314;
    TNode<IntPtrT> tmp315;
    TNode<String> tmp316;
    TNode<Smi> tmp317;
    TNode<Number> tmp318;
    TNode<String> tmp319;
    TNode<IntPtrT> tmp320;
    TNode<Smi> tmp321;
    ca_.Bind(&block30, &tmp311, &tmp312, &tmp313, &tmp314, &tmp315, &tmp316, &tmp317, &tmp318, &tmp319, &tmp320, &tmp321);
  }

  if (block29.is_used()) {
    TNode<Context> tmp322;
    TNode<Object> tmp323;
    TNode<RawPtrT> tmp324;
    TNode<RawPtrT> tmp325;
    TNode<IntPtrT> tmp326;
    TNode<String> tmp327;
    TNode<Smi> tmp328;
    TNode<Number> tmp329;
    TNode<String> tmp330;
    TNode<IntPtrT> tmp331;
    TNode<Smi> tmp332;
    ca_.Bind(&block29, &tmp322, &tmp323, &tmp324, &tmp325, &tmp326, &tmp327, &tmp328, &tmp329, &tmp330, &tmp331, &tmp332);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 63);
    TNode<Smi> tmp333;
    USE(tmp333);
    tmp333 = CodeStubAssembler(state_).SmiSub(TNode<Smi>{tmp332}, TNode<Smi>{tmp328});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 65);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 66);
    TNode<IntPtrT> tmp334;
    USE(tmp334);
    tmp334 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, 1);
    TNode<BoolT> tmp335;
    USE(tmp335);
    tmp335 = CodeStubAssembler(state_).WordEqual(TNode<IntPtrT>{tmp331}, TNode<IntPtrT>{tmp334});
    ca_.Branch(tmp335, &block32, &block33, tmp322, tmp323, tmp324, tmp325, tmp326, tmp327, tmp328, tmp329, tmp330, tmp331, tmp332, tmp333, ca_.Uninitialized<String>());
  }

  if (block32.is_used()) {
    TNode<Context> tmp336;
    TNode<Object> tmp337;
    TNode<RawPtrT> tmp338;
    TNode<RawPtrT> tmp339;
    TNode<IntPtrT> tmp340;
    TNode<String> tmp341;
    TNode<Smi> tmp342;
    TNode<Number> tmp343;
    TNode<String> tmp344;
    TNode<IntPtrT> tmp345;
    TNode<Smi> tmp346;
    TNode<Smi> tmp347;
    TNode<String> tmp348;
    ca_.Bind(&block32, &tmp336, &tmp337, &tmp338, &tmp339, &tmp340, &tmp341, &tmp342, &tmp343, &tmp344, &tmp345, &tmp346, &tmp347, &tmp348);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 70);
    TNode<String> tmp349;
    tmp349 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kStringRepeat, tmp336, tmp344, tmp347));
    USE(tmp349);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 66);
    ca_.Goto(&block34, tmp336, tmp337, tmp338, tmp339, tmp340, tmp341, tmp342, tmp343, tmp344, tmp345, tmp346, tmp347, tmp349);
  }

  if (block33.is_used()) {
    TNode<Context> tmp350;
    TNode<Object> tmp351;
    TNode<RawPtrT> tmp352;
    TNode<RawPtrT> tmp353;
    TNode<IntPtrT> tmp354;
    TNode<String> tmp355;
    TNode<Smi> tmp356;
    TNode<Number> tmp357;
    TNode<String> tmp358;
    TNode<IntPtrT> tmp359;
    TNode<Smi> tmp360;
    TNode<Smi> tmp361;
    TNode<String> tmp362;
    ca_.Bind(&block33, &tmp350, &tmp351, &tmp352, &tmp353, &tmp354, &tmp355, &tmp356, &tmp357, &tmp358, &tmp359, &tmp360, &tmp361, &tmp362);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 73);
    TNode<Int32T> tmp363;
    USE(tmp363);
    tmp363 = CodeStubAssembler(state_).TruncateIntPtrToInt32(TNode<IntPtrT>{tmp359});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 74);
    TNode<Int32T> tmp364;
    USE(tmp364);
    tmp364 = Convert7ATint325ATSmi_195(state_, TNode<Smi>{tmp361});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 75);
    TNode<Int32T> tmp365;
    USE(tmp365);
    tmp365 = CodeStubAssembler(state_).Int32Div(TNode<Int32T>{tmp364}, TNode<Int32T>{tmp363});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 76);
    TNode<Int32T> tmp366;
    USE(tmp366);
    tmp366 = CodeStubAssembler(state_).Int32Mod(TNode<Int32T>{tmp364}, TNode<Int32T>{tmp363});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 78);
    TNode<Smi> tmp367;
    USE(tmp367);
    tmp367 = Convert5ATSmi7ATint32_179(state_, TNode<Int32T>{tmp365});
    TNode<String> tmp368;
    tmp368 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kStringRepeat, tmp350, tmp358, tmp367));
    USE(tmp368);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 77);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 80);
    TNode<Int32T> tmp369;
    USE(tmp369);
    tmp369 = FromConstexpr7ATint3217ATconstexpr_int31_149(state_, 0);
    TNode<BoolT> tmp370;
    USE(tmp370);
    tmp370 = CodeStubAssembler(state_).Word32NotEqual(TNode<Int32T>{tmp366}, TNode<Int32T>{tmp369});
    ca_.Branch(tmp370, &block35, &block36, tmp350, tmp351, tmp352, tmp353, tmp354, tmp355, tmp356, tmp357, tmp358, tmp359, tmp360, tmp361, tmp368, tmp363, tmp364, tmp365, tmp366);
  }

  if (block35.is_used()) {
    TNode<Context> tmp371;
    TNode<Object> tmp372;
    TNode<RawPtrT> tmp373;
    TNode<RawPtrT> tmp374;
    TNode<IntPtrT> tmp375;
    TNode<String> tmp376;
    TNode<Smi> tmp377;
    TNode<Number> tmp378;
    TNode<String> tmp379;
    TNode<IntPtrT> tmp380;
    TNode<Smi> tmp381;
    TNode<Smi> tmp382;
    TNode<String> tmp383;
    TNode<Int32T> tmp384;
    TNode<Int32T> tmp385;
    TNode<Int32T> tmp386;
    TNode<Int32T> tmp387;
    ca_.Bind(&block35, &tmp371, &tmp372, &tmp373, &tmp374, &tmp375, &tmp376, &tmp377, &tmp378, &tmp379, &tmp380, &tmp381, &tmp382, &tmp383, &tmp384, &tmp385, &tmp386, &tmp387);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 82);
    TNode<IntPtrT> tmp388;
    USE(tmp388);
    tmp388 = Convert8ATintptr7ATint32_177(state_, TNode<Int32T>{tmp387});
    TNode<IntPtrT> tmp389;
    USE(tmp389);
    tmp389 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, 0);
    TNode<String> tmp390;
    tmp390 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kStringSubstring, tmp371, tmp379, tmp389, tmp388));
    USE(tmp390);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 83);
    TNode<String> tmp391;
    USE(tmp391);
    tmp391 = StringAdd_82(state_, TNode<Context>{tmp371}, TNode<String>{tmp383}, TNode<String>{tmp390});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 80);
    ca_.Goto(&block36, tmp371, tmp372, tmp373, tmp374, tmp375, tmp376, tmp377, tmp378, tmp379, tmp380, tmp381, tmp382, tmp391, tmp384, tmp385, tmp386, tmp387);
  }

  if (block36.is_used()) {
    TNode<Context> tmp392;
    TNode<Object> tmp393;
    TNode<RawPtrT> tmp394;
    TNode<RawPtrT> tmp395;
    TNode<IntPtrT> tmp396;
    TNode<String> tmp397;
    TNode<Smi> tmp398;
    TNode<Number> tmp399;
    TNode<String> tmp400;
    TNode<IntPtrT> tmp401;
    TNode<Smi> tmp402;
    TNode<Smi> tmp403;
    TNode<String> tmp404;
    TNode<Int32T> tmp405;
    TNode<Int32T> tmp406;
    TNode<Int32T> tmp407;
    TNode<Int32T> tmp408;
    ca_.Bind(&block36, &tmp392, &tmp393, &tmp394, &tmp395, &tmp396, &tmp397, &tmp398, &tmp399, &tmp400, &tmp401, &tmp402, &tmp403, &tmp404, &tmp405, &tmp406, &tmp407, &tmp408);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 71);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 66);
    ca_.Goto(&block34, tmp392, tmp393, tmp394, tmp395, tmp396, tmp397, tmp398, tmp399, tmp400, tmp401, tmp402, tmp403, tmp404);
  }

  if (block34.is_used()) {
    TNode<Context> tmp409;
    TNode<Object> tmp410;
    TNode<RawPtrT> tmp411;
    TNode<RawPtrT> tmp412;
    TNode<IntPtrT> tmp413;
    TNode<String> tmp414;
    TNode<Smi> tmp415;
    TNode<Number> tmp416;
    TNode<String> tmp417;
    TNode<IntPtrT> tmp418;
    TNode<Smi> tmp419;
    TNode<Smi> tmp420;
    TNode<String> tmp421;
    ca_.Bind(&block34, &tmp409, &tmp410, &tmp411, &tmp412, &tmp413, &tmp414, &tmp415, &tmp416, &tmp417, &tmp418, &tmp419, &tmp420, &tmp421);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 88);
    ca_.Goto(&block38, tmp409, tmp410, tmp411, tmp412, tmp413, tmp414, tmp415, tmp416, tmp417, tmp418, tmp419, tmp420, tmp421);
  }

  if (block37.is_used()) {
    TNode<Context> tmp422;
    TNode<Object> tmp423;
    TNode<RawPtrT> tmp424;
    TNode<RawPtrT> tmp425;
    TNode<IntPtrT> tmp426;
    TNode<String> tmp427;
    TNode<Smi> tmp428;
    TNode<Number> tmp429;
    TNode<String> tmp430;
    TNode<IntPtrT> tmp431;
    TNode<Smi> tmp432;
    TNode<Smi> tmp433;
    TNode<String> tmp434;
    ca_.Bind(&block37, &tmp422, &tmp423, &tmp424, &tmp425, &tmp426, &tmp427, &tmp428, &tmp429, &tmp430, &tmp431, &tmp432, &tmp433, &tmp434);
    TNode<Smi> tmp435;
    USE(tmp435);
    tmp435 = CodeStubAssembler(state_).LoadStringLengthAsSmi(TNode<String>{tmp434});
    TNode<BoolT> tmp436;
    USE(tmp436);
    tmp436 = CodeStubAssembler(state_).SmiEqual(TNode<Smi>{tmp433}, TNode<Smi>{tmp435});
    ca_.Branch(tmp436, &block39, &block40, tmp422, tmp423, tmp424, tmp425, tmp426, tmp427, tmp428, tmp429, tmp430, tmp431, tmp432, tmp433, tmp434);
  }

  if (block40.is_used()) {
    TNode<Context> tmp437;
    TNode<Object> tmp438;
    TNode<RawPtrT> tmp439;
    TNode<RawPtrT> tmp440;
    TNode<IntPtrT> tmp441;
    TNode<String> tmp442;
    TNode<Smi> tmp443;
    TNode<Number> tmp444;
    TNode<String> tmp445;
    TNode<IntPtrT> tmp446;
    TNode<Smi> tmp447;
    TNode<Smi> tmp448;
    TNode<String> tmp449;
    ca_.Bind(&block40, &tmp437, &tmp438, &tmp439, &tmp440, &tmp441, &tmp442, &tmp443, &tmp444, &tmp445, &tmp446, &tmp447, &tmp448, &tmp449);
    CodeStubAssembler(state_).FailAssert("Torque assert 'padLength == padding.length_smi' failed", "../../deps/v8/src/builtins/string-pad.tq", 88);
  }

  if (block39.is_used()) {
    TNode<Context> tmp450;
    TNode<Object> tmp451;
    TNode<RawPtrT> tmp452;
    TNode<RawPtrT> tmp453;
    TNode<IntPtrT> tmp454;
    TNode<String> tmp455;
    TNode<Smi> tmp456;
    TNode<Number> tmp457;
    TNode<String> tmp458;
    TNode<IntPtrT> tmp459;
    TNode<Smi> tmp460;
    TNode<Smi> tmp461;
    TNode<String> tmp462;
    ca_.Bind(&block39, &tmp450, &tmp451, &tmp452, &tmp453, &tmp454, &tmp455, &tmp456, &tmp457, &tmp458, &tmp459, &tmp460, &tmp461, &tmp462);
  }

  if (block38.is_used()) {
    TNode<Context> tmp463;
    TNode<Object> tmp464;
    TNode<RawPtrT> tmp465;
    TNode<RawPtrT> tmp466;
    TNode<IntPtrT> tmp467;
    TNode<String> tmp468;
    TNode<Smi> tmp469;
    TNode<Number> tmp470;
    TNode<String> tmp471;
    TNode<IntPtrT> tmp472;
    TNode<Smi> tmp473;
    TNode<Smi> tmp474;
    TNode<String> tmp475;
    ca_.Bind(&block38, &tmp463, &tmp464, &tmp465, &tmp466, &tmp467, &tmp468, &tmp469, &tmp470, &tmp471, &tmp472, &tmp473, &tmp474, &tmp475);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 89);
    TNode<BoolT> tmp476;
    USE(tmp476);
    tmp476 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, (CodeStubAssembler(state_).ConstexprInt31Equal(p_variant, kStringPadStart_349(state_))));
    ca_.Branch(tmp476, &block41, &block42, tmp463, tmp464, tmp465, tmp466, tmp467, tmp468, tmp469, tmp470, tmp471, tmp472, tmp473, tmp474, tmp475);
  }

  if (block41.is_used()) {
    TNode<Context> tmp477;
    TNode<Object> tmp478;
    TNode<RawPtrT> tmp479;
    TNode<RawPtrT> tmp480;
    TNode<IntPtrT> tmp481;
    TNode<String> tmp482;
    TNode<Smi> tmp483;
    TNode<Number> tmp484;
    TNode<String> tmp485;
    TNode<IntPtrT> tmp486;
    TNode<Smi> tmp487;
    TNode<Smi> tmp488;
    TNode<String> tmp489;
    ca_.Bind(&block41, &tmp477, &tmp478, &tmp479, &tmp480, &tmp481, &tmp482, &tmp483, &tmp484, &tmp485, &tmp486, &tmp487, &tmp488, &tmp489);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 90);
    TNode<String> tmp490;
    USE(tmp490);
    tmp490 = StringAdd_82(state_, TNode<Context>{tmp477}, TNode<String>{tmp489}, TNode<String>{tmp482});
    ca_.Goto(&block1, tmp477, tmp478, tmp479, tmp480, tmp481, tmp490);
  }

  if (block42.is_used()) {
    TNode<Context> tmp491;
    TNode<Object> tmp492;
    TNode<RawPtrT> tmp493;
    TNode<RawPtrT> tmp494;
    TNode<IntPtrT> tmp495;
    TNode<String> tmp496;
    TNode<Smi> tmp497;
    TNode<Number> tmp498;
    TNode<String> tmp499;
    TNode<IntPtrT> tmp500;
    TNode<Smi> tmp501;
    TNode<Smi> tmp502;
    TNode<String> tmp503;
    ca_.Bind(&block42, &tmp491, &tmp492, &tmp493, &tmp494, &tmp495, &tmp496, &tmp497, &tmp498, &tmp499, &tmp500, &tmp501, &tmp502, &tmp503);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 92);
    ca_.Goto(&block44, tmp491, tmp492, tmp493, tmp494, tmp495, tmp496, tmp497, tmp498, tmp499, tmp500, tmp501, tmp502, tmp503);
  }

  if (block43.is_used()) {
    TNode<Context> tmp504;
    TNode<Object> tmp505;
    TNode<RawPtrT> tmp506;
    TNode<RawPtrT> tmp507;
    TNode<IntPtrT> tmp508;
    TNode<String> tmp509;
    TNode<Smi> tmp510;
    TNode<Number> tmp511;
    TNode<String> tmp512;
    TNode<IntPtrT> tmp513;
    TNode<Smi> tmp514;
    TNode<Smi> tmp515;
    TNode<String> tmp516;
    ca_.Bind(&block43, &tmp504, &tmp505, &tmp506, &tmp507, &tmp508, &tmp509, &tmp510, &tmp511, &tmp512, &tmp513, &tmp514, &tmp515, &tmp516);
    TNode<BoolT> tmp517;
    USE(tmp517);
    tmp517 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, (CodeStubAssembler(state_).ConstexprInt31Equal(p_variant, kStringPadEnd_350(state_))));
    ca_.Branch(tmp517, &block45, &block46, tmp504, tmp505, tmp506, tmp507, tmp508, tmp509, tmp510, tmp511, tmp512, tmp513, tmp514, tmp515, tmp516);
  }

  if (block46.is_used()) {
    TNode<Context> tmp518;
    TNode<Object> tmp519;
    TNode<RawPtrT> tmp520;
    TNode<RawPtrT> tmp521;
    TNode<IntPtrT> tmp522;
    TNode<String> tmp523;
    TNode<Smi> tmp524;
    TNode<Number> tmp525;
    TNode<String> tmp526;
    TNode<IntPtrT> tmp527;
    TNode<Smi> tmp528;
    TNode<Smi> tmp529;
    TNode<String> tmp530;
    ca_.Bind(&block46, &tmp518, &tmp519, &tmp520, &tmp521, &tmp522, &tmp523, &tmp524, &tmp525, &tmp526, &tmp527, &tmp528, &tmp529, &tmp530);
    CodeStubAssembler(state_).FailAssert("Torque assert 'variant == kStringPadEnd' failed", "../../deps/v8/src/builtins/string-pad.tq", 92);
  }

  if (block45.is_used()) {
    TNode<Context> tmp531;
    TNode<Object> tmp532;
    TNode<RawPtrT> tmp533;
    TNode<RawPtrT> tmp534;
    TNode<IntPtrT> tmp535;
    TNode<String> tmp536;
    TNode<Smi> tmp537;
    TNode<Number> tmp538;
    TNode<String> tmp539;
    TNode<IntPtrT> tmp540;
    TNode<Smi> tmp541;
    TNode<Smi> tmp542;
    TNode<String> tmp543;
    ca_.Bind(&block45, &tmp531, &tmp532, &tmp533, &tmp534, &tmp535, &tmp536, &tmp537, &tmp538, &tmp539, &tmp540, &tmp541, &tmp542, &tmp543);
  }

  if (block44.is_used()) {
    TNode<Context> tmp544;
    TNode<Object> tmp545;
    TNode<RawPtrT> tmp546;
    TNode<RawPtrT> tmp547;
    TNode<IntPtrT> tmp548;
    TNode<String> tmp549;
    TNode<Smi> tmp550;
    TNode<Number> tmp551;
    TNode<String> tmp552;
    TNode<IntPtrT> tmp553;
    TNode<Smi> tmp554;
    TNode<Smi> tmp555;
    TNode<String> tmp556;
    ca_.Bind(&block44, &tmp544, &tmp545, &tmp546, &tmp547, &tmp548, &tmp549, &tmp550, &tmp551, &tmp552, &tmp553, &tmp554, &tmp555, &tmp556);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 93);
    TNode<String> tmp557;
    USE(tmp557);
    tmp557 = StringAdd_82(state_, TNode<Context>{tmp544}, TNode<String>{tmp549}, TNode<String>{tmp556});
    ca_.Goto(&block1, tmp544, tmp545, tmp546, tmp547, tmp548, tmp557);
  }

  if (block1.is_used()) {
    TNode<Context> tmp558;
    TNode<Object> tmp559;
    TNode<RawPtrT> tmp560;
    TNode<RawPtrT> tmp561;
    TNode<IntPtrT> tmp562;
    TNode<String> tmp563;
    ca_.Bind(&block1, &tmp558, &tmp559, &tmp560, &tmp561, &tmp562, &tmp563);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 15);
    ca_.Goto(&block47, tmp558, tmp559, tmp560, tmp561, tmp562, tmp563);
  }

    TNode<Context> tmp564;
    TNode<Object> tmp565;
    TNode<RawPtrT> tmp566;
    TNode<RawPtrT> tmp567;
    TNode<IntPtrT> tmp568;
    TNode<String> tmp569;
    ca_.Bind(&block47, &tmp564, &tmp565, &tmp566, &tmp567, &tmp568, &tmp569);
  return TNode<String>{tmp569};
}

TF_BUILTIN(StringPrototypePadStart, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  Node* argc = Parameter(Descriptor::kJSActualArgumentsCount);
  TNode<IntPtrT> arguments_length(ChangeInt32ToIntPtr(argc));
  TNode<RawPtrT> arguments_frame = UncheckedCast<RawPtrT>(LoadFramePointer());
  TorqueStructArguments torque_arguments(GetFrameArguments(arguments_frame, arguments_length));
  CodeStubArguments arguments(this, torque_arguments);
  TNode<Context> parameter0 = UncheckedCast<Context>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<Object> parameter1 = arguments.GetReceiver();
USE(parameter1);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, torque_arguments.frame, torque_arguments.base, torque_arguments.length, parameter0, parameter1);

  if (block0.is_used()) {
    TNode<RawPtrT> tmp0;
    TNode<RawPtrT> tmp1;
    TNode<IntPtrT> tmp2;
    TNode<Context> tmp3;
    TNode<Object> tmp4;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 101);
    TNode<String> tmp5;
    USE(tmp5);
    tmp5 = StringPad_351(state_, TNode<Context>{tmp3}, TNode<Object>{tmp4}, TorqueStructArguments{TNode<RawPtrT>{tmp0}, TNode<RawPtrT>{tmp1}, TNode<IntPtrT>{tmp2}}, "String.prototype.padStart", kStringPadStart_349(state_));
    arguments.PopAndReturn(tmp5);
  }
}

TF_BUILTIN(StringPrototypePadEnd, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  Node* argc = Parameter(Descriptor::kJSActualArgumentsCount);
  TNode<IntPtrT> arguments_length(ChangeInt32ToIntPtr(argc));
  TNode<RawPtrT> arguments_frame = UncheckedCast<RawPtrT>(LoadFramePointer());
  TorqueStructArguments torque_arguments(GetFrameArguments(arguments_frame, arguments_length));
  CodeStubArguments arguments(this, torque_arguments);
  TNode<Context> parameter0 = UncheckedCast<Context>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<Object> parameter1 = arguments.GetReceiver();
USE(parameter1);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, torque_arguments.frame, torque_arguments.base, torque_arguments.length, parameter0, parameter1);

  if (block0.is_used()) {
    TNode<RawPtrT> tmp0;
    TNode<RawPtrT> tmp1;
    TNode<IntPtrT> tmp2;
    TNode<Context> tmp3;
    TNode<Object> tmp4;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-pad.tq", 109);
    TNode<String> tmp5;
    USE(tmp5);
    tmp5 = StringPad_351(state_, TNode<Context>{tmp3}, TNode<Object>{tmp4}, TorqueStructArguments{TNode<RawPtrT>{tmp0}, TNode<RawPtrT>{tmp1}, TNode<IntPtrT>{tmp2}}, "String.prototype.padEnd", kStringPadEnd_350(state_));
    arguments.PopAndReturn(tmp5);
  }
}

}  // namespace internal
}  // namespace v8

