#include "src/builtins/builtins-array-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-utils-gen.h"
#include "src/builtins/builtins.h"
#include "src/codegen/code-factory.h"
#include "src/heap/factory-inl.h"
#include "src/objects/arguments.h"
#include "src/objects/bigint.h"
#include "src/objects/elements-kind.h"
#include "src/objects/free-space.h"
#include "src/objects/js-generator.h"
#include "src/objects/js-promise.h"
#include "src/objects/js-regexp-string-iterator.h"
#include "src/objects/js-weak-refs.h"
#include "src/objects/objects.h"
#include "src/objects/source-text-module.h"
#include "src/objects/stack-frame-info.h"
#include "src/objects/synthetic-module.h"
#include "src/objects/template-objects.h"
#include "src/builtins/builtins-bigint-gen.h"
#include "src/builtins/builtins-collections-gen.h"
#include "src/builtins/builtins-data-view-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-iterator-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-constructor-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/objects/js-break-iterator.h"
#include "src/objects/js-collator.h"
#include "src/objects/js-number-format.h"
#include "src/objects/js-objects.h"
#include "src/objects/js-plural-rules.h"
#include "src/objects/js-relative-time-format.h"
#include "src/objects/js-date-time-format.h"
#include "src/objects/js-list-format.h"
#include "src/objects/js-locale.h"
#include "src/objects/js-segment-iterator.h"
#include "src/objects/js-segmenter.h"
#include "torque-generated/../../deps/v8/src/builtins/arguments-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-copywithin-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-join-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-lastindexof-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-map-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-right-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reverse-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-shift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-splice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-unshift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/base-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/bigint-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/boolean-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/collections-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/data-view-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/extras-utils-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/frames-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/growable-fixed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/internal-coverage-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/math-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-fromentries-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-constructor-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-delete-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-has-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-is-extensible-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-prevent-extensions-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revocable-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revoke-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/reflect-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-exec-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-all-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-replace-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-search-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-source-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-split-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-test-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-endswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-html-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-pad-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-repeat-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-startswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-substring-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/torque-internal-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-createtypedarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduceright-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-subarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/third_party/v8/builtins/array-sort-tq-csa.h"
#include "torque-generated/../../deps/v8/test/torque/test-torque-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/intl-objects-tq-csa.h"

namespace v8 {
namespace internal {

TNode<JSArray> HandleSimpleArgumentsSlice_38(compiler::CodeAssemblerState* state_, TNode<NativeContext> p_context, TNode<JSArgumentsObjectWithLength> p_args, TNode<Smi> p_start, TNode<Smi> p_count, compiler::CodeAssemblerLabel* label_Bailout) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, Smi, FixedArrayBase> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, Smi, FixedArrayBase, FixedArray> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, Smi, FixedArray> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, Smi, FixedArray> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, Smi, FixedArray, Map, JSArray, FixedArrayBase> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, Smi, FixedArray, Map, JSArray, FixedArrayBase, FixedArray> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, JSArray> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, JSArray> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_args, p_start, p_count);

  if (block0.is_used()) {
    TNode<NativeContext> tmp0;
    TNode<JSArgumentsObjectWithLength> tmp1;
    TNode<Smi> tmp2;
    TNode<Smi> tmp3;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 11);
    TNode<Smi> tmp4;
    USE(tmp4);
    tmp4 = FromConstexpr5ATSmi17ATconstexpr_int31_155(state_, FixedArray::kMaxRegularLength);
    TNode<BoolT> tmp5;
    USE(tmp5);
    tmp5 = CodeStubAssembler(state_).SmiGreaterThanOrEqual(TNode<Smi>{tmp3}, TNode<Smi>{tmp4});
    ca_.Branch(tmp5, &block3, &block4, tmp0, tmp1, tmp2, tmp3);
  }

  if (block3.is_used()) {
    TNode<NativeContext> tmp6;
    TNode<JSArgumentsObjectWithLength> tmp7;
    TNode<Smi> tmp8;
    TNode<Smi> tmp9;
    ca_.Bind(&block3, &tmp6, &tmp7, &tmp8, &tmp9);
    ca_.Goto(&block1);
  }

  if (block4.is_used()) {
    TNode<NativeContext> tmp10;
    TNode<JSArgumentsObjectWithLength> tmp11;
    TNode<Smi> tmp12;
    TNode<Smi> tmp13;
    ca_.Bind(&block4, &tmp10, &tmp11, &tmp12, &tmp13);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 13);
    TNode<Smi> tmp14;
    USE(tmp14);
    tmp14 = CodeStubAssembler(state_).SmiAdd(TNode<Smi>{tmp12}, TNode<Smi>{tmp13});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 15);
    TNode<IntPtrT> tmp15 = ca_.IntPtrConstant(JSObject::kElementsOffset);
    USE(tmp15);
    TNode<FixedArrayBase>tmp16 = CodeStubAssembler(state_).LoadReference<FixedArrayBase>(CodeStubAssembler::Reference{tmp11, tmp15});
    TNode<FixedArray> tmp17;
    USE(tmp17);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp17 = Cast10FixedArray_103(state_, TNode<HeapObject>{tmp16}, &label0);
    ca_.Goto(&block5, tmp10, tmp11, tmp12, tmp13, tmp14, tmp16, tmp17);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block6, tmp10, tmp11, tmp12, tmp13, tmp14, tmp16);
    }
  }

  if (block6.is_used()) {
    TNode<NativeContext> tmp18;
    TNode<JSArgumentsObjectWithLength> tmp19;
    TNode<Smi> tmp20;
    TNode<Smi> tmp21;
    TNode<Smi> tmp22;
    TNode<FixedArrayBase> tmp23;
    ca_.Bind(&block6, &tmp18, &tmp19, &tmp20, &tmp21, &tmp22, &tmp23);
    ca_.Goto(&block1);
  }

  if (block5.is_used()) {
    TNode<NativeContext> tmp24;
    TNode<JSArgumentsObjectWithLength> tmp25;
    TNode<Smi> tmp26;
    TNode<Smi> tmp27;
    TNode<Smi> tmp28;
    TNode<FixedArrayBase> tmp29;
    TNode<FixedArray> tmp30;
    ca_.Bind(&block5, &tmp24, &tmp25, &tmp26, &tmp27, &tmp28, &tmp29, &tmp30);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 14);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 16);
    TNode<IntPtrT> tmp31 = ca_.IntPtrConstant(FixedArrayBase::kLengthOffset);
    USE(tmp31);
    TNode<Smi>tmp32 = CodeStubAssembler(state_).LoadReference<Smi>(CodeStubAssembler::Reference{tmp30, tmp31});
    TNode<BoolT> tmp33;
    USE(tmp33);
    tmp33 = CodeStubAssembler(state_).SmiAbove(TNode<Smi>{tmp28}, TNode<Smi>{tmp32});
    ca_.Branch(tmp33, &block7, &block8, tmp24, tmp25, tmp26, tmp27, tmp28, tmp30);
  }

  if (block7.is_used()) {
    TNode<NativeContext> tmp34;
    TNode<JSArgumentsObjectWithLength> tmp35;
    TNode<Smi> tmp36;
    TNode<Smi> tmp37;
    TNode<Smi> tmp38;
    TNode<FixedArray> tmp39;
    ca_.Bind(&block7, &tmp34, &tmp35, &tmp36, &tmp37, &tmp38, &tmp39);
    ca_.Goto(&block1);
  }

  if (block8.is_used()) {
    TNode<NativeContext> tmp40;
    TNode<JSArgumentsObjectWithLength> tmp41;
    TNode<Smi> tmp42;
    TNode<Smi> tmp43;
    TNode<Smi> tmp44;
    TNode<FixedArray> tmp45;
    ca_.Bind(&block8, &tmp40, &tmp41, &tmp42, &tmp43, &tmp44, &tmp45);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 18);
    TNode<Map> tmp46;
    USE(tmp46);
    tmp46 = CodeStubAssembler(state_).LoadJSArrayElementsMap(HOLEY_ELEMENTS, TNode<NativeContext>{tmp40});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 20);
    TNode<JSArray> tmp47;
    USE(tmp47);
    tmp47 = CodeStubAssembler(state_).AllocateJSArray(HOLEY_ELEMENTS, TNode<Map>{tmp46}, TNode<Smi>{tmp43}, TNode<Smi>{tmp43});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 19);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 22);
    TNode<IntPtrT> tmp48 = ca_.IntPtrConstant(JSObject::kElementsOffset);
    USE(tmp48);
    TNode<FixedArrayBase>tmp49 = CodeStubAssembler(state_).LoadReference<FixedArrayBase>(CodeStubAssembler::Reference{tmp47, tmp48});
    TNode<FixedArray> tmp50;
    USE(tmp50);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp50 = Cast10FixedArray_103(state_, TNode<HeapObject>{tmp49}, &label0);
    ca_.Goto(&block9, tmp40, tmp41, tmp42, tmp43, tmp44, tmp45, tmp46, tmp47, tmp49, tmp50);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block10, tmp40, tmp41, tmp42, tmp43, tmp44, tmp45, tmp46, tmp47, tmp49);
    }
  }

  if (block10.is_used()) {
    TNode<NativeContext> tmp51;
    TNode<JSArgumentsObjectWithLength> tmp52;
    TNode<Smi> tmp53;
    TNode<Smi> tmp54;
    TNode<Smi> tmp55;
    TNode<FixedArray> tmp56;
    TNode<Map> tmp57;
    TNode<JSArray> tmp58;
    TNode<FixedArrayBase> tmp59;
    ca_.Bind(&block10, &tmp51, &tmp52, &tmp53, &tmp54, &tmp55, &tmp56, &tmp57, &tmp58, &tmp59);
    ca_.Goto(&block1);
  }

  if (block9.is_used()) {
    TNode<NativeContext> tmp60;
    TNode<JSArgumentsObjectWithLength> tmp61;
    TNode<Smi> tmp62;
    TNode<Smi> tmp63;
    TNode<Smi> tmp64;
    TNode<FixedArray> tmp65;
    TNode<Map> tmp66;
    TNode<JSArray> tmp67;
    TNode<FixedArrayBase> tmp68;
    TNode<FixedArray> tmp69;
    ca_.Bind(&block9, &tmp60, &tmp61, &tmp62, &tmp63, &tmp64, &tmp65, &tmp66, &tmp67, &tmp68, &tmp69);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 21);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 24);
    TNode<IntPtrT> tmp70;
    USE(tmp70);
    tmp70 = Convert8ATintptr5ATSmi_189(state_, TNode<Smi>{tmp62});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 25);
    TNode<IntPtrT> tmp71;
    USE(tmp71);
    tmp71 = Convert8ATintptr5ATSmi_189(state_, TNode<Smi>{tmp63});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 23);
    TNode<IntPtrT> tmp72;
    USE(tmp72);
    tmp72 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, 0);
    CodeStubAssembler(state_).CopyElements(PACKED_ELEMENTS, TNode<FixedArrayBase>{tmp69}, TNode<IntPtrT>{tmp72}, TNode<FixedArrayBase>{tmp65}, TNode<IntPtrT>{tmp70}, TNode<IntPtrT>{tmp71});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 26);
    ca_.Goto(&block2, tmp60, tmp61, tmp62, tmp63, tmp67);
  }

  if (block2.is_used()) {
    TNode<NativeContext> tmp73;
    TNode<JSArgumentsObjectWithLength> tmp74;
    TNode<Smi> tmp75;
    TNode<Smi> tmp76;
    TNode<JSArray> tmp77;
    ca_.Bind(&block2, &tmp73, &tmp74, &tmp75, &tmp76, &tmp77);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 6);
    ca_.Goto(&block11, tmp73, tmp74, tmp75, tmp76, tmp77);
  }

  if (block1.is_used()) {
    ca_.Bind(&block1);
    ca_.Goto(label_Bailout);
  }

    TNode<NativeContext> tmp78;
    TNode<JSArgumentsObjectWithLength> tmp79;
    TNode<Smi> tmp80;
    TNode<Smi> tmp81;
    TNode<JSArray> tmp82;
    ca_.Bind(&block11, &tmp78, &tmp79, &tmp80, &tmp81, &tmp82);
  return TNode<JSArray>{tmp82};
}

TNode<JSArray> HandleFastAliasedSloppyArgumentsSlice_39(compiler::CodeAssemblerState* state_, TNode<NativeContext> p_context, TNode<JSArgumentsObjectWithLength> p_args, TNode<Smi> p_start, TNode<Smi> p_count, compiler::CodeAssemblerLabel* label_Bailout) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArrayBase> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArrayBase, FixedArray> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, IntPtrT, IntPtrT, IntPtrT, HeapObject, IntPtrT, IntPtrT, IntPtrT, IntPtrT> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, IntPtrT, IntPtrT, IntPtrT, HeapObject, IntPtrT, IntPtrT, IntPtrT, IntPtrT> block12(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, IntPtrT, IntPtrT, IntPtrT, HeapObject, IntPtrT, IntPtrT, IntPtrT, IntPtrT, HeapObject, IntPtrT> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, IntPtrT, IntPtrT, IntPtrT> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, IntPtrT, IntPtrT, IntPtrT, HeapObject, IntPtrT> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, IntPtrT, IntPtrT, HeapObject, IntPtrT> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, Object> block15(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, Object, FixedArray> block14(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi> block17(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, FixedArray, IntPtrT, IntPtrT, IntPtrT, HeapObject, IntPtrT, IntPtrT, IntPtrT, IntPtrT> block22(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, FixedArray, IntPtrT, IntPtrT, IntPtrT, HeapObject, IntPtrT, IntPtrT, IntPtrT, IntPtrT> block23(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, FixedArray, IntPtrT, IntPtrT, IntPtrT, HeapObject, IntPtrT, IntPtrT, IntPtrT, IntPtrT, HeapObject, IntPtrT> block21(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, FixedArray, IntPtrT, IntPtrT, IntPtrT> block20(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, FixedArray, IntPtrT, IntPtrT, IntPtrT, HeapObject, IntPtrT> block19(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, FixedArray, IntPtrT, IntPtrT, HeapObject, IntPtrT> block18(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi> block27(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi> block25(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT, HeapObject, IntPtrT, IntPtrT, IntPtrT, IntPtrT> block33(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT, HeapObject, IntPtrT, IntPtrT, IntPtrT, IntPtrT> block34(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT, HeapObject, IntPtrT, IntPtrT, IntPtrT, IntPtrT, HeapObject, IntPtrT> block32(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT> block31(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT, HeapObject, IntPtrT> block30(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi, FixedArray, IntPtrT, IntPtrT, Smi, Smi, HeapObject, IntPtrT> block29(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi, Object> block36(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi, Object> block37(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi, Object, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT, HeapObject, IntPtrT, IntPtrT, IntPtrT, IntPtrT> block44(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi, Object, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT, HeapObject, IntPtrT, IntPtrT, IntPtrT, IntPtrT> block45(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi, Object, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT, HeapObject, IntPtrT, IntPtrT, IntPtrT, IntPtrT, HeapObject, IntPtrT> block43(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi, Object, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT> block42(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi, Object, FixedArray, IntPtrT, IntPtrT, Smi, Smi, IntPtrT, HeapObject, IntPtrT> block41(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi, Object, FixedArray, IntPtrT, IntPtrT, Smi, Smi, HeapObject, IntPtrT> block40(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi, Object, Object> block39(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi, Object, Object> block38(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi> block28(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, FixedArray, Smi, Smi, Smi, FixedArray, Smi, Context, Map, JSArray, Smi, FixedArray, Smi, Smi> block26(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, JSArray> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, JSArgumentsObjectWithLength, Smi, Smi, JSArray> block47(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_args, p_start, p_count);

  if (block0.is_used()) {
    TNode<NativeContext> tmp0;
    TNode<JSArgumentsObjectWithLength> tmp1;
    TNode<Smi> tmp2;
    TNode<Smi> tmp3;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 34);
    TNode<Smi> tmp4;
    USE(tmp4);
    tmp4 = FromConstexpr5ATSmi17ATconstexpr_int31_155(state_, FixedArray::kMaxRegularLength);
    TNode<BoolT> tmp5;
    USE(tmp5);
    tmp5 = CodeStubAssembler(state_).SmiGreaterThanOrEqual(TNode<Smi>{tmp3}, TNode<Smi>{tmp4});
    ca_.Branch(tmp5, &block3, &block4, tmp0, tmp1, tmp2, tmp3);
  }

  if (block3.is_used()) {
    TNode<NativeContext> tmp6;
    TNode<JSArgumentsObjectWithLength> tmp7;
    TNode<Smi> tmp8;
    TNode<Smi> tmp9;
    ca_.Bind(&block3, &tmp6, &tmp7, &tmp8, &tmp9);
    ca_.Goto(&block1);
  }

  if (block4.is_used()) {
    TNode<NativeContext> tmp10;
    TNode<JSArgumentsObjectWithLength> tmp11;
    TNode<Smi> tmp12;
    TNode<Smi> tmp13;
    ca_.Bind(&block4, &tmp10, &tmp11, &tmp12, &tmp13);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 37);
    TNode<IntPtrT> tmp14 = ca_.IntPtrConstant(JSObject::kElementsOffset);
    USE(tmp14);
    TNode<FixedArrayBase>tmp15 = CodeStubAssembler(state_).LoadReference<FixedArrayBase>(CodeStubAssembler::Reference{tmp11, tmp14});
    TNode<FixedArray> tmp16;
    USE(tmp16);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp16 = Cast25ATSloppyArgumentsElements_105(state_, TNode<HeapObject>{tmp15}, &label0);
    ca_.Goto(&block5, tmp10, tmp11, tmp12, tmp13, tmp15, tmp16);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block6, tmp10, tmp11, tmp12, tmp13, tmp15);
    }
  }

  if (block6.is_used()) {
    TNode<NativeContext> tmp17;
    TNode<JSArgumentsObjectWithLength> tmp18;
    TNode<Smi> tmp19;
    TNode<Smi> tmp20;
    TNode<FixedArrayBase> tmp21;
    ca_.Bind(&block6, &tmp17, &tmp18, &tmp19, &tmp20, &tmp21);
    ca_.Goto(&block1);
  }

  if (block5.is_used()) {
    TNode<NativeContext> tmp22;
    TNode<JSArgumentsObjectWithLength> tmp23;
    TNode<Smi> tmp24;
    TNode<Smi> tmp25;
    TNode<FixedArrayBase> tmp26;
    TNode<FixedArray> tmp27;
    ca_.Bind(&block5, &tmp22, &tmp23, &tmp24, &tmp25, &tmp26, &tmp27);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 36);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 38);
    TNode<IntPtrT> tmp28 = ca_.IntPtrConstant(FixedArrayBase::kLengthOffset);
    USE(tmp28);
    TNode<Smi>tmp29 = CodeStubAssembler(state_).LoadReference<Smi>(CodeStubAssembler::Reference{tmp27, tmp28});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 40);
    TNode<Smi> tmp30;
    USE(tmp30);
    tmp30 = FromConstexpr5ATSmi17ATconstexpr_int31_155(state_, SloppyArgumentsElements::kParameterMapStart);
    TNode<Smi> tmp31;
    USE(tmp31);
    tmp31 = CodeStubAssembler(state_).SmiSub(TNode<Smi>{tmp29}, TNode<Smi>{tmp30});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 39);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 44);
    TNode<Smi> tmp32;
    USE(tmp32);
    tmp32 = CodeStubAssembler(state_).SmiAdd(TNode<Smi>{tmp24}, TNode<Smi>{tmp25});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 46);
    TNode<IntPtrT> tmp33 = ca_.IntPtrConstant(FixedArray::kObjectsOffset);
    USE(tmp33);
    TNode<IntPtrT> tmp34 = ca_.IntPtrConstant(FixedArrayBase::kLengthOffset);
    USE(tmp34);
    TNode<Smi>tmp35 = CodeStubAssembler(state_).LoadReference<Smi>(CodeStubAssembler::Reference{tmp27, tmp34});
    TNode<IntPtrT> tmp36;
    USE(tmp36);
    tmp36 = Convert8ATintptr5ATSmi_189(state_, TNode<Smi>{tmp35});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 50);
    TNode<IntPtrT> tmp37;
    USE(tmp37);
    tmp37 = Convert8ATintptr17ATconstexpr_int31_1444(state_, SloppyArgumentsElements::kArgumentsIndex);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 51);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 37);
    TNode<UintPtrT> tmp38;
    USE(tmp38);
    tmp38 = Convert9ATuintptr8ATintptr_206(state_, TNode<IntPtrT>{tmp37});
    TNode<UintPtrT> tmp39;
    USE(tmp39);
    tmp39 = Convert9ATuintptr8ATintptr_206(state_, TNode<IntPtrT>{tmp36});
    TNode<BoolT> tmp40;
    USE(tmp40);
    tmp40 = CodeStubAssembler(state_).UintPtrLessThan(TNode<UintPtrT>{tmp38}, TNode<UintPtrT>{tmp39});
    ca_.Branch(tmp40, &block11, &block12, tmp22, tmp23, tmp24, tmp25, tmp27, tmp29, tmp31, tmp32, tmp27, tmp33, tmp36, tmp37, tmp27, tmp33, tmp36, tmp37, tmp37);
  }

  if (block11.is_used()) {
    TNode<NativeContext> tmp41;
    TNode<JSArgumentsObjectWithLength> tmp42;
    TNode<Smi> tmp43;
    TNode<Smi> tmp44;
    TNode<FixedArray> tmp45;
    TNode<Smi> tmp46;
    TNode<Smi> tmp47;
    TNode<Smi> tmp48;
    TNode<FixedArray> tmp49;
    TNode<IntPtrT> tmp50;
    TNode<IntPtrT> tmp51;
    TNode<IntPtrT> tmp52;
    TNode<HeapObject> tmp53;
    TNode<IntPtrT> tmp54;
    TNode<IntPtrT> tmp55;
    TNode<IntPtrT> tmp56;
    TNode<IntPtrT> tmp57;
    ca_.Bind(&block11, &tmp41, &tmp42, &tmp43, &tmp44, &tmp45, &tmp46, &tmp47, &tmp48, &tmp49, &tmp50, &tmp51, &tmp52, &tmp53, &tmp54, &tmp55, &tmp56, &tmp57);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 39);
    TNode<IntPtrT> tmp58;
    USE(tmp58);
    tmp58 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, (SizeOf20UT5ATSmi10HeapObject_354(state_)));
    TNode<IntPtrT> tmp59;
    USE(tmp59);
    tmp59 = CodeStubAssembler(state_).IntPtrMul(TNode<IntPtrT>{tmp57}, TNode<IntPtrT>{tmp58});
    TNode<IntPtrT> tmp60;
    USE(tmp60);
    tmp60 = CodeStubAssembler(state_).IntPtrAdd(TNode<IntPtrT>{tmp54}, TNode<IntPtrT>{tmp59});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 38);
    TNode<HeapObject> tmp61;
    USE(tmp61);
    TNode<IntPtrT> tmp62;
    USE(tmp62);
    std::tie(tmp61, tmp62) = UnsafeNewReference20UT5ATSmi10HeapObject_1440(state_, TNode<HeapObject>{tmp53}, TNode<IntPtrT>{tmp60}).Flatten();
    ca_.Goto(&block10, tmp41, tmp42, tmp43, tmp44, tmp45, tmp46, tmp47, tmp48, tmp49, tmp50, tmp51, tmp52, tmp53, tmp54, tmp55, tmp56, tmp57, tmp61, tmp62);
  }

  if (block12.is_used()) {
    TNode<NativeContext> tmp63;
    TNode<JSArgumentsObjectWithLength> tmp64;
    TNode<Smi> tmp65;
    TNode<Smi> tmp66;
    TNode<FixedArray> tmp67;
    TNode<Smi> tmp68;
    TNode<Smi> tmp69;
    TNode<Smi> tmp70;
    TNode<FixedArray> tmp71;
    TNode<IntPtrT> tmp72;
    TNode<IntPtrT> tmp73;
    TNode<IntPtrT> tmp74;
    TNode<HeapObject> tmp75;
    TNode<IntPtrT> tmp76;
    TNode<IntPtrT> tmp77;
    TNode<IntPtrT> tmp78;
    TNode<IntPtrT> tmp79;
    ca_.Bind(&block12, &tmp63, &tmp64, &tmp65, &tmp66, &tmp67, &tmp68, &tmp69, &tmp70, &tmp71, &tmp72, &tmp73, &tmp74, &tmp75, &tmp76, &tmp77, &tmp78, &tmp79);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 41);
    ca_.Goto(&block9, tmp63, tmp64, tmp65, tmp66, tmp67, tmp68, tmp69, tmp70, tmp71, tmp72, tmp73, tmp74);
  }

  if (block10.is_used()) {
    TNode<NativeContext> tmp80;
    TNode<JSArgumentsObjectWithLength> tmp81;
    TNode<Smi> tmp82;
    TNode<Smi> tmp83;
    TNode<FixedArray> tmp84;
    TNode<Smi> tmp85;
    TNode<Smi> tmp86;
    TNode<Smi> tmp87;
    TNode<FixedArray> tmp88;
    TNode<IntPtrT> tmp89;
    TNode<IntPtrT> tmp90;
    TNode<IntPtrT> tmp91;
    TNode<HeapObject> tmp92;
    TNode<IntPtrT> tmp93;
    TNode<IntPtrT> tmp94;
    TNode<IntPtrT> tmp95;
    TNode<IntPtrT> tmp96;
    TNode<HeapObject> tmp97;
    TNode<IntPtrT> tmp98;
    ca_.Bind(&block10, &tmp80, &tmp81, &tmp82, &tmp83, &tmp84, &tmp85, &tmp86, &tmp87, &tmp88, &tmp89, &tmp90, &tmp91, &tmp92, &tmp93, &tmp94, &tmp95, &tmp96, &tmp97, &tmp98);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 51);
    ca_.Goto(&block8, tmp80, tmp81, tmp82, tmp83, tmp84, tmp85, tmp86, tmp87, tmp88, tmp89, tmp90, tmp91, tmp97, tmp98);
  }

  if (block9.is_used()) {
    TNode<NativeContext> tmp99;
    TNode<JSArgumentsObjectWithLength> tmp100;
    TNode<Smi> tmp101;
    TNode<Smi> tmp102;
    TNode<FixedArray> tmp103;
    TNode<Smi> tmp104;
    TNode<Smi> tmp105;
    TNode<Smi> tmp106;
    TNode<FixedArray> tmp107;
    TNode<IntPtrT> tmp108;
    TNode<IntPtrT> tmp109;
    TNode<IntPtrT> tmp110;
    ca_.Bind(&block9, &tmp99, &tmp100, &tmp101, &tmp102, &tmp103, &tmp104, &tmp105, &tmp106, &tmp107, &tmp108, &tmp109, &tmp110);
    CodeStubAssembler(state_).Unreachable();
  }

  if (block8.is_used()) {
    TNode<NativeContext> tmp111;
    TNode<JSArgumentsObjectWithLength> tmp112;
    TNode<Smi> tmp113;
    TNode<Smi> tmp114;
    TNode<FixedArray> tmp115;
    TNode<Smi> tmp116;
    TNode<Smi> tmp117;
    TNode<Smi> tmp118;
    TNode<FixedArray> tmp119;
    TNode<IntPtrT> tmp120;
    TNode<IntPtrT> tmp121;
    TNode<IntPtrT> tmp122;
    TNode<HeapObject> tmp123;
    TNode<IntPtrT> tmp124;
    ca_.Bind(&block8, &tmp111, &tmp112, &tmp113, &tmp114, &tmp115, &tmp116, &tmp117, &tmp118, &tmp119, &tmp120, &tmp121, &tmp122, &tmp123, &tmp124);
    ca_.Goto(&block7, tmp111, tmp112, tmp113, tmp114, tmp115, tmp116, tmp117, tmp118, tmp119, tmp120, tmp121, tmp123, tmp124);
  }

  if (block7.is_used()) {
    TNode<NativeContext> tmp125;
    TNode<JSArgumentsObjectWithLength> tmp126;
    TNode<Smi> tmp127;
    TNode<Smi> tmp128;
    TNode<FixedArray> tmp129;
    TNode<Smi> tmp130;
    TNode<Smi> tmp131;
    TNode<Smi> tmp132;
    TNode<FixedArray> tmp133;
    TNode<IntPtrT> tmp134;
    TNode<IntPtrT> tmp135;
    TNode<HeapObject> tmp136;
    TNode<IntPtrT> tmp137;
    ca_.Bind(&block7, &tmp125, &tmp126, &tmp127, &tmp128, &tmp129, &tmp130, &tmp131, &tmp132, &tmp133, &tmp134, &tmp135, &tmp136, &tmp137);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 46);
    TNode<Object>tmp138 = CodeStubAssembler(state_).LoadReference<Object>(CodeStubAssembler::Reference{tmp136, tmp137});
    TNode<FixedArray> tmp139;
    USE(tmp139);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp139 = Cast10FixedArray_1462(state_, TNode<Context>{tmp125}, TNode<Object>{tmp138}, &label0);
    ca_.Goto(&block14, tmp125, tmp126, tmp127, tmp128, tmp129, tmp130, tmp131, tmp132, tmp138, tmp139);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block15, tmp125, tmp126, tmp127, tmp128, tmp129, tmp130, tmp131, tmp132, tmp138);
    }
  }

  if (block15.is_used()) {
    TNode<NativeContext> tmp140;
    TNode<JSArgumentsObjectWithLength> tmp141;
    TNode<Smi> tmp142;
    TNode<Smi> tmp143;
    TNode<FixedArray> tmp144;
    TNode<Smi> tmp145;
    TNode<Smi> tmp146;
    TNode<Smi> tmp147;
    TNode<Object> tmp148;
    ca_.Bind(&block15, &tmp140, &tmp141, &tmp142, &tmp143, &tmp144, &tmp145, &tmp146, &tmp147, &tmp148);
    ca_.Goto(&block1);
  }

  if (block14.is_used()) {
    TNode<NativeContext> tmp149;
    TNode<JSArgumentsObjectWithLength> tmp150;
    TNode<Smi> tmp151;
    TNode<Smi> tmp152;
    TNode<FixedArray> tmp153;
    TNode<Smi> tmp154;
    TNode<Smi> tmp155;
    TNode<Smi> tmp156;
    TNode<Object> tmp157;
    TNode<FixedArray> tmp158;
    ca_.Bind(&block14, &tmp149, &tmp150, &tmp151, &tmp152, &tmp153, &tmp154, &tmp155, &tmp156, &tmp157, &tmp158);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 45);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 48);
    TNode<IntPtrT> tmp159 = ca_.IntPtrConstant(FixedArrayBase::kLengthOffset);
    USE(tmp159);
    TNode<Smi>tmp160 = CodeStubAssembler(state_).LoadReference<Smi>(CodeStubAssembler::Reference{tmp158, tmp159});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 49);
    TNode<BoolT> tmp161;
    USE(tmp161);
    tmp161 = CodeStubAssembler(state_).SmiAbove(TNode<Smi>{tmp156}, TNode<Smi>{tmp160});
    ca_.Branch(tmp161, &block16, &block17, tmp149, tmp150, tmp151, tmp152, tmp153, tmp154, tmp155, tmp156, tmp158, tmp160);
  }

  if (block16.is_used()) {
    TNode<NativeContext> tmp162;
    TNode<JSArgumentsObjectWithLength> tmp163;
    TNode<Smi> tmp164;
    TNode<Smi> tmp165;
    TNode<FixedArray> tmp166;
    TNode<Smi> tmp167;
    TNode<Smi> tmp168;
    TNode<Smi> tmp169;
    TNode<FixedArray> tmp170;
    TNode<Smi> tmp171;
    ca_.Bind(&block16, &tmp162, &tmp163, &tmp164, &tmp165, &tmp166, &tmp167, &tmp168, &tmp169, &tmp170, &tmp171);
    ca_.Goto(&block1);
  }

  if (block17.is_used()) {
    TNode<NativeContext> tmp172;
    TNode<JSArgumentsObjectWithLength> tmp173;
    TNode<Smi> tmp174;
    TNode<Smi> tmp175;
    TNode<FixedArray> tmp176;
    TNode<Smi> tmp177;
    TNode<Smi> tmp178;
    TNode<Smi> tmp179;
    TNode<FixedArray> tmp180;
    TNode<Smi> tmp181;
    ca_.Bind(&block17, &tmp172, &tmp173, &tmp174, &tmp175, &tmp176, &tmp177, &tmp178, &tmp179, &tmp180, &tmp181);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 52);
    TNode<IntPtrT> tmp182 = ca_.IntPtrConstant(FixedArray::kObjectsOffset);
    USE(tmp182);
    TNode<IntPtrT> tmp183 = ca_.IntPtrConstant(FixedArrayBase::kLengthOffset);
    USE(tmp183);
    TNode<Smi>tmp184 = CodeStubAssembler(state_).LoadReference<Smi>(CodeStubAssembler::Reference{tmp176, tmp183});
    TNode<IntPtrT> tmp185;
    USE(tmp185);
    tmp185 = Convert8ATintptr5ATSmi_189(state_, TNode<Smi>{tmp184});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 50);
    TNode<IntPtrT> tmp186;
    USE(tmp186);
    tmp186 = Convert8ATintptr17ATconstexpr_int31_1444(state_, SloppyArgumentsElements::kContextIndex);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 51);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 37);
    TNode<UintPtrT> tmp187;
    USE(tmp187);
    tmp187 = Convert9ATuintptr8ATintptr_206(state_, TNode<IntPtrT>{tmp186});
    TNode<UintPtrT> tmp188;
    USE(tmp188);
    tmp188 = Convert9ATuintptr8ATintptr_206(state_, TNode<IntPtrT>{tmp185});
    TNode<BoolT> tmp189;
    USE(tmp189);
    tmp189 = CodeStubAssembler(state_).UintPtrLessThan(TNode<UintPtrT>{tmp187}, TNode<UintPtrT>{tmp188});
    ca_.Branch(tmp189, &block22, &block23, tmp172, tmp173, tmp174, tmp175, tmp176, tmp177, tmp178, tmp179, tmp180, tmp181, tmp176, tmp182, tmp185, tmp186, tmp176, tmp182, tmp185, tmp186, tmp186);
  }

  if (block22.is_used()) {
    TNode<NativeContext> tmp190;
    TNode<JSArgumentsObjectWithLength> tmp191;
    TNode<Smi> tmp192;
    TNode<Smi> tmp193;
    TNode<FixedArray> tmp194;
    TNode<Smi> tmp195;
    TNode<Smi> tmp196;
    TNode<Smi> tmp197;
    TNode<FixedArray> tmp198;
    TNode<Smi> tmp199;
    TNode<FixedArray> tmp200;
    TNode<IntPtrT> tmp201;
    TNode<IntPtrT> tmp202;
    TNode<IntPtrT> tmp203;
    TNode<HeapObject> tmp204;
    TNode<IntPtrT> tmp205;
    TNode<IntPtrT> tmp206;
    TNode<IntPtrT> tmp207;
    TNode<IntPtrT> tmp208;
    ca_.Bind(&block22, &tmp190, &tmp191, &tmp192, &tmp193, &tmp194, &tmp195, &tmp196, &tmp197, &tmp198, &tmp199, &tmp200, &tmp201, &tmp202, &tmp203, &tmp204, &tmp205, &tmp206, &tmp207, &tmp208);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 39);
    TNode<IntPtrT> tmp209;
    USE(tmp209);
    tmp209 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, (SizeOf20UT5ATSmi10HeapObject_354(state_)));
    TNode<IntPtrT> tmp210;
    USE(tmp210);
    tmp210 = CodeStubAssembler(state_).IntPtrMul(TNode<IntPtrT>{tmp208}, TNode<IntPtrT>{tmp209});
    TNode<IntPtrT> tmp211;
    USE(tmp211);
    tmp211 = CodeStubAssembler(state_).IntPtrAdd(TNode<IntPtrT>{tmp205}, TNode<IntPtrT>{tmp210});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 38);
    TNode<HeapObject> tmp212;
    USE(tmp212);
    TNode<IntPtrT> tmp213;
    USE(tmp213);
    std::tie(tmp212, tmp213) = UnsafeNewReference20UT5ATSmi10HeapObject_1440(state_, TNode<HeapObject>{tmp204}, TNode<IntPtrT>{tmp211}).Flatten();
    ca_.Goto(&block21, tmp190, tmp191, tmp192, tmp193, tmp194, tmp195, tmp196, tmp197, tmp198, tmp199, tmp200, tmp201, tmp202, tmp203, tmp204, tmp205, tmp206, tmp207, tmp208, tmp212, tmp213);
  }

  if (block23.is_used()) {
    TNode<NativeContext> tmp214;
    TNode<JSArgumentsObjectWithLength> tmp215;
    TNode<Smi> tmp216;
    TNode<Smi> tmp217;
    TNode<FixedArray> tmp218;
    TNode<Smi> tmp219;
    TNode<Smi> tmp220;
    TNode<Smi> tmp221;
    TNode<FixedArray> tmp222;
    TNode<Smi> tmp223;
    TNode<FixedArray> tmp224;
    TNode<IntPtrT> tmp225;
    TNode<IntPtrT> tmp226;
    TNode<IntPtrT> tmp227;
    TNode<HeapObject> tmp228;
    TNode<IntPtrT> tmp229;
    TNode<IntPtrT> tmp230;
    TNode<IntPtrT> tmp231;
    TNode<IntPtrT> tmp232;
    ca_.Bind(&block23, &tmp214, &tmp215, &tmp216, &tmp217, &tmp218, &tmp219, &tmp220, &tmp221, &tmp222, &tmp223, &tmp224, &tmp225, &tmp226, &tmp227, &tmp228, &tmp229, &tmp230, &tmp231, &tmp232);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 41);
    ca_.Goto(&block20, tmp214, tmp215, tmp216, tmp217, tmp218, tmp219, tmp220, tmp221, tmp222, tmp223, tmp224, tmp225, tmp226, tmp227);
  }

  if (block21.is_used()) {
    TNode<NativeContext> tmp233;
    TNode<JSArgumentsObjectWithLength> tmp234;
    TNode<Smi> tmp235;
    TNode<Smi> tmp236;
    TNode<FixedArray> tmp237;
    TNode<Smi> tmp238;
    TNode<Smi> tmp239;
    TNode<Smi> tmp240;
    TNode<FixedArray> tmp241;
    TNode<Smi> tmp242;
    TNode<FixedArray> tmp243;
    TNode<IntPtrT> tmp244;
    TNode<IntPtrT> tmp245;
    TNode<IntPtrT> tmp246;
    TNode<HeapObject> tmp247;
    TNode<IntPtrT> tmp248;
    TNode<IntPtrT> tmp249;
    TNode<IntPtrT> tmp250;
    TNode<IntPtrT> tmp251;
    TNode<HeapObject> tmp252;
    TNode<IntPtrT> tmp253;
    ca_.Bind(&block21, &tmp233, &tmp234, &tmp235, &tmp236, &tmp237, &tmp238, &tmp239, &tmp240, &tmp241, &tmp242, &tmp243, &tmp244, &tmp245, &tmp246, &tmp247, &tmp248, &tmp249, &tmp250, &tmp251, &tmp252, &tmp253);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 51);
    ca_.Goto(&block19, tmp233, tmp234, tmp235, tmp236, tmp237, tmp238, tmp239, tmp240, tmp241, tmp242, tmp243, tmp244, tmp245, tmp246, tmp252, tmp253);
  }

  if (block20.is_used()) {
    TNode<NativeContext> tmp254;
    TNode<JSArgumentsObjectWithLength> tmp255;
    TNode<Smi> tmp256;
    TNode<Smi> tmp257;
    TNode<FixedArray> tmp258;
    TNode<Smi> tmp259;
    TNode<Smi> tmp260;
    TNode<Smi> tmp261;
    TNode<FixedArray> tmp262;
    TNode<Smi> tmp263;
    TNode<FixedArray> tmp264;
    TNode<IntPtrT> tmp265;
    TNode<IntPtrT> tmp266;
    TNode<IntPtrT> tmp267;
    ca_.Bind(&block20, &tmp254, &tmp255, &tmp256, &tmp257, &tmp258, &tmp259, &tmp260, &tmp261, &tmp262, &tmp263, &tmp264, &tmp265, &tmp266, &tmp267);
    CodeStubAssembler(state_).Unreachable();
  }

  if (block19.is_used()) {
    TNode<NativeContext> tmp268;
    TNode<JSArgumentsObjectWithLength> tmp269;
    TNode<Smi> tmp270;
    TNode<Smi> tmp271;
    TNode<FixedArray> tmp272;
    TNode<Smi> tmp273;
    TNode<Smi> tmp274;
    TNode<Smi> tmp275;
    TNode<FixedArray> tmp276;
    TNode<Smi> tmp277;
    TNode<FixedArray> tmp278;
    TNode<IntPtrT> tmp279;
    TNode<IntPtrT> tmp280;
    TNode<IntPtrT> tmp281;
    TNode<HeapObject> tmp282;
    TNode<IntPtrT> tmp283;
    ca_.Bind(&block19, &tmp268, &tmp269, &tmp270, &tmp271, &tmp272, &tmp273, &tmp274, &tmp275, &tmp276, &tmp277, &tmp278, &tmp279, &tmp280, &tmp281, &tmp282, &tmp283);
    ca_.Goto(&block18, tmp268, tmp269, tmp270, tmp271, tmp272, tmp273, tmp274, tmp275, tmp276, tmp277, tmp278, tmp279, tmp280, tmp282, tmp283);
  }

  if (block18.is_used()) {
    TNode<NativeContext> tmp284;
    TNode<JSArgumentsObjectWithLength> tmp285;
    TNode<Smi> tmp286;
    TNode<Smi> tmp287;
    TNode<FixedArray> tmp288;
    TNode<Smi> tmp289;
    TNode<Smi> tmp290;
    TNode<Smi> tmp291;
    TNode<FixedArray> tmp292;
    TNode<Smi> tmp293;
    TNode<FixedArray> tmp294;
    TNode<IntPtrT> tmp295;
    TNode<IntPtrT> tmp296;
    TNode<HeapObject> tmp297;
    TNode<IntPtrT> tmp298;
    ca_.Bind(&block18, &tmp284, &tmp285, &tmp286, &tmp287, &tmp288, &tmp289, &tmp290, &tmp291, &tmp292, &tmp293, &tmp294, &tmp295, &tmp296, &tmp297, &tmp298);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 52);
    TNode<Object>tmp299 = CodeStubAssembler(state_).LoadReference<Object>(CodeStubAssembler::Reference{tmp297, tmp298});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 51);
    TNode<Context> tmp300;
    USE(tmp300);
    tmp300 = UnsafeCast7Context_1463(state_, TNode<Context>{tmp284}, TNode<Object>{tmp299});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 54);
    TNode<Map> tmp301;
    USE(tmp301);
    tmp301 = CodeStubAssembler(state_).LoadJSArrayElementsMap(HOLEY_ELEMENTS, TNode<NativeContext>{tmp284});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 56);
    TNode<JSArray> tmp302;
    USE(tmp302);
    tmp302 = CodeStubAssembler(state_).AllocateJSArray(HOLEY_ELEMENTS, TNode<Map>{tmp301}, TNode<Smi>{tmp287}, TNode<Smi>{tmp287});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 55);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 58);
    TNode<Smi> tmp303;
    USE(tmp303);
    tmp303 = FromConstexpr5ATSmi17ATconstexpr_int31_155(state_, 0);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 59);
    TNode<IntPtrT> tmp304 = ca_.IntPtrConstant(JSObject::kElementsOffset);
    USE(tmp304);
    TNode<FixedArrayBase>tmp305 = CodeStubAssembler(state_).LoadReference<FixedArrayBase>(CodeStubAssembler::Reference{tmp302, tmp304});
    TNode<FixedArray> tmp306;
    USE(tmp306);
    tmp306 = UnsafeCast10FixedArray_1438(state_, TNode<Context>{tmp284}, TNode<Object>{tmp305});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 60);
    TNode<Smi> tmp307;
    USE(tmp307);
    tmp307 = CodeStubAssembler(state_).SmiMin(TNode<Smi>{tmp290}, TNode<Smi>{tmp291});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 63);
    ca_.Goto(&block27, tmp284, tmp285, tmp286, tmp287, tmp288, tmp289, tmp290, tmp291, tmp292, tmp293, tmp300, tmp301, tmp302, tmp303, tmp306, tmp307, tmp286);
  }

  if (block27.is_used()) {
    TNode<NativeContext> tmp308;
    TNode<JSArgumentsObjectWithLength> tmp309;
    TNode<Smi> tmp310;
    TNode<Smi> tmp311;
    TNode<FixedArray> tmp312;
    TNode<Smi> tmp313;
    TNode<Smi> tmp314;
    TNode<Smi> tmp315;
    TNode<FixedArray> tmp316;
    TNode<Smi> tmp317;
    TNode<Context> tmp318;
    TNode<Map> tmp319;
    TNode<JSArray> tmp320;
    TNode<Smi> tmp321;
    TNode<FixedArray> tmp322;
    TNode<Smi> tmp323;
    TNode<Smi> tmp324;
    ca_.Bind(&block27, &tmp308, &tmp309, &tmp310, &tmp311, &tmp312, &tmp313, &tmp314, &tmp315, &tmp316, &tmp317, &tmp318, &tmp319, &tmp320, &tmp321, &tmp322, &tmp323, &tmp324);
    TNode<BoolT> tmp325;
    USE(tmp325);
    tmp325 = CodeStubAssembler(state_).SmiLessThan(TNode<Smi>{tmp324}, TNode<Smi>{tmp323});
    ca_.Branch(tmp325, &block25, &block26, tmp308, tmp309, tmp310, tmp311, tmp312, tmp313, tmp314, tmp315, tmp316, tmp317, tmp318, tmp319, tmp320, tmp321, tmp322, tmp323, tmp324);
  }

  if (block25.is_used()) {
    TNode<NativeContext> tmp326;
    TNode<JSArgumentsObjectWithLength> tmp327;
    TNode<Smi> tmp328;
    TNode<Smi> tmp329;
    TNode<FixedArray> tmp330;
    TNode<Smi> tmp331;
    TNode<Smi> tmp332;
    TNode<Smi> tmp333;
    TNode<FixedArray> tmp334;
    TNode<Smi> tmp335;
    TNode<Context> tmp336;
    TNode<Map> tmp337;
    TNode<JSArray> tmp338;
    TNode<Smi> tmp339;
    TNode<FixedArray> tmp340;
    TNode<Smi> tmp341;
    TNode<Smi> tmp342;
    ca_.Bind(&block25, &tmp326, &tmp327, &tmp328, &tmp329, &tmp330, &tmp331, &tmp332, &tmp333, &tmp334, &tmp335, &tmp336, &tmp337, &tmp338, &tmp339, &tmp340, &tmp341, &tmp342);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 65);
    TNode<IntPtrT> tmp343 = ca_.IntPtrConstant(FixedArray::kObjectsOffset);
    USE(tmp343);
    TNode<IntPtrT> tmp344 = ca_.IntPtrConstant(FixedArrayBase::kLengthOffset);
    USE(tmp344);
    TNode<Smi>tmp345 = CodeStubAssembler(state_).LoadReference<Smi>(CodeStubAssembler::Reference{tmp330, tmp344});
    TNode<IntPtrT> tmp346;
    USE(tmp346);
    tmp346 = Convert8ATintptr5ATSmi_189(state_, TNode<Smi>{tmp345});
    TNode<Smi> tmp347;
    USE(tmp347);
    tmp347 = FromConstexpr5ATSmi17ATconstexpr_int31_155(state_, SloppyArgumentsElements::kParameterMapStart);
    TNode<Smi> tmp348;
    USE(tmp348);
    tmp348 = CodeStubAssembler(state_).SmiAdd(TNode<Smi>{tmp342}, TNode<Smi>{tmp347});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 55);
    TNode<IntPtrT> tmp349;
    USE(tmp349);
    tmp349 = Convert8ATintptr5ATSmi_189(state_, TNode<Smi>{tmp348});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 56);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 37);
    TNode<UintPtrT> tmp350;
    USE(tmp350);
    tmp350 = Convert9ATuintptr8ATintptr_206(state_, TNode<IntPtrT>{tmp349});
    TNode<UintPtrT> tmp351;
    USE(tmp351);
    tmp351 = Convert9ATuintptr8ATintptr_206(state_, TNode<IntPtrT>{tmp346});
    TNode<BoolT> tmp352;
    USE(tmp352);
    tmp352 = CodeStubAssembler(state_).UintPtrLessThan(TNode<UintPtrT>{tmp350}, TNode<UintPtrT>{tmp351});
    ca_.Branch(tmp352, &block33, &block34, tmp326, tmp327, tmp328, tmp329, tmp330, tmp331, tmp332, tmp333, tmp334, tmp335, tmp336, tmp337, tmp338, tmp339, tmp340, tmp341, tmp342, tmp330, tmp343, tmp346, tmp348, tmp348, tmp349, tmp330, tmp343, tmp346, tmp349, tmp349);
  }

  if (block33.is_used()) {
    TNode<NativeContext> tmp353;
    TNode<JSArgumentsObjectWithLength> tmp354;
    TNode<Smi> tmp355;
    TNode<Smi> tmp356;
    TNode<FixedArray> tmp357;
    TNode<Smi> tmp358;
    TNode<Smi> tmp359;
    TNode<Smi> tmp360;
    TNode<FixedArray> tmp361;
    TNode<Smi> tmp362;
    TNode<Context> tmp363;
    TNode<Map> tmp364;
    TNode<JSArray> tmp365;
    TNode<Smi> tmp366;
    TNode<FixedArray> tmp367;
    TNode<Smi> tmp368;
    TNode<Smi> tmp369;
    TNode<FixedArray> tmp370;
    TNode<IntPtrT> tmp371;
    TNode<IntPtrT> tmp372;
    TNode<Smi> tmp373;
    TNode<Smi> tmp374;
    TNode<IntPtrT> tmp375;
    TNode<HeapObject> tmp376;
    TNode<IntPtrT> tmp377;
    TNode<IntPtrT> tmp378;
    TNode<IntPtrT> tmp379;
    TNode<IntPtrT> tmp380;
    ca_.Bind(&block33, &tmp353, &tmp354, &tmp355, &tmp356, &tmp357, &tmp358, &tmp359, &tmp360, &tmp361, &tmp362, &tmp363, &tmp364, &tmp365, &tmp366, &tmp367, &tmp368, &tmp369, &tmp370, &tmp371, &tmp372, &tmp373, &tmp374, &tmp375, &tmp376, &tmp377, &tmp378, &tmp379, &tmp380);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 39);
    TNode<IntPtrT> tmp381;
    USE(tmp381);
    tmp381 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, (SizeOf20UT5ATSmi10HeapObject_354(state_)));
    TNode<IntPtrT> tmp382;
    USE(tmp382);
    tmp382 = CodeStubAssembler(state_).IntPtrMul(TNode<IntPtrT>{tmp380}, TNode<IntPtrT>{tmp381});
    TNode<IntPtrT> tmp383;
    USE(tmp383);
    tmp383 = CodeStubAssembler(state_).IntPtrAdd(TNode<IntPtrT>{tmp377}, TNode<IntPtrT>{tmp382});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 38);
    TNode<HeapObject> tmp384;
    USE(tmp384);
    TNode<IntPtrT> tmp385;
    USE(tmp385);
    std::tie(tmp384, tmp385) = UnsafeNewReference20UT5ATSmi10HeapObject_1440(state_, TNode<HeapObject>{tmp376}, TNode<IntPtrT>{tmp383}).Flatten();
    ca_.Goto(&block32, tmp353, tmp354, tmp355, tmp356, tmp357, tmp358, tmp359, tmp360, tmp361, tmp362, tmp363, tmp364, tmp365, tmp366, tmp367, tmp368, tmp369, tmp370, tmp371, tmp372, tmp373, tmp374, tmp375, tmp376, tmp377, tmp378, tmp379, tmp380, tmp384, tmp385);
  }

  if (block34.is_used()) {
    TNode<NativeContext> tmp386;
    TNode<JSArgumentsObjectWithLength> tmp387;
    TNode<Smi> tmp388;
    TNode<Smi> tmp389;
    TNode<FixedArray> tmp390;
    TNode<Smi> tmp391;
    TNode<Smi> tmp392;
    TNode<Smi> tmp393;
    TNode<FixedArray> tmp394;
    TNode<Smi> tmp395;
    TNode<Context> tmp396;
    TNode<Map> tmp397;
    TNode<JSArray> tmp398;
    TNode<Smi> tmp399;
    TNode<FixedArray> tmp400;
    TNode<Smi> tmp401;
    TNode<Smi> tmp402;
    TNode<FixedArray> tmp403;
    TNode<IntPtrT> tmp404;
    TNode<IntPtrT> tmp405;
    TNode<Smi> tmp406;
    TNode<Smi> tmp407;
    TNode<IntPtrT> tmp408;
    TNode<HeapObject> tmp409;
    TNode<IntPtrT> tmp410;
    TNode<IntPtrT> tmp411;
    TNode<IntPtrT> tmp412;
    TNode<IntPtrT> tmp413;
    ca_.Bind(&block34, &tmp386, &tmp387, &tmp388, &tmp389, &tmp390, &tmp391, &tmp392, &tmp393, &tmp394, &tmp395, &tmp396, &tmp397, &tmp398, &tmp399, &tmp400, &tmp401, &tmp402, &tmp403, &tmp404, &tmp405, &tmp406, &tmp407, &tmp408, &tmp409, &tmp410, &tmp411, &tmp412, &tmp413);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 41);
    ca_.Goto(&block31, tmp386, tmp387, tmp388, tmp389, tmp390, tmp391, tmp392, tmp393, tmp394, tmp395, tmp396, tmp397, tmp398, tmp399, tmp400, tmp401, tmp402, tmp403, tmp404, tmp405, tmp406, tmp407, tmp408);
  }

  if (block32.is_used()) {
    TNode<NativeContext> tmp414;
    TNode<JSArgumentsObjectWithLength> tmp415;
    TNode<Smi> tmp416;
    TNode<Smi> tmp417;
    TNode<FixedArray> tmp418;
    TNode<Smi> tmp419;
    TNode<Smi> tmp420;
    TNode<Smi> tmp421;
    TNode<FixedArray> tmp422;
    TNode<Smi> tmp423;
    TNode<Context> tmp424;
    TNode<Map> tmp425;
    TNode<JSArray> tmp426;
    TNode<Smi> tmp427;
    TNode<FixedArray> tmp428;
    TNode<Smi> tmp429;
    TNode<Smi> tmp430;
    TNode<FixedArray> tmp431;
    TNode<IntPtrT> tmp432;
    TNode<IntPtrT> tmp433;
    TNode<Smi> tmp434;
    TNode<Smi> tmp435;
    TNode<IntPtrT> tmp436;
    TNode<HeapObject> tmp437;
    TNode<IntPtrT> tmp438;
    TNode<IntPtrT> tmp439;
    TNode<IntPtrT> tmp440;
    TNode<IntPtrT> tmp441;
    TNode<HeapObject> tmp442;
    TNode<IntPtrT> tmp443;
    ca_.Bind(&block32, &tmp414, &tmp415, &tmp416, &tmp417, &tmp418, &tmp419, &tmp420, &tmp421, &tmp422, &tmp423, &tmp424, &tmp425, &tmp426, &tmp427, &tmp428, &tmp429, &tmp430, &tmp431, &tmp432, &tmp433, &tmp434, &tmp435, &tmp436, &tmp437, &tmp438, &tmp439, &tmp440, &tmp441, &tmp442, &tmp443);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 56);
    ca_.Goto(&block30, tmp414, tmp415, tmp416, tmp417, tmp418, tmp419, tmp420, tmp421, tmp422, tmp423, tmp424, tmp425, tmp426, tmp427, tmp428, tmp429, tmp430, tmp431, tmp432, tmp433, tmp434, tmp435, tmp436, tmp442, tmp443);
  }

  if (block31.is_used()) {
    TNode<NativeContext> tmp444;
    TNode<JSArgumentsObjectWithLength> tmp445;
    TNode<Smi> tmp446;
    TNode<Smi> tmp447;
    TNode<FixedArray> tmp448;
    TNode<Smi> tmp449;
    TNode<Smi> tmp450;
    TNode<Smi> tmp451;
    TNode<FixedArray> tmp452;
    TNode<Smi> tmp453;
    TNode<Context> tmp454;
    TNode<Map> tmp455;
    TNode<JSArray> tmp456;
    TNode<Smi> tmp457;
    TNode<FixedArray> tmp458;
    TNode<Smi> tmp459;
    TNode<Smi> tmp460;
    TNode<FixedArray> tmp461;
    TNode<IntPtrT> tmp462;
    TNode<IntPtrT> tmp463;
    TNode<Smi> tmp464;
    TNode<Smi> tmp465;
    TNode<IntPtrT> tmp466;
    ca_.Bind(&block31, &tmp444, &tmp445, &tmp446, &tmp447, &tmp448, &tmp449, &tmp450, &tmp451, &tmp452, &tmp453, &tmp454, &tmp455, &tmp456, &tmp457, &tmp458, &tmp459, &tmp460, &tmp461, &tmp462, &tmp463, &tmp464, &tmp465, &tmp466);
    CodeStubAssembler(state_).Unreachable();
  }

  if (block30.is_used()) {
    TNode<NativeContext> tmp467;
    TNode<JSArgumentsObjectWithLength> tmp468;
    TNode<Smi> tmp469;
    TNode<Smi> tmp470;
    TNode<FixedArray> tmp471;
    TNode<Smi> tmp472;
    TNode<Smi> tmp473;
    TNode<Smi> tmp474;
    TNode<FixedArray> tmp475;
    TNode<Smi> tmp476;
    TNode<Context> tmp477;
    TNode<Map> tmp478;
    TNode<JSArray> tmp479;
    TNode<Smi> tmp480;
    TNode<FixedArray> tmp481;
    TNode<Smi> tmp482;
    TNode<Smi> tmp483;
    TNode<FixedArray> tmp484;
    TNode<IntPtrT> tmp485;
    TNode<IntPtrT> tmp486;
    TNode<Smi> tmp487;
    TNode<Smi> tmp488;
    TNode<IntPtrT> tmp489;
    TNode<HeapObject> tmp490;
    TNode<IntPtrT> tmp491;
    ca_.Bind(&block30, &tmp467, &tmp468, &tmp469, &tmp470, &tmp471, &tmp472, &tmp473, &tmp474, &tmp475, &tmp476, &tmp477, &tmp478, &tmp479, &tmp480, &tmp481, &tmp482, &tmp483, &tmp484, &tmp485, &tmp486, &tmp487, &tmp488, &tmp489, &tmp490, &tmp491);
    ca_.Goto(&block29, tmp467, tmp468, tmp469, tmp470, tmp471, tmp472, tmp473, tmp474, tmp475, tmp476, tmp477, tmp478, tmp479, tmp480, tmp481, tmp482, tmp483, tmp484, tmp485, tmp486, tmp487, tmp488, tmp490, tmp491);
  }

  if (block29.is_used()) {
    TNode<NativeContext> tmp492;
    TNode<JSArgumentsObjectWithLength> tmp493;
    TNode<Smi> tmp494;
    TNode<Smi> tmp495;
    TNode<FixedArray> tmp496;
    TNode<Smi> tmp497;
    TNode<Smi> tmp498;
    TNode<Smi> tmp499;
    TNode<FixedArray> tmp500;
    TNode<Smi> tmp501;
    TNode<Context> tmp502;
    TNode<Map> tmp503;
    TNode<JSArray> tmp504;
    TNode<Smi> tmp505;
    TNode<FixedArray> tmp506;
    TNode<Smi> tmp507;
    TNode<Smi> tmp508;
    TNode<FixedArray> tmp509;
    TNode<IntPtrT> tmp510;
    TNode<IntPtrT> tmp511;
    TNode<Smi> tmp512;
    TNode<Smi> tmp513;
    TNode<HeapObject> tmp514;
    TNode<IntPtrT> tmp515;
    ca_.Bind(&block29, &tmp492, &tmp493, &tmp494, &tmp495, &tmp496, &tmp497, &tmp498, &tmp499, &tmp500, &tmp501, &tmp502, &tmp503, &tmp504, &tmp505, &tmp506, &tmp507, &tmp508, &tmp509, &tmp510, &tmp511, &tmp512, &tmp513, &tmp514, &tmp515);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 65);
    TNode<Object>tmp516 = CodeStubAssembler(state_).LoadReference<Object>(CodeStubAssembler::Reference{tmp514, tmp515});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 64);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 67);
    TNode<Oddball> tmp517;
    USE(tmp517);
    tmp517 = TheHole_62(state_);
    TNode<BoolT> tmp518;
    USE(tmp518);
    tmp518 = CodeStubAssembler(state_).TaggedNotEqual(TNode<Object>{tmp516}, TNode<HeapObject>{tmp517});
    ca_.Branch(tmp518, &block36, &block37, tmp492, tmp493, tmp494, tmp495, tmp496, tmp497, tmp498, tmp499, tmp500, tmp501, tmp502, tmp503, tmp504, tmp505, tmp506, tmp507, tmp508, tmp516);
  }

  if (block36.is_used()) {
    TNode<NativeContext> tmp519;
    TNode<JSArgumentsObjectWithLength> tmp520;
    TNode<Smi> tmp521;
    TNode<Smi> tmp522;
    TNode<FixedArray> tmp523;
    TNode<Smi> tmp524;
    TNode<Smi> tmp525;
    TNode<Smi> tmp526;
    TNode<FixedArray> tmp527;
    TNode<Smi> tmp528;
    TNode<Context> tmp529;
    TNode<Map> tmp530;
    TNode<JSArray> tmp531;
    TNode<Smi> tmp532;
    TNode<FixedArray> tmp533;
    TNode<Smi> tmp534;
    TNode<Smi> tmp535;
    TNode<Object> tmp536;
    ca_.Bind(&block36, &tmp519, &tmp520, &tmp521, &tmp522, &tmp523, &tmp524, &tmp525, &tmp526, &tmp527, &tmp528, &tmp529, &tmp530, &tmp531, &tmp532, &tmp533, &tmp534, &tmp535, &tmp536);
    TNode<Smi> tmp537;
    USE(tmp537);
    tmp537 = UnsafeCast5ATSmi_1439(state_, TNode<Context>{tmp519}, TNode<Object>{tmp536});
    TNode<Object> tmp538;
    USE(tmp538);
    tmp538 = CodeStubAssembler(state_).LoadContextElement(TNode<Context>{tmp529}, TNode<Smi>{tmp537});
    ca_.Goto(&block39, tmp519, tmp520, tmp521, tmp522, tmp523, tmp524, tmp525, tmp526, tmp527, tmp528, tmp529, tmp530, tmp531, tmp532, tmp533, tmp534, tmp535, tmp536, tmp538);
  }

  if (block37.is_used()) {
    TNode<NativeContext> tmp539;
    TNode<JSArgumentsObjectWithLength> tmp540;
    TNode<Smi> tmp541;
    TNode<Smi> tmp542;
    TNode<FixedArray> tmp543;
    TNode<Smi> tmp544;
    TNode<Smi> tmp545;
    TNode<Smi> tmp546;
    TNode<FixedArray> tmp547;
    TNode<Smi> tmp548;
    TNode<Context> tmp549;
    TNode<Map> tmp550;
    TNode<JSArray> tmp551;
    TNode<Smi> tmp552;
    TNode<FixedArray> tmp553;
    TNode<Smi> tmp554;
    TNode<Smi> tmp555;
    TNode<Object> tmp556;
    ca_.Bind(&block37, &tmp539, &tmp540, &tmp541, &tmp542, &tmp543, &tmp544, &tmp545, &tmp546, &tmp547, &tmp548, &tmp549, &tmp550, &tmp551, &tmp552, &tmp553, &tmp554, &tmp555, &tmp556);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 68);
    TNode<IntPtrT> tmp557 = ca_.IntPtrConstant(FixedArray::kObjectsOffset);
    USE(tmp557);
    TNode<IntPtrT> tmp558 = ca_.IntPtrConstant(FixedArrayBase::kLengthOffset);
    USE(tmp558);
    TNode<Smi>tmp559 = CodeStubAssembler(state_).LoadReference<Smi>(CodeStubAssembler::Reference{tmp547, tmp558});
    TNode<IntPtrT> tmp560;
    USE(tmp560);
    tmp560 = Convert8ATintptr5ATSmi_189(state_, TNode<Smi>{tmp559});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 55);
    TNode<IntPtrT> tmp561;
    USE(tmp561);
    tmp561 = Convert8ATintptr5ATSmi_189(state_, TNode<Smi>{tmp555});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 56);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 37);
    TNode<UintPtrT> tmp562;
    USE(tmp562);
    tmp562 = Convert9ATuintptr8ATintptr_206(state_, TNode<IntPtrT>{tmp561});
    TNode<UintPtrT> tmp563;
    USE(tmp563);
    tmp563 = Convert9ATuintptr8ATintptr_206(state_, TNode<IntPtrT>{tmp560});
    TNode<BoolT> tmp564;
    USE(tmp564);
    tmp564 = CodeStubAssembler(state_).UintPtrLessThan(TNode<UintPtrT>{tmp562}, TNode<UintPtrT>{tmp563});
    ca_.Branch(tmp564, &block44, &block45, tmp539, tmp540, tmp541, tmp542, tmp543, tmp544, tmp545, tmp546, tmp547, tmp548, tmp549, tmp550, tmp551, tmp552, tmp553, tmp554, tmp555, tmp556, tmp547, tmp557, tmp560, tmp555, tmp555, tmp561, tmp547, tmp557, tmp560, tmp561, tmp561);
  }

  if (block44.is_used()) {
    TNode<NativeContext> tmp565;
    TNode<JSArgumentsObjectWithLength> tmp566;
    TNode<Smi> tmp567;
    TNode<Smi> tmp568;
    TNode<FixedArray> tmp569;
    TNode<Smi> tmp570;
    TNode<Smi> tmp571;
    TNode<Smi> tmp572;
    TNode<FixedArray> tmp573;
    TNode<Smi> tmp574;
    TNode<Context> tmp575;
    TNode<Map> tmp576;
    TNode<JSArray> tmp577;
    TNode<Smi> tmp578;
    TNode<FixedArray> tmp579;
    TNode<Smi> tmp580;
    TNode<Smi> tmp581;
    TNode<Object> tmp582;
    TNode<FixedArray> tmp583;
    TNode<IntPtrT> tmp584;
    TNode<IntPtrT> tmp585;
    TNode<Smi> tmp586;
    TNode<Smi> tmp587;
    TNode<IntPtrT> tmp588;
    TNode<HeapObject> tmp589;
    TNode<IntPtrT> tmp590;
    TNode<IntPtrT> tmp591;
    TNode<IntPtrT> tmp592;
    TNode<IntPtrT> tmp593;
    ca_.Bind(&block44, &tmp565, &tmp566, &tmp567, &tmp568, &tmp569, &tmp570, &tmp571, &tmp572, &tmp573, &tmp574, &tmp575, &tmp576, &tmp577, &tmp578, &tmp579, &tmp580, &tmp581, &tmp582, &tmp583, &tmp584, &tmp585, &tmp586, &tmp587, &tmp588, &tmp589, &tmp590, &tmp591, &tmp592, &tmp593);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 39);
    TNode<IntPtrT> tmp594;
    USE(tmp594);
    tmp594 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, (SizeOf20UT5ATSmi10HeapObject_354(state_)));
    TNode<IntPtrT> tmp595;
    USE(tmp595);
    tmp595 = CodeStubAssembler(state_).IntPtrMul(TNode<IntPtrT>{tmp593}, TNode<IntPtrT>{tmp594});
    TNode<IntPtrT> tmp596;
    USE(tmp596);
    tmp596 = CodeStubAssembler(state_).IntPtrAdd(TNode<IntPtrT>{tmp590}, TNode<IntPtrT>{tmp595});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 38);
    TNode<HeapObject> tmp597;
    USE(tmp597);
    TNode<IntPtrT> tmp598;
    USE(tmp598);
    std::tie(tmp597, tmp598) = UnsafeNewReference20UT5ATSmi10HeapObject_1440(state_, TNode<HeapObject>{tmp589}, TNode<IntPtrT>{tmp596}).Flatten();
    ca_.Goto(&block43, tmp565, tmp566, tmp567, tmp568, tmp569, tmp570, tmp571, tmp572, tmp573, tmp574, tmp575, tmp576, tmp577, tmp578, tmp579, tmp580, tmp581, tmp582, tmp583, tmp584, tmp585, tmp586, tmp587, tmp588, tmp589, tmp590, tmp591, tmp592, tmp593, tmp597, tmp598);
  }

  if (block45.is_used()) {
    TNode<NativeContext> tmp599;
    TNode<JSArgumentsObjectWithLength> tmp600;
    TNode<Smi> tmp601;
    TNode<Smi> tmp602;
    TNode<FixedArray> tmp603;
    TNode<Smi> tmp604;
    TNode<Smi> tmp605;
    TNode<Smi> tmp606;
    TNode<FixedArray> tmp607;
    TNode<Smi> tmp608;
    TNode<Context> tmp609;
    TNode<Map> tmp610;
    TNode<JSArray> tmp611;
    TNode<Smi> tmp612;
    TNode<FixedArray> tmp613;
    TNode<Smi> tmp614;
    TNode<Smi> tmp615;
    TNode<Object> tmp616;
    TNode<FixedArray> tmp617;
    TNode<IntPtrT> tmp618;
    TNode<IntPtrT> tmp619;
    TNode<Smi> tmp620;
    TNode<Smi> tmp621;
    TNode<IntPtrT> tmp622;
    TNode<HeapObject> tmp623;
    TNode<IntPtrT> tmp624;
    TNode<IntPtrT> tmp625;
    TNode<IntPtrT> tmp626;
    TNode<IntPtrT> tmp627;
    ca_.Bind(&block45, &tmp599, &tmp600, &tmp601, &tmp602, &tmp603, &tmp604, &tmp605, &tmp606, &tmp607, &tmp608, &tmp609, &tmp610, &tmp611, &tmp612, &tmp613, &tmp614, &tmp615, &tmp616, &tmp617, &tmp618, &tmp619, &tmp620, &tmp621, &tmp622, &tmp623, &tmp624, &tmp625, &tmp626, &tmp627);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 41);
    ca_.Goto(&block42, tmp599, tmp600, tmp601, tmp602, tmp603, tmp604, tmp605, tmp606, tmp607, tmp608, tmp609, tmp610, tmp611, tmp612, tmp613, tmp614, tmp615, tmp616, tmp617, tmp618, tmp619, tmp620, tmp621, tmp622);
  }

  if (block43.is_used()) {
    TNode<NativeContext> tmp628;
    TNode<JSArgumentsObjectWithLength> tmp629;
    TNode<Smi> tmp630;
    TNode<Smi> tmp631;
    TNode<FixedArray> tmp632;
    TNode<Smi> tmp633;
    TNode<Smi> tmp634;
    TNode<Smi> tmp635;
    TNode<FixedArray> tmp636;
    TNode<Smi> tmp637;
    TNode<Context> tmp638;
    TNode<Map> tmp639;
    TNode<JSArray> tmp640;
    TNode<Smi> tmp641;
    TNode<FixedArray> tmp642;
    TNode<Smi> tmp643;
    TNode<Smi> tmp644;
    TNode<Object> tmp645;
    TNode<FixedArray> tmp646;
    TNode<IntPtrT> tmp647;
    TNode<IntPtrT> tmp648;
    TNode<Smi> tmp649;
    TNode<Smi> tmp650;
    TNode<IntPtrT> tmp651;
    TNode<HeapObject> tmp652;
    TNode<IntPtrT> tmp653;
    TNode<IntPtrT> tmp654;
    TNode<IntPtrT> tmp655;
    TNode<IntPtrT> tmp656;
    TNode<HeapObject> tmp657;
    TNode<IntPtrT> tmp658;
    ca_.Bind(&block43, &tmp628, &tmp629, &tmp630, &tmp631, &tmp632, &tmp633, &tmp634, &tmp635, &tmp636, &tmp637, &tmp638, &tmp639, &tmp640, &tmp641, &tmp642, &tmp643, &tmp644, &tmp645, &tmp646, &tmp647, &tmp648, &tmp649, &tmp650, &tmp651, &tmp652, &tmp653, &tmp654, &tmp655, &tmp656, &tmp657, &tmp658);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/torque-internal.tq", 56);
    ca_.Goto(&block41, tmp628, tmp629, tmp630, tmp631, tmp632, tmp633, tmp634, tmp635, tmp636, tmp637, tmp638, tmp639, tmp640, tmp641, tmp642, tmp643, tmp644, tmp645, tmp646, tmp647, tmp648, tmp649, tmp650, tmp651, tmp657, tmp658);
  }

  if (block42.is_used()) {
    TNode<NativeContext> tmp659;
    TNode<JSArgumentsObjectWithLength> tmp660;
    TNode<Smi> tmp661;
    TNode<Smi> tmp662;
    TNode<FixedArray> tmp663;
    TNode<Smi> tmp664;
    TNode<Smi> tmp665;
    TNode<Smi> tmp666;
    TNode<FixedArray> tmp667;
    TNode<Smi> tmp668;
    TNode<Context> tmp669;
    TNode<Map> tmp670;
    TNode<JSArray> tmp671;
    TNode<Smi> tmp672;
    TNode<FixedArray> tmp673;
    TNode<Smi> tmp674;
    TNode<Smi> tmp675;
    TNode<Object> tmp676;
    TNode<FixedArray> tmp677;
    TNode<IntPtrT> tmp678;
    TNode<IntPtrT> tmp679;
    TNode<Smi> tmp680;
    TNode<Smi> tmp681;
    TNode<IntPtrT> tmp682;
    ca_.Bind(&block42, &tmp659, &tmp660, &tmp661, &tmp662, &tmp663, &tmp664, &tmp665, &tmp666, &tmp667, &tmp668, &tmp669, &tmp670, &tmp671, &tmp672, &tmp673, &tmp674, &tmp675, &tmp676, &tmp677, &tmp678, &tmp679, &tmp680, &tmp681, &tmp682);
    CodeStubAssembler(state_).Unreachable();
  }

  if (block41.is_used()) {
    TNode<NativeContext> tmp683;
    TNode<JSArgumentsObjectWithLength> tmp684;
    TNode<Smi> tmp685;
    TNode<Smi> tmp686;
    TNode<FixedArray> tmp687;
    TNode<Smi> tmp688;
    TNode<Smi> tmp689;
    TNode<Smi> tmp690;
    TNode<FixedArray> tmp691;
    TNode<Smi> tmp692;
    TNode<Context> tmp693;
    TNode<Map> tmp694;
    TNode<JSArray> tmp695;
    TNode<Smi> tmp696;
    TNode<FixedArray> tmp697;
    TNode<Smi> tmp698;
    TNode<Smi> tmp699;
    TNode<Object> tmp700;
    TNode<FixedArray> tmp701;
    TNode<IntPtrT> tmp702;
    TNode<IntPtrT> tmp703;
    TNode<Smi> tmp704;
    TNode<Smi> tmp705;
    TNode<IntPtrT> tmp706;
    TNode<HeapObject> tmp707;
    TNode<IntPtrT> tmp708;
    ca_.Bind(&block41, &tmp683, &tmp684, &tmp685, &tmp686, &tmp687, &tmp688, &tmp689, &tmp690, &tmp691, &tmp692, &tmp693, &tmp694, &tmp695, &tmp696, &tmp697, &tmp698, &tmp699, &tmp700, &tmp701, &tmp702, &tmp703, &tmp704, &tmp705, &tmp706, &tmp707, &tmp708);
    ca_.Goto(&block40, tmp683, tmp684, tmp685, tmp686, tmp687, tmp688, tmp689, tmp690, tmp691, tmp692, tmp693, tmp694, tmp695, tmp696, tmp697, tmp698, tmp699, tmp700, tmp701, tmp702, tmp703, tmp704, tmp705, tmp707, tmp708);
  }

  if (block40.is_used()) {
    TNode<NativeContext> tmp709;
    TNode<JSArgumentsObjectWithLength> tmp710;
    TNode<Smi> tmp711;
    TNode<Smi> tmp712;
    TNode<FixedArray> tmp713;
    TNode<Smi> tmp714;
    TNode<Smi> tmp715;
    TNode<Smi> tmp716;
    TNode<FixedArray> tmp717;
    TNode<Smi> tmp718;
    TNode<Context> tmp719;
    TNode<Map> tmp720;
    TNode<JSArray> tmp721;
    TNode<Smi> tmp722;
    TNode<FixedArray> tmp723;
    TNode<Smi> tmp724;
    TNode<Smi> tmp725;
    TNode<Object> tmp726;
    TNode<FixedArray> tmp727;
    TNode<IntPtrT> tmp728;
    TNode<IntPtrT> tmp729;
    TNode<Smi> tmp730;
    TNode<Smi> tmp731;
    TNode<HeapObject> tmp732;
    TNode<IntPtrT> tmp733;
    ca_.Bind(&block40, &tmp709, &tmp710, &tmp711, &tmp712, &tmp713, &tmp714, &tmp715, &tmp716, &tmp717, &tmp718, &tmp719, &tmp720, &tmp721, &tmp722, &tmp723, &tmp724, &tmp725, &tmp726, &tmp727, &tmp728, &tmp729, &tmp730, &tmp731, &tmp732, &tmp733);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 68);
    TNode<Object>tmp734 = CodeStubAssembler(state_).LoadReference<Object>(CodeStubAssembler::Reference{tmp732, tmp733});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 67);
    ca_.Goto(&block38, tmp709, tmp710, tmp711, tmp712, tmp713, tmp714, tmp715, tmp716, tmp717, tmp718, tmp719, tmp720, tmp721, tmp722, tmp723, tmp724, tmp725, tmp726, tmp734);
  }

  if (block39.is_used()) {
    TNode<NativeContext> tmp735;
    TNode<JSArgumentsObjectWithLength> tmp736;
    TNode<Smi> tmp737;
    TNode<Smi> tmp738;
    TNode<FixedArray> tmp739;
    TNode<Smi> tmp740;
    TNode<Smi> tmp741;
    TNode<Smi> tmp742;
    TNode<FixedArray> tmp743;
    TNode<Smi> tmp744;
    TNode<Context> tmp745;
    TNode<Map> tmp746;
    TNode<JSArray> tmp747;
    TNode<Smi> tmp748;
    TNode<FixedArray> tmp749;
    TNode<Smi> tmp750;
    TNode<Smi> tmp751;
    TNode<Object> tmp752;
    TNode<Object> tmp753;
    ca_.Bind(&block39, &tmp735, &tmp736, &tmp737, &tmp738, &tmp739, &tmp740, &tmp741, &tmp742, &tmp743, &tmp744, &tmp745, &tmp746, &tmp747, &tmp748, &tmp749, &tmp750, &tmp751, &tmp752, &tmp753);
    ca_.Goto(&block38, tmp735, tmp736, tmp737, tmp738, tmp739, tmp740, tmp741, tmp742, tmp743, tmp744, tmp745, tmp746, tmp747, tmp748, tmp749, tmp750, tmp751, tmp752, tmp753);
  }

  if (block38.is_used()) {
    TNode<NativeContext> tmp754;
    TNode<JSArgumentsObjectWithLength> tmp755;
    TNode<Smi> tmp756;
    TNode<Smi> tmp757;
    TNode<FixedArray> tmp758;
    TNode<Smi> tmp759;
    TNode<Smi> tmp760;
    TNode<Smi> tmp761;
    TNode<FixedArray> tmp762;
    TNode<Smi> tmp763;
    TNode<Context> tmp764;
    TNode<Map> tmp765;
    TNode<JSArray> tmp766;
    TNode<Smi> tmp767;
    TNode<FixedArray> tmp768;
    TNode<Smi> tmp769;
    TNode<Smi> tmp770;
    TNode<Object> tmp771;
    TNode<Object> tmp772;
    ca_.Bind(&block38, &tmp754, &tmp755, &tmp756, &tmp757, &tmp758, &tmp759, &tmp760, &tmp761, &tmp762, &tmp763, &tmp764, &tmp765, &tmp766, &tmp767, &tmp768, &tmp769, &tmp770, &tmp771, &tmp772);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 66);
    TNode<Object> tmp773;
    USE(tmp773);
    tmp773 = UnsafeCast90UT8ATBigInt7ATFalse6ATNull5ATSmi6ATTrue11ATUndefined10HeapNumber10JSReceiver6String6Symbol_1441(state_, TNode<Context>{tmp754}, TNode<Object>{tmp772});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 74);
    TNode<Smi> tmp774;
    USE(tmp774);
    tmp774 = FromConstexpr5ATSmi17ATconstexpr_int31_155(state_, 1);
    TNode<Smi> tmp775;
    USE(tmp775);
    tmp775 = CodeStubAssembler(state_).SmiAdd(TNode<Smi>{tmp767}, TNode<Smi>{tmp774});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 73);
    CodeStubAssembler(state_).StoreFixedArrayElement(TNode<FixedArray>{tmp768}, TNode<Smi>{tmp767}, TNode<Object>{tmp773}, UNSAFE_SKIP_WRITE_BARRIER);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 63);
    ca_.Goto(&block28, tmp754, tmp755, tmp756, tmp757, tmp758, tmp759, tmp760, tmp761, tmp762, tmp763, tmp764, tmp765, tmp766, tmp775, tmp768, tmp769, tmp770);
  }

  if (block28.is_used()) {
    TNode<NativeContext> tmp776;
    TNode<JSArgumentsObjectWithLength> tmp777;
    TNode<Smi> tmp778;
    TNode<Smi> tmp779;
    TNode<FixedArray> tmp780;
    TNode<Smi> tmp781;
    TNode<Smi> tmp782;
    TNode<Smi> tmp783;
    TNode<FixedArray> tmp784;
    TNode<Smi> tmp785;
    TNode<Context> tmp786;
    TNode<Map> tmp787;
    TNode<JSArray> tmp788;
    TNode<Smi> tmp789;
    TNode<FixedArray> tmp790;
    TNode<Smi> tmp791;
    TNode<Smi> tmp792;
    ca_.Bind(&block28, &tmp776, &tmp777, &tmp778, &tmp779, &tmp780, &tmp781, &tmp782, &tmp783, &tmp784, &tmp785, &tmp786, &tmp787, &tmp788, &tmp789, &tmp790, &tmp791, &tmp792);
    TNode<Smi> tmp793;
    USE(tmp793);
    tmp793 = FromConstexpr5ATSmi17ATconstexpr_int31_155(state_, 1);
    TNode<Smi> tmp794;
    USE(tmp794);
    tmp794 = CodeStubAssembler(state_).SmiAdd(TNode<Smi>{tmp792}, TNode<Smi>{tmp793});
    ca_.Goto(&block27, tmp776, tmp777, tmp778, tmp779, tmp780, tmp781, tmp782, tmp783, tmp784, tmp785, tmp786, tmp787, tmp788, tmp789, tmp790, tmp791, tmp794);
  }

  if (block26.is_used()) {
    TNode<NativeContext> tmp795;
    TNode<JSArgumentsObjectWithLength> tmp796;
    TNode<Smi> tmp797;
    TNode<Smi> tmp798;
    TNode<FixedArray> tmp799;
    TNode<Smi> tmp800;
    TNode<Smi> tmp801;
    TNode<Smi> tmp802;
    TNode<FixedArray> tmp803;
    TNode<Smi> tmp804;
    TNode<Context> tmp805;
    TNode<Map> tmp806;
    TNode<JSArray> tmp807;
    TNode<Smi> tmp808;
    TNode<FixedArray> tmp809;
    TNode<Smi> tmp810;
    TNode<Smi> tmp811;
    ca_.Bind(&block26, &tmp795, &tmp796, &tmp797, &tmp798, &tmp799, &tmp800, &tmp801, &tmp802, &tmp803, &tmp804, &tmp805, &tmp806, &tmp807, &tmp808, &tmp809, &tmp810, &tmp811);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 79);
    TNode<Smi> tmp812;
    USE(tmp812);
    tmp812 = CodeStubAssembler(state_).SmiMax(TNode<Smi>{tmp801}, TNode<Smi>{tmp797});
    TNode<Smi> tmp813;
    USE(tmp813);
    tmp813 = CodeStubAssembler(state_).SmiMin(TNode<Smi>{tmp812}, TNode<Smi>{tmp802});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 80);
    TNode<Smi> tmp814;
    USE(tmp814);
    tmp814 = CodeStubAssembler(state_).SmiSub(TNode<Smi>{tmp802}, TNode<Smi>{tmp813});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 82);
    TNode<IntPtrT> tmp815;
    USE(tmp815);
    tmp815 = Convert8ATintptr5ATSmi_189(state_, TNode<Smi>{tmp808});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 83);
    TNode<IntPtrT> tmp816;
    USE(tmp816);
    tmp816 = Convert8ATintptr5ATSmi_189(state_, TNode<Smi>{tmp813});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 84);
    TNode<IntPtrT> tmp817;
    USE(tmp817);
    tmp817 = Convert8ATintptr5ATSmi_189(state_, TNode<Smi>{tmp814});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 81);
    CodeStubAssembler(state_).CopyElements(PACKED_ELEMENTS, TNode<FixedArrayBase>{tmp809}, TNode<IntPtrT>{tmp815}, TNode<FixedArrayBase>{tmp803}, TNode<IntPtrT>{tmp816}, TNode<IntPtrT>{tmp817});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 85);
    ca_.Goto(&block2, tmp795, tmp796, tmp797, tmp798, tmp807);
  }

  if (block2.is_used()) {
    TNode<NativeContext> tmp818;
    TNode<JSArgumentsObjectWithLength> tmp819;
    TNode<Smi> tmp820;
    TNode<Smi> tmp821;
    TNode<JSArray> tmp822;
    ca_.Bind(&block2, &tmp818, &tmp819, &tmp820, &tmp821, &tmp822);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 29);
    ca_.Goto(&block47, tmp818, tmp819, tmp820, tmp821, tmp822);
  }

  if (block1.is_used()) {
    ca_.Bind(&block1);
    ca_.Goto(label_Bailout);
  }

    TNode<NativeContext> tmp823;
    TNode<JSArgumentsObjectWithLength> tmp824;
    TNode<Smi> tmp825;
    TNode<Smi> tmp826;
    TNode<JSArray> tmp827;
    ca_.Bind(&block47, &tmp823, &tmp824, &tmp825, &tmp826, &tmp827);
  return TNode<JSArray>{tmp827};
}

TNode<JSArray> HandleFastSlice_40(compiler::CodeAssemblerState* state_, TNode<NativeContext> p_context, TNode<Object> p_o, TNode<Number> p_startNumber, TNode<Number> p_countNumber, compiler::CodeAssemblerLabel* label_Bailout) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Number> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Number, Smi> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Number> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Number, Smi> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi> block10(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object, Object> block14(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object, Object, JSArray> block13(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object, JSArray> block15(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object, JSArray> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object> block12(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object, Object> block20(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object, Object, JSArgumentsObjectWithLength> block19(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object, JSArgumentsObjectWithLength, Map> block21(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object, JSArgumentsObjectWithLength, Map, NativeContext, JSArgumentsObjectWithLength, Smi, Smi> block25(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object, JSArgumentsObjectWithLength, Map, NativeContext, JSArgumentsObjectWithLength, Smi, Smi, JSArray> block24(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object, JSArgumentsObjectWithLength, Map> block22(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object, JSArgumentsObjectWithLength, Map, BoolT> block28(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object, JSArgumentsObjectWithLength, Map, BoolT> block29(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object, JSArgumentsObjectWithLength, Map, BoolT, BoolT> block30(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object, JSArgumentsObjectWithLength, Map> block26(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object, JSArgumentsObjectWithLength, Map, NativeContext, JSArgumentsObjectWithLength, Smi, Smi> block32(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object, JSArgumentsObjectWithLength, Map, NativeContext, JSArgumentsObjectWithLength, Smi, Smi, JSArray> block31(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object, JSArgumentsObjectWithLength, Map> block27(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object, JSArgumentsObjectWithLength, Map> block23(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object> block18(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object> block17(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, Smi, Smi, Object> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, JSArray> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Number, Number, JSArray> block33(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_o, p_startNumber, p_countNumber);

  if (block0.is_used()) {
    TNode<NativeContext> tmp0;
    TNode<Object> tmp1;
    TNode<Number> tmp2;
    TNode<Number> tmp3;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 92);
    TNode<Smi> tmp4;
    USE(tmp4);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp4 = Cast5ATSmi_83(state_, TNode<Object>{tmp2}, &label0);
    ca_.Goto(&block3, tmp0, tmp1, tmp2, tmp3, tmp2, tmp4);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block4, tmp0, tmp1, tmp2, tmp3, tmp2);
    }
  }

  if (block4.is_used()) {
    TNode<NativeContext> tmp5;
    TNode<Object> tmp6;
    TNode<Number> tmp7;
    TNode<Number> tmp8;
    TNode<Number> tmp9;
    ca_.Bind(&block4, &tmp5, &tmp6, &tmp7, &tmp8, &tmp9);
    ca_.Goto(&block1);
  }

  if (block3.is_used()) {
    TNode<NativeContext> tmp10;
    TNode<Object> tmp11;
    TNode<Number> tmp12;
    TNode<Number> tmp13;
    TNode<Number> tmp14;
    TNode<Smi> tmp15;
    ca_.Bind(&block3, &tmp10, &tmp11, &tmp12, &tmp13, &tmp14, &tmp15);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 93);
    TNode<Smi> tmp16;
    USE(tmp16);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp16 = Cast5ATSmi_83(state_, TNode<Object>{tmp13}, &label0);
    ca_.Goto(&block5, tmp10, tmp11, tmp12, tmp13, tmp15, tmp13, tmp16);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block6, tmp10, tmp11, tmp12, tmp13, tmp15, tmp13);
    }
  }

  if (block6.is_used()) {
    TNode<NativeContext> tmp17;
    TNode<Object> tmp18;
    TNode<Number> tmp19;
    TNode<Number> tmp20;
    TNode<Smi> tmp21;
    TNode<Number> tmp22;
    ca_.Bind(&block6, &tmp17, &tmp18, &tmp19, &tmp20, &tmp21, &tmp22);
    ca_.Goto(&block1);
  }

  if (block5.is_used()) {
    TNode<NativeContext> tmp23;
    TNode<Object> tmp24;
    TNode<Number> tmp25;
    TNode<Number> tmp26;
    TNode<Smi> tmp27;
    TNode<Number> tmp28;
    TNode<Smi> tmp29;
    ca_.Bind(&block5, &tmp23, &tmp24, &tmp25, &tmp26, &tmp27, &tmp28, &tmp29);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 94);
    ca_.Goto(&block8, tmp23, tmp24, tmp25, tmp26, tmp27, tmp29);
  }

  if (block7.is_used()) {
    TNode<NativeContext> tmp30;
    TNode<Object> tmp31;
    TNode<Number> tmp32;
    TNode<Number> tmp33;
    TNode<Smi> tmp34;
    TNode<Smi> tmp35;
    ca_.Bind(&block7, &tmp30, &tmp31, &tmp32, &tmp33, &tmp34, &tmp35);
    TNode<Smi> tmp36;
    USE(tmp36);
    tmp36 = FromConstexpr5ATSmi17ATconstexpr_int31_155(state_, 0);
    TNode<BoolT> tmp37;
    USE(tmp37);
    tmp37 = CodeStubAssembler(state_).SmiGreaterThanOrEqual(TNode<Smi>{tmp34}, TNode<Smi>{tmp36});
    ca_.Branch(tmp37, &block9, &block10, tmp30, tmp31, tmp32, tmp33, tmp34, tmp35);
  }

  if (block10.is_used()) {
    TNode<NativeContext> tmp38;
    TNode<Object> tmp39;
    TNode<Number> tmp40;
    TNode<Number> tmp41;
    TNode<Smi> tmp42;
    TNode<Smi> tmp43;
    ca_.Bind(&block10, &tmp38, &tmp39, &tmp40, &tmp41, &tmp42, &tmp43);
    CodeStubAssembler(state_).FailAssert("Torque assert 'start >= 0' failed", "../../deps/v8/src/builtins/array-slice.tq", 94);
  }

  if (block9.is_used()) {
    TNode<NativeContext> tmp44;
    TNode<Object> tmp45;
    TNode<Number> tmp46;
    TNode<Number> tmp47;
    TNode<Smi> tmp48;
    TNode<Smi> tmp49;
    ca_.Bind(&block9, &tmp44, &tmp45, &tmp46, &tmp47, &tmp48, &tmp49);
  }

  if (block8.is_used()) {
    TNode<NativeContext> tmp50;
    TNode<Object> tmp51;
    TNode<Number> tmp52;
    TNode<Number> tmp53;
    TNode<Smi> tmp54;
    TNode<Smi> tmp55;
    ca_.Bind(&block8, &tmp50, &tmp51, &tmp52, &tmp53, &tmp54, &tmp55);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 96);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 97);
    TNode<JSArray> tmp56;
    USE(tmp56);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp56 = Cast20ATFastJSArrayForCopy_1464(state_, TNode<Context>{tmp50}, TNode<Object>{tmp51}, &label0);
    ca_.Goto(&block13, tmp50, tmp51, tmp52, tmp53, tmp54, tmp55, tmp51, tmp51, tmp56);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block14, tmp50, tmp51, tmp52, tmp53, tmp54, tmp55, tmp51, tmp51);
    }
  }

  if (block14.is_used()) {
    TNode<NativeContext> tmp57;
    TNode<Object> tmp58;
    TNode<Number> tmp59;
    TNode<Number> tmp60;
    TNode<Smi> tmp61;
    TNode<Smi> tmp62;
    TNode<Object> tmp63;
    TNode<Object> tmp64;
    ca_.Bind(&block14, &tmp57, &tmp58, &tmp59, &tmp60, &tmp61, &tmp62, &tmp63, &tmp64);
    ca_.Goto(&block12, tmp57, tmp58, tmp59, tmp60, tmp61, tmp62, tmp63);
  }

  if (block13.is_used()) {
    TNode<NativeContext> tmp65;
    TNode<Object> tmp66;
    TNode<Number> tmp67;
    TNode<Number> tmp68;
    TNode<Smi> tmp69;
    TNode<Smi> tmp70;
    TNode<Object> tmp71;
    TNode<Object> tmp72;
    TNode<JSArray> tmp73;
    ca_.Bind(&block13, &tmp65, &tmp66, &tmp67, &tmp68, &tmp69, &tmp70, &tmp71, &tmp72, &tmp73);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 104);
    TNode<Smi> tmp74;
    USE(tmp74);
    tmp74 = CodeStubAssembler(state_).SmiAdd(TNode<Smi>{tmp69}, TNode<Smi>{tmp70});
    TNode<Smi> tmp75;
    USE(tmp75);
    tmp75 = CodeStubAssembler(state_).LoadFastJSArrayLength(TNode<JSArray>{tmp73});
    TNode<BoolT> tmp76;
    USE(tmp76);
    tmp76 = CodeStubAssembler(state_).SmiAbove(TNode<Smi>{tmp74}, TNode<Smi>{tmp75});
    ca_.Branch(tmp76, &block15, &block16, tmp65, tmp66, tmp67, tmp68, tmp69, tmp70, tmp71, tmp73);
  }

  if (block15.is_used()) {
    TNode<NativeContext> tmp77;
    TNode<Object> tmp78;
    TNode<Number> tmp79;
    TNode<Number> tmp80;
    TNode<Smi> tmp81;
    TNode<Smi> tmp82;
    TNode<Object> tmp83;
    TNode<JSArray> tmp84;
    ca_.Bind(&block15, &tmp77, &tmp78, &tmp79, &tmp80, &tmp81, &tmp82, &tmp83, &tmp84);
    ca_.Goto(&block1);
  }

  if (block16.is_used()) {
    TNode<NativeContext> tmp85;
    TNode<Object> tmp86;
    TNode<Number> tmp87;
    TNode<Number> tmp88;
    TNode<Smi> tmp89;
    TNode<Smi> tmp90;
    TNode<Object> tmp91;
    TNode<JSArray> tmp92;
    ca_.Bind(&block16, &tmp85, &tmp86, &tmp87, &tmp88, &tmp89, &tmp90, &tmp91, &tmp92);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 105);
    TNode<JSArray> tmp93;
    tmp93 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kExtractFastJSArray, tmp85, tmp92, tmp89, tmp90));
    USE(tmp93);
    ca_.Goto(&block2, tmp85, tmp86, tmp87, tmp88, tmp93);
  }

  if (block12.is_used()) {
    TNode<NativeContext> tmp94;
    TNode<Object> tmp95;
    TNode<Number> tmp96;
    TNode<Number> tmp97;
    TNode<Smi> tmp98;
    TNode<Smi> tmp99;
    TNode<Object> tmp100;
    ca_.Bind(&block12, &tmp94, &tmp95, &tmp96, &tmp97, &tmp98, &tmp99, &tmp100);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 107);
    TNode<JSArgumentsObjectWithLength> tmp101;
    USE(tmp101);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp101 = Cast27JSArgumentsObjectWithLength_1465(state_, TNode<Context>{tmp94}, TNode<Object>{ca_.UncheckedCast<Object>(tmp100)}, &label0);
    ca_.Goto(&block19, tmp94, tmp95, tmp96, tmp97, tmp98, tmp99, tmp100, ca_.UncheckedCast<Object>(tmp100), tmp101);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block20, tmp94, tmp95, tmp96, tmp97, tmp98, tmp99, tmp100, ca_.UncheckedCast<Object>(tmp100));
    }
  }

  if (block20.is_used()) {
    TNode<NativeContext> tmp102;
    TNode<Object> tmp103;
    TNode<Number> tmp104;
    TNode<Number> tmp105;
    TNode<Smi> tmp106;
    TNode<Smi> tmp107;
    TNode<Object> tmp108;
    TNode<Object> tmp109;
    ca_.Bind(&block20, &tmp102, &tmp103, &tmp104, &tmp105, &tmp106, &tmp107, &tmp108, &tmp109);
    ca_.Goto(&block18, tmp102, tmp103, tmp104, tmp105, tmp106, tmp107, tmp108);
  }

  if (block19.is_used()) {
    TNode<NativeContext> tmp110;
    TNode<Object> tmp111;
    TNode<Number> tmp112;
    TNode<Number> tmp113;
    TNode<Smi> tmp114;
    TNode<Smi> tmp115;
    TNode<Object> tmp116;
    TNode<Object> tmp117;
    TNode<JSArgumentsObjectWithLength> tmp118;
    ca_.Bind(&block19, &tmp110, &tmp111, &tmp112, &tmp113, &tmp114, &tmp115, &tmp116, &tmp117, &tmp118);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 108);
    TNode<IntPtrT> tmp119 = ca_.IntPtrConstant(HeapObject::kMapOffset);
    USE(tmp119);
    TNode<Map>tmp120 = CodeStubAssembler(state_).LoadReference<Map>(CodeStubAssembler::Reference{tmp118, tmp119});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 109);
    TNode<BoolT> tmp121;
    USE(tmp121);
    tmp121 = CodeStubAssembler(state_).IsFastAliasedArgumentsMap(TNode<Context>{tmp110}, TNode<Map>{tmp120});
    ca_.Branch(tmp121, &block21, &block22, tmp110, tmp111, tmp112, tmp113, tmp114, tmp115, tmp116, tmp118, tmp120);
  }

  if (block21.is_used()) {
    TNode<NativeContext> tmp122;
    TNode<Object> tmp123;
    TNode<Number> tmp124;
    TNode<Number> tmp125;
    TNode<Smi> tmp126;
    TNode<Smi> tmp127;
    TNode<Object> tmp128;
    TNode<JSArgumentsObjectWithLength> tmp129;
    TNode<Map> tmp130;
    ca_.Bind(&block21, &tmp122, &tmp123, &tmp124, &tmp125, &tmp126, &tmp127, &tmp128, &tmp129, &tmp130);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 110);
    TNode<JSArray> tmp131;
    USE(tmp131);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp131 = HandleFastAliasedSloppyArgumentsSlice_39(state_, TNode<NativeContext>{tmp122}, TNode<JSArgumentsObjectWithLength>{tmp129}, TNode<Smi>{tmp126}, TNode<Smi>{tmp127}, &label0);
    ca_.Goto(&block24, tmp122, tmp123, tmp124, tmp125, tmp126, tmp127, tmp128, tmp129, tmp130, tmp122, tmp129, tmp126, tmp127, tmp131);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block25, tmp122, tmp123, tmp124, tmp125, tmp126, tmp127, tmp128, tmp129, tmp130, tmp122, tmp129, tmp126, tmp127);
    }
  }

  if (block25.is_used()) {
    TNode<NativeContext> tmp132;
    TNode<Object> tmp133;
    TNode<Number> tmp134;
    TNode<Number> tmp135;
    TNode<Smi> tmp136;
    TNode<Smi> tmp137;
    TNode<Object> tmp138;
    TNode<JSArgumentsObjectWithLength> tmp139;
    TNode<Map> tmp140;
    TNode<NativeContext> tmp141;
    TNode<JSArgumentsObjectWithLength> tmp142;
    TNode<Smi> tmp143;
    TNode<Smi> tmp144;
    ca_.Bind(&block25, &tmp132, &tmp133, &tmp134, &tmp135, &tmp136, &tmp137, &tmp138, &tmp139, &tmp140, &tmp141, &tmp142, &tmp143, &tmp144);
    ca_.Goto(&block1);
  }

  if (block24.is_used()) {
    TNode<NativeContext> tmp145;
    TNode<Object> tmp146;
    TNode<Number> tmp147;
    TNode<Number> tmp148;
    TNode<Smi> tmp149;
    TNode<Smi> tmp150;
    TNode<Object> tmp151;
    TNode<JSArgumentsObjectWithLength> tmp152;
    TNode<Map> tmp153;
    TNode<NativeContext> tmp154;
    TNode<JSArgumentsObjectWithLength> tmp155;
    TNode<Smi> tmp156;
    TNode<Smi> tmp157;
    TNode<JSArray> tmp158;
    ca_.Bind(&block24, &tmp145, &tmp146, &tmp147, &tmp148, &tmp149, &tmp150, &tmp151, &tmp152, &tmp153, &tmp154, &tmp155, &tmp156, &tmp157, &tmp158);
    ca_.Goto(&block2, tmp145, tmp146, tmp147, tmp148, tmp158);
  }

  if (block22.is_used()) {
    TNode<NativeContext> tmp159;
    TNode<Object> tmp160;
    TNode<Number> tmp161;
    TNode<Number> tmp162;
    TNode<Smi> tmp163;
    TNode<Smi> tmp164;
    TNode<Object> tmp165;
    TNode<JSArgumentsObjectWithLength> tmp166;
    TNode<Map> tmp167;
    ca_.Bind(&block22, &tmp159, &tmp160, &tmp161, &tmp162, &tmp163, &tmp164, &tmp165, &tmp166, &tmp167);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 112);
    TNode<BoolT> tmp168;
    USE(tmp168);
    tmp168 = CodeStubAssembler(state_).IsStrictArgumentsMap(TNode<Context>{tmp159}, TNode<Map>{tmp167});
    ca_.Branch(tmp168, &block28, &block29, tmp159, tmp160, tmp161, tmp162, tmp163, tmp164, tmp165, tmp166, tmp167, tmp168);
  }

  if (block28.is_used()) {
    TNode<NativeContext> tmp169;
    TNode<Object> tmp170;
    TNode<Number> tmp171;
    TNode<Number> tmp172;
    TNode<Smi> tmp173;
    TNode<Smi> tmp174;
    TNode<Object> tmp175;
    TNode<JSArgumentsObjectWithLength> tmp176;
    TNode<Map> tmp177;
    TNode<BoolT> tmp178;
    ca_.Bind(&block28, &tmp169, &tmp170, &tmp171, &tmp172, &tmp173, &tmp174, &tmp175, &tmp176, &tmp177, &tmp178);
    TNode<BoolT> tmp179;
    USE(tmp179);
    tmp179 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, true);
    ca_.Goto(&block30, tmp169, tmp170, tmp171, tmp172, tmp173, tmp174, tmp175, tmp176, tmp177, tmp178, tmp179);
  }

  if (block29.is_used()) {
    TNode<NativeContext> tmp180;
    TNode<Object> tmp181;
    TNode<Number> tmp182;
    TNode<Number> tmp183;
    TNode<Smi> tmp184;
    TNode<Smi> tmp185;
    TNode<Object> tmp186;
    TNode<JSArgumentsObjectWithLength> tmp187;
    TNode<Map> tmp188;
    TNode<BoolT> tmp189;
    ca_.Bind(&block29, &tmp180, &tmp181, &tmp182, &tmp183, &tmp184, &tmp185, &tmp186, &tmp187, &tmp188, &tmp189);
    TNode<BoolT> tmp190;
    USE(tmp190);
    tmp190 = CodeStubAssembler(state_).IsSloppyArgumentsMap(TNode<Context>{tmp180}, TNode<Map>{tmp188});
    ca_.Goto(&block30, tmp180, tmp181, tmp182, tmp183, tmp184, tmp185, tmp186, tmp187, tmp188, tmp189, tmp190);
  }

  if (block30.is_used()) {
    TNode<NativeContext> tmp191;
    TNode<Object> tmp192;
    TNode<Number> tmp193;
    TNode<Number> tmp194;
    TNode<Smi> tmp195;
    TNode<Smi> tmp196;
    TNode<Object> tmp197;
    TNode<JSArgumentsObjectWithLength> tmp198;
    TNode<Map> tmp199;
    TNode<BoolT> tmp200;
    TNode<BoolT> tmp201;
    ca_.Bind(&block30, &tmp191, &tmp192, &tmp193, &tmp194, &tmp195, &tmp196, &tmp197, &tmp198, &tmp199, &tmp200, &tmp201);
    ca_.Branch(tmp201, &block26, &block27, tmp191, tmp192, tmp193, tmp194, tmp195, tmp196, tmp197, tmp198, tmp199);
  }

  if (block26.is_used()) {
    TNode<NativeContext> tmp202;
    TNode<Object> tmp203;
    TNode<Number> tmp204;
    TNode<Number> tmp205;
    TNode<Smi> tmp206;
    TNode<Smi> tmp207;
    TNode<Object> tmp208;
    TNode<JSArgumentsObjectWithLength> tmp209;
    TNode<Map> tmp210;
    ca_.Bind(&block26, &tmp202, &tmp203, &tmp204, &tmp205, &tmp206, &tmp207, &tmp208, &tmp209, &tmp210);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 113);
    TNode<JSArray> tmp211;
    USE(tmp211);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp211 = HandleSimpleArgumentsSlice_38(state_, TNode<NativeContext>{tmp202}, TNode<JSArgumentsObjectWithLength>{tmp209}, TNode<Smi>{tmp206}, TNode<Smi>{tmp207}, &label0);
    ca_.Goto(&block31, tmp202, tmp203, tmp204, tmp205, tmp206, tmp207, tmp208, tmp209, tmp210, tmp202, tmp209, tmp206, tmp207, tmp211);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block32, tmp202, tmp203, tmp204, tmp205, tmp206, tmp207, tmp208, tmp209, tmp210, tmp202, tmp209, tmp206, tmp207);
    }
  }

  if (block32.is_used()) {
    TNode<NativeContext> tmp212;
    TNode<Object> tmp213;
    TNode<Number> tmp214;
    TNode<Number> tmp215;
    TNode<Smi> tmp216;
    TNode<Smi> tmp217;
    TNode<Object> tmp218;
    TNode<JSArgumentsObjectWithLength> tmp219;
    TNode<Map> tmp220;
    TNode<NativeContext> tmp221;
    TNode<JSArgumentsObjectWithLength> tmp222;
    TNode<Smi> tmp223;
    TNode<Smi> tmp224;
    ca_.Bind(&block32, &tmp212, &tmp213, &tmp214, &tmp215, &tmp216, &tmp217, &tmp218, &tmp219, &tmp220, &tmp221, &tmp222, &tmp223, &tmp224);
    ca_.Goto(&block1);
  }

  if (block31.is_used()) {
    TNode<NativeContext> tmp225;
    TNode<Object> tmp226;
    TNode<Number> tmp227;
    TNode<Number> tmp228;
    TNode<Smi> tmp229;
    TNode<Smi> tmp230;
    TNode<Object> tmp231;
    TNode<JSArgumentsObjectWithLength> tmp232;
    TNode<Map> tmp233;
    TNode<NativeContext> tmp234;
    TNode<JSArgumentsObjectWithLength> tmp235;
    TNode<Smi> tmp236;
    TNode<Smi> tmp237;
    TNode<JSArray> tmp238;
    ca_.Bind(&block31, &tmp225, &tmp226, &tmp227, &tmp228, &tmp229, &tmp230, &tmp231, &tmp232, &tmp233, &tmp234, &tmp235, &tmp236, &tmp237, &tmp238);
    ca_.Goto(&block2, tmp225, tmp226, tmp227, tmp228, tmp238);
  }

  if (block27.is_used()) {
    TNode<NativeContext> tmp239;
    TNode<Object> tmp240;
    TNode<Number> tmp241;
    TNode<Number> tmp242;
    TNode<Smi> tmp243;
    TNode<Smi> tmp244;
    TNode<Object> tmp245;
    TNode<JSArgumentsObjectWithLength> tmp246;
    TNode<Map> tmp247;
    ca_.Bind(&block27, &tmp239, &tmp240, &tmp241, &tmp242, &tmp243, &tmp244, &tmp245, &tmp246, &tmp247);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 109);
    ca_.Goto(&block23, tmp239, tmp240, tmp241, tmp242, tmp243, tmp244, tmp245, tmp246, tmp247);
  }

  if (block23.is_used()) {
    TNode<NativeContext> tmp248;
    TNode<Object> tmp249;
    TNode<Number> tmp250;
    TNode<Number> tmp251;
    TNode<Smi> tmp252;
    TNode<Smi> tmp253;
    TNode<Object> tmp254;
    TNode<JSArgumentsObjectWithLength> tmp255;
    TNode<Map> tmp256;
    ca_.Bind(&block23, &tmp248, &tmp249, &tmp250, &tmp251, &tmp252, &tmp253, &tmp254, &tmp255, &tmp256);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 107);
    ca_.Goto(&block17, tmp248, tmp249, tmp250, tmp251, tmp252, tmp253, tmp254);
  }

  if (block18.is_used()) {
    TNode<NativeContext> tmp257;
    TNode<Object> tmp258;
    TNode<Number> tmp259;
    TNode<Number> tmp260;
    TNode<Smi> tmp261;
    TNode<Smi> tmp262;
    TNode<Object> tmp263;
    ca_.Bind(&block18, &tmp257, &tmp258, &tmp259, &tmp260, &tmp261, &tmp262, &tmp263);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 117);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 107);
    ca_.Goto(&block17, tmp257, tmp258, tmp259, tmp260, tmp261, tmp262, tmp263);
  }

  if (block17.is_used()) {
    TNode<NativeContext> tmp264;
    TNode<Object> tmp265;
    TNode<Number> tmp266;
    TNode<Number> tmp267;
    TNode<Smi> tmp268;
    TNode<Smi> tmp269;
    TNode<Object> tmp270;
    ca_.Bind(&block17, &tmp264, &tmp265, &tmp266, &tmp267, &tmp268, &tmp269, &tmp270);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 97);
    ca_.Goto(&block11, tmp264, tmp265, tmp266, tmp267, tmp268, tmp269, tmp270);
  }

  if (block11.is_used()) {
    TNode<NativeContext> tmp271;
    TNode<Object> tmp272;
    TNode<Number> tmp273;
    TNode<Number> tmp274;
    TNode<Smi> tmp275;
    TNode<Smi> tmp276;
    TNode<Object> tmp277;
    ca_.Bind(&block11, &tmp271, &tmp272, &tmp273, &tmp274, &tmp275, &tmp276, &tmp277);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 96);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 120);
    ca_.Goto(&block1);
  }

  if (block2.is_used()) {
    TNode<NativeContext> tmp278;
    TNode<Object> tmp279;
    TNode<Number> tmp280;
    TNode<Number> tmp281;
    TNode<JSArray> tmp282;
    ca_.Bind(&block2, &tmp278, &tmp279, &tmp280, &tmp281, &tmp282);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 88);
    ca_.Goto(&block33, tmp278, tmp279, tmp280, tmp281, tmp282);
  }

  if (block1.is_used()) {
    ca_.Bind(&block1);
    ca_.Goto(label_Bailout);
  }

    TNode<NativeContext> tmp283;
    TNode<Object> tmp284;
    TNode<Number> tmp285;
    TNode<Number> tmp286;
    TNode<JSArray> tmp287;
    ca_.Bind(&block33, &tmp283, &tmp284, &tmp285, &tmp286, &tmp287);
  return TNode<JSArray>{tmp287};
}

TF_BUILTIN(ArrayPrototypeSlice, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  Node* argc = Parameter(Descriptor::kJSActualArgumentsCount);
  TNode<IntPtrT> arguments_length(ChangeInt32ToIntPtr(argc));
  TNode<RawPtrT> arguments_frame = UncheckedCast<RawPtrT>(LoadFramePointer());
  TorqueStructArguments torque_arguments(GetFrameArguments(arguments_frame, arguments_length));
  CodeStubArguments arguments(this, torque_arguments);
  TNode<Context> parameter0 = UncheckedCast<Context>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<Object> parameter1 = arguments.GetReceiver();
USE(parameter1);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, Object, Object> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, Object, Object, JSArray> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, Object> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, Object> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object> block12(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number> block14(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number> block13(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number> block15(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number> block18(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number> block17(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block19(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block22(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block21(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block20(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block23(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block26(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block25(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block24(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block27(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block30(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block29(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block28(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block31(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block34(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block33(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block32(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block35(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block38(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block37(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block36(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block39(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block42(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block41(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block40(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number, NativeContext, JSReceiver, Number, Number> block46(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number, NativeContext, JSReceiver, Number, Number, JSArray> block45(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block44(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number> block43(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number, JSReceiver, Number> block49(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number, JSReceiver, Number> block47(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number, JSReceiver, Number, Number, Oddball> block50(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number, JSReceiver, Number, Number, Oddball> block51(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, Context, Object, JSReceiver, Number, Object, Number, Number, Object, Number, Number, Number, JSReceiver, Number> block48(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, torque_arguments.frame, torque_arguments.base, torque_arguments.length, parameter0, parameter1);

  if (block0.is_used()) {
    TNode<RawPtrT> tmp0;
    TNode<RawPtrT> tmp1;
    TNode<IntPtrT> tmp2;
    TNode<Context> tmp3;
    TNode<Object> tmp4;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 128);
    TNode<IntPtrT> tmp5;
    USE(tmp5);
    tmp5 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, 0);
    TNode<BoolT> tmp6;
    USE(tmp6);
    tmp6 = CodeStubAssembler(state_).WordEqual(TNode<IntPtrT>{tmp2}, TNode<IntPtrT>{tmp5});
    ca_.Branch(tmp6, &block1, &block2, tmp0, tmp1, tmp2, tmp3, tmp4);
  }

  if (block1.is_used()) {
    TNode<RawPtrT> tmp7;
    TNode<RawPtrT> tmp8;
    TNode<IntPtrT> tmp9;
    TNode<Context> tmp10;
    TNode<Object> tmp11;
    ca_.Bind(&block1, &tmp7, &tmp8, &tmp9, &tmp10, &tmp11);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 129);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 130);
    TNode<JSArray> tmp12;
    USE(tmp12);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp12 = Cast20ATFastJSArrayForCopy_1464(state_, TNode<Context>{tmp10}, TNode<Object>{tmp11}, &label0);
    ca_.Goto(&block5, tmp7, tmp8, tmp9, tmp10, tmp11, tmp11, tmp11, tmp12);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block6, tmp7, tmp8, tmp9, tmp10, tmp11, tmp11, tmp11);
    }
  }

  if (block6.is_used()) {
    TNode<RawPtrT> tmp13;
    TNode<RawPtrT> tmp14;
    TNode<IntPtrT> tmp15;
    TNode<Context> tmp16;
    TNode<Object> tmp17;
    TNode<Object> tmp18;
    TNode<Object> tmp19;
    ca_.Bind(&block6, &tmp13, &tmp14, &tmp15, &tmp16, &tmp17, &tmp18, &tmp19);
    ca_.Goto(&block4, tmp13, tmp14, tmp15, tmp16, tmp17, tmp18);
  }

  if (block5.is_used()) {
    TNode<RawPtrT> tmp20;
    TNode<RawPtrT> tmp21;
    TNode<IntPtrT> tmp22;
    TNode<Context> tmp23;
    TNode<Object> tmp24;
    TNode<Object> tmp25;
    TNode<Object> tmp26;
    TNode<JSArray> tmp27;
    ca_.Bind(&block5, &tmp20, &tmp21, &tmp22, &tmp23, &tmp24, &tmp25, &tmp26, &tmp27);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 131);
    TNode<JSArray> tmp28;
    tmp28 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kCloneFastJSArray, tmp23, tmp27));
    USE(tmp28);
    arguments.PopAndReturn(tmp28);
  }

  if (block4.is_used()) {
    TNode<RawPtrT> tmp29;
    TNode<RawPtrT> tmp30;
    TNode<IntPtrT> tmp31;
    TNode<Context> tmp32;
    TNode<Object> tmp33;
    TNode<Object> tmp34;
    ca_.Bind(&block4, &tmp29, &tmp30, &tmp31, &tmp32, &tmp33, &tmp34);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 133);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 130);
    ca_.Goto(&block3, tmp29, tmp30, tmp31, tmp32, tmp33, tmp34);
  }

  if (block3.is_used()) {
    TNode<RawPtrT> tmp35;
    TNode<RawPtrT> tmp36;
    TNode<IntPtrT> tmp37;
    TNode<Context> tmp38;
    TNode<Object> tmp39;
    TNode<Object> tmp40;
    ca_.Bind(&block3, &tmp35, &tmp36, &tmp37, &tmp38, &tmp39, &tmp40);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 129);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 128);
    ca_.Goto(&block2, tmp35, tmp36, tmp37, tmp38, tmp39);
  }

  if (block2.is_used()) {
    TNode<RawPtrT> tmp41;
    TNode<RawPtrT> tmp42;
    TNode<IntPtrT> tmp43;
    TNode<Context> tmp44;
    TNode<Object> tmp45;
    ca_.Bind(&block2, &tmp41, &tmp42, &tmp43, &tmp44, &tmp45);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 139);
    TNode<JSReceiver> tmp46;
    USE(tmp46);
    tmp46 = CodeStubAssembler(state_).ToObject_Inline(TNode<Context>{tmp44}, TNode<Object>{tmp45});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 142);
    TNode<Number> tmp47;
    USE(tmp47);
    tmp47 = GetLengthProperty_247(state_, TNode<Context>{tmp44}, TNode<Object>{tmp46});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 145);
    TNode<IntPtrT> tmp48;
    USE(tmp48);
    tmp48 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, 0);
    TNode<Object> tmp49;
    USE(tmp49);
    tmp49 = CodeStubAssembler(state_).GetArgumentValue(TorqueStructArguments{TNode<RawPtrT>{tmp41}, TNode<RawPtrT>{tmp42}, TNode<IntPtrT>{tmp43}}, TNode<IntPtrT>{tmp48});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 146);
    TNode<Number> tmp50;
    USE(tmp50);
    tmp50 = CodeStubAssembler(state_).ToInteger_Inline(TNode<Context>{tmp44}, TNode<Object>{tmp49});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 150);
    TNode<Number> tmp51;
    USE(tmp51);
    tmp51 = FromConstexpr20UT5ATSmi10HeapNumber17ATconstexpr_int31_161(state_, 0);
    TNode<BoolT> tmp52;
    USE(tmp52);
    tmp52 = NumberIsLessThan_75(state_, TNode<Number>{tmp50}, TNode<Number>{tmp51});
    ca_.Branch(tmp52, &block7, &block8, tmp41, tmp42, tmp43, tmp44, tmp45, tmp46, tmp47, tmp49, tmp50);
  }

  if (block7.is_used()) {
    TNode<RawPtrT> tmp53;
    TNode<RawPtrT> tmp54;
    TNode<IntPtrT> tmp55;
    TNode<Context> tmp56;
    TNode<Object> tmp57;
    TNode<JSReceiver> tmp58;
    TNode<Number> tmp59;
    TNode<Object> tmp60;
    TNode<Number> tmp61;
    ca_.Bind(&block7, &tmp53, &tmp54, &tmp55, &tmp56, &tmp57, &tmp58, &tmp59, &tmp60, &tmp61);
    TNode<Number> tmp62;
    USE(tmp62);
    tmp62 = CodeStubAssembler(state_).NumberAdd(TNode<Number>{tmp59}, TNode<Number>{tmp61});
    TNode<Number> tmp63;
    USE(tmp63);
    tmp63 = FromConstexpr20UT5ATSmi10HeapNumber17ATconstexpr_int31_161(state_, 0);
    TNode<Number> tmp64;
    USE(tmp64);
    tmp64 = Max_81(state_, TNode<Number>{tmp62}, TNode<Number>{tmp63});
    ca_.Goto(&block10, tmp53, tmp54, tmp55, tmp56, tmp57, tmp58, tmp59, tmp60, tmp61, tmp64);
  }

  if (block8.is_used()) {
    TNode<RawPtrT> tmp65;
    TNode<RawPtrT> tmp66;
    TNode<IntPtrT> tmp67;
    TNode<Context> tmp68;
    TNode<Object> tmp69;
    TNode<JSReceiver> tmp70;
    TNode<Number> tmp71;
    TNode<Object> tmp72;
    TNode<Number> tmp73;
    ca_.Bind(&block8, &tmp65, &tmp66, &tmp67, &tmp68, &tmp69, &tmp70, &tmp71, &tmp72, &tmp73);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 151);
    TNode<Number> tmp74;
    USE(tmp74);
    tmp74 = Min_80(state_, TNode<Number>{tmp73}, TNode<Number>{tmp71});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 150);
    ca_.Goto(&block9, tmp65, tmp66, tmp67, tmp68, tmp69, tmp70, tmp71, tmp72, tmp73, tmp74);
  }

  if (block10.is_used()) {
    TNode<RawPtrT> tmp75;
    TNode<RawPtrT> tmp76;
    TNode<IntPtrT> tmp77;
    TNode<Context> tmp78;
    TNode<Object> tmp79;
    TNode<JSReceiver> tmp80;
    TNode<Number> tmp81;
    TNode<Object> tmp82;
    TNode<Number> tmp83;
    TNode<Number> tmp84;
    ca_.Bind(&block10, &tmp75, &tmp76, &tmp77, &tmp78, &tmp79, &tmp80, &tmp81, &tmp82, &tmp83, &tmp84);
    ca_.Goto(&block9, tmp75, tmp76, tmp77, tmp78, tmp79, tmp80, tmp81, tmp82, tmp83, tmp84);
  }

  if (block9.is_used()) {
    TNode<RawPtrT> tmp85;
    TNode<RawPtrT> tmp86;
    TNode<IntPtrT> tmp87;
    TNode<Context> tmp88;
    TNode<Object> tmp89;
    TNode<JSReceiver> tmp90;
    TNode<Number> tmp91;
    TNode<Object> tmp92;
    TNode<Number> tmp93;
    TNode<Number> tmp94;
    ca_.Bind(&block9, &tmp85, &tmp86, &tmp87, &tmp88, &tmp89, &tmp90, &tmp91, &tmp92, &tmp93, &tmp94);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 155);
    TNode<IntPtrT> tmp95;
    USE(tmp95);
    tmp95 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, 1);
    TNode<Object> tmp96;
    USE(tmp96);
    tmp96 = CodeStubAssembler(state_).GetArgumentValue(TorqueStructArguments{TNode<RawPtrT>{tmp85}, TNode<RawPtrT>{tmp86}, TNode<IntPtrT>{tmp87}}, TNode<IntPtrT>{tmp95});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 157);
    TNode<Oddball> tmp97;
    USE(tmp97);
    tmp97 = Undefined_64(state_);
    TNode<BoolT> tmp98;
    USE(tmp98);
    tmp98 = CodeStubAssembler(state_).TaggedEqual(TNode<Object>{tmp96}, TNode<HeapObject>{tmp97});
    ca_.Branch(tmp98, &block11, &block12, tmp85, tmp86, tmp87, tmp88, tmp89, tmp90, tmp91, tmp92, tmp93, tmp94, tmp96);
  }

  if (block11.is_used()) {
    TNode<RawPtrT> tmp99;
    TNode<RawPtrT> tmp100;
    TNode<IntPtrT> tmp101;
    TNode<Context> tmp102;
    TNode<Object> tmp103;
    TNode<JSReceiver> tmp104;
    TNode<Number> tmp105;
    TNode<Object> tmp106;
    TNode<Number> tmp107;
    TNode<Number> tmp108;
    TNode<Object> tmp109;
    ca_.Bind(&block11, &tmp99, &tmp100, &tmp101, &tmp102, &tmp103, &tmp104, &tmp105, &tmp106, &tmp107, &tmp108, &tmp109);
    ca_.Goto(&block14, tmp99, tmp100, tmp101, tmp102, tmp103, tmp104, tmp105, tmp106, tmp107, tmp108, tmp109, tmp105);
  }

  if (block12.is_used()) {
    TNode<RawPtrT> tmp110;
    TNode<RawPtrT> tmp111;
    TNode<IntPtrT> tmp112;
    TNode<Context> tmp113;
    TNode<Object> tmp114;
    TNode<JSReceiver> tmp115;
    TNode<Number> tmp116;
    TNode<Object> tmp117;
    TNode<Number> tmp118;
    TNode<Number> tmp119;
    TNode<Object> tmp120;
    ca_.Bind(&block12, &tmp110, &tmp111, &tmp112, &tmp113, &tmp114, &tmp115, &tmp116, &tmp117, &tmp118, &tmp119, &tmp120);
    TNode<Number> tmp121;
    USE(tmp121);
    tmp121 = CodeStubAssembler(state_).ToInteger_Inline(TNode<Context>{tmp113}, TNode<Object>{tmp120});
    ca_.Goto(&block13, tmp110, tmp111, tmp112, tmp113, tmp114, tmp115, tmp116, tmp117, tmp118, tmp119, tmp120, tmp121);
  }

  if (block14.is_used()) {
    TNode<RawPtrT> tmp122;
    TNode<RawPtrT> tmp123;
    TNode<IntPtrT> tmp124;
    TNode<Context> tmp125;
    TNode<Object> tmp126;
    TNode<JSReceiver> tmp127;
    TNode<Number> tmp128;
    TNode<Object> tmp129;
    TNode<Number> tmp130;
    TNode<Number> tmp131;
    TNode<Object> tmp132;
    TNode<Number> tmp133;
    ca_.Bind(&block14, &tmp122, &tmp123, &tmp124, &tmp125, &tmp126, &tmp127, &tmp128, &tmp129, &tmp130, &tmp131, &tmp132, &tmp133);
    ca_.Goto(&block13, tmp122, tmp123, tmp124, tmp125, tmp126, tmp127, tmp128, tmp129, tmp130, tmp131, tmp132, tmp133);
  }

  if (block13.is_used()) {
    TNode<RawPtrT> tmp134;
    TNode<RawPtrT> tmp135;
    TNode<IntPtrT> tmp136;
    TNode<Context> tmp137;
    TNode<Object> tmp138;
    TNode<JSReceiver> tmp139;
    TNode<Number> tmp140;
    TNode<Object> tmp141;
    TNode<Number> tmp142;
    TNode<Number> tmp143;
    TNode<Object> tmp144;
    TNode<Number> tmp145;
    ca_.Bind(&block13, &tmp134, &tmp135, &tmp136, &tmp137, &tmp138, &tmp139, &tmp140, &tmp141, &tmp142, &tmp143, &tmp144, &tmp145);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 156);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 162);
    TNode<Number> tmp146;
    USE(tmp146);
    tmp146 = FromConstexpr20UT5ATSmi10HeapNumber17ATconstexpr_int31_161(state_, 0);
    TNode<BoolT> tmp147;
    USE(tmp147);
    tmp147 = NumberIsLessThan_75(state_, TNode<Number>{tmp145}, TNode<Number>{tmp146});
    ca_.Branch(tmp147, &block15, &block16, tmp134, tmp135, tmp136, tmp137, tmp138, tmp139, tmp140, tmp141, tmp142, tmp143, tmp144, tmp145);
  }

  if (block15.is_used()) {
    TNode<RawPtrT> tmp148;
    TNode<RawPtrT> tmp149;
    TNode<IntPtrT> tmp150;
    TNode<Context> tmp151;
    TNode<Object> tmp152;
    TNode<JSReceiver> tmp153;
    TNode<Number> tmp154;
    TNode<Object> tmp155;
    TNode<Number> tmp156;
    TNode<Number> tmp157;
    TNode<Object> tmp158;
    TNode<Number> tmp159;
    ca_.Bind(&block15, &tmp148, &tmp149, &tmp150, &tmp151, &tmp152, &tmp153, &tmp154, &tmp155, &tmp156, &tmp157, &tmp158, &tmp159);
    TNode<Number> tmp160;
    USE(tmp160);
    tmp160 = CodeStubAssembler(state_).NumberAdd(TNode<Number>{tmp154}, TNode<Number>{tmp159});
    TNode<Number> tmp161;
    USE(tmp161);
    tmp161 = FromConstexpr20UT5ATSmi10HeapNumber17ATconstexpr_int31_161(state_, 0);
    TNode<Number> tmp162;
    USE(tmp162);
    tmp162 = Max_81(state_, TNode<Number>{tmp160}, TNode<Number>{tmp161});
    ca_.Goto(&block18, tmp148, tmp149, tmp150, tmp151, tmp152, tmp153, tmp154, tmp155, tmp156, tmp157, tmp158, tmp159, tmp162);
  }

  if (block16.is_used()) {
    TNode<RawPtrT> tmp163;
    TNode<RawPtrT> tmp164;
    TNode<IntPtrT> tmp165;
    TNode<Context> tmp166;
    TNode<Object> tmp167;
    TNode<JSReceiver> tmp168;
    TNode<Number> tmp169;
    TNode<Object> tmp170;
    TNode<Number> tmp171;
    TNode<Number> tmp172;
    TNode<Object> tmp173;
    TNode<Number> tmp174;
    ca_.Bind(&block16, &tmp163, &tmp164, &tmp165, &tmp166, &tmp167, &tmp168, &tmp169, &tmp170, &tmp171, &tmp172, &tmp173, &tmp174);
    TNode<Number> tmp175;
    USE(tmp175);
    tmp175 = Min_80(state_, TNode<Number>{tmp174}, TNode<Number>{tmp169});
    ca_.Goto(&block17, tmp163, tmp164, tmp165, tmp166, tmp167, tmp168, tmp169, tmp170, tmp171, tmp172, tmp173, tmp174, tmp175);
  }

  if (block18.is_used()) {
    TNode<RawPtrT> tmp176;
    TNode<RawPtrT> tmp177;
    TNode<IntPtrT> tmp178;
    TNode<Context> tmp179;
    TNode<Object> tmp180;
    TNode<JSReceiver> tmp181;
    TNode<Number> tmp182;
    TNode<Object> tmp183;
    TNode<Number> tmp184;
    TNode<Number> tmp185;
    TNode<Object> tmp186;
    TNode<Number> tmp187;
    TNode<Number> tmp188;
    ca_.Bind(&block18, &tmp176, &tmp177, &tmp178, &tmp179, &tmp180, &tmp181, &tmp182, &tmp183, &tmp184, &tmp185, &tmp186, &tmp187, &tmp188);
    ca_.Goto(&block17, tmp176, tmp177, tmp178, tmp179, tmp180, tmp181, tmp182, tmp183, tmp184, tmp185, tmp186, tmp187, tmp188);
  }

  if (block17.is_used()) {
    TNode<RawPtrT> tmp189;
    TNode<RawPtrT> tmp190;
    TNode<IntPtrT> tmp191;
    TNode<Context> tmp192;
    TNode<Object> tmp193;
    TNode<JSReceiver> tmp194;
    TNode<Number> tmp195;
    TNode<Object> tmp196;
    TNode<Number> tmp197;
    TNode<Number> tmp198;
    TNode<Object> tmp199;
    TNode<Number> tmp200;
    TNode<Number> tmp201;
    ca_.Bind(&block17, &tmp189, &tmp190, &tmp191, &tmp192, &tmp193, &tmp194, &tmp195, &tmp196, &tmp197, &tmp198, &tmp199, &tmp200, &tmp201);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 161);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 165);
    TNode<Number> tmp202;
    USE(tmp202);
    tmp202 = CodeStubAssembler(state_).NumberSub(TNode<Number>{tmp201}, TNode<Number>{tmp198});
    TNode<Number> tmp203;
    USE(tmp203);
    tmp203 = FromConstexpr20UT5ATSmi10HeapNumber17ATconstexpr_int31_161(state_, 0);
    TNode<Number> tmp204;
    USE(tmp204);
    tmp204 = Max_81(state_, TNode<Number>{tmp202}, TNode<Number>{tmp203});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 167);
    ca_.Goto(&block20, tmp189, tmp190, tmp191, tmp192, tmp193, tmp194, tmp195, tmp196, tmp197, tmp198, tmp199, tmp200, tmp201, tmp204);
  }

  if (block19.is_used()) {
    TNode<RawPtrT> tmp205;
    TNode<RawPtrT> tmp206;
    TNode<IntPtrT> tmp207;
    TNode<Context> tmp208;
    TNode<Object> tmp209;
    TNode<JSReceiver> tmp210;
    TNode<Number> tmp211;
    TNode<Object> tmp212;
    TNode<Number> tmp213;
    TNode<Number> tmp214;
    TNode<Object> tmp215;
    TNode<Number> tmp216;
    TNode<Number> tmp217;
    TNode<Number> tmp218;
    ca_.Bind(&block19, &tmp205, &tmp206, &tmp207, &tmp208, &tmp209, &tmp210, &tmp211, &tmp212, &tmp213, &tmp214, &tmp215, &tmp216, &tmp217, &tmp218);
    TNode<Number> tmp219;
    USE(tmp219);
    tmp219 = FromConstexpr20UT5ATSmi10HeapNumber17ATconstexpr_int31_161(state_, 0);
    TNode<BoolT> tmp220;
    USE(tmp220);
    tmp220 = NumberIsLessThanOrEqual_76(state_, TNode<Number>{tmp219}, TNode<Number>{tmp214});
    ca_.Branch(tmp220, &block21, &block22, tmp205, tmp206, tmp207, tmp208, tmp209, tmp210, tmp211, tmp212, tmp213, tmp214, tmp215, tmp216, tmp217, tmp218);
  }

  if (block22.is_used()) {
    TNode<RawPtrT> tmp221;
    TNode<RawPtrT> tmp222;
    TNode<IntPtrT> tmp223;
    TNode<Context> tmp224;
    TNode<Object> tmp225;
    TNode<JSReceiver> tmp226;
    TNode<Number> tmp227;
    TNode<Object> tmp228;
    TNode<Number> tmp229;
    TNode<Number> tmp230;
    TNode<Object> tmp231;
    TNode<Number> tmp232;
    TNode<Number> tmp233;
    TNode<Number> tmp234;
    ca_.Bind(&block22, &tmp221, &tmp222, &tmp223, &tmp224, &tmp225, &tmp226, &tmp227, &tmp228, &tmp229, &tmp230, &tmp231, &tmp232, &tmp233, &tmp234);
    CodeStubAssembler(state_).FailAssert("Torque assert '0 <= k' failed", "../../deps/v8/src/builtins/array-slice.tq", 167);
  }

  if (block21.is_used()) {
    TNode<RawPtrT> tmp235;
    TNode<RawPtrT> tmp236;
    TNode<IntPtrT> tmp237;
    TNode<Context> tmp238;
    TNode<Object> tmp239;
    TNode<JSReceiver> tmp240;
    TNode<Number> tmp241;
    TNode<Object> tmp242;
    TNode<Number> tmp243;
    TNode<Number> tmp244;
    TNode<Object> tmp245;
    TNode<Number> tmp246;
    TNode<Number> tmp247;
    TNode<Number> tmp248;
    ca_.Bind(&block21, &tmp235, &tmp236, &tmp237, &tmp238, &tmp239, &tmp240, &tmp241, &tmp242, &tmp243, &tmp244, &tmp245, &tmp246, &tmp247, &tmp248);
  }

  if (block20.is_used()) {
    TNode<RawPtrT> tmp249;
    TNode<RawPtrT> tmp250;
    TNode<IntPtrT> tmp251;
    TNode<Context> tmp252;
    TNode<Object> tmp253;
    TNode<JSReceiver> tmp254;
    TNode<Number> tmp255;
    TNode<Object> tmp256;
    TNode<Number> tmp257;
    TNode<Number> tmp258;
    TNode<Object> tmp259;
    TNode<Number> tmp260;
    TNode<Number> tmp261;
    TNode<Number> tmp262;
    ca_.Bind(&block20, &tmp249, &tmp250, &tmp251, &tmp252, &tmp253, &tmp254, &tmp255, &tmp256, &tmp257, &tmp258, &tmp259, &tmp260, &tmp261, &tmp262);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 168);
    ca_.Goto(&block24, tmp249, tmp250, tmp251, tmp252, tmp253, tmp254, tmp255, tmp256, tmp257, tmp258, tmp259, tmp260, tmp261, tmp262);
  }

  if (block23.is_used()) {
    TNode<RawPtrT> tmp263;
    TNode<RawPtrT> tmp264;
    TNode<IntPtrT> tmp265;
    TNode<Context> tmp266;
    TNode<Object> tmp267;
    TNode<JSReceiver> tmp268;
    TNode<Number> tmp269;
    TNode<Object> tmp270;
    TNode<Number> tmp271;
    TNode<Number> tmp272;
    TNode<Object> tmp273;
    TNode<Number> tmp274;
    TNode<Number> tmp275;
    TNode<Number> tmp276;
    ca_.Bind(&block23, &tmp263, &tmp264, &tmp265, &tmp266, &tmp267, &tmp268, &tmp269, &tmp270, &tmp271, &tmp272, &tmp273, &tmp274, &tmp275, &tmp276);
    TNode<BoolT> tmp277;
    USE(tmp277);
    tmp277 = NumberIsLessThanOrEqual_76(state_, TNode<Number>{tmp272}, TNode<Number>{tmp269});
    ca_.Branch(tmp277, &block25, &block26, tmp263, tmp264, tmp265, tmp266, tmp267, tmp268, tmp269, tmp270, tmp271, tmp272, tmp273, tmp274, tmp275, tmp276);
  }

  if (block26.is_used()) {
    TNode<RawPtrT> tmp278;
    TNode<RawPtrT> tmp279;
    TNode<IntPtrT> tmp280;
    TNode<Context> tmp281;
    TNode<Object> tmp282;
    TNode<JSReceiver> tmp283;
    TNode<Number> tmp284;
    TNode<Object> tmp285;
    TNode<Number> tmp286;
    TNode<Number> tmp287;
    TNode<Object> tmp288;
    TNode<Number> tmp289;
    TNode<Number> tmp290;
    TNode<Number> tmp291;
    ca_.Bind(&block26, &tmp278, &tmp279, &tmp280, &tmp281, &tmp282, &tmp283, &tmp284, &tmp285, &tmp286, &tmp287, &tmp288, &tmp289, &tmp290, &tmp291);
    CodeStubAssembler(state_).FailAssert("Torque assert 'k <= len' failed", "../../deps/v8/src/builtins/array-slice.tq", 168);
  }

  if (block25.is_used()) {
    TNode<RawPtrT> tmp292;
    TNode<RawPtrT> tmp293;
    TNode<IntPtrT> tmp294;
    TNode<Context> tmp295;
    TNode<Object> tmp296;
    TNode<JSReceiver> tmp297;
    TNode<Number> tmp298;
    TNode<Object> tmp299;
    TNode<Number> tmp300;
    TNode<Number> tmp301;
    TNode<Object> tmp302;
    TNode<Number> tmp303;
    TNode<Number> tmp304;
    TNode<Number> tmp305;
    ca_.Bind(&block25, &tmp292, &tmp293, &tmp294, &tmp295, &tmp296, &tmp297, &tmp298, &tmp299, &tmp300, &tmp301, &tmp302, &tmp303, &tmp304, &tmp305);
  }

  if (block24.is_used()) {
    TNode<RawPtrT> tmp306;
    TNode<RawPtrT> tmp307;
    TNode<IntPtrT> tmp308;
    TNode<Context> tmp309;
    TNode<Object> tmp310;
    TNode<JSReceiver> tmp311;
    TNode<Number> tmp312;
    TNode<Object> tmp313;
    TNode<Number> tmp314;
    TNode<Number> tmp315;
    TNode<Object> tmp316;
    TNode<Number> tmp317;
    TNode<Number> tmp318;
    TNode<Number> tmp319;
    ca_.Bind(&block24, &tmp306, &tmp307, &tmp308, &tmp309, &tmp310, &tmp311, &tmp312, &tmp313, &tmp314, &tmp315, &tmp316, &tmp317, &tmp318, &tmp319);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 169);
    ca_.Goto(&block28, tmp306, tmp307, tmp308, tmp309, tmp310, tmp311, tmp312, tmp313, tmp314, tmp315, tmp316, tmp317, tmp318, tmp319);
  }

  if (block27.is_used()) {
    TNode<RawPtrT> tmp320;
    TNode<RawPtrT> tmp321;
    TNode<IntPtrT> tmp322;
    TNode<Context> tmp323;
    TNode<Object> tmp324;
    TNode<JSReceiver> tmp325;
    TNode<Number> tmp326;
    TNode<Object> tmp327;
    TNode<Number> tmp328;
    TNode<Number> tmp329;
    TNode<Object> tmp330;
    TNode<Number> tmp331;
    TNode<Number> tmp332;
    TNode<Number> tmp333;
    ca_.Bind(&block27, &tmp320, &tmp321, &tmp322, &tmp323, &tmp324, &tmp325, &tmp326, &tmp327, &tmp328, &tmp329, &tmp330, &tmp331, &tmp332, &tmp333);
    TNode<Number> tmp334;
    USE(tmp334);
    tmp334 = FromConstexpr20UT5ATSmi10HeapNumber17ATconstexpr_int31_161(state_, 0);
    TNode<BoolT> tmp335;
    USE(tmp335);
    tmp335 = NumberIsLessThanOrEqual_76(state_, TNode<Number>{tmp334}, TNode<Number>{tmp332});
    ca_.Branch(tmp335, &block29, &block30, tmp320, tmp321, tmp322, tmp323, tmp324, tmp325, tmp326, tmp327, tmp328, tmp329, tmp330, tmp331, tmp332, tmp333);
  }

  if (block30.is_used()) {
    TNode<RawPtrT> tmp336;
    TNode<RawPtrT> tmp337;
    TNode<IntPtrT> tmp338;
    TNode<Context> tmp339;
    TNode<Object> tmp340;
    TNode<JSReceiver> tmp341;
    TNode<Number> tmp342;
    TNode<Object> tmp343;
    TNode<Number> tmp344;
    TNode<Number> tmp345;
    TNode<Object> tmp346;
    TNode<Number> tmp347;
    TNode<Number> tmp348;
    TNode<Number> tmp349;
    ca_.Bind(&block30, &tmp336, &tmp337, &tmp338, &tmp339, &tmp340, &tmp341, &tmp342, &tmp343, &tmp344, &tmp345, &tmp346, &tmp347, &tmp348, &tmp349);
    CodeStubAssembler(state_).FailAssert("Torque assert '0 <= final' failed", "../../deps/v8/src/builtins/array-slice.tq", 169);
  }

  if (block29.is_used()) {
    TNode<RawPtrT> tmp350;
    TNode<RawPtrT> tmp351;
    TNode<IntPtrT> tmp352;
    TNode<Context> tmp353;
    TNode<Object> tmp354;
    TNode<JSReceiver> tmp355;
    TNode<Number> tmp356;
    TNode<Object> tmp357;
    TNode<Number> tmp358;
    TNode<Number> tmp359;
    TNode<Object> tmp360;
    TNode<Number> tmp361;
    TNode<Number> tmp362;
    TNode<Number> tmp363;
    ca_.Bind(&block29, &tmp350, &tmp351, &tmp352, &tmp353, &tmp354, &tmp355, &tmp356, &tmp357, &tmp358, &tmp359, &tmp360, &tmp361, &tmp362, &tmp363);
  }

  if (block28.is_used()) {
    TNode<RawPtrT> tmp364;
    TNode<RawPtrT> tmp365;
    TNode<IntPtrT> tmp366;
    TNode<Context> tmp367;
    TNode<Object> tmp368;
    TNode<JSReceiver> tmp369;
    TNode<Number> tmp370;
    TNode<Object> tmp371;
    TNode<Number> tmp372;
    TNode<Number> tmp373;
    TNode<Object> tmp374;
    TNode<Number> tmp375;
    TNode<Number> tmp376;
    TNode<Number> tmp377;
    ca_.Bind(&block28, &tmp364, &tmp365, &tmp366, &tmp367, &tmp368, &tmp369, &tmp370, &tmp371, &tmp372, &tmp373, &tmp374, &tmp375, &tmp376, &tmp377);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 170);
    ca_.Goto(&block32, tmp364, tmp365, tmp366, tmp367, tmp368, tmp369, tmp370, tmp371, tmp372, tmp373, tmp374, tmp375, tmp376, tmp377);
  }

  if (block31.is_used()) {
    TNode<RawPtrT> tmp378;
    TNode<RawPtrT> tmp379;
    TNode<IntPtrT> tmp380;
    TNode<Context> tmp381;
    TNode<Object> tmp382;
    TNode<JSReceiver> tmp383;
    TNode<Number> tmp384;
    TNode<Object> tmp385;
    TNode<Number> tmp386;
    TNode<Number> tmp387;
    TNode<Object> tmp388;
    TNode<Number> tmp389;
    TNode<Number> tmp390;
    TNode<Number> tmp391;
    ca_.Bind(&block31, &tmp378, &tmp379, &tmp380, &tmp381, &tmp382, &tmp383, &tmp384, &tmp385, &tmp386, &tmp387, &tmp388, &tmp389, &tmp390, &tmp391);
    TNode<BoolT> tmp392;
    USE(tmp392);
    tmp392 = NumberIsLessThanOrEqual_76(state_, TNode<Number>{tmp390}, TNode<Number>{tmp384});
    ca_.Branch(tmp392, &block33, &block34, tmp378, tmp379, tmp380, tmp381, tmp382, tmp383, tmp384, tmp385, tmp386, tmp387, tmp388, tmp389, tmp390, tmp391);
  }

  if (block34.is_used()) {
    TNode<RawPtrT> tmp393;
    TNode<RawPtrT> tmp394;
    TNode<IntPtrT> tmp395;
    TNode<Context> tmp396;
    TNode<Object> tmp397;
    TNode<JSReceiver> tmp398;
    TNode<Number> tmp399;
    TNode<Object> tmp400;
    TNode<Number> tmp401;
    TNode<Number> tmp402;
    TNode<Object> tmp403;
    TNode<Number> tmp404;
    TNode<Number> tmp405;
    TNode<Number> tmp406;
    ca_.Bind(&block34, &tmp393, &tmp394, &tmp395, &tmp396, &tmp397, &tmp398, &tmp399, &tmp400, &tmp401, &tmp402, &tmp403, &tmp404, &tmp405, &tmp406);
    CodeStubAssembler(state_).FailAssert("Torque assert 'final <= len' failed", "../../deps/v8/src/builtins/array-slice.tq", 170);
  }

  if (block33.is_used()) {
    TNode<RawPtrT> tmp407;
    TNode<RawPtrT> tmp408;
    TNode<IntPtrT> tmp409;
    TNode<Context> tmp410;
    TNode<Object> tmp411;
    TNode<JSReceiver> tmp412;
    TNode<Number> tmp413;
    TNode<Object> tmp414;
    TNode<Number> tmp415;
    TNode<Number> tmp416;
    TNode<Object> tmp417;
    TNode<Number> tmp418;
    TNode<Number> tmp419;
    TNode<Number> tmp420;
    ca_.Bind(&block33, &tmp407, &tmp408, &tmp409, &tmp410, &tmp411, &tmp412, &tmp413, &tmp414, &tmp415, &tmp416, &tmp417, &tmp418, &tmp419, &tmp420);
  }

  if (block32.is_used()) {
    TNode<RawPtrT> tmp421;
    TNode<RawPtrT> tmp422;
    TNode<IntPtrT> tmp423;
    TNode<Context> tmp424;
    TNode<Object> tmp425;
    TNode<JSReceiver> tmp426;
    TNode<Number> tmp427;
    TNode<Object> tmp428;
    TNode<Number> tmp429;
    TNode<Number> tmp430;
    TNode<Object> tmp431;
    TNode<Number> tmp432;
    TNode<Number> tmp433;
    TNode<Number> tmp434;
    ca_.Bind(&block32, &tmp421, &tmp422, &tmp423, &tmp424, &tmp425, &tmp426, &tmp427, &tmp428, &tmp429, &tmp430, &tmp431, &tmp432, &tmp433, &tmp434);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 171);
    ca_.Goto(&block36, tmp421, tmp422, tmp423, tmp424, tmp425, tmp426, tmp427, tmp428, tmp429, tmp430, tmp431, tmp432, tmp433, tmp434);
  }

  if (block35.is_used()) {
    TNode<RawPtrT> tmp435;
    TNode<RawPtrT> tmp436;
    TNode<IntPtrT> tmp437;
    TNode<Context> tmp438;
    TNode<Object> tmp439;
    TNode<JSReceiver> tmp440;
    TNode<Number> tmp441;
    TNode<Object> tmp442;
    TNode<Number> tmp443;
    TNode<Number> tmp444;
    TNode<Object> tmp445;
    TNode<Number> tmp446;
    TNode<Number> tmp447;
    TNode<Number> tmp448;
    ca_.Bind(&block35, &tmp435, &tmp436, &tmp437, &tmp438, &tmp439, &tmp440, &tmp441, &tmp442, &tmp443, &tmp444, &tmp445, &tmp446, &tmp447, &tmp448);
    TNode<Number> tmp449;
    USE(tmp449);
    tmp449 = FromConstexpr20UT5ATSmi10HeapNumber17ATconstexpr_int31_161(state_, 0);
    TNode<BoolT> tmp450;
    USE(tmp450);
    tmp450 = NumberIsLessThanOrEqual_76(state_, TNode<Number>{tmp449}, TNode<Number>{tmp448});
    ca_.Branch(tmp450, &block37, &block38, tmp435, tmp436, tmp437, tmp438, tmp439, tmp440, tmp441, tmp442, tmp443, tmp444, tmp445, tmp446, tmp447, tmp448);
  }

  if (block38.is_used()) {
    TNode<RawPtrT> tmp451;
    TNode<RawPtrT> tmp452;
    TNode<IntPtrT> tmp453;
    TNode<Context> tmp454;
    TNode<Object> tmp455;
    TNode<JSReceiver> tmp456;
    TNode<Number> tmp457;
    TNode<Object> tmp458;
    TNode<Number> tmp459;
    TNode<Number> tmp460;
    TNode<Object> tmp461;
    TNode<Number> tmp462;
    TNode<Number> tmp463;
    TNode<Number> tmp464;
    ca_.Bind(&block38, &tmp451, &tmp452, &tmp453, &tmp454, &tmp455, &tmp456, &tmp457, &tmp458, &tmp459, &tmp460, &tmp461, &tmp462, &tmp463, &tmp464);
    CodeStubAssembler(state_).FailAssert("Torque assert '0 <= count' failed", "../../deps/v8/src/builtins/array-slice.tq", 171);
  }

  if (block37.is_used()) {
    TNode<RawPtrT> tmp465;
    TNode<RawPtrT> tmp466;
    TNode<IntPtrT> tmp467;
    TNode<Context> tmp468;
    TNode<Object> tmp469;
    TNode<JSReceiver> tmp470;
    TNode<Number> tmp471;
    TNode<Object> tmp472;
    TNode<Number> tmp473;
    TNode<Number> tmp474;
    TNode<Object> tmp475;
    TNode<Number> tmp476;
    TNode<Number> tmp477;
    TNode<Number> tmp478;
    ca_.Bind(&block37, &tmp465, &tmp466, &tmp467, &tmp468, &tmp469, &tmp470, &tmp471, &tmp472, &tmp473, &tmp474, &tmp475, &tmp476, &tmp477, &tmp478);
  }

  if (block36.is_used()) {
    TNode<RawPtrT> tmp479;
    TNode<RawPtrT> tmp480;
    TNode<IntPtrT> tmp481;
    TNode<Context> tmp482;
    TNode<Object> tmp483;
    TNode<JSReceiver> tmp484;
    TNode<Number> tmp485;
    TNode<Object> tmp486;
    TNode<Number> tmp487;
    TNode<Number> tmp488;
    TNode<Object> tmp489;
    TNode<Number> tmp490;
    TNode<Number> tmp491;
    TNode<Number> tmp492;
    ca_.Bind(&block36, &tmp479, &tmp480, &tmp481, &tmp482, &tmp483, &tmp484, &tmp485, &tmp486, &tmp487, &tmp488, &tmp489, &tmp490, &tmp491, &tmp492);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 172);
    ca_.Goto(&block40, tmp479, tmp480, tmp481, tmp482, tmp483, tmp484, tmp485, tmp486, tmp487, tmp488, tmp489, tmp490, tmp491, tmp492);
  }

  if (block39.is_used()) {
    TNode<RawPtrT> tmp493;
    TNode<RawPtrT> tmp494;
    TNode<IntPtrT> tmp495;
    TNode<Context> tmp496;
    TNode<Object> tmp497;
    TNode<JSReceiver> tmp498;
    TNode<Number> tmp499;
    TNode<Object> tmp500;
    TNode<Number> tmp501;
    TNode<Number> tmp502;
    TNode<Object> tmp503;
    TNode<Number> tmp504;
    TNode<Number> tmp505;
    TNode<Number> tmp506;
    ca_.Bind(&block39, &tmp493, &tmp494, &tmp495, &tmp496, &tmp497, &tmp498, &tmp499, &tmp500, &tmp501, &tmp502, &tmp503, &tmp504, &tmp505, &tmp506);
    TNode<BoolT> tmp507;
    USE(tmp507);
    tmp507 = NumberIsLessThanOrEqual_76(state_, TNode<Number>{tmp506}, TNode<Number>{tmp499});
    ca_.Branch(tmp507, &block41, &block42, tmp493, tmp494, tmp495, tmp496, tmp497, tmp498, tmp499, tmp500, tmp501, tmp502, tmp503, tmp504, tmp505, tmp506);
  }

  if (block42.is_used()) {
    TNode<RawPtrT> tmp508;
    TNode<RawPtrT> tmp509;
    TNode<IntPtrT> tmp510;
    TNode<Context> tmp511;
    TNode<Object> tmp512;
    TNode<JSReceiver> tmp513;
    TNode<Number> tmp514;
    TNode<Object> tmp515;
    TNode<Number> tmp516;
    TNode<Number> tmp517;
    TNode<Object> tmp518;
    TNode<Number> tmp519;
    TNode<Number> tmp520;
    TNode<Number> tmp521;
    ca_.Bind(&block42, &tmp508, &tmp509, &tmp510, &tmp511, &tmp512, &tmp513, &tmp514, &tmp515, &tmp516, &tmp517, &tmp518, &tmp519, &tmp520, &tmp521);
    CodeStubAssembler(state_).FailAssert("Torque assert 'count <= len' failed", "../../deps/v8/src/builtins/array-slice.tq", 172);
  }

  if (block41.is_used()) {
    TNode<RawPtrT> tmp522;
    TNode<RawPtrT> tmp523;
    TNode<IntPtrT> tmp524;
    TNode<Context> tmp525;
    TNode<Object> tmp526;
    TNode<JSReceiver> tmp527;
    TNode<Number> tmp528;
    TNode<Object> tmp529;
    TNode<Number> tmp530;
    TNode<Number> tmp531;
    TNode<Object> tmp532;
    TNode<Number> tmp533;
    TNode<Number> tmp534;
    TNode<Number> tmp535;
    ca_.Bind(&block41, &tmp522, &tmp523, &tmp524, &tmp525, &tmp526, &tmp527, &tmp528, &tmp529, &tmp530, &tmp531, &tmp532, &tmp533, &tmp534, &tmp535);
  }

  if (block40.is_used()) {
    TNode<RawPtrT> tmp536;
    TNode<RawPtrT> tmp537;
    TNode<IntPtrT> tmp538;
    TNode<Context> tmp539;
    TNode<Object> tmp540;
    TNode<JSReceiver> tmp541;
    TNode<Number> tmp542;
    TNode<Object> tmp543;
    TNode<Number> tmp544;
    TNode<Number> tmp545;
    TNode<Object> tmp546;
    TNode<Number> tmp547;
    TNode<Number> tmp548;
    TNode<Number> tmp549;
    ca_.Bind(&block40, &tmp536, &tmp537, &tmp538, &tmp539, &tmp540, &tmp541, &tmp542, &tmp543, &tmp544, &tmp545, &tmp546, &tmp547, &tmp548, &tmp549);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 175);
    TNode<NativeContext> tmp550;
    USE(tmp550);
    tmp550 = UnsafeCast13NativeContext_1466(state_, TNode<Context>{tmp539}, TNode<Object>{tmp539});
    TNode<JSArray> tmp551;
    USE(tmp551);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp551 = HandleFastSlice_40(state_, TNode<NativeContext>{tmp550}, TNode<Object>{tmp541}, TNode<Number>{tmp545}, TNode<Number>{tmp549}, &label0);
    ca_.Goto(&block45, tmp536, tmp537, tmp538, tmp539, tmp540, tmp541, tmp542, tmp543, tmp544, tmp545, tmp546, tmp547, tmp548, tmp549, tmp550, tmp541, tmp545, tmp549, tmp551);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block46, tmp536, tmp537, tmp538, tmp539, tmp540, tmp541, tmp542, tmp543, tmp544, tmp545, tmp546, tmp547, tmp548, tmp549, tmp550, tmp541, tmp545, tmp549);
    }
  }

  if (block46.is_used()) {
    TNode<RawPtrT> tmp552;
    TNode<RawPtrT> tmp553;
    TNode<IntPtrT> tmp554;
    TNode<Context> tmp555;
    TNode<Object> tmp556;
    TNode<JSReceiver> tmp557;
    TNode<Number> tmp558;
    TNode<Object> tmp559;
    TNode<Number> tmp560;
    TNode<Number> tmp561;
    TNode<Object> tmp562;
    TNode<Number> tmp563;
    TNode<Number> tmp564;
    TNode<Number> tmp565;
    TNode<NativeContext> tmp566;
    TNode<JSReceiver> tmp567;
    TNode<Number> tmp568;
    TNode<Number> tmp569;
    ca_.Bind(&block46, &tmp552, &tmp553, &tmp554, &tmp555, &tmp556, &tmp557, &tmp558, &tmp559, &tmp560, &tmp561, &tmp562, &tmp563, &tmp564, &tmp565, &tmp566, &tmp567, &tmp568, &tmp569);
    ca_.Goto(&block44, tmp552, tmp553, tmp554, tmp555, tmp556, tmp557, tmp558, tmp559, tmp560, tmp561, tmp562, tmp563, tmp564, tmp565);
  }

  if (block45.is_used()) {
    TNode<RawPtrT> tmp570;
    TNode<RawPtrT> tmp571;
    TNode<IntPtrT> tmp572;
    TNode<Context> tmp573;
    TNode<Object> tmp574;
    TNode<JSReceiver> tmp575;
    TNode<Number> tmp576;
    TNode<Object> tmp577;
    TNode<Number> tmp578;
    TNode<Number> tmp579;
    TNode<Object> tmp580;
    TNode<Number> tmp581;
    TNode<Number> tmp582;
    TNode<Number> tmp583;
    TNode<NativeContext> tmp584;
    TNode<JSReceiver> tmp585;
    TNode<Number> tmp586;
    TNode<Number> tmp587;
    TNode<JSArray> tmp588;
    ca_.Bind(&block45, &tmp570, &tmp571, &tmp572, &tmp573, &tmp574, &tmp575, &tmp576, &tmp577, &tmp578, &tmp579, &tmp580, &tmp581, &tmp582, &tmp583, &tmp584, &tmp585, &tmp586, &tmp587, &tmp588);
    arguments.PopAndReturn(tmp588);
  }

  if (block44.is_used()) {
    TNode<RawPtrT> tmp589;
    TNode<RawPtrT> tmp590;
    TNode<IntPtrT> tmp591;
    TNode<Context> tmp592;
    TNode<Object> tmp593;
    TNode<JSReceiver> tmp594;
    TNode<Number> tmp595;
    TNode<Object> tmp596;
    TNode<Number> tmp597;
    TNode<Number> tmp598;
    TNode<Object> tmp599;
    TNode<Number> tmp600;
    TNode<Number> tmp601;
    TNode<Number> tmp602;
    ca_.Bind(&block44, &tmp589, &tmp590, &tmp591, &tmp592, &tmp593, &tmp594, &tmp595, &tmp596, &tmp597, &tmp598, &tmp599, &tmp600, &tmp601, &tmp602);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 174);
    ca_.Goto(&block43, tmp589, tmp590, tmp591, tmp592, tmp593, tmp594, tmp595, tmp596, tmp597, tmp598, tmp599, tmp600, tmp601, tmp602);
  }

  if (block43.is_used()) {
    TNode<RawPtrT> tmp603;
    TNode<RawPtrT> tmp604;
    TNode<IntPtrT> tmp605;
    TNode<Context> tmp606;
    TNode<Object> tmp607;
    TNode<JSReceiver> tmp608;
    TNode<Number> tmp609;
    TNode<Object> tmp610;
    TNode<Number> tmp611;
    TNode<Number> tmp612;
    TNode<Object> tmp613;
    TNode<Number> tmp614;
    TNode<Number> tmp615;
    TNode<Number> tmp616;
    ca_.Bind(&block43, &tmp603, &tmp604, &tmp605, &tmp606, &tmp607, &tmp608, &tmp609, &tmp610, &tmp611, &tmp612, &tmp613, &tmp614, &tmp615, &tmp616);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 181);
    TNode<JSReceiver> tmp617;
    USE(tmp617);
    tmp617 = CodeStubAssembler(state_).ArraySpeciesCreate(TNode<Context>{tmp606}, TNode<Object>{tmp608}, TNode<Number>{tmp616});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 184);
    TNode<Number> tmp618;
    USE(tmp618);
    tmp618 = FromConstexpr20UT5ATSmi10HeapNumber17ATconstexpr_int31_161(state_, 0);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 187);
    ca_.Goto(&block49, tmp603, tmp604, tmp605, tmp606, tmp607, tmp608, tmp609, tmp610, tmp611, tmp612, tmp613, tmp614, tmp615, tmp616, tmp617, tmp618);
  }

  if (block49.is_used()) {
    TNode<RawPtrT> tmp619;
    TNode<RawPtrT> tmp620;
    TNode<IntPtrT> tmp621;
    TNode<Context> tmp622;
    TNode<Object> tmp623;
    TNode<JSReceiver> tmp624;
    TNode<Number> tmp625;
    TNode<Object> tmp626;
    TNode<Number> tmp627;
    TNode<Number> tmp628;
    TNode<Object> tmp629;
    TNode<Number> tmp630;
    TNode<Number> tmp631;
    TNode<Number> tmp632;
    TNode<JSReceiver> tmp633;
    TNode<Number> tmp634;
    ca_.Bind(&block49, &tmp619, &tmp620, &tmp621, &tmp622, &tmp623, &tmp624, &tmp625, &tmp626, &tmp627, &tmp628, &tmp629, &tmp630, &tmp631, &tmp632, &tmp633, &tmp634);
    TNode<BoolT> tmp635;
    USE(tmp635);
    tmp635 = NumberIsLessThan_75(state_, TNode<Number>{tmp628}, TNode<Number>{tmp631});
    ca_.Branch(tmp635, &block47, &block48, tmp619, tmp620, tmp621, tmp622, tmp623, tmp624, tmp625, tmp626, tmp627, tmp628, tmp629, tmp630, tmp631, tmp632, tmp633, tmp634);
  }

  if (block47.is_used()) {
    TNode<RawPtrT> tmp636;
    TNode<RawPtrT> tmp637;
    TNode<IntPtrT> tmp638;
    TNode<Context> tmp639;
    TNode<Object> tmp640;
    TNode<JSReceiver> tmp641;
    TNode<Number> tmp642;
    TNode<Object> tmp643;
    TNode<Number> tmp644;
    TNode<Number> tmp645;
    TNode<Object> tmp646;
    TNode<Number> tmp647;
    TNode<Number> tmp648;
    TNode<Number> tmp649;
    TNode<JSReceiver> tmp650;
    TNode<Number> tmp651;
    ca_.Bind(&block47, &tmp636, &tmp637, &tmp638, &tmp639, &tmp640, &tmp641, &tmp642, &tmp643, &tmp644, &tmp645, &tmp646, &tmp647, &tmp648, &tmp649, &tmp650, &tmp651);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 189);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 192);
    TNode<Oddball> tmp652;
    tmp652 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kHasProperty, tmp639, tmp641, tmp645));
    USE(tmp652);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 195);
    TNode<Oddball> tmp653;
    USE(tmp653);
    tmp653 = True_65(state_);
    TNode<BoolT> tmp654;
    USE(tmp654);
    tmp654 = CodeStubAssembler(state_).TaggedEqual(TNode<HeapObject>{tmp652}, TNode<HeapObject>{tmp653});
    ca_.Branch(tmp654, &block50, &block51, tmp636, tmp637, tmp638, tmp639, tmp640, tmp641, tmp642, tmp643, tmp644, tmp645, tmp646, tmp647, tmp648, tmp649, tmp650, tmp651, tmp645, tmp652);
  }

  if (block50.is_used()) {
    TNode<RawPtrT> tmp655;
    TNode<RawPtrT> tmp656;
    TNode<IntPtrT> tmp657;
    TNode<Context> tmp658;
    TNode<Object> tmp659;
    TNode<JSReceiver> tmp660;
    TNode<Number> tmp661;
    TNode<Object> tmp662;
    TNode<Number> tmp663;
    TNode<Number> tmp664;
    TNode<Object> tmp665;
    TNode<Number> tmp666;
    TNode<Number> tmp667;
    TNode<Number> tmp668;
    TNode<JSReceiver> tmp669;
    TNode<Number> tmp670;
    TNode<Number> tmp671;
    TNode<Oddball> tmp672;
    ca_.Bind(&block50, &tmp655, &tmp656, &tmp657, &tmp658, &tmp659, &tmp660, &tmp661, &tmp662, &tmp663, &tmp664, &tmp665, &tmp666, &tmp667, &tmp668, &tmp669, &tmp670, &tmp671, &tmp672);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 197);
    TNode<Object> tmp673;
    USE(tmp673);
    tmp673 = CodeStubAssembler(state_).GetProperty(TNode<Context>{tmp658}, TNode<Object>{tmp660}, TNode<Object>{tmp671});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 200);
    TNode<Object> tmp674;
    tmp674 = CodeStubAssembler(state_).CallBuiltin(Builtins::kFastCreateDataProperty, tmp658, tmp669, tmp670, tmp673);
    USE(tmp674);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 195);
    ca_.Goto(&block51, tmp655, tmp656, tmp657, tmp658, tmp659, tmp660, tmp661, tmp662, tmp663, tmp664, tmp665, tmp666, tmp667, tmp668, tmp669, tmp670, tmp671, tmp672);
  }

  if (block51.is_used()) {
    TNode<RawPtrT> tmp675;
    TNode<RawPtrT> tmp676;
    TNode<IntPtrT> tmp677;
    TNode<Context> tmp678;
    TNode<Object> tmp679;
    TNode<JSReceiver> tmp680;
    TNode<Number> tmp681;
    TNode<Object> tmp682;
    TNode<Number> tmp683;
    TNode<Number> tmp684;
    TNode<Object> tmp685;
    TNode<Number> tmp686;
    TNode<Number> tmp687;
    TNode<Number> tmp688;
    TNode<JSReceiver> tmp689;
    TNode<Number> tmp690;
    TNode<Number> tmp691;
    TNode<Oddball> tmp692;
    ca_.Bind(&block51, &tmp675, &tmp676, &tmp677, &tmp678, &tmp679, &tmp680, &tmp681, &tmp682, &tmp683, &tmp684, &tmp685, &tmp686, &tmp687, &tmp688, &tmp689, &tmp690, &tmp691, &tmp692);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 204);
    TNode<Number> tmp693;
    USE(tmp693);
    tmp693 = FromConstexpr20UT5ATSmi10HeapNumber17ATconstexpr_int31_161(state_, 1);
    TNode<Number> tmp694;
    USE(tmp694);
    tmp694 = CodeStubAssembler(state_).NumberAdd(TNode<Number>{tmp684}, TNode<Number>{tmp693});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 207);
    TNode<Number> tmp695;
    USE(tmp695);
    tmp695 = FromConstexpr20UT5ATSmi10HeapNumber17ATconstexpr_int31_161(state_, 1);
    TNode<Number> tmp696;
    USE(tmp696);
    tmp696 = CodeStubAssembler(state_).NumberAdd(TNode<Number>{tmp690}, TNode<Number>{tmp695});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 187);
    ca_.Goto(&block49, tmp675, tmp676, tmp677, tmp678, tmp679, tmp680, tmp681, tmp682, tmp683, tmp694, tmp685, tmp686, tmp687, tmp688, tmp689, tmp696);
  }

  if (block48.is_used()) {
    TNode<RawPtrT> tmp697;
    TNode<RawPtrT> tmp698;
    TNode<IntPtrT> tmp699;
    TNode<Context> tmp700;
    TNode<Object> tmp701;
    TNode<JSReceiver> tmp702;
    TNode<Number> tmp703;
    TNode<Object> tmp704;
    TNode<Number> tmp705;
    TNode<Number> tmp706;
    TNode<Object> tmp707;
    TNode<Number> tmp708;
    TNode<Number> tmp709;
    TNode<Number> tmp710;
    TNode<JSReceiver> tmp711;
    TNode<Number> tmp712;
    ca_.Bind(&block48, &tmp697, &tmp698, &tmp699, &tmp700, &tmp701, &tmp702, &tmp703, &tmp704, &tmp705, &tmp706, &tmp707, &tmp708, &tmp709, &tmp710, &tmp711, &tmp712);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 211);
    TNode<String> tmp713;
    USE(tmp713);
    tmp713 = kLengthString_68(state_);
    CodeStubAssembler(state_).CallBuiltin(Builtins::kSetProperty, tmp700, tmp711, tmp713, tmp712);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 214);
    arguments.PopAndReturn(tmp711);
  }
}

TNode<FixedArray> Cast10FixedArray_1462(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<Object> p_o, compiler::CodeAssemblerLabel* label_CastError) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, HeapObject> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, HeapObject> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, HeapObject, FixedArray> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, FixedArray> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, FixedArray> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_o);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<Object> tmp1;
    ca_.Bind(&block0, &tmp0, &tmp1);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/base.tq", 2215);
    TNode<HeapObject> tmp2;
    USE(tmp2);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp2 = CodeStubAssembler(state_).TaggedToHeapObject(TNode<Object>{tmp1}, &label0);
    ca_.Goto(&block3, tmp0, tmp1, tmp1, tmp2);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block4, tmp0, tmp1, tmp1);
    }
  }

  if (block4.is_used()) {
    TNode<Context> tmp3;
    TNode<Object> tmp4;
    TNode<Object> tmp5;
    ca_.Bind(&block4, &tmp3, &tmp4, &tmp5);
    ca_.Goto(&block1);
  }

  if (block3.is_used()) {
    TNode<Context> tmp6;
    TNode<Object> tmp7;
    TNode<Object> tmp8;
    TNode<HeapObject> tmp9;
    ca_.Bind(&block3, &tmp6, &tmp7, &tmp8, &tmp9);
    TNode<FixedArray> tmp10;
    USE(tmp10);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp10 = Cast10FixedArray_103(state_, TNode<HeapObject>{tmp9}, &label0);
    ca_.Goto(&block5, tmp6, tmp7, tmp9, tmp10);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block6, tmp6, tmp7, tmp9);
    }
  }

  if (block6.is_used()) {
    TNode<Context> tmp11;
    TNode<Object> tmp12;
    TNode<HeapObject> tmp13;
    ca_.Bind(&block6, &tmp11, &tmp12, &tmp13);
    ca_.Goto(&block1);
  }

  if (block5.is_used()) {
    TNode<Context> tmp14;
    TNode<Object> tmp15;
    TNode<HeapObject> tmp16;
    TNode<FixedArray> tmp17;
    ca_.Bind(&block5, &tmp14, &tmp15, &tmp16, &tmp17);
    ca_.Goto(&block2, tmp14, tmp15, tmp17);
  }

  if (block2.is_used()) {
    TNode<Context> tmp18;
    TNode<Object> tmp19;
    TNode<FixedArray> tmp20;
    ca_.Bind(&block2, &tmp18, &tmp19, &tmp20);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 46);
    ca_.Goto(&block7, tmp18, tmp19, tmp20);
  }

  if (block1.is_used()) {
    ca_.Bind(&block1);
    ca_.Goto(label_CastError);
  }

    TNode<Context> tmp21;
    TNode<Object> tmp22;
    TNode<FixedArray> tmp23;
    ca_.Bind(&block7, &tmp21, &tmp22, &tmp23);
  return TNode<FixedArray>{tmp23};
}

TNode<Context> UnsafeCast7Context_1463(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<Object> p_o) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block5(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Context> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Context> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_o);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<Object> tmp1;
    ca_.Bind(&block0, &tmp0, &tmp1);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/base.tq", 3001);
    ca_.Goto(&block3, tmp0, tmp1);
  }

  if (block2.is_used()) {
    TNode<Context> tmp2;
    TNode<Object> tmp3;
    ca_.Bind(&block2, &tmp2, &tmp3);
    TNode<BoolT> tmp4;
    USE(tmp4);
    tmp4 = Is7Context20UT5ATSmi10HeapObject_1536(state_, TNode<Context>{tmp2}, TNode<Object>{tmp3});
    ca_.Branch(tmp4, &block4, &block5, tmp2, tmp3);
  }

  if (block5.is_used()) {
    TNode<Context> tmp5;
    TNode<Object> tmp6;
    ca_.Bind(&block5, &tmp5, &tmp6);
    CodeStubAssembler(state_).FailAssert("Torque assert 'Is<A>(o)' failed", "../../deps/v8/src/builtins/base.tq", 3001);
  }

  if (block4.is_used()) {
    TNode<Context> tmp7;
    TNode<Object> tmp8;
    ca_.Bind(&block4, &tmp7, &tmp8);
  }

  if (block3.is_used()) {
    TNode<Context> tmp9;
    TNode<Object> tmp10;
    ca_.Bind(&block3, &tmp9, &tmp10);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/base.tq", 3002);
    TNode<Context> tmp11;
    USE(tmp11);
    tmp11 = TORQUE_CAST(TNode<Object>{tmp10});
    ca_.Goto(&block1, tmp9, tmp10, tmp11);
  }

  if (block1.is_used()) {
    TNode<Context> tmp12;
    TNode<Object> tmp13;
    TNode<Context> tmp14;
    ca_.Bind(&block1, &tmp12, &tmp13, &tmp14);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 51);
    ca_.Goto(&block6, tmp12, tmp13, tmp14);
  }

    TNode<Context> tmp15;
    TNode<Object> tmp16;
    TNode<Context> tmp17;
    ca_.Bind(&block6, &tmp15, &tmp16, &tmp17);
  return TNode<Context>{tmp17};
}

TNode<JSArray> Cast20ATFastJSArrayForCopy_1464(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<Object> p_o, compiler::CodeAssemblerLabel* label_CastError) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, HeapObject> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, HeapObject> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, HeapObject, JSArray> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, JSArray> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, JSArray> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_o);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<Object> tmp1;
    ca_.Bind(&block0, &tmp0, &tmp1);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/base.tq", 2215);
    TNode<HeapObject> tmp2;
    USE(tmp2);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp2 = CodeStubAssembler(state_).TaggedToHeapObject(TNode<Object>{tmp1}, &label0);
    ca_.Goto(&block3, tmp0, tmp1, tmp1, tmp2);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block4, tmp0, tmp1, tmp1);
    }
  }

  if (block4.is_used()) {
    TNode<Context> tmp3;
    TNode<Object> tmp4;
    TNode<Object> tmp5;
    ca_.Bind(&block4, &tmp3, &tmp4, &tmp5);
    ca_.Goto(&block1);
  }

  if (block3.is_used()) {
    TNode<Context> tmp6;
    TNode<Object> tmp7;
    TNode<Object> tmp8;
    TNode<HeapObject> tmp9;
    ca_.Bind(&block3, &tmp6, &tmp7, &tmp8, &tmp9);
    TNode<JSArray> tmp10;
    USE(tmp10);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp10 = Cast20ATFastJSArrayForCopy_140(state_, TNode<Context>{tmp6}, TNode<HeapObject>{tmp9}, &label0);
    ca_.Goto(&block5, tmp6, tmp7, tmp9, tmp10);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block6, tmp6, tmp7, tmp9);
    }
  }

  if (block6.is_used()) {
    TNode<Context> tmp11;
    TNode<Object> tmp12;
    TNode<HeapObject> tmp13;
    ca_.Bind(&block6, &tmp11, &tmp12, &tmp13);
    ca_.Goto(&block1);
  }

  if (block5.is_used()) {
    TNode<Context> tmp14;
    TNode<Object> tmp15;
    TNode<HeapObject> tmp16;
    TNode<JSArray> tmp17;
    ca_.Bind(&block5, &tmp14, &tmp15, &tmp16, &tmp17);
    ca_.Goto(&block2, tmp14, tmp15, tmp17);
  }

  if (block2.is_used()) {
    TNode<Context> tmp18;
    TNode<Object> tmp19;
    TNode<JSArray> tmp20;
    ca_.Bind(&block2, &tmp18, &tmp19, &tmp20);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 97);
    ca_.Goto(&block7, tmp18, tmp19, tmp20);
  }

  if (block1.is_used()) {
    ca_.Bind(&block1);
    ca_.Goto(label_CastError);
  }

    TNode<Context> tmp21;
    TNode<Object> tmp22;
    TNode<JSArray> tmp23;
    ca_.Bind(&block7, &tmp21, &tmp22, &tmp23);
  return TNode<JSArray>{tmp23};
}

TNode<JSArgumentsObjectWithLength> Cast27JSArgumentsObjectWithLength_1465(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<Object> p_o, compiler::CodeAssemblerLabel* label_CastError) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, HeapObject> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, HeapObject> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, HeapObject, JSArgumentsObjectWithLength> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, JSArgumentsObjectWithLength> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, JSArgumentsObjectWithLength> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_o);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<Object> tmp1;
    ca_.Bind(&block0, &tmp0, &tmp1);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/base.tq", 2215);
    TNode<HeapObject> tmp2;
    USE(tmp2);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp2 = CodeStubAssembler(state_).TaggedToHeapObject(TNode<Object>{tmp1}, &label0);
    ca_.Goto(&block3, tmp0, tmp1, tmp1, tmp2);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block4, tmp0, tmp1, tmp1);
    }
  }

  if (block4.is_used()) {
    TNode<Context> tmp3;
    TNode<Object> tmp4;
    TNode<Object> tmp5;
    ca_.Bind(&block4, &tmp3, &tmp4, &tmp5);
    ca_.Goto(&block1);
  }

  if (block3.is_used()) {
    TNode<Context> tmp6;
    TNode<Object> tmp7;
    TNode<Object> tmp8;
    TNode<HeapObject> tmp9;
    ca_.Bind(&block3, &tmp6, &tmp7, &tmp8, &tmp9);
    TNode<JSArgumentsObjectWithLength> tmp10;
    USE(tmp10);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp10 = Cast27JSArgumentsObjectWithLength_136(state_, TNode<Context>{tmp6}, TNode<HeapObject>{tmp9}, &label0);
    ca_.Goto(&block5, tmp6, tmp7, tmp9, tmp10);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block6, tmp6, tmp7, tmp9);
    }
  }

  if (block6.is_used()) {
    TNode<Context> tmp11;
    TNode<Object> tmp12;
    TNode<HeapObject> tmp13;
    ca_.Bind(&block6, &tmp11, &tmp12, &tmp13);
    ca_.Goto(&block1);
  }

  if (block5.is_used()) {
    TNode<Context> tmp14;
    TNode<Object> tmp15;
    TNode<HeapObject> tmp16;
    TNode<JSArgumentsObjectWithLength> tmp17;
    ca_.Bind(&block5, &tmp14, &tmp15, &tmp16, &tmp17);
    ca_.Goto(&block2, tmp14, tmp15, tmp17);
  }

  if (block2.is_used()) {
    TNode<Context> tmp18;
    TNode<Object> tmp19;
    TNode<JSArgumentsObjectWithLength> tmp20;
    ca_.Bind(&block2, &tmp18, &tmp19, &tmp20);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 107);
    ca_.Goto(&block7, tmp18, tmp19, tmp20);
  }

  if (block1.is_used()) {
    ca_.Bind(&block1);
    ca_.Goto(label_CastError);
  }

    TNode<Context> tmp21;
    TNode<Object> tmp22;
    TNode<JSArgumentsObjectWithLength> tmp23;
    ca_.Bind(&block7, &tmp21, &tmp22, &tmp23);
  return TNode<JSArgumentsObjectWithLength>{tmp23};
}

TNode<NativeContext> UnsafeCast13NativeContext_1466(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<Object> p_o) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block5(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, NativeContext> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, NativeContext> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_o);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<Object> tmp1;
    ca_.Bind(&block0, &tmp0, &tmp1);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/base.tq", 3001);
    ca_.Goto(&block3, tmp0, tmp1);
  }

  if (block2.is_used()) {
    TNode<Context> tmp2;
    TNode<Object> tmp3;
    ca_.Bind(&block2, &tmp2, &tmp3);
    TNode<BoolT> tmp4;
    USE(tmp4);
    tmp4 = Is13NativeContext20UT5ATSmi10HeapObject_1537(state_, TNode<Context>{tmp2}, TNode<Object>{tmp3});
    ca_.Branch(tmp4, &block4, &block5, tmp2, tmp3);
  }

  if (block5.is_used()) {
    TNode<Context> tmp5;
    TNode<Object> tmp6;
    ca_.Bind(&block5, &tmp5, &tmp6);
    CodeStubAssembler(state_).FailAssert("Torque assert 'Is<A>(o)' failed", "../../deps/v8/src/builtins/base.tq", 3001);
  }

  if (block4.is_used()) {
    TNode<Context> tmp7;
    TNode<Object> tmp8;
    ca_.Bind(&block4, &tmp7, &tmp8);
  }

  if (block3.is_used()) {
    TNode<Context> tmp9;
    TNode<Object> tmp10;
    ca_.Bind(&block3, &tmp9, &tmp10);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/base.tq", 3002);
    TNode<NativeContext> tmp11;
    USE(tmp11);
    tmp11 = TORQUE_CAST(TNode<Object>{tmp10});
    ca_.Goto(&block1, tmp9, tmp10, tmp11);
  }

  if (block1.is_used()) {
    TNode<Context> tmp12;
    TNode<Object> tmp13;
    TNode<NativeContext> tmp14;
    ca_.Bind(&block1, &tmp12, &tmp13, &tmp14);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/array-slice.tq", 175);
    ca_.Goto(&block6, tmp12, tmp13, tmp14);
  }

    TNode<Context> tmp15;
    TNode<Object> tmp16;
    TNode<NativeContext> tmp17;
    ca_.Bind(&block6, &tmp15, &tmp16, &tmp17);
  return TNode<NativeContext>{tmp17};
}

}  // namespace internal
}  // namespace v8

